#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{                                                                   }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System.Drawing;
using DevExpress.XtraEditors;
namespace DevExpress.Utils.About {
	public class AboutProducts : AboutForm {
		static string version = string.Empty;
		public static void ShowStatic() {
			if(!AllowStaticAbout) return;
			Show();
		}
		public new static void Show() {
			CalcVersion();
			AboutForm form = new AboutProducts(CreateProductInfo());
			form.ShowDialog();
			form.Dispose();
		}
		protected static bool AllowStaticAbout {
			get {
				return false;
			}
		}
		protected static ProductInfo CreateProductInfo() {
			return new ProductInfo("", typeof(DevExpress.Utils.ImageCollection), ProductKind.DXperienceEnt, ProductInfoStage.Registered);
		}
		protected override void CalcBounds() {
			CalcBounds(new Rectangle(160, 36, 200, 20), new Rectangle(HorzTextIndent, 340, 0, 80));
		}
		protected static void CalcVersion() {
			version = string.Empty;
			switch(GetVersion()) {
				case ProductKind.DXperienceEnt: version = "enterprise.png"; break;
				case ProductKind.DXperiencePro: version = "professional.png"; break;
			}
		}
		Image logoEx = null; 
		protected override Image LogoEx {
			get {
				if(logoEx == null && version != string.Empty) {
					logoEx = DevExpress.Utils.ResourceImageHelper.CreateImageFromResources("DevExpress.Utils.Images." + version, typeof(AboutForm).Assembly);
				}
				return logoEx;
			}
		}
		Image logoEx2 = null; 
		protected override Image LogoEx2 {
			get {
				if(logoEx2 == null && this.IsTrial) {
					logoEx2 = DevExpress.Utils.ResourceImageHelper.CreateImageFromResources("DevExpress.Utils.Images.trial.png", typeof(AboutForm).Assembly);
				}
				return logoEx2;
			}
		}
		public AboutProducts(ProductInfo info) : base(info) {
			CreateDescription();
			this.KeyPreview = true;
		}
		protected virtual void CreateDescription() {
			if(!IsTrial) CreateGroup();
		}
		protected override string Serial {
			get {
				return base.Serial;
			}
		}
		static ProductKind GetVersion() {
			ProductKind kind = ProductKind.Default;
			return kind;
		}
		protected string GetTrialText() {
			string res = string.Empty;
			return res;
		}
		protected string GetRegisteredText() {
			string res = string.Empty;
			return res;
		}
		void CreateGroup() {
			GroupControl gc = new GroupControl();
			gc.Location = new Point(HorzTextIndent, 80);
			gc.Size = new Size(this.ClientRectangle.Width - HorzTextIndent * 2, 235);
			gc.LookAndFeel.UseDefaultLookAndFeel = false;
			gc.LookAndFeel.SetSkinStyle("iMaginary");
			gc.Text = "Products:";
			gc.DockPadding.All = 0;
			string res = string.Empty;
			string text = GetRegisteredText();
			if(text != string.Empty) res += " --- REGISTERED: ---\xd\xa" + text;
			text = GetTrialText();
			if(text != string.Empty) {
				if(res != string.Empty) res += "\xd\xa";
				res += " --- EVALUATION: ---\xd\xa" + text;
			}
			CreateProductList(res, gc);
			gc.Parent = this;
		}
		protected void CreateProductList(string text, System.Windows.Forms.Control parent) {
			if(text == string.Empty) return; 
			System.Windows.Forms.ListBox lb = new System.Windows.Forms.ListBox();
			text = text.Replace("\xa", "");
			string[] lines = text.Split(new char[] {'\xd'});
			foreach(string line in lines) {
				if(line == string.Empty) continue;
				lb.Items.Add(line);
			}
			lb.IntegralHeight = false;
			lb.BorderStyle = System.Windows.Forms.BorderStyle.None;
			lb.Dock = System.Windows.Forms.DockStyle.Fill;
			lb.SelectionMode = System.Windows.Forms.SelectionMode.None;
			lb.Parent = parent;
		}
	}
}
