#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{                                                                   }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System;
using System.Drawing;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Drawing.Text;
using System.ComponentModel;
using System.Reflection;
namespace DevExpress.Utils.Drawing.Helpers {
	public class MSG {
		public const int
			WM_DWMCOMPOSITIONCHANGED = 0x031E,
			SIZE_RESTORED = 0,
			VK_LBUTTON = 0x01,
			VK_RBUTTON = 0x02,
			MK_LBUTTON = 0x0001, MK_RBUTTON = 0x0002,
			WA_INACTIVE = 0,
			WM_SETCURSOR = 0x0020,
			WM_MOUSEACTIVATE = 0x0021,
			WM_ACTIVATE = 0x0006,
			WM_SETFOCUS = 0x0007,
			WM_KILLFOCUS = 0x0008,
			WM_VSCROLL = 0x115,
			WM_HSCROLL = 0x114,
			WM_NCCALCSIZE = 0x0083,
			WM_GETMINMAXINFO = 0x24,
			WM_NCHITTEST = 0x0084,
			WM_NCRBUTTONUP = 0x00A5,
			WM_NCLBUTTONDOWN = 0x00A1,
			WM_NCLBUTTONUP = 0x00A2,
			WM_NCMOUSEMOVE = 0x00A0,
			WM_NCMOUSELEAVE = 0x02A2,
			WM_MOUSELEAVE = 675,
			WM_MOUSEHOVER = 673,
			WM_NCMOUSEHOVER = 0x02A0,
			WM_NCPAINT = 0x0085,
			WM_NCACTIVATE = 0x0086,
			WM_SETICON = 0x0080,
			WM_SETTEXT = 0x000C,
			WM_LBUTTONDOWN = 0x0201,
			WM_LBUTTONUP = 0x0202,
			WM_LBUTTONDBLCLK = 0x0203,
			WM_MOUSEWHEEL = 0x020A,
			WM_MOUSEMOVE = 0x0200,
			WM_PRINTCLIENT = 0x0318,
			WM_IME_NOTIFY = 642,
			WM_DEADCHAR = 0x103,
			WM_SYSKEYDOWN = 0x104,
			WM_KEYUP = 257,
			WM_KEYDOWN = 256,
			WM_CAPTURECHANGED = 0x215,
			WM_SYSCOMMAND = 0x0112,
			WM_SIZE = 5,
			WM_SIZING = 0x0214,
			WM_EXITSIZEMOVE = 0x0232,
			WM_SYNCPAINT = 0x0088,
			WM_PAINT = 0x000F,
			WM_PRINT = 0x0317,
			WM_ERASEBKGND = 0x0014,
			WM_SHOWWINDOW = 0x18,
			WM_NCCREATE = 0x0081,
			WM_ACTIVATEAPP = 28,
			WM_WINDOWPOSCHANGING = 0x0046,
			WM_WINDOWPOSCHANGED = 0x0047,
			WM_CONTEXTMENU = 0x007B,
			WM_USER = 0x0400,
			WM_NCUAHDRAWCAPTION = 0x00AE,
			WM_NCUAHDRAWFRAME = 0x00AF,
			WM_IME_STARTCOMPOSITION = 0x010D,
			WM_IME_ENDCOMPOSITION = 0x010E,
			WM_IME_COMPOSITION = 0x010F,
			WM_IME_KEYLAST = 0x010F,
			WM_XREDRAW = WM_USER + 100,
			WM_XREDRAWC = WM_USER + 101,
			WM_USER7441 = WM_USER + 7441;
	}
	public class NativeVista {
		[DllImport("UxTheme.dll")]
		public static extern IntPtr BeginBufferedPaint(IntPtr pHdcTarget, IntPtr lpRect, IntPtr bufferFormat, IntPtr bpPaintParams, ref IntPtr pHdc);
		[DllImport("UxTheme.dll")]
		public static extern IntPtr BufferedPaintSetAlpha(IntPtr hBufferedPaint, IntPtr prc, byte alpha);
		[DllImport("UxTheme.dll")]
		public static extern IntPtr EndBufferedPaint(IntPtr hBufferedPaint, IntPtr fUpdateTarget);
		[DllImport("user32.dll", CharSet = CharSet.Auto)]
		public static extern IntPtr SendMessage(IntPtr hWnd, int Msg, int wParam, int lParam);
		[DllImport("user32.dll", CharSet = CharSet.Auto)]
		public static extern IntPtr BeginPaint(IntPtr hWnd, ref PAINTSTRUCT ps);
		[DllImport("user32.dll", CharSet = CharSet.Auto)]
		public static extern bool EndPaint(IntPtr hWnd, ref PAINTSTRUCT ps);
		[DllImport("user32.dll", CharSet = CharSet.Auto)]
		public static extern IntPtr GetDC(IntPtr hWnd);
		[DllImport("user32.dll", CharSet = CharSet.Auto)]
		public static extern int ReleaseDC(IntPtr hWnd, IntPtr hDC);
		[DllImport("gdi32.dll", CharSet = CharSet.Auto)]
		public static extern IntPtr DeleteObject(IntPtr hObject);
		[DllImport("gdi32.dll", EntryPoint = "CreateSolidBrush", CharSet = CharSet.Auto, ExactSpelling = true)]
		private static extern IntPtr IntCreateSolidBrush(uint crColor);
		[DllImport("user32.dll", CharSet = CharSet.Auto, ExactSpelling = true)]
		public static extern int FillRect(IntPtr hdc, [In] ref RECT rect, IntPtr hbrush);
		[StructLayout(LayoutKind.Sequential)]
		public struct PAINTSTRUCT {
			public IntPtr hdc;
			public int fErase;
			public Rectangle rcPaint;
			public int fRestore;
			public int fIncUpdate;
			public int Reserved1;
			public int Reserved2;
			public int Reserved3;
			public int Reserved4;
			public int Reserved5;
			public int Reserved6;
			public int Reserved7;
			public int Reserved8;
		}
		const int BPBF_TOPDOWNDIB = 2;
		const int PRF_CLIENT = 0x00000004;
		[StructLayout(LayoutKind.Sequential)]
		public struct RECT {
			public int left;
			public int top;
			public int right;
			public int bottom;
			public RECT(int left, int top, int right, int bottom) {
				this.left = left;
				this.top = top;
				this.bottom = bottom;
				this.right = right;
			}
		}
		public static void FillRect(IntPtr hdc, Rectangle rect) {
			RECT r = new RECT(rect.Left, rect.Top, rect.Right, rect.Bottom);
			IntPtr hb = IntCreateSolidBrush(0x000000);
			FillRect(hdc, ref r, hb);
			DeleteObject(hb);
		}
		public static void PaintControl(IntPtr hwnd, IntPtr hdc, Rectangle rect, bool bEraseBackground) {
			IntPtr hdcPaint = IntPtr.Zero;
			IntPtr rectPtr = Marshal.AllocHGlobal(Marshal.SizeOf(rect));
			Marshal.StructureToPtr(rect, rectPtr, false);
			IntPtr hBufferedPaint = BeginBufferedPaint(hdc, rectPtr, new IntPtr(BPBF_TOPDOWNDIB), IntPtr.Zero, ref hdcPaint);
			if(hdcPaint != IntPtr.Zero) {
				if(bEraseBackground) SendMessage(hwnd, MSG.WM_ERASEBKGND, hdcPaint.ToInt32(), hdcPaint.ToInt32());
				SendMessage(hwnd, MSG.WM_PRINTCLIENT, hdcPaint.ToInt32(), PRF_CLIENT);
				BufferedPaintSetAlpha(hBufferedPaint, rectPtr, 255);
				EndBufferedPaint(hBufferedPaint, new IntPtr(1));
			}
		}
		[DllImport("uxtheme", ExactSpelling = true, CharSet = CharSet.Unicode)]
		public extern static Int32 GetThemeTextExtent(IntPtr hTheme, IntPtr hdc, int iPartId, int iStateId, String text, int textLength, int textFlags, ref RECT boundingRect, out RECT extentRect);
		[DllImport("uxtheme", ExactSpelling = true, CharSet = CharSet.Unicode)]
		public extern static Int32 GetThemeTextExtent(IntPtr hTheme, IntPtr hdc, int iPartId, int iStateId, String text, int textLength, int textFlags, IntPtr boundsingRect, out RECT extentRect);
		[DllImport("UxTheme.dll", CharSet = CharSet.Unicode)]
		private static extern int DrawThemeTextEx(IntPtr hTheme, IntPtr hdc, int iPartId, int iStateId, string text, int iCharCount, int dwFlags, ref NativeMethods.RECT pRect, ref DTTOPTS pOptions);
#if !DXWhidbey
		public static void DrawGlowingText(Graphics graphics, string text, Font font, Rectangle bounds, Color color, object flags) {
			graphics.DrawString(text, font, new SolidBrush(color), bounds);
#else
		public static Size CalcTextSizeOnGlass(Graphics graphics, string text, Font font, Rectangle bounds, TextFormatFlags flags) {
			IntPtr primaryHdc = graphics.GetHdc();
			System.Windows.Forms.VisualStyles.VisualStyleRenderer renderer = new System.Windows.Forms.VisualStyles.VisualStyleRenderer(System.Windows.Forms.VisualStyles.VisualStyleElement.Window.Caption.Active);
			IntPtr fontHandle = font.ToHfont();
			IntPtr prevFontHandle = NativeMethods.SelectObject(primaryHdc, fontHandle);
			DTTOPTS dttOpts = new DTTOPTS();
			dttOpts.dwSize = Marshal.SizeOf(typeof(DTTOPTS));
			dttOpts.dwFlags = DTT_COMPOSITED | DTT_CALCRECT | DTT_TEXTCOLOR;
			dttOpts.crText = ColorTranslator.ToWin32(Color.Black);
			dttOpts.iGlowSize = 10;
			NativeMethods.RECT textBounds = new NativeMethods.RECT(0, 0, bounds.Right - bounds.Left, bounds.Bottom - bounds.Top);
			DrawThemeTextEx(renderer.Handle, primaryHdc, 0, 0, text, -1, ((int)flags) | DT_CALCRECT, ref textBounds, ref dttOpts);
			NativeMethods.DeleteObject(fontHandle);
			NativeMethods.SelectObject(primaryHdc, prevFontHandle);
			graphics.ReleaseHdc(primaryHdc);
			return new Size(textBounds.Right - textBounds.Left, textBounds.Bottom - textBounds.Top);
		}
		static IntPtr CachedDibSection = IntPtr.Zero;
		static void DrawTextOnGlass(Graphics graphics, string text, Font font, Rectangle bounds, Color color, int flags, int rflags) {
			if(!System.Windows.Forms.VisualStyles.VisualStyleRenderer.IsSupported) {
				using(SolidBrush brush = new SolidBrush(color)) {
					graphics.DrawString(text, font, brush, bounds);
				}
				return;
			}
			IntPtr primaryHdc = graphics.GetHdc();
			IntPtr memoryHdc = NativeMethods.CreateCompatibleDC(primaryHdc);
			if(CachedDibSection == IntPtr.Zero) {
				NativeMethods.BITMAPINFO_SMALL info = new NativeMethods.BITMAPINFO_SMALL();
				info.biSize = Marshal.SizeOf(info);
				info.biWidth = 1280;
				info.biHeight = -64;
				info.biPlanes = 1;
				info.biBitCount = 32;
				info.biCompression = 0;
				CachedDibSection = NativeMethods.CreateDIBSection(primaryHdc, ref info, 0, 0, IntPtr.Zero, 0);
			}
			NativeMethods.SelectObject(memoryHdc, CachedDibSection);
			IntPtr fontHandle = font.ToHfont();
			NativeMethods.SelectObject(memoryHdc, fontHandle);
			const int SRCCOPY = 0xCC0020;
			NativeMethods.BitBlt(memoryHdc, 0, 0, bounds.Width, bounds.Height, primaryHdc, bounds.X, bounds.Y, SRCCOPY);
			System.Windows.Forms.VisualStyles.VisualStyleRenderer renderer = new System.Windows.Forms.VisualStyles.VisualStyleRenderer(System.Windows.Forms.VisualStyles.VisualStyleElement.Window.Caption.Active);
			DTTOPTS dttOpts = new DTTOPTS();
			dttOpts.dwSize = Marshal.SizeOf(typeof(DTTOPTS));
			dttOpts.dwFlags = DTT_COMPOSITED | rflags | DTT_TEXTCOLOR;
			dttOpts.crText = ColorTranslator.ToWin32(color);
			dttOpts.iGlowSize = 10;
			NativeMethods.RECT textBounds = new NativeMethods.RECT(0, 0, bounds.Right - bounds.Left, bounds.Bottom - bounds.Top);
			DrawThemeTextEx(renderer.Handle, memoryHdc, 0, 0, text, -1, (int)flags, ref textBounds, ref dttOpts);
			NativeMethods.BitBlt(primaryHdc, bounds.Left, bounds.Top, bounds.Width, bounds.Height, memoryHdc, 0, 0, SRCCOPY);
			NativeMethods.DeleteObject(fontHandle);
			NativeMethods.DeleteDC(memoryHdc);
			graphics.ReleaseHdc(primaryHdc);
		}
		static void DrawTextOnGlass(Graphics graphics, string text, Font font, Rectangle bounds, Color color, TextFormatFlags flags, int rflags) {
			DrawTextOnGlass(graphics, text, font, bounds, color, (int)flags, rflags);
		}
		public static void DrawTextOnGlass(Graphics graphics, string text, Font font, Rectangle bounds, Color color, TextFormatFlags flags) {
			DrawTextOnGlass(graphics, text, font, bounds, color, flags, 0);
		}
		public static void DrawGlowingText(Graphics graphics, string text, Font font, Rectangle bounds, Color color, TextFormatFlags flags) {
			DrawTextOnGlass(graphics, text, font, bounds, color, flags, DTT_GLOWSIZE);
#endif
		}
		[StructLayout(LayoutKind.Sequential)]
		private struct DTTOPTS {
			public int dwSize;
			public int dwFlags;
			public int crText;
			public int crBorder;
			public int crShadow;
			public int iTextShadowType;
			public NativeMethods.POINT ptShadowOffset;
			public int iBorderSize;
			public int iFontPropId;
			public int iColorPropId;
			public int iStateId;
			public bool fApplyOverlay;
			public int iGlowSize;
			public int pfnDrawTextCallback;
			public IntPtr lParam;
		}
		private const int DTT_COMPOSITED = 8192;
		private const int DTT_GLOWSIZE = 2048;
		private const int DTT_TEXTCOLOR = 1;
		private const int DTT_CALCRECT = 0x200;
		private const int DT_CALCRECT = 1024;
		public static bool IsVista {
			get { return Environment.OSVersion.Version.Major == 6; }
		}
		public static bool IsWindows7 {
			get { return Environment.OSVersion.Version.Major == 6 && Environment.OSVersion.Version.Minor > 0; }
		}
		public static bool IsCompositionEnabled() {
			if(!IsVista) return false;
			bool enabled = false;
			DwmIsCompositionEnabled(ref enabled);
			return enabled;
		}
		public static void CallDwmBase(ref Message m) {
			IntPtr res = m.Result;
			DwmDefWindowProc(m.HWnd, m.Msg, m.WParam, m.LParam, out res);
			m.Result = res;
		}
		public static void DisableWindowGhosting() {
			if(!IsVista) return;
			DisableProcessWindowsGhosting();
		}
		[DllImport("user32.dll")]
		public static extern void DisableProcessWindowsGhosting();
		[DllImport("dwmapi.dll")]
		public static extern void DwmIsCompositionEnabled(ref bool isEnabled);
		[DllImport("dwmapi.dll")]
		public static extern void DwmExtendFrameIntoClientArea(System.IntPtr hWnd, ref NativeMethods.Margins pMargins);
		[DllImport("dwmapi.dll")]
		public static extern int DwmDefWindowProc(IntPtr hWnd, int msg, IntPtr wParam, IntPtr lParam, out IntPtr result);
		[DllImport("dwmapi.dll", PreserveSig = false)]
		public static extern int DwmSetWindowAttribute(IntPtr hwnd, int attr, ref int attrValue, int attrSize);
		public enum DWMWINDOWATTRIBUTE { 
			DWMWA_NCRENDERING_ENABLED = 1, 
			DWMWA_NCRENDERING_POLICY, 
			DWMWA_TRANSITIONS_FORCEDISABLED, 
			DWMWA_ALLOW_NCPAINT, 
			DWMWA_CAPTION_BUTTON_BOUNDS, 
			DWMWA_NONCLIENT_RTL_LAYOUT, 
			DWMWA_FORCE_ICONIC_REPRESENTATION, 
			DWMWA_FLIP3D_POLICY, 
			DWMWA_EXTENDED_FRAME_BOUNDS, 
			DWMWA_HAS_ICONIC_BITMAP, 
			DWMWA_DISALLOW_PEEK, 
			DWMWA_EXCLUDED_FROM_PEEK, 
			DWMWA_LAST 
		}
		public enum DWMNCRenderingPolicy {
			DWMNCRP_USEWINDOWSTYLE, 
			DWMNCRP_DISABLED, 
			DWMNCRP_ENABLED, 
			DWMNCRP_LAST
		}
		public static void SetNCRendering(IntPtr handle, bool enable) {
			int renderPolicy = (int)(enable ? DWMNCRenderingPolicy.DWMNCRP_ENABLED : DWMNCRenderingPolicy.DWMNCRP_DISABLED);
			DwmSetWindowAttribute(handle, (int)DWMWINDOWATTRIBUTE.DWMWA_NCRENDERING_POLICY, ref renderPolicy, sizeof(int));
		}
		public static void SetNCPaint(IntPtr handle, bool enable) {
			int renderPolicy = (int)(enable ? 1 : 0);
			DwmSetWindowAttribute(handle, (int)DWMWINDOWATTRIBUTE.DWMWA_ALLOW_NCPAINT, ref renderPolicy, sizeof(int));
		}
	}
	public static class LayoutTransactionHelper {
		static Type layoutTransactionType = null;
		static Type iArrangedElementType = null;
		static void InitLayoutTransactionType() {
			AssemblyName[] refAssemblies = Assembly.GetExecutingAssembly().GetReferencedAssemblies();
			AssemblyName systemWindowsForms = null;
			foreach(AssemblyName a in refAssemblies) {
				if(a.FullName.Contains("System.Windows.Forms")) {
					systemWindowsForms = a;
					break;
				}
			}
			Assembly asm = Assembly.Load(systemWindowsForms);
			layoutTransactionType = asm.GetType("System.Windows.Forms.Layout.LayoutTransaction");
			iArrangedElementType = asm.GetType("System.Windows.Forms.Layout.IArrangedElement");
		}
		static MethodInfo createTransactionIfMethod = null;
		public static IDisposable CreateLayoutTransactionIf(Control ctrl, bool condition, string propName) {
			if(layoutTransactionType == null)
				InitLayoutTransactionType();
			if(createTransactionIfMethod == null)
				createTransactionIfMethod = layoutTransactionType.GetMethod("CreateTransactionIf", BindingFlags.Static | BindingFlags.Public, null, new Type[] { typeof(bool), typeof(Control), iArrangedElementType, typeof(string) }, null);
			return (IDisposable)createTransactionIfMethod.Invoke(null, new object[] { condition, ctrl.Parent, ctrl, propName });
		}
	}
	public class NativeMethods {
		[StructLayout(LayoutKind.Sequential)]
		public struct Margins {
			public int Left, Right, Top, Bottom;
		}
		[StructLayout(LayoutKind.Sequential)]
		public struct BITMAPINFO_SMALL {
			public int biSize;
			public int biWidth;
			public int biHeight;
			public short biPlanes;
			public short biBitCount;
			public int biCompression;
			public int biSizeImage;
			public int biXPelsPerMeter;
			public int biYPelsPerMeter;
			public int biClrUsed;
			public int biClrImportant;
			public byte bmiColors_rgbBlue;
			public byte bmiColors_rgbGreen;
			public byte bmiColors_rgbRed;
			public byte bmiColors_rgbReserved;
		}
		[StructLayout(LayoutKind.Sequential)]
		public struct BITMAPINFO_FLAT {
			public int biSize;
			public int biWidth;
			public int biHeight;
			public short biPlanes;
			public short biBitCount;
			public int biCompression;
			public int bmiHeader_biSizeImage;
			public int bmiHeader_biXPelsPerMeter;
			public int bmiHeader_biYPelsPerMeter;
			public int bmiHeader_biClrUsed;
			public int bmiHeader_biClrImportant;
			[MarshalAs(UnmanagedType.ByValArray, SizeConst = 0x400)]
			public byte[] bmiColors;
		}
		[StructLayout(LayoutKind.Sequential)]
		public class BITMAPINFOHEADER {
			public int biSize;
			public int biWidth;
			public int biHeight;
			public short biPlanes;
			public short biBitCount;
			public int biCompression;
			public int biSizeImage;
			public int biXPelsPerMeter;
			public int biYPelsPerMeter;
			public int biClrUsed;
			public int biClrImportant;
			public BITMAPINFOHEADER() {
				this.biSize = 40;
			}
		}
		public static bool IsKeyboardContextMenuMessage(Message msg) {
			if(msg.Msg != MSG.WM_CONTEXTMENU) return false;
			Point pt = new Point(msg.LParam.ToInt32());
			if(pt.X == -1 && pt.Y == -1) return true;
			return false;
		}
		[DllImport("GDI32.dll")]
		public static extern int RestoreDC(IntPtr hdc, int savedDC);
		[DllImport("GDI32.dll")]
		public static extern int SaveDC(IntPtr hdc);
		[DllImport("gdi32.dll", CharSet = CharSet.Auto, SetLastError = true, ExactSpelling = true)]
		public static extern int BitBlt(HandleRef hDC, int x, int y, int nWidth, int nHeight, HandleRef hSrcDC, int xSrc, int ySrc, int dwRop);
		[DllImport("gdi32.dll", CharSet = CharSet.Auto, SetLastError = true, ExactSpelling = true)]
		public static extern int BitBlt(IntPtr hDC, int x, int y, int nWidth, int nHeight, IntPtr hSrcDC, int xSrc, int ySrc, int dwRop);
		[DllImport("gdi32.dll", CharSet = CharSet.Auto, SetLastError = true, ExactSpelling = true)]
		public static extern IntPtr SelectObject(HandleRef hdc, HandleRef obj);
		[DllImport("gdi32.dll", CharSet = CharSet.Auto, SetLastError = true, ExactSpelling = true)]
		public static extern IntPtr SelectObject(IntPtr hdc, IntPtr obj);
		[DllImport("gdi32.dll")]
		public extern static IntPtr CreateRoundRectRgn(int nLeftRect, int nTopRect, int nRightRect,
							int nBottomRect, int nWidthEllipse, int nHeightEllipse);
		[DllImport("gdi32.dll")]
		public static extern int GetDIBits(HandleRef hdc, HandleRef hbm, int arg1, int arg2, IntPtr arg3, ref NativeMethods.BITMAPINFO_FLAT bmi, int arg5);
		[DllImport("gdi32.dll")]
		public static extern IntPtr CreateCompatibleBitmap(IntPtr hDC, int width, int height);
		[DllImport("gdi32.dll")]
		public static extern IntPtr CreateCompatibleBitmap(HandleRef hDC, int width, int height);
		[DllImport("gdi32.dll")]
		public static extern IntPtr CreateCompatibleDC(HandleRef hDC);
		[DllImport("gdi32.dll")]
		public static extern IntPtr CreateCompatibleDC(IntPtr hDC);
		[DllImport("gdi32.dll")]
		public static extern bool DeleteDC(HandleRef hDC);
		[DllImport("gdi32.dll")]
		public static extern bool DeleteDC(IntPtr hDC);
		[DllImport("gdi32.dll")]
		public static extern bool DeleteObject(HandleRef hObject);
		[DllImport("gdi32.dll")]
		public static extern bool DeleteObject(IntPtr hObject);
		[DllImport("gdi32.dll", SetLastError = true)]
		public static extern IntPtr CreateDIBSection(HandleRef hdc, ref BITMAPINFO_FLAT bmi, int iUsage, ref IntPtr ppvBits, IntPtr hSection, int dwOffset);
		[DllImport("gdi32.dll", SetLastError = true)]
		public static extern IntPtr CreateDIBSection(IntPtr hdc, ref BITMAPINFO_SMALL bmi, int iUsage, int pvvBits, IntPtr hSection, int dwOffset);
		[DllImport("gdi32.dll")]
		public static extern int GetPaletteEntries(IntPtr hPal, int startIndex, int entries, byte[] palette);
		[DllImport("comctl32.dll", ExactSpelling = true)]
		internal static extern bool _TrackMouseEvent(TRACKMOUSEEVENT tme);
		[DllImport("user32.dll")]
		public static extern IntPtr TrackPopupMenu(IntPtr menuHandle, int uFlags, int x, int y, int nReserved, IntPtr hwnd, IntPtr par);
		[DllImport("gdi32.dll", CharSet = CharSet.Auto, SetLastError = true, ExactSpelling = true)]
		public static extern bool GetViewportOrgEx(IntPtr hDC, ref POINT point);
		internal static void ExcludeClipRect(IntPtr hdc, Rectangle rect) {
			ExcludeClipRect(hdc, rect.X, rect.Y, rect.Right, rect.Bottom);
		}
		[DllImport("user32.dll", CharSet = CharSet.Auto, ExactSpelling = true)]
		public static extern bool ScrollWindowEx(IntPtr hWnd, int nXAmount, int nYAmount, RECT rectScrollRegion, ref RECT rectClip, IntPtr hrgnUpdate, ref RECT prcUpdate, int flags);
		[DllImport("user32.dll", CharSet = CharSet.Auto, ExactSpelling = true)]
		public static extern bool ScrollWindowEx(IntPtr hWnd, int nXAmount, int nYAmount, IntPtr rectScrollRegion, ref RECT rectClip, IntPtr hrgnUpdate, ref RECT prcUpdate, int flags);
		[DllImport("USER32.dll")]
		public static extern int ReleaseDC(IntPtr hWnd, IntPtr hDC);
		[DllImport("USER32.dll")]
		public static extern IntPtr GetDCEx(IntPtr hWnd, IntPtr hrgnClip, int flags);
		[DllImport("USER32.dll")]
		public static extern IntPtr GetWindowDC(IntPtr hwnd);
		[DllImport("USER32.dll")]
		public static extern int GetWindowLong(IntPtr hwnd, int flags);
		[DllImport("USER32.dll")]
		public static extern int SetWindowLong(IntPtr hwnd, int flags, int val);
		[DllImport("user32.dll")]
		public static extern IntPtr SetWindowLong(IntPtr hWnd, int nIndex, IntPtr dwNewLong);
		[DllImport("USER32.dll")]
		public static extern IntPtr GetDesktopWindow();
		[DllImport("USER32.dll")]
		public static extern bool RedrawWindow(IntPtr hwnd, IntPtr rcUpdate, IntPtr hrgnUpdate, int flags);
		[DllImport("USER32.dll")]
		public static extern short GetAsyncKeyState(int vKey);
		[DllImport("USER32.dll")]
		public static extern bool SetWindowPos(IntPtr hWnd, IntPtr hWndInsertAfter,
			int X, int Y, int cx, int cy, int uFlags);
		[DllImport("USER32.dll")]
		public static extern int SetCapture(IntPtr hWnd);
		[DllImport("USER32.dll")]
		public static extern bool ReleaseCapture();
		[DllImport("USER32.dll")]
		public static extern bool IsWindowVisible(IntPtr hWnd);
		[DllImport("user32.dll", CharSet = CharSet.Auto)]
		public static extern IntPtr SendMessage(IntPtr hWnd, int Msg, int wParam, IntPtr lParam);
		[DllImport("USER32.dll")]
		public static extern int SendMessage(IntPtr hWnd, int Msg, IntPtr wParam, IntPtr lParam);
		[DllImport("USER32.dll")]
		public static extern int PostMessage(IntPtr hWnd, int Msg, IntPtr wParam, IntPtr lParam);
		[DllImport("USER32.dll")]
		public static extern bool IsZoomed(IntPtr hwnd);
		[DllImport("USER32.dll")]
		public static extern bool IsIconic(IntPtr hwnd);
		[DllImport("USER32.dll")]
		public static extern bool GetWindowRect(IntPtr hWnd, ref RECT lpRect);
		[DllImport("USER32.dll")]
		public static extern bool ValidateRect(IntPtr hwnd, ref RECT lpRect);
		[DllImport("USER32.dll")]
		public static extern IntPtr BeginPaint(IntPtr hWnd, [In, Out] ref PAINTSTRUCT lpPaint);
		[DllImport("USER32.dll")]
		public static extern bool EndPaint(IntPtr hWnd, ref PAINTSTRUCT lpPaint);
		[DllImport("USER32.dll")]
		public static extern bool LockWindowUpdate(IntPtr hWndLock);
		[DllImport("USER32.dll")]
		public static extern int SetWindowRgn(IntPtr hWnd, IntPtr hRgn, bool redraw);
		[DllImport("GDI32.dll")]
		public static extern int CombineRgn(IntPtr hrgnDest, IntPtr hrgnSrc1, IntPtr hrgnSrc2, int fnCombineMode);
		[DllImport("GDI32.dll")]
		public static extern int ExcludeClipRect(IntPtr hdc, int left, int top, int right, int bottom);
		[DllImport("GDI32.dll")]
		public static extern int GetClipRgn(IntPtr hdc, IntPtr hrgn);
		[DllImport("GDI32.dll")]
		public static extern int SelectClipRgn(IntPtr hdc, IntPtr hrgn);
		[DllImport("GDI32.dll")]
		public static extern int ExtSelectClipRgn(IntPtr hdc, IntPtr hrgn, int mode);
		[DllImport("GDI32.dll")]
		public static extern IntPtr CreateRectRgn(int nLeftRect, int nTopRect, int nRightRect, int nBottomRect);
		[DllImport("GDI32.dll")]
		public static extern bool RectVisible(IntPtr hdc, ref NativeMethods.RECT rect);
		[DllImport("User32.dll", CharSet = CharSet.Auto)]
		public static extern int MapWindowPoints(IntPtr hwnd, IntPtr hWndTo, [In, Out] ref NativeMethods.POINT rect, int cPoints);
		[DllImport("gdi32.dll", CharSet = CharSet.Auto)]
		public static extern int GetObject(IntPtr hObject, int nSize, [In, Out] ControlUtils.LOGFONT lf);
		public static Region CreateRoundRegion(Rectangle windowBounds, int ellipseSize) {
			IntPtr rgn = CreateRoundRectRgn(windowBounds.X, windowBounds.Y, windowBounds.Width + 1, windowBounds.Height + 1, ellipseSize, ellipseSize);
			Region res = Region.FromHrgn(rgn);
			DeleteObject(rgn);
			return res;
		}
		public const int RGN_AND = 1, RGN_OR = 2, RGN_XOR = 3, RGN_DIFF = 4, RGN_COPY = 5;
		[StructLayout(LayoutKind.Sequential)]
		public class TRACKMOUSEEVENT {
			public int cbSize;
			public int dwFlags;
			public IntPtr hwndTrack;
			public int dwHoverTime = 0;
			public TRACKMOUSEEVENT() {
				this.cbSize = Marshal.SizeOf(typeof(TRACKMOUSEEVENT));
			}
		}
		[StructLayout(LayoutKind.Sequential)]
		public struct NCCALCSIZE_PARAMS {
			public RECT rgrc0, rgrc1, rgrc2;
			public IntPtr lppos;
			public static NCCALCSIZE_PARAMS GetFrom(IntPtr lParam) {
				return (NCCALCSIZE_PARAMS)Marshal.PtrToStructure(lParam, typeof(NCCALCSIZE_PARAMS));
			}
			public void SetTo(IntPtr lParam) {
				Marshal.StructureToPtr(this, lParam, false);
			}
		}
		[StructLayout(LayoutKind.Sequential)]
		public struct PAINTSTRUCT {
			public IntPtr hdc;
			public bool fErase;
			public RECT rcPaint;
			public bool fRestore;
			public bool fIncUpdate;
			public int reserved1;
			public int reserved2;
			public int reserved3;
			public int reserved4;
			public int reserved5;
			public int reserved6;
			public int reserved7;
			public int reserved8;
		}
		[System.Runtime.InteropServices.StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential)]
		public struct POINT {
			public int X, Y;
			public POINT(int x, int y) {
				this.X = x;
				this.Y = y;
			}
			public POINT(Point pt) {
				this.X = pt.X;
				this.Y = pt.Y;
			}
			public Point ToPoint() { return new Point(X, Y); }
		}
		[System.Runtime.InteropServices.StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential)]
		public struct SIZE {
			public int Width, Height;
			public SIZE(int w, int h) {
				this.Width = w;
				this.Height = h;
			}
			public SIZE(Size size) {
				this.Width = size.Width;
				this.Height = size.Height;
			}
			public Size ToSize() { return new Size(Width, Height); }
		}
		[StructLayout(LayoutKind.Sequential)]
		public struct RECT {
			public int Left, Top, Right, Bottom;
			public RECT(int l, int t, int r, int b) {
				Left = l; Top = t; Right = r; Bottom = b;
			}
			public RECT(Rectangle r) {
				Left = r.Left; Top = r.Top; Right = r.Right; Bottom = r.Bottom;
			}
			public Rectangle ToRectangle() {
				return Rectangle.FromLTRB(Left, Top, Right, Bottom);
			}
		}
		[StructLayout(LayoutKind.Sequential)]
		public struct MINMAXINFO {
			public POINT ptReserved,
			ptMaxSize, ptMaxPosition, ptMinTrackSize, ptMaxTrackSize;
			public static MINMAXINFO GetFrom(IntPtr lParam) {
				return (MINMAXINFO)Marshal.PtrToStructure(lParam, typeof(MINMAXINFO));
			}
		}
		public class WMSZ { 
			public const int 
				WMSZ_LEFT = 1,
				WMSZ_RIGHT = 2,
				WMSZ_TOP = 3,
				WMSZ_TOPLEFT = 4,
				WMSZ_TOPRIGHT = 5,
				WMSZ_BOTTOM = 6,
				WMSZ_BOTTOMLEFT = 7,
				WMSZ_BOTTOMRIGHT = 8;
		} 
		public class SWP {
			public const int
				SWP_NOSIZE = 0x0001,
				SWP_NOMOVE = 0x0002,
				SWP_NOZORDER = 0x0004,
				SWP_NOREDRAW = 0x0008,
				SWP_NOACTIVATE = 0x0010,
				SWP_FRAMECHANGED = 0x0020, 
				SWP_DRAWFRAME = SWP_FRAMECHANGED,
				SWP_SHOWWINDOW = 0x0040,
				SWP_HIDEWINDOW = 0x0080,
				SWP_NOCOPYBITS = 0x0100,
				SWP_NOOWNERZORDER = 0x0200, 
				SWP_NOREPOSITION = SWP_NOOWNERZORDER,
				SWP_NOSENDCHANGING = 0x0400; 
		}
		public class DC {
			public const int
				DCX_WINDOW = 0x00000001,
				DCX_CACHE = 0x00000002,
				DCX_NORESETATTRS = 0x00000004,
				DCX_CLIPCHILDREN = 0x00000008,
				DCX_CLIPSIBLINGS = 0x00000010,
				DCX_PARENTCLIP = 0x00000020,
				DCX_EXCLUDERGN = 0x00000040,
				DCX_INTERSECTRGN = 0x00000080,
				DCX_EXCLUDEUPDATE = 0x00000100,
				DCX_INTERSECTUPDATE = 0x00000200,
				DCX_LOCKWINDOWUPDATE = 0x00000400,
				DCX_VALIDATE = 0x00200000;
		}
		[StructLayout(LayoutKind.Sequential)]
		public struct WINDOWPOS {
			public IntPtr hWnd;
			public IntPtr hHndInsertAfter;
			public int x;
			public int y;
			public int cx;
			public int cy;
			public int flags;
		}
		public class SC {
			public const int
				SC_SIZE = 0xf000,
				SC_MOVE = 0xf010,
				SC_MINIMIZE = 0xf020,
				SC_MAXIMIZE = 0xf030,
				SC_NEXTWINDOW = 0xf040,
				SC_PREVWINDOW = 0xf050,
				SC_CLOSE = 0xf060,
				SC_VSCROLL = 0xf070,
				SC_HSCROLL = 0xf080,
				SC_MOUSEMENU = 0xf090,
				SC_KEYMENU = 0xf100,
				SC_ARRANGE = 0xf110,
				SC_RESTORE = 0xf120,
				SC_TASKLIST = 0xf130,
				SC_SCREENSAVE = 0xf140,
				SC_HOTKEY = 0xf150,
				SC_CONTEXTHELP = 0xf180,
				SC_DRAGMOVE = 0xf012,
				SC_SYSMENU = 0xf093;
		}
		public class HT {
			public const int HTERROR = (-2);
			public const int HTTRANSPARENT = (-1);
			public const int HTNOWHERE = 0, HTCLIENT = 1, HTCAPTION = 2, HTSYSMENU = 3,
				HTGROWBOX = 4, HTSIZE = HTGROWBOX, HTMENU = 5, HTHSCROLL = 6, HTVSCROLL = 7, HTMINBUTTON = 8, HTMAXBUTTON = 9,
				HTLEFT = 10, HTRIGHT = 11, HTTOP = 12, HTTOPLEFT = 13, HTTOPRIGHT = 14, HTBOTTOM = 15, HTBOTTOMLEFT = 16,
				HTBOTTOMRIGHT = 17, HTBORDER = 18, HTREDUCE = HTMINBUTTON, HTZOOM = HTMAXBUTTON, HTSIZEFIRST = HTLEFT,
				HTSIZELAST = HTBOTTOMRIGHT, HTOBJECT = 19, HTCLOSE = 20, HTHELP = 21;
		}
	}
	[ToolboxItem(false)]
	public class SmartDoubleBufferPainter : Control {
		bool initialized = false, isVista = false;
		[ThreadStatic]
		static SmartDoubleBufferPainter _default;
		public SmartDoubleBufferPainter() {
			this.isVista = false; 
		}
		public static SmartDoubleBufferPainter Default {
			get {
				if(_default == null) _default = new SmartDoubleBufferPainter();
				return _default;
			}
		}
		public bool ProcessMessage(Control control, ref Message m) {
			if(!isVista) return false;
			if(m.Msg == MSG.WM_PAINT) return WMPaint(control, ref m);
			if(m.Msg == MSG.WM_ERASEBKGND) return WMEraseBkgn(control, ref m);
			return false;
		}
		private bool WMEraseBkgn(Control control, ref Message m) {
			DrawToDc(control, m.WParam, Rectangle.Empty);
			m.Result = IntPtr.Zero;
			return true;
		}
		bool WMPaint(Control control, ref Message m) {
			Init();
			NativeMethods.PAINTSTRUCT ps = new NativeMethods.PAINTSTRUCT();
			IntPtr dc = NativeMethods.BeginPaint(control.Handle, ref ps);
			DrawToDc(control, dc, ps.rcPaint.ToRectangle());
			NativeMethods.EndPaint(Handle, ref ps);
			m.Result = IntPtr.Zero;
			return true;
		}
		void DrawToDc(Control control, IntPtr dc, Rectangle rect) {
			NativeMethods.RECT target = new NativeMethods.RECT(rect);
			IntPtr resDC = IntPtr.Zero;
			IntPtr hpaint = BeginBufferedPaint(dc, ref target, BP_BUFFERFORMAT.BPBF_DIB, IntPtr.Zero, ref resDC);
			if(hpaint == IntPtr.Zero) {
				isVista = false;
				resDC = dc;
			}
			Graphics g = Graphics.FromHdc(resDC);
			try {
				InvokePaint(control, new PaintEventArgs(g, rect));
				g.Dispose();
			}
			catch {
			}
			if(hpaint != IntPtr.Zero) EndBufferedPaint(hpaint, true);
		}
		void Init() {
			if(initialized) return;
			this.initialized = true;
			BufferedPaintInit();
		}
		[DllImport("UxTheme.dll", CharSet = CharSet.Auto)]
		static extern IntPtr BeginBufferedPaint(IntPtr hdcTarget,
			ref DevExpress.Utils.Drawing.Helpers.NativeMethods.RECT prcTarget, BP_BUFFERFORMAT dwFormat,
			IntPtr pPaintParams, ref IntPtr hdc);
		[DllImport("UxTheme.dll", CharSet = CharSet.Auto)]
		static extern void BufferedPaintInit();
		[DllImport("UxTheme.dll", CharSet = CharSet.Auto)]
		static extern int EndBufferedPaint(IntPtr hBufferedPaint, bool fUpdateTarget);
		public enum BP_BUFFERFORMAT { BPBF_COMPATIBLEBITMAP, BPBF_DIB, BPBF_TOPDOWNDIB, BPBF_TOPDOWNMONODIB };
		[StructLayout(LayoutKind.Sequential)]
		public struct BP_PAINTPARAMS {
			public int cbSize;
			public int dwFlags;
			IntPtr prcExclude;
			IntPtr pBlendFunction;
		}
	}
	public class WindowScroller {
		[DllImport("user32.dll", CharSet = CharSet.Auto)]
		static extern int ScrollWindowEx(IntPtr hWnd, int dx, int dy,
			ref RECT scrollRect, ref RECT clipRect, IntPtr hrgnUpdate, IntPtr updateRect, int flags);
		[DllImport("user32.dll", CharSet = CharSet.Auto, ExactSpelling = true)]
		static extern bool ScrollWindow(IntPtr hWnd, int nXAmount, int nYAmount, ref RECT rectScrollRegion, ref RECT rectClip);
		[StructLayout(LayoutKind.Sequential)]
		struct RECT {
			public int Left, Top, Right, Bottom;
		}
		const int WM_PAINT = 0x000F;
		[System.Runtime.InteropServices.DllImport("user32.dll")]
		static extern int SendMessage(IntPtr hWnd, int Msg, uint wParam, uint lParam);
		enum ScrollWindowExFlags { SW_SCROLLCHILDREN = 0x01, SW_INVALIDATE = 0x02, SW_ERASE = 0x04, SW_SMOOTHSCROLL = 0x10 };
		public static bool ScrollVertical(Control control, Rectangle maxBounds, int y, int distance) {
			if(distance == 0 || control == null || !control.IsHandleCreated) return false;
			Rectangle rows = maxBounds;
			y = Math.Max(rows.Y, y);
			if(distance < 0) {
				if(y + distance < rows.Y) distance = (rows.Y - y);
			}
			else {
				if(distance >= rows.Height) distance = rows.Height;
			}
			RECT scrollRect = new RECT();
			scrollRect.Left = rows.X;
			scrollRect.Right = rows.Right;
			scrollRect.Top = y;
			scrollRect.Bottom = rows.Bottom - (distance > 0 ? distance : 0); 
			RECT clip = new RECT();
			clip.Left = maxBounds.Left;
			clip.Right = maxBounds.Right;
			clip.Top = maxBounds.Top;
			clip.Bottom = maxBounds.Bottom;
			ScrollWindowEx(control.Handle, 0, distance, ref scrollRect, ref clip, IntPtr.Zero, IntPtr.Zero, (int)(ScrollWindowExFlags.SW_INVALIDATE | ScrollWindowExFlags.SW_ERASE));
			Rectangle inv = rows;
			inv.Y = distance < 0 ? rows.Bottom + distance : y;
			inv.Height = Math.Abs(distance);
			control.Invalidate(inv);
			return true;
		}
		public static bool ScrollHorizontal(Control control, Rectangle maxBounds, int x, int distance) {
			if(distance == 0 || control == null || !control.IsHandleCreated) return false;
			Rectangle rows = maxBounds;
			x = Math.Max(rows.X, x);
			if(distance < 0) {
				if(x + distance < rows.X) distance = (rows.X - x);
			}
			else {
				if(distance >= rows.Width) distance = rows.Width;
			}
			RECT scrollRect = new RECT();
			scrollRect.Left = x;
			scrollRect.Right = rows.Right - (distance > 0 ? distance : 0); 
			scrollRect.Top = rows.Y;
			scrollRect.Bottom = rows.Bottom; 
			RECT clip = new RECT();
			clip.Left = maxBounds.Left;
			clip.Right = maxBounds.Right;
			clip.Top = maxBounds.Top;
			clip.Bottom = maxBounds.Bottom;
			ScrollWindowEx(control.Handle, distance, 0, ref scrollRect, ref clip, IntPtr.Zero, IntPtr.Zero, (int)(ScrollWindowExFlags.SW_INVALIDATE | ScrollWindowExFlags.SW_ERASE));
			Rectangle inv = rows;
			inv.X = distance < 0 ? rows.Right + distance : x;
			inv.Height = Math.Abs(distance);
			control.Invalidate(inv);
			return true;
		}
		public static void Repaint(Control control) {
			if(control == null || !control.IsHandleCreated) return;
		}
	}
}
namespace DevExpress.Utils.NonclientArea {
	public class NCMessages {
		public const int WM_NCCALCSIZE = 0x0083;
		public const int WM_NCHITTEST = 0x0084;
		public const int WM_NCPAINT = 0x0085;
		public const int WM_NCMOUSEMOVE = 0x00A0;
		public const int WM_NCLBUTTONDOWN = 0x00A1;
		public const int WM_NCLBUTTONUP = 0x00A2;
		public const int WM_NCLBUTTONDBLCLK = 0x00A3;
		public const int WM_NCMOUSELEAVE = 0x02A2;
	}
	public class CMessages {
		public const int WM_MOUSEMOVE = 0x0200;
		public const int WM_LBUTTONDOWN = 0x0201;
		public const int WM_LBUTTONUP = 0x0202;
		public const int WM_LBUTTONDBLCLK = 0x0203;
		public const int WM_RBUTTONDOWN = 0x0204;
		public const int WM_RBUTTONUP = 0x0205;
		public const int WM_RBUTTONDBLCLK = 0x0206;
		public const int WM_MBUTTONDOWN = 0x0207;
		public const int WM_MBUTTONUP = 0x0208;
		public const int WM_MBUTTONDBLCLK = 0x0209;
		public const int WM_MOUSEHOVER = 0x02A1;
		public const int WM_MOUSELEAVE = 0x02A3;
		public static bool IsMouseMessage(int msg){
			switch(msg){
				case(CMessages.WM_MOUSEMOVE): 
				case(CMessages.WM_LBUTTONDOWN): 
				case(CMessages.WM_LBUTTONUP): 
				case(CMessages.WM_LBUTTONDBLCLK): 
				case(CMessages.WM_RBUTTONDOWN): 
				case(CMessages.WM_RBUTTONUP): 
				case(CMessages.WM_RBUTTONDBLCLK): 
				case(CMessages.WM_MBUTTONDOWN): 
				case(CMessages.WM_MBUTTONUP): 
				case(CMessages.WM_MBUTTONDBLCLK): 
				case (CMessages.WM_MOUSEHOVER): 
				case (CMessages.WM_MOUSELEAVE): 
					return true;
			}
			return false;
		} 
	}
}
