#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{                                                                   }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;
using DevExpress.Skins;
using System.Collections;
using DevExpress.Utils;
using DevExpress.Utils.Controls;
namespace DevExpress.Skins {
	public class RibbonSkins {
		public static string
			SkinSupportGlassTabHeader = "SupportGlassTabHeader",
			SkinSupportTransparentPages = "SupportTransparentPages",
			SkinDrawCategoryBackground = "DrawCategoryBackground",
			SkinTabHeaderBackground = "TabHeaderBackground",
			SkinTabHeaderBackground2010 = "TabHeaderBackground2010",
			SkinTabHeaderBackgroundCaption = "TabHeaderBackgroundCaption",
			SkinTabHeaderPage = "TabHeaderPage",
			SkinApplicationTabHeaderPage = "ApplicationTabHeaderPage",
			SkinPageSeparator = "PageSeparator",
			SkinSeparator = "Separator",
			SkinTabPanel = "TabPanel",
			SkinTabPanelGroupMinimized = "TabPanelGroupMinimized",
			SkinTabPanelGroupMinimizedGlyph = "TabPanelGroupMinimizedGlyph",
			SkinTabPanelGroupBody = "TabPanelGroupBody",
			SkinTabPanelGroupCaption = "TabPanelGroupCaption",
			SkinTabPanelGroupButton = "TabPanelGroupButton",
			SkinLargeButton = "LargeButton",
			SkinLargeSplitButton = "LargeSplitButton",
			SkinLargeSplitButton2 = "LargeSplitButton2",
			SkinButton = "Button",
			SkinSplitButton = "SplitButton",
			SkinSplitButton2 = "SplitButton2",
			SkinButtonArrow = "ButtonArrow",
			SkinButtonGroup = "ButtonGroup",
			SkinButtonGroupButton = "ButtonGroupButton",
			SkinButtonGroupSplitButton = "ButtonGroupSplitButton",
			SkinButtonGroupSplitButton2 = "ButtonGroupSplitButton2",
			SkinButtonGroupSeparator = "ButtonGroupSeparator",
			SkinStatusBarBackground = "StatusBarBackground",
			SkinStatusBarFormBackground = "StatusBarFormBackground",
			SkinStatusBarButton = "StatusBarButton",
			SkinStatusBarSeparator = "StatusBarSeparator",
			SkinQuickToolbarBelowBackground = "QuickToolbarBelowBackground",
			SkinQuickToolbarInCaptionBackground = "QuickToolbarInCaptionBackground",
			SkinQuickToolbarInCaptionBackground2010 = "QuickToolbarInCaptionBackground2010",
			SkinQuickToolbarAboveBackground = "QuickToolbarAboveBackground",
			SkinQuickToolbarAboveBackground2 = "QuickToolbarAboveBackground2",
			SkinQuickToolbarDropDown = "QuickToolbarDropDown",
			SkinQuickToolbarGlyph = "QuickToolbarGlyph",
			SkinQuickToolbarButtonGlyph = "QuickToolbarButtonGlyph";
		public static string
			SkinFormFrameLeft = "FormFrameLeft",
			SkinFormFrameRight = "FormFrameRight",
			SkinFormFrameLeftTop = "FormFrameLeftTop",
			SkinFormFrameRightTop = "FormFrameRightTop",
			SkinFormFrameLeftNoRibbon = "FormFrameLeftNoRibbon",
			SkinFormFrameRightNoRibbon = "FormFrameRightNoRibbon",
			SkinFormFrameBottom = "FormFrameBottom",
			SkinFormFrameBottomWithoutStatusBar = "FormFrameBottomWithoutStatusBar",
			SkinFormCaption = "FormCaption",
			SkinFormCaptionNoRibbon = "FormCaptionNoRibbon",
			SkinFormCaptionMinimized = "FormCaptionMinimized",
			SkinFormApplicationButton = "FormApplicationButton",
			SkinApplicationButton2010 = "ApplicationButton2010",
			SkinApplicationButtonContainerControl = "ApplicationButtonContainerControl";
		public static string
			SkinPopupGalleryImageBackground = "PopupGalleryImageBackground",
			SkinPopupGalleryBackground = "PopupGalleryBackground",
			SkinPopupGalleryPopupButton = "PopupGalleryButton",
			SkinPopupGalleryFilterPanel = "PopupGalleryFilterPanel",
			SkinPopupGalleryGroupCaption = "PopupGalleryGroupCaption",
			SkinPopupGallerySizerPanel = "PopupGallerySizerPanel",
			SkinPopupGalleryItemCaption = "PopupGalleryItemCaption",
			SkinPopupGalleryItemSubCaption = "PopupGalleryItemSubCaption",
			SkinPopupGallerySizerGrips = "PopupGallerySizerGrips",
			SkinPopupGalleryMenuSeparator = "PopupGalleryMenuSeparator",
			SkinGalleryImageBackground = "GalleryImageBackground",
			SkinGalleryPane = "GalleryPane",
			SkinGalleryButton = "GalleryButton",
			SkinGalleryButtonUp = "GalleryButtonUp",
			SkinGalleryButtonDown = "GalleryButtonDown",
			SkinGalleryButtonDropDown = "GalleryButtonDropDown",
			SkinAppMenuBackgroundTop = "AppMenuBackgroundTop",
			SkinAppMenuBackground = "AppMenuBackground",
			SkinAppMenuBackgroundBottom = "AppMenuBackgroundBottom",
			SkinAppMenuItemDescription = "AppMenuItemDescription",
			SkinAppMenuPane = "AppMenuPane",
			SkinBackstageViewControlLeftPane = "BackstageViewControlLeftPane",
			SkinBackstageViewControlButton = "BackstageViewControlButton",
			SkinBackstageViewControlTab = "BackstageViewControlTab",
			SkinBackstageViewSeparator = "BackstageViewSeparator",
			SkinBackstageViewImage = "BackstageViewImage",
			SkinBackstageViewControlTabArrow = "BackstageViewControlTabArrow",
			SkinMacStyleGalleryButtonDropDown = "MacStyleGalleryButtonDropDown",
			SkinMacTabHeaderBackground = "MacTabHeaderBackground",
			SkinMacTabHeaderPage = "MacTabHeaderPage",
			SkinMacContextTabHeaderPage = "MacContextTabHeaderPage";
		public static string
			OptAppMenuFileLabelDescriptionColor = "AppMenuFileLabelDescriptionColor",
			OptIsColoredBackstageView = "IsColoredBackstageView",
			OptBackstageViewIndentBetweenItems = "BackstageViewIndentBetweenItems",
			OptBackstageViewButtonIndent = "BackstageViewButtonIndent",
			OptBackstageViewControlItemGlyphToCaptionIndent = "BackstageViewControlItemGlyphToCaptionIndent",
			OptPageCategoryTextShadowColor = "PageCategoryTextShadowColor",
			OptPageCategoryTextShadowOffset = "PageCategoryTextShadowOffset",
			OptBaseColor = "BaseColor",
			OptApplicationContainerControlTopIndent = "ApplicationContainerControlTopIndent",
			OptIndentBetweenPages = "IndentBetweenPages",
			OptIndentBetweenMacPages = "IndentBetweenMacPages",
			OptIndentBetweenCategoryPages = "IndentBetweenCategoryPages",
			OptApplicationMenuCornerRadius = "ApplicationMenuCornerRadius",
			OptOffice2010ApplicationIconIndent = "Office2010ApplicationIconIndent",
			OptOffice2010ApplicationButtonLeftIndent = "Office2010ApplicationButtonLeftIndent",
			OptOffice2010ApplicationButtonRightIndent = "Office2010ApplicationButtonRightIndent",
			OptTabHeaderLeftXIndent = "LeftXIndent",
			OptTabHeaderRightXIndent = "RightXIndent",
			OptTabHeaderDownGrow = "TabHeaderDownGrow",
			OptIndentBetweenColumns = "IndentBetweenColumns",
			OptIndentBetweenRows = "IndentBetweenRows",
			OptIndentBetweenButtonGroups = "IndentBetweenButtonGroups",
			OptIndentBetweenButtonGroupRows = "IndentBetweenButtonGroupRows",
			OptIndentBetweenStatusBarColumns = "IndentBetweenStatusBarColumns",
			OptIndentBetweenPageGroups = "IndentBetweenPageGroups",
			OptColorButtonDisabled = "ButtonDisabled",
			OptColorEditorBackground = "EditorBackground",
			OptFormCaptionTextColor2 = "ForeColor2",
			OptFormCaptionTextColorDisabled = "ForeColorInactive",
			OptFormApplicationButtonLeftIndent = "FormApplicationButtonLeftIndent",
			OptFormApplicationButtonRightIndent = "FormApplicationButtonRightIndent",
			OptMacStyleGalleryCommandButtonTopIndent = "MacStyleGalleryCommandButtonTopIndent";
		public static string
			SkinKeyTipWindow = "KeyTipWindow";
		public static string
			SkinContextTabCategory = "ContextTabCategory",
			SkinContextTabCategory2 = "ContextTabCategory2",
			SkinContextTabCategorySeparator = "ContextTabCategorySeparator",
			SkinContextTabHeaderPage = "ContextTabHeaderPage",
			SkinContextTabHeaderPageMask = "ContextTabHeaderPageMask",
			SkinContextMacTabHeaderPageMask = "MacContextTabHeaderPageMask",
			SkinContextTabPanel = "ContextTabPanel",
			SkinContextTabPanelBorder = "ContextTabPanelBorder";
		public static string 
			SkinTabPanelRegionRadius = "TabPanelRegionRadius",
			SkinTabPanelBottomIndent = "TabPanelBottomIndent", 
			SkinTabPanelRightIndent = "TabPanelRightIndent",
			SkinTabPanelTopIndent = "TabPanelTopIndent", 
			SkinTabPanelLeftIndent = "TabPanelLeftIndent", 
			SkinTabPanelGroupRegionRadius = "TabPanelGroupRegionRadius",
			SkinTabPanelGroupBottomIndent = "TabPanelGroupBottomIndent", 
			SkinTabPanelGroupRightIndent = "TabPanelGroupRightIndent",
			SkinTabPanelGroupTopIndent = "TabPanelGroupTopIndent", 
			SkinTabPanelGroupLeftIndent = "TabPanelGroupLeftIndent";
		public static string
			SkinLeftScrollButton = "LeftScrollButton",
			SkinRightScrollButton = "RightScrollButton";
		public static string
			SkinForeColorInCaptionQuickAccessToolbar = "ForeColorInCaptionQuickAccessToolbar",
			SkinForeColorInTopQuickAccessToolbar = "ForeColorInTopQuickAccessToolbar",
			SkinForeColorInBottomQuickAccessToolbar = "ForeColorInBottomQuickAccessToolbar",
			SkinForeColorInPageHeader = "ForeColorInPageHeader",
			SkinForeColorDisabledInCaptionQuickAccessToolbar = "ForeColorDisabledInCaptionQuickAccessToolbar",
			SkinForeColorDisabledInTopQuickAccessToolbar = "ForeColorDisabledInTopQuickAccessToolbar",
			SkinForeColorDisabledInBottomQuickAccessToolbar = "ForeColorDisabledInBottomQuickAccessToolbar",
			SkinForeColorDisabledInPageHeader = "ForeColorDisabledInPageHeader";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Ribbon, provider);
		}
	}
	public class PrintingSkins {
		public static string
			SkinBackgroundPreview = "PreviewBackground",
			SkinBorderPage = "PageBorder";
		public static string
			OptForeColor = "ForeColor",
			OptPageVerticalIndent = "PageVerticalIndent",
			OptPageHorizontalIndent = "PageHorizontalIndent";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Printing, provider);
		}
	}
	public class ReportsSkins {
		public static string 
			SkinBandHeaderLevel0 = "BandHeaderLevel0",
			SkinBandHeaderLevel1 = "BandHeaderLevel1",
			SkinBandHeaderLevel2 = "BandHeaderLevel2",
			SkinBandButtonLevel0 = "BandButtonLevel0",
			SkinBandButtonLevel1 = "BandButtonLevel1",
			SkinBandButtonLevel2 = "BandButtonLevel2",
			SkinCornerPanel = "CornerPanel",
			SkinPopupFormCaption = "PopupFormCaption",
			SkinPopupFormBackground = "PopupFormBackground",
			SkinRulerBackground = "RulerBackground",
			SkinSmartTag = "SmartTag",
			SkinRulerShadow = "RulerShadow",
			SkinRulerSelection = "RulerSelection",
			SkinRulerSection = "RulerSection",
			SkinRulerRightMargin = "RulerRightMargin",
			SkinBandButtonSelected = "BandButtonSelected",
			SkinBandHeaderSelected = "BandHeaderSelected",
			SkinSlider = "Slider",
			SkinSliderSelected = "SliderSelected",
			SkinComponentTrayBackground = "ComponentTrayBackground",
			SkinScriptControl = "ScriptControl";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Reports, provider); 
		}
	}
	public class EditorsSkins {
		public static string
			SkinNavigator = "Navigator",
			SkinPopupFormBorder = "PopupFormBorder",
			SkinEditorButton = "EditorButton",
			SkinCalendarNavigationButton = "CalendarNavigationButton",
			SkinCalendarNormalCellColor = "CalendarNormalCellColor",
			SkinCalendarInactiveCellColor = "CalendarInactiveCellColor",
			SkinCalendarTodayCellColor = "CalendarTodayCellColor",
			SkinCalendarSelectedCellColor = "CalendarSelectedCellColor",
			SkinCalendarHolidayCellColor = "CalendarHolidayCellColor",
			SkinComboButton = "ComboButton",
			SkinNavigatorButton = "NavigatorButton",
			SkinCloseButton = "CloseButton",
			SkinCheckBox = "CheckBox",
			SkinRadioButton = "RadioButton",
			SkinSpinDown = "SpinDown",
			SkinSpinUp = "SpinUp",
			SkinSpinLeft = "SpinLeft",
			SkinSpinRight = "SpinRight",
			SkinProgressBorder = "ProgressBorder",
			SkinProgressBorderVert = "ProgressBorderVert",
			SkinProgressChunk = "ProgressChunk",
			SkinProgressChunkVert = "ProgressChunkVert",
			SkinTrackBarTickLine = "TrackBarTickLine",
			SkinTrackBarThumb = "TrackBarThumb",
			SkinTrackBarThumbBoth = "TrackBarThumbBoth",
			SkinTrackBarTrack = "TrackBarTrack",
			SkinRangeTrackBarLeftThumb = "RangeTrackBarLeftThumb",
			SkinRangeTrackBarRightThumb = "RangeTrackBarRightThumb",
			SkinRangeTrackBarThumbBoth = "RangeTrackBarThumbBoth",
			SkinDateEditClockFace = "ClockFace",
			SkinDateEditClockGlass = "ClockGlass",
			SkinZoomTrackBarZoomInButton = "ZoomTrackBarZoomInButton",
			SkinZoomTrackBarZoomOutButton = "ZoomTrackBarZoomOutButton",
			SkinZoomTrackBarMiddleLine = "ZoomTrackBarMiddleLine",
			SkinProgressBarEmptyTextColor = "ProgressBarEmptyTextColor",
			SkinProgressBarFilledTextColor = "ProgressBarFilledTextColor",
			SkinFilterControlGroupOperatorTextColor = "FilterControlGroupOperatorTextColor",
			SkinFilterControlFieldNameTextColor = "FilterControlFieldNameTextColor",
			SkinFilterControlOperatorTextColor = "FilterControlOperatorTextColor",
			SkinFilterControlValueTextColor = "FilterControlValueTextColor",
			SkinFilterControlEmptyValueTextColor = "FilterControlEmptyValueTextColor",
			SkinHyperlinkTextColor = "HyperLinkTextColor",
			SkinCalcEditOperationTextColor = "CalcEditOperationTextColor",
			SkinCalcEditDigitTextColor = "CalcEditDigitTextColor";
		public static string OptIsSingleLineBorder = "IsSingleLineBorder";
		public static Skin GetSkin(ISkinProvider provider) { return SkinManager.Default.GetSkin(SkinProductId.Editors, provider); }
	}
	public class VGridSkins {
		public static string
			SkinGridLine = "GridLine",
			SkinCategory = "Category",
			SkinCategoryButton = "CategoryButton",
			SkinRow = "Row",
			SkinBorder = "Border",
			SkinBandBorder = "BandBorder",
			SkinRowDisabled = "RowDisabled",
			SkinFixedLine = "FixedLine";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.VGrid, provider); 
		}
	}
	public class GridSkins {
		public static string 
			SkinViewCaption = "ViewCaption",
			SkinIndicator = "Indicator",
			SkinBorder = "Border",
			SkinIndicatorImages = "IndicatorImages",
			SkinHeader = "Header",
			SkinHeaderSpecial = "HeaderSpecial",
			SkinHeaderLeft = "HeaderLeft",
			SkinHeaderRight = "HeaderRight",
			SkinFooterPanel = "FooterPanel",
			SkinFooterCell = "FooterCell",
			SkinPlusMinus = "PlusMinus",
			SkinPlusMinusEx = "PlusMinusEx",
			SkinSortShape = "SortShape",
			SkinSmartFilterButton = "SmartFilterButton",
			SkinFieldHeaderButton = "FieldHeaderButton",
			SkinFilterButton = "FilterButton",
			SkinFilterButtonActive = "FilterButtonActive",
			SkinGridGroupPanel = "GridGroupPanel",
			SkinGridFilterPanel = "GridFilterPanel",
			SkinGridSpecialRowIndent = "GridSpecialRowIndent",
			SkinGridPreview = "GridPreview",
			SkinGridTopNewRow = "GridTopNewRow",
			SkinGridOddRow = "GridOddRow",
			SkinGridEvenRow = "GridEvenRow",
			SkinGridRow = "GridRow",
			SkinGridLine = "GridLine",
			SkinGridFixedLine = "GridFixedLine",
			SkinGridGroupRow = "GroupRow",
			SkinGridEmptyArea = "GridEmptyArea",
			SkinCardEmptyArea = "CardEmptyArea",
			SkinCardCaption = "CardCaption",
			SkinCard = "Card",
			SkinCardCaptionSelected = "CardCaptionSelected",
			SkinCardSeparator = "CardSeparator",
			SkinCardSelected = "CardSelected",
			SkinCardOpenButton = "CardOpenButton",
			SkinCardCloseButton = "CardCloseButton";
		public static string
			OptCardCaptionExpandButtonIndent = "CardCaptionExpandButtonIndent",
			OptHeaderRequireHorzOffset = "HeaderRequireHorzOffset",
			OptHeaderRequireVertOffset = "HeaderRequireVertOffset",
			OptBorderIndent = "BorderIndent",
			OptFilterButtonOffsetX = "OffsetX",
			OptFilterButtonOffsetY = "OffsetY",
			OptColorCardFocusedFieldForeColor = "CardFocusedFieldForeColor",
			OptColorCardFocusedFieldBackColor = "CardFocusedFieldBackColor",
			OptColorLayoutCardFocusedFieldForeColor = "LayoutCardFocusedFieldForeColor",
			OptColorLayoutCardFocusedFieldBackColor = "LayoutCardFocusedFieldBackColor",
			OptShowTreeLine = "ShowTreeLine",
			OptFindPanelBorder = "FindPanelBorder";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Grid, provider); 
		}
	}
	public class NavBarSkins {
		public static string 
			SkinGroupOpenButton = "GroupOpenButton",
			SkinGroupCloseButton= "GroupCloseButton",
			SkinItem = "Item",
			SkinBackground = "Background",
			SkinGroupHeader = "GroupHeader",
			SkinGroupFooter = "GroupFooter",
			SkinGroupClient = "GroupClient",
			SkinScrollUp = "ScrollUpButton",
			SkinScrollDown="ScrollDownButton",
			SkinGroupClientLinksStrip = "GroupClientLinksStrip";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.NavBar, provider); 
		}
	}
	public class NavPaneSkins {
		public static string 
			SkinCaption = "Caption",
			SkinItem = "Item",
			SkinItemSelected = "ItemSelected",
			SkinExpandButton = "ExpandButton",
			SkinCollapseButton = "CollapseButton",
			SkinCollapsedGroupClient = "CollapsedGroupClient",
			SkinCollapsedGroupClientWithBorder = "CollapsedGroupClientWithBorder",
			SkinNavPaneFormBorder = "NavPaneFormBorder",
			SkinNavPaneFormSizeGrip = "NavPaneFormSizeGrip",
			SkinNavPaneFormLeftSizeGrip = "NavPaneFormLeftSizeGrip",
			SkinGroupButton = "GroupButton",
			SkinGroupButtonSelected = "GroupButtonSelected",
			SkinGroupClient = "GroupClient",
			SkinGroupClientWithBorder = "GroupClientWithBorder",
			SkinOverflowPanel = "OverflowPanel",
			SkinOverflowPanelItem = "OverflowPanelItem",
			SkinOverflowPanelExpandItem = "OverflowPanelExpandItem",
			SkinSplitter = "Splitter",
			SkinScrollUp = "ScrollUpButton",
			SkinScrollDown="ScrollDownButton";
		public static string 
			OptGroupRequireOffset = "GroupRequireOffset",
			OptGroupClientTopIndent = "GroupClientTopIndent",
			OptFontSize = "FontSize";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.NavPane, provider); 
		}
	}
	public class DockingSkins {
		public static string
			SkinTabHeaderBackground = "TabHeaderBackground",
			SkinTabHeader = "TabHeader",
			SkinTabHeaderHideBar = "TabHeaderHideBar",
			SkinTabHeaderLine = "TabHeaderLine",
			SkinHideBar = "HideBar",
			SkinHideBarBottom = "HideBarBottom",
			SkinHideBarLeft = "HideBarLeft",
			SkinHideBarRight = "HideBarRight",
			SkinDockWindowButton = "DockWindowButton",
			SkinDockWindow = "DockWindowCaption",
			SkinDockWindowBorder = "DockWindowBorder",
			SkinFloatingWindow = "FloatingWindowCaption",
			SkinFloatingWindowBorder = "FloatingWindowBorder",
			SkinUnFocusCaptionColor = "UnFocusCaptionColor",
			SkinNativeMdiViewBackground = "NativeMdiViewBackground",
			SkinDocumentGroupTabHeader = "DocumentGroupTabHeader",
			SkinDocumentGroupTabPane = "DocumentGroupTabPane",
			SkinDocumentGroupTabHeaderButton = "DocumentGroupTabHeaderButton",
			SkinDocumentGroupTabPageButton = "DocumentGroupTabPageButton",
			SkinDocumentSelector = "DocumentSelector",
			SkinDocumentSelectorHeader = "DocumentSelectorHeader",
			SkinFloatDocument = "FloatDocumentCaption",
			SkinFloatDocumentBorder = "FloatDocumentBorder";
		public static string
			TabHeaderLineHGrow = "TabHeaderLineHGrow",
			DocumentGroupHeaderTextColor = "DocumentGroupHeaderTextColor",
			DocumentGroupHeaderTextColorActive = "DocumentGroupHeaderTextColorActive",
			DocumentGroupHeaderTextColorHot = "DocumentGroupHeaderTextColorHot",
			DocumentGroupHeaderTextColorDisabled = "DocumentGroupHeaderTextColorDisabled",
			DocumentGroupRootMargin = "DocumentGroupRootMargin";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Docking, provider); 
		}
	}
	public class TabSkinProperties {
		public static string 
			TabHeaderTextColor = "TabHeaderTextColor",
			TabHeaderTextColorActive = "TabHeaderTextColorActive", 
			TabHeaderTextColorHot = "TabHeaderTextColorHot", 
			TabHeaderTextColorDisabled = "TabHeaderTextColorDisabled",
			TabHeaderButtonTextColor="TabHeaderButtonTextColor",
			TabHeaderButtonTextColorHot = "TabHeaderButtonTextColorHot",
			SelectedHeaderUpGrow = "SelectedHeaderUpGrow",
			SelectedHeaderHGrow = "SelectedHeaderHGrow",
			SelectedHeaderDownGrow = "SelectedHeaderDownGrow",
			SelectedHeaderDownGrowBottomRight = "SelectedHeaderDownGrowBottomRight",
			UpperHeaderDownGrow = "UpperHeaderDownGrow",
			UpperHeaderDownGrowBottomRight = "UpperHeaderDownGrowBottomRight",
			HeaderDownGrow = "HeaderDownGrow",
			HeaderDownGrowBottomRight = "HeaderDownGrowBottomRight",
			RowIndentNear = "RowIndentNear",
			RowIndentFar = "RowIndentFar",
			LeftContentIndent = "LeftContentIndent",
			BottomContentIndent = "BottomContentIndent",
			RightContentIndent = "RightContentIndent";
	}
	public class BarSkins {
		public static string
			SkinDock = "Dock",
			SkinBar = "Bar",
			SkinBarVertical = "BarVertical",
			SkinBarCustomize = "BarCustomize",
			SkinMainMenuCustomize = "MainMenuCustomize",
			SkinMainMenuDrag = "MainMenuDrag",
			SkinBarCustomizeVertical = "BarCustomizeVertical",
			SkinBarDrag = "BarDrag",
			SkinBarDragVertical = "BarDragVertical",
			SkinBarSeparator = "BarSeparator",
			SkinBarVerticalSeparator = "BarVerticalSeparator",
			SkinPopupMenu = "PopupMenu",
			SkinPopupMenuSeparator = "PopupMenuSeparator",
			SkinPopupMenuSideStrip = "PopupMenuSideStrip",
			SkinPopupMenuSideStripNonRecent = "PopupMenuSideStripNonRecent",
			SkinPopupMenuLinkSelected = "PopupMenuLinkSelected",
			SkinPopupMenuSplitButton = "PopupMenuSplitButton",
			SkinPopupMenuSplitButton2 = "PopupMenuSplitButton2",
			SkinPopupMenuCheck = "PopupMenuCheck",
			SkinPopupMenuExpandButton = "PopupMenuExpandButton",
			SkinLinkBorderPainter = "LinkBorderPainter",
			SkinMainMenu = "MainMenu",
			SkinMainMenuVertical = "MainMenuVertical",
			SkinFloatingBar = "FloatingBar",
			SkinStatusBar = "StatusBar",
			SkinLinkSelected = "LinkSelected",
			SkinMainMenuLinkSelected = "MainMenuLinkSelected",
			SkinDockWindowButtonsHot = "DockWindowButtonsHot",
			SkinDockWindowButtonsPressed = "DockWindowButtonsPressed",
			SkinDockWindowButtonsSelected = "DockWindowButtonsSelected",
			SkinDockWindowButtons = "DockWindowButtons",
			SkinAlertBarItem = "AlertBarItem",
			SkinAlertCaptionTop = "AlertCaptionTop",
			SkinAlertWindow = "AlertWindow",
			SkinAlertWindowCornerRadius = "CornerRadius",
			SkinCloseButtonGlyph = "CloseButtonGlyph",
			SkinRestoreButtonGlyph = "RestoreButtonGlyph",
			SkinMinimizeButtonGlyph = "MinimizeButtonGlyph",
			SkinCollapseButtonGlyph = "CollapseButtonGlyph",
			SkinExpandButtonGlyph = "ExpandButtonGlyph";
			public static string 
			SkinBarDockedRowIndent = "BarDockedRowIndent",
			SkinBarDockedRowBarIndent = "BarDockedRowBarIndent";
		public static string
			OptFloatingBarTitleLeftIndent = "TitleLeftIndent",
			OptFloatingBarTitleRightIndent = "TitleRightIndent",
			OptFloatingBarTitleTopIndent = "TitleTopIndent",
			OptFloatingBarTitleBottomIndent = "TitleBottomIndent";
		public static string 
			ColorLinkDisabledForeColor = "ColorLinkDisabledForeColor";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Bars, provider); 
		}
	}
	public class TabSkins {
		public static string 
			SkinTabPane = "TabPane",
			SkinTabHeader = "TabHeader",
			SkinTabHeaderLine = "TabHeaderLine",
			SkinTabPageButton = "TabPageButton",
			SkinTabHeaderButton = "TabHeaderButton";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Tab, provider); 
		}
	}
	public class SchedulerSkins {
		public static string
			SkinHeader = "Header",
			SkinHeaderVertical = "HeaderVertical",
			SkinHeaderSelected = "HeaderSelected",
			SkinHeaderAlternate = "HeaderAlternate",
			SkinHeaderAlternateSelected = "HeaderAlternateSelected",
			SkinHeaderResource = "HeaderResource",
			SkinHeaderResourceVertical = "HeaderResourceVertical",
			SkinDefaultTimeLine = "DefaultTimeLine",
			SkinRulerHeader = "RulerHeader",
			SkinRuler = "Ruler",
			SkinRulerHourLine = "RulerHourLine",
			SkinRulerMinLine = "RulerMinLine",
			SkinGroupSeparatorVertical = "GroupSeparatorVertical",
			SkinGroupSeparatorHorizontal = "GroupSeparatorHorizontal",
			SkinAllDayArea = "AllDayArea",
			SkinAllDayAreaSelected = "AllDayAreaSelected",
			SkinAppointmentBorder = "AppointmentBorder",
			SkinAppointment = "Appointment",
			SkinCurrentTimeIndicator = "CurrentTimeIndicator",
			SkinBorder = "Border",
			SkinMoreButton = "MoreButton",
			SkinUpperLeftCorner = "UpperLeftCorner",
			SkinCellBorder = "CellBorder",
			SkinAppointmentLeftBorder = "AppointmentLeftBorder",
			SkinAppointmentRightBorder = "AppointmentRightBorder",
			SkinAppointmentNoLeftBorder = "AppointmentNoLeftBorder",
			SkinAppointmentNoRightBorder = "AppointmentNoRightBorder",
			SkinAppointmentContent = "AppointmentContent",
			SkinAppointmentSameDayContent = "AppointmentSameDayContent",
			SkinAppointmentSameDayLeftBorder = "AppointmentSameDayLeftBorder",
			SkinAppointmentSameDayRightBorder = "AppointmentSameDayRightBorder",
			SkinAppointmentSameDayNoLeftBorder = "AppointmentSameDayNoLeftBorder",
			SkinAppointmentSameDayNoRightBorder = "AppointmentSameDayNoRightBorder",
			SkinAppointmentStatusTopMask = "AppointmentStatusTopMask",
			SkinAppointmentStatusLeftMask = "AppointmentStatusLeftMask",
			SkinAppointmentRightShadow = "AppointmentRightShadow",
			SkinAppointmentBottomShadow = "AppointmentBottomShadow",
			SkinNavigationButtonPrev = "NavButtonPrev",
			SkinNavigationButtonNext = "NavButtonNext",
			SkinNavigationButtonPrevArrow = "NavButtonPrevArrow",
			SkinNavigationButtonNextArrow = "NavButtonNextArrow";
		public static string
			OptHeaderRequireHorzOffset = "HeaderRequireHorzOffset",
			OptHeaderRequireVertOffset = "HeaderRequireVertOffset",
			OptPaintResourceHeaderWithResourceColor = "PaintResourceHeaderWithResourceColor",
			OptPaintHotTrackedWithResourceColor = "PaintHotTrackedWithResourceColor",
			OptAppointmentVerticalStatusLineWidth = "AppointmentStatusLineWidth",
			OptAppointmentHorizontalStatusLineHeight = "AppointmentStatusLineHeight",
			OptDayViewAppointmentLeftPadding = "DayViewAppointmentLeftPadding",
			OptMonthViewCellHeaderForeColor = "MonthViewCellHeaderForeColor",
			OptMonthViewSelectedCellHeaderForeColor = "MonthViewSelectedCellHeaderForeColor";
		public static string
			PropBaseColor = "BaseColor",
			PropAlternateColor = "AlternateColor",
			PropContentVerticalGap = "ContentVerticalGap";
	   public static string
			ColorRatioCell = "ColorRatioCell",
			ColorRatioCellBorder = "ColorRatioCellBorder",
			ColorRatioCellBorderDark = "ColorRatioCellBorderDark",
			ColorRatioCellLight = "ColorRatioCellLight",
			ColorRatioCellLightBorder = "ColorRatioCellLightBorder",
			ColorRatioCellLightBorderDark = "ColorRatioCellLightBorderDark",
			ColorResource01 = "ResourceColor01",
			ColorResource02 = "ResourceColor02",
			ColorResource03 = "ResourceColor03",
			ColorResource04 = "ResourceColor04",
			ColorResource05 = "ResourceColor05",
			ColorResource06 = "ResourceColor06",
			ColorResource07 = "ResourceColor07",
			ColorResource08 = "ResourceColor08",
			ColorResource09 = "ResourceColor09",
			ColorResource10 = "ResourceColor10",
			ColorResource11 = "ResourceColor11",
			ColorResource12 = "ResourceColor12";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Scheduler, provider);
		}
	}
	public class RichEditSkins {
		public static string
			SkinRulerTabTypeBackground = "RulerTabTypeBackground",
			SkinRulerTab = "RulerTab",
			SkinRulerIndent = "RulerIndent",
			SkinRulerIndentBottom = "RulerIndentBottom",
			SkinRulerColumnResizer = "RulerColumnResizer",
			SkinRulerDefaultTabColor = "RulerDefaultTabColor",
			SkinHorizontalRulerBackground = "HorizontalRulerBackground",
			SkinVerticalRulerBackground = "VerticalRulerBackground",
			SkinHorizontalCornerPanel = "CornerPanel";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.RichEdit, provider);
		}
	}
	public class GaugesSkins {
		public static string SkinBackground = "Background";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Gauges, provider);
		}
	}
	public class ChartSkins {
		public static string
			SkinBackground = "Background",
			SkinLegend = "Legend",
			SkinXYDiagram = "XYDiagram",
			SkinXYDiagramInterlaced = "XYDiagramInterlaced",
			SkinRadarDiagram = "RadarDiagram",
			SkinRadarDiagramInterlaced = "RadarDiagramInterlaced",
			SkinXYDiagram3D = "XYDiagram3D",
			SkinXYDiagram3DInterlaced = "XYDiagram3DInterlaced",
			SkinStrip = "Strip",
			SkinTextAnnotation = "TextAnnotation",
			SkinImageAnnotation = "ImageAnnotation",
			SkinBar = "Bar",
			SkinArea = "Area",
			SkinPie = "Pie",
			SkinFunnel = "Funnel",
			SkinBar3D = "Bar3D",
			SkinPie3D = "Pie3D",
			SkinMarker = "Marker",
			SkinSeriesLabel2D = "SeriesLabel2D",
			SkinSeriesLabel3D = "SeriesLabel3D",
			SkinScrollBar = "ScrollBar";
	   public static string
			ColorChartTitle = "ColorChartTitle",
			ColorAxis = "ColorAxis",
			ColorAxisLabel = "ColorAxisLabel",
			ColorGridLines = "ColorGridLines",
			ColorMinorGridLines = "ColorMinorGridLines",
			ColorAxisTitle = "ColorAxisTitle",
			ColorConstantLine = "ColorConstantLine",
			ColorConstantLineTitle = "ColorConstantLineTitle",
			ColorLine3DMarker = "ColorLine3DMarker",
			ColorArea3DMarker = "ColorArea3DMarker",
			ColorSeriesLabelConnector = "ColorSeriesLabelConnector";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Chart, provider);
		}
	}
	public class CommonSkins {
		public static string
			SkinLabel = "Label",
			SkinLabelLine = "LabelLine",
			SkinLabelLineVert = "LabelLineVert",
			SkinSplitter = "Splitter",
			SkinSplitterHorz = "SplitterHorz",
			SkinButton = "Button",
			SkinTextBorder = "TextBorder",
			SkinSizeGrip = "SizeGrip",
			SkinScrollButton = "ScrollButton",
			SkinScrollButtonThumb = "ScrollThumbButton",
			SkinScrollButtonThumbVert = "ScrollThumbButtonVert",
			SkinScrollShaft = "ScrollShaft",
			SkinScrollShaftVert = "ScrollShaftVert",
			SkinGroupPanel = "GroupPanel",
			SkinGroupPanelNoBorder = "GroupPanelNoBorder",
			SkinGroupPanelTop = "GroupPanelTop",
			SkinGroupPanelCaptionTop = "GroupPanelCaptionTop",
			SkinGroupPanelBottom = "GroupPanelBottom",
			SkinGroupPanelCaptionBottom = "GroupPanelCaptionBottom",
			SkinGroupPanelRight = "GroupPanelRight",
			SkinGroupPanelCaptionRight = "GroupPanelCaptionRight",
			SkinGroupPanelLeft = "GroupPanelLeft",
			SkinGroupPanelCaptionLeft = "GroupPanelCaptionLeft",
			SkinGroupPanelExpandButton = "GroupExpandButton",
			SkinLayoutItemBackground = "LayoutItemBackground",
			SkinLayoutGroupWithoutBordersPadding = "LayoutGroupWithoutBordersPadding",
			SkinLayoutGroupWithoutBordersSpacing = "LayoutGroupWithoutBordersSpacing",
			SkinLayoutRootGroupPadding = "LayoutRootGroupPadding",
			SkinLayoutRootGroupSpacing = "LayoutRootGroupSpacing",
			SkinLayoutRootGroupWithoutBordersPadding = "LayoutRootGroupWithoutBordersPadding",
			SkinLayoutRootGroupWithoutBordersSpacing = "LayoutRootGroupWithoutBordersSpacing",
			SkinLayoutItemPadding = "LayoutItemPadding",
			SkinLayoutGroupPadding = "LayoutGroupPadding",
			SkinLayoutTabbedGroupPadding = "LayoutTabbedGroupPadding",
			SkinLayoutItemSpacing = "LayoutItemSpacing",
			SkinLayoutGroupSpacing = "LayoutGroupSpacing",
			SkinLayoutTabbedGroupSpacing = "LayoutTabbedGroupSpacing",
			SkinLayoutItemTextToControlDistance = "LayoutItemTextToControlDistance",
			SkinLayoutItemBackgroundSpacingProperty = "Spacing",
			SkinToolTipWindow = "ToolTipWindow",
			SkinToolTipWindowCornerRadius = "CornerRadius",
			SkinToolTipSeparator = "ToolTipSeparator",
			SkinToolTipItem = "ToolTipItem",
			SkinToolTipTitleItem = "ToolTipTitleItem",
			SkinForm = "Form",
			SkinDropDownButton1 = "DropDownButton1",
			SkinDropDownButton2 = "DropDownButton2",
			SkinHighlightedItem = "HighlightedItem",
			SkinBackButton = "BackButton",
			SkinDropArrows = "DropArrows",
			SkinSelection = "Selection",
			SkinSelectionOpacity = "SelectionOpacity",
			SkinInformationColor = "Information",
			SkinWarningColor = "Warning",
			SkinCriticalColor = "Critical",
			SkinQuestionColor = "Question",
			SkinHighlightAlternateColor = "HighlightAlternate";
		public static string OptScrollButtonCorner = "CornerSize";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Common, provider); 
		}
	}
	public class FormSkins {
		public static string 
			SkinFormFrameLeft = "FormFrameLeft",
			SkinFormFrameRight = "FormFrameRight",
			SkinFormFrameBottom = "FormFrameBottom",
			SkinFormCaption = "FormCaption",
			SkinFormCaptionMinimized = "FormCaptionMinimized",
			SkinFormMdiBar = "FormMdiBar",
			SkinFormButtonMdiClose = "FormButtonMdiClose",
			SkinFormButtonMdiRestore = "FormButtonMdiRestore",
			SkinFormButtonMdiMinimize = "FormButtonMdiMinimize",
			SkinFormButtonClose = "FormButtonClose",
			SkinFormButtonMinimize = "FormButtonMinimize",
			SkinFormButtonMaximize = "FormButtonMaximize",
			SkinFormButtonHelp = "FormButtonHelp",
			SkinFormButtonRestore = "FormButtonRestore";
		public static string 
			OptInactiveColor = "InactiveColor",
			OptTextShadowColor = "TextShadowColor";
		public static Skin GetSkin(ISkinProvider provider) {
			return SkinManager.Default.GetSkin(SkinProductId.Form, provider); 
		}
	}
	public class CommonColors {
		static KnownColor[] Colors = new KnownColor[] {
			KnownColor.Control, KnownColor.ControlText, KnownColor.ControlDark, KnownColor.GrayText, 
			KnownColor.Window, KnownColor.WindowText, KnownColor.Highlight, KnownColor.HighlightText, 
			KnownColor.Info, KnownColor.InfoText, KnownColor.Menu, KnownColor.MenuText, KnownColor.InactiveCaption, KnownColor.InactiveCaptionText,
			KnownColor.ControlLight 
		};
		public static string[] GetSystemColorNames() {
			return new string[] { Control, ControlText,  DisabledControl, DisabledText, 
									Window, WindowText, Highlight, HighligthText, 
									Info, InfoText, Menu, MenuText, HideSelection, HighligthText, ReadOnly
								};
		}
		static Hashtable colorMapTable = null;
		protected static Hashtable ColorMapTable {
			get {
				if(colorMapTable == null) {
					string[] systemNames = GetSystemColorNames();
					colorMapTable = new Hashtable();
					for(int n = 0; n < Colors.Length; n++) {
						colorMapTable[Colors[n]] = systemNames[n];
					}
				}
				return colorMapTable;
			}
		}
		public static Color GetSystemColor(string name) {
			int index = Array.IndexOf(GetSystemColorNames(), name);
			if(index == -1) return Color.Empty;
			return Color.FromKnownColor(Colors[index]);
		}
		public static string GetSystemColorName(KnownColor color, bool alwaysReturnColor) {
			object res = ColorMapTable[color];
			if(res == null) return alwaysReturnColor ? Control : null;
			return (string)res;
		}
		public static string GetSystemColorName(KnownColor color) {
			return GetSystemColorName(color, true);
		}
		public static bool IsSystemColor(Color color) {
			if(!color.IsKnownColor) return false;
			return ColorMapTable.Contains(color.ToKnownColor());
		}
		public static Color GetInformationColor(ISkinProvider skinProvider) { 
			Color ret = GetCommonPredefinedColor(skinProvider, CommonSkins.SkinInformationColor);
			return ret == Color.Empty ? Color.Green : ret;
		}
		public static Color GetWarningColor(ISkinProvider skinProvider) {
			Color ret = GetCommonPredefinedColor(skinProvider, CommonSkins.SkinWarningColor);
			return ret == Color.Empty ? Color.Yellow : ret;
		}
		public static Color GetCriticalColor(ISkinProvider skinProvider) {
			Color ret = GetCommonPredefinedColor(skinProvider, CommonSkins.SkinCriticalColor);
			return ret == Color.Empty ? Color.Red : ret;
		}
		public static Color GetQuestionColor(ISkinProvider skinProvider) {
			Color ret = GetCommonPredefinedColor(skinProvider, CommonSkins.SkinQuestionColor);
			return ret == Color.Empty ? Color.Blue : ret;
		}
		static Color GetCommonPredefinedColor(ISkinProvider skinProvider, object colorName) {
			Skin skin = CommonSkins.GetSkin(skinProvider);
			Color ret = skin.Colors.GetColor(colorName);
			return ret;
		}
		public static string 
			ReadOnly = "ReadOnly",
			Control = "Control", 
			ControlText = "ControlText", 
			DisabledControl = "DisabledControl", 
			DisabledText = "DisabledText",
			Window = "Window",
			WindowText = "WindowText",
			Highlight = "Highlight",
			HighligthText = "HighlightText",
			Info = "Info",
			InfoText = "InfoText",
			Menu = "Menu",
			MenuText = "MenuText",
			HideSelection = "HideSelection",
			HighlightSearch = "HighlightSearch",
			HighlightSearchText = "HighlightSearchText";
	}
	public class CommonSkinsRegistration { 
	}
	public enum SkinIconsSize { Small, Large }
	public static class SkinCollectionHelper {
		[ThreadStatic]
		static ImageCollection skinIconsSmall = null;
		[ThreadStatic]
		static ImageCollection skinIconsLarge = null;
		public static string[] StandardSkins = new string[] { 
			"DevExpress Style",
			"Caramel",
			"Money Twins",
			"DevExpress Dark Style",
			"iMaginary",
			"Lilian",
			"Black",
			"Blue"
		};
		public static string[] BonusSkins = new string[] { 
			"Seven",
			"Seven Classic",
			"Darkroom",
			"McSkin",
			"Sharp",
			"Sharp Plus",
			"Foggy",
			"Dark Side",
			"Xmas 2008 Blue",
			"Springtime",
			"Summer 2008",
			"Pumpkin",
			"Valentine",
			"Stardust",
			"Coffee",
			"Glass Oceans",
			"High Contrast",
			"Liquid Sky",
			"London Liquid Sky",
			"The Asphalt World",
			"Blueprint",
			"Whiteprint",
			"VS2010"
		};
		public static string[] OfficeSkins = new string[] { 
			"Office 2010 Blue",
			"Office 2010 Black",
			"Office 2010 Silver",
			"Office 2007 Blue",
			"Office 2007 Black",
			"Office 2007 Silver",
			"Office 2007 Green",
			"Office 2007 Pink"
		};
		static ArrayList skinIconNames = null;
		static ArrayList SkinIconNames {
			get {
				if(skinIconNames == null) {
					skinIconNames = new ArrayList();
					skinIconNames.Add(string.Empty);
					skinIconNames.AddRange(StandardSkins);
					skinIconNames.AddRange(OfficeSkins);
					skinIconNames.AddRange(BonusSkins);
				}
				return skinIconNames;
			}
		}
		private static bool ContainsName(string[] skins, string name) {
			foreach(string s in skins) {
				if(s == name)
					return true;
			}
			return false;
		}
		public static bool IsBonusSkin(string name) {
			return ContainsName(BonusSkins, name);
		}
		public static bool IsOfficeSkin(string name) {
			return ContainsName(OfficeSkins, name);
		}
		public static bool IsStandardSkins(string name) {
			return ContainsName(StandardSkins, name);
		}
		public static ImageCollection SkinIconsSmall {
			get {
				if(skinIconsSmall == null)
					skinIconsSmall = ImageHelper.CreateImageCollectionFromResources("DevExpress.Utils.Skins.Skins_Icons_16x16.png", typeof(SkinCollectionHelper).Assembly, new Size(16, 16), Color.Empty);
				return skinIconsSmall;
			}
		}
		public static ImageCollection SkinIconsLarge {
			get {
				if(skinIconsLarge == null)
					skinIconsLarge = ImageHelper.CreateImageCollectionFromResources("DevExpress.Utils.Skins.Skins_Icons_48x48.png", typeof(SkinCollectionHelper).Assembly, new Size(48, 48), Color.Empty);
				return skinIconsLarge;
			}
		}
		public static int GetSkinIndexByName(string name) {
			for(int i = 0; i < SkinIconNames.Count; i++)
				if(SkinIconNames[i].Equals(name)) return i;
			return 0;
		}
		public static Image GetSkinIcon(string name, SkinIconsSize size) {
			int index = GetSkinIndexByName(name);
			if(index >= SkinIconsSmall.Images.Count) index = 0;
			return (size == SkinIconsSize.Small) ? SkinIconsSmall.Images[index] : SkinIconsLarge.Images[index];
		}
	}
}
