#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{                                                                   }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Windows.Forms;
using DevExpress.Utils.Design;
using DevExpress.XtraEditors;
using DevExpress.XtraEditors.Controls;
namespace DevExpress.Utils.Frames {
	[ToolboxItem(false)] 
	public class XtraFrame : XtraUserControl {
		private object editingObject;
		private object infoObject;
		private bool drawGradientHeader = true;
		private Color headerGradientFirstColor = Color.FromArgb(200, 191, 173);
		private Color headerGradientSecondColor = Color.FromArgb(170, 156, 128);
		private bool havepg = false;
		public Label lbCaption;
		public PanelControl pnlMain;
		private int id;
		protected DevExpress.XtraEditors.PanelControl horzSplitter;
		DesignerItem designerItem = null;
		NotePanelEx pnlDescription = null;
		static ImageCollection designerImages16 = null;
		static ImageCollection designerImages12 = null;
		public event RefreshWizardEventHandler RefreshWizard;
		public event MouseEventHandler ShowMenu;
		public const int DesignerImages16AddIndex = 0;
		public const int DesignerImages16InsertIndex = 1;
		public const int DesignerImages16RemoveIndex = 2;
		public const int DesignerImages16RetrieveIndex = 3;
		public const int DesignerImages16LoadIndex = 4;
		public const int DesignerImages16SaveIndex = 5;
		public const int DesignerImages16PlusIndex = 6;
		public const int DesignerImages16MinusIndex = 7;
		public const int DesignerImages16ResetIndex = 8;
		public const int DesignerImages16ApplyIndex = 9;
		public const int DesignerImages16LeftIndex = 10;
		public const int DesignerImages16RightIndex = 11;
		public const int DesignerImages16UpIndex = 12;
		public const int DesignerImages16DownIndex = 13;
		public static ImageCollection DesignerImages16 {
			get {
				if(designerImages16 == null)
					designerImages16 = DevExpress.Utils.Controls.ImageHelper.CreateImageCollectionFromResources("DevExpress.Utils.Images.designer16x16.png", typeof(XtraFrame).Assembly, new Size(16, 16));
				return designerImages16;
			}
		}
		public static ImageCollection DesignerImages12 {
			get {
				if(designerImages12 == null)
					designerImages12 = DevExpress.Utils.Controls.ImageHelper.CreateImageCollectionFromResources("DevExpress.Utils.Images.designer12x12.png", typeof(XtraFrame).Assembly, new Size(12, 12));
				return designerImages12;
			}
		}
		public bool DrawGradientHeader {
			get { return drawGradientHeader; }
			set {
				if(drawGradientHeader != value) {
					if(value) {
						this.lbCaption.BackColor = System.Drawing.SystemColors.ControlDark;
						this.lbCaption.Dock = System.Windows.Forms.DockStyle.Top;
						this.lbCaption.ForeColor = System.Drawing.SystemColors.HighlightText;
						this.lbCaption.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
						this.lbCaption.Name = "lbCaption";
						this.lbCaption.Size = new System.Drawing.Size(400, 24);
						this.lbCaption.TabIndex = 0;
						this.lbCaption.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
						try {
							lbCaption.Font = new System.Drawing.Font(AppearanceObject.DefaultFont.Name, 12F, System.Drawing.FontStyle.Regular);
						} catch { }
						this.lbCaption.Margin = new Padding(3, 0, 3, 0);
						this.pnlMain.Location = new System.Drawing.Point(0, 28);
						indention = 5;
					} else {
						Label defaultLabel = new Label();
						this.lbCaption.BackColor = Color.Transparent;
						this.lbCaption.Dock = System.Windows.Forms.DockStyle.Top;
						this.lbCaption.ForeColor = defaultLabel.ForeColor;
						this.lbCaption.ImageAlign = System.Drawing.ContentAlignment.BottomRight;
						this.lbCaption.Name = "lbCaption";
						this.lbCaption.Size = new System.Drawing.Size(400, 22);
						this.lbCaption.TabIndex = 0;
						this.lbCaption.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
						this.lbCaption.Font = defaultLabel.Font;
						this.lbCaption.BorderStyle = BorderStyle.None;
						this.lbCaption.Margin = new Padding(0, 0, 0, 0);
						this.pnlMain.Location = new System.Drawing.Point(0, 22);
						indention = 0;
					}
				}
				drawGradientHeader = value;
			}
		}
		public Color HeaderGradientFirstColor { get { return headerGradientFirstColor; } set { headerGradientFirstColor = value; } }
		public Color HeaderGradientSecondColor { get { return headerGradientSecondColor; } set { headerGradientSecondColor = value; } }
		public Component EditingComponent { get { return EditingObject as Component; } }
		public object EditingObject { get { return editingObject; } }
		public object InfoObject { get { return infoObject; } }
		public virtual object GetComponentService(Type type) {
			return EditingComponent == null || EditingComponent.Site == null ? null : EditingComponent.Site.GetService(type);
		}
		protected virtual bool AllowGlobalStore { get { return true; } }
		public void StoreProperties(PropertyStore globalStore) {
			StoreGlobalProperties(globalStore);
			PropertyStore store = new PropertyStore(globalStore, GetPropertyStoreName());
			StoreLocalProperties(store);
			if(store.IsEmpty) return;
			globalStore.AddProperty(GetPropertyStoreName(), store);
		}
		public void RestoreProperties(PropertyStore globalStore) {
			RestoreGlobalProperties(globalStore);
			PropertyStore store = globalStore.RestoreProperties(GetPropertyStoreName());
			if(store == null) return;
			RestoreLocalProperties(store);
		}
		public virtual void StoreGlobalProperties(PropertyStore globalStore) {}
		public virtual void RestoreGlobalProperties(PropertyStore globalStore) {}
		public virtual void StoreLocalProperties(PropertyStore localStore) {}
		public virtual void RestoreLocalProperties(PropertyStore localStore) {}
		public virtual string GetPropertyStoreName() {
			if(DesignerItem != null) return string.Format("XF_{0}_{1}", DesignerItem.Group.Caption, DesignerItem.Caption);
			return string.Format("XF_{0}", ID);
		}
		public XtraFrame() : this(0) {
		}
		public XtraFrame(int i) {
			SetStyle(ControlStyles.SupportsTransparentBackColor, true);
			InitializeComponent();
			lbCaption.Paint += new PaintEventHandler(caption_Paint);
			try {
				lbCaption.Font = new System.Drawing.Font(AppearanceObject.DefaultFont.Name, 12F, System.Drawing.FontStyle.Regular);
			} catch {}
			ID = i;
		}
		protected virtual DockStyle DescriptionPanelDock { get { return DockStyle.Bottom; } }
		int indention = 5;
		void caption_Paint(object sender, PaintEventArgs e) {
			Label lb = sender as Label;
			Size imageSize = lb.Image != null ? lb.Image.Size : new Size(0, 0);
			Rectangle r = lb.DisplayRectangle;
			Rectangle rImage = new Rectangle(r.X + (r.Width - indention - imageSize.Width), r.Y + (r.Height - imageSize.Height) / 2, imageSize.Width, imageSize.Height);
			if(drawGradientHeader) {
				System.Drawing.Drawing2D.LinearGradientBrush brush = new System.Drawing.Drawing2D.LinearGradientBrush(r, headerGradientFirstColor, headerGradientSecondColor, System.Drawing.Drawing2D.LinearGradientMode.Vertical);
				using(brush)
					e.Graphics.FillRectangle(brush, r);
			} else {
				Brush brush = new SolidBrush(Parent.BackColor);
				using(brush)
					e.Graphics.FillRectangle(brush, r);
			}
			if(lb.Text != "") {
				r.Inflate(-indention, 0);
				r.Width -= imageSize.Width > 0 ? imageSize.Width + indention : 0;
				StringFormat sf = new StringFormat();
				sf.Trimming = StringTrimming.EllipsisCharacter;
				using(sf) {
					if(drawGradientHeader) {
						sf.LineAlignment = StringAlignment.Center;
						e.Graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
						e.Graphics.DrawString(lb.Text, lb.Font, Brushes.White, r, sf);
					} else {
						sf.LineAlignment = StringAlignment.Far;
						r.Offset(-2, 0);
						r.Inflate(0, 3);
						e.Graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.SystemDefault;
						Brush sBrush = new SolidBrush(lb.ForeColor);
						using(sBrush) {
							e.Graphics.DrawString(lb.Text, lb.Font, sBrush, r, sf);
						}
					}
				}
			}
			if(lb.Image != null)
				e.Graphics.DrawImageUnscaled(lb.Image, rImage);
		}
		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public DesignerItem DesignerItem { get { return designerItem; } set { designerItem = value; } }
		public int ID {
			get { return id;}
			set { id = value; }
		}
		public bool HavePG {
			get{return havepg;}
			set{havepg = value;}
		}
		public void InitFrame() {
			InitFrame("");
		}
		public void InitFrame(string caption) {
			InitFrame(caption, null);
		}
		public void InitFrame(string caption, Image img) {
			InitFrame(null, caption, img);
		}
		public void InitFrame(object editingObject, string caption, Image img) {
			InitFrame(editingObject, null, caption, img);
		}
		public void InitFrame(object editingObject, object infoObject, string caption, Image img) {
			this.editingObject = editingObject;
			this.infoObject = infoObject;
			lbCaption.Text = caption;
			lbCaption.Image = img;
			lbCaption.Visible = lbCaption.Text != string.Empty || lbCaption.Image != null;
			UpdateDescriptionPanel();
			InitComponent();
			InitImages();
			DoInitFrame();
		}
		public virtual void DoInitFrame() {}
		public virtual void InitComponent() {}
		protected virtual void InitImages() {}
		public virtual void RefreshFrame(bool b) {}
		protected virtual string DescriptionText { get { return string.Empty; } }
		protected virtual string GetDescriptionTextCore() {
			return DescriptionText;
		}
		protected void UpdateDescriptionPanel() { 
			if(GetDescriptionTextCore() != string.Empty) {
				if(this.pnlDescription == null) 
					SetupDescriptionPanel();
				this.pnlDescription.Text = GetDescriptionTextCore();
			} else 
				if(this.pnlDescription != null) {
				this.pnlDescription.Dispose();
				this.pnlDescription = null;
			}
		}
		void SetupDescriptionPanel() {
			if(GetDescriptionTextCore() == string.Empty) return;
			this.pnlDescription = new NotePanelEx();
			this.pnlDescription.Parent = this;
			this.pnlDescription.Dock = DescriptionPanelDock;
			this.pnlDescription.Height = 20;
		}
		protected void RaiseRefreshWizard(string viewName, string condition) {
			if(RefreshWizard != null)
				RefreshWizard(this, new RefreshWizardEventArgs(viewName, condition));
		}
		protected void RaiseShowPGMenu(object sender, MouseEventArgs e) {
			if(ShowMenu != null)
				ShowMenu(sender, e);
		}
		protected void SetPanelBkColor(Control pnl) {
			SetPanelBkColor(pnl, true);
		}
		protected void SetPanelBkColor(Control pnl, bool allColors) {
			pnl.BackColor = ColorUtils.FlatBarBackColor;
			if(allColors)
				foreach(Control c in pnl.Controls)
					if(c is Button)
						c.BackColor = SystemColors.Control;
			SetTransparentBitmap(pnl);
		}
		protected void SetTransparentBitmap(Control pnl) {
			foreach(object obj in pnl.Controls) 
				if(obj is Button) {
					Button btn = (Button)obj;
					if(btn.Image != null)
						((Bitmap)btn.Image).MakeTransparent();
				} 
		}
		#region Component Designer generated code
		private void InitializeComponent() {
			this.lbCaption = new System.Windows.Forms.Label();
			this.pnlMain = new PanelControl();
			this.horzSplitter = new DevExpress.XtraEditors.PanelControl();
			((System.ComponentModel.ISupportInitialize)(this.pnlMain)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.horzSplitter)).BeginInit();
			this.SuspendLayout();
			this.lbCaption.Left = 0;
			this.lbCaption.BackColor = System.Drawing.SystemColors.ControlDark;
			this.lbCaption.Dock = System.Windows.Forms.DockStyle.Top;
			this.lbCaption.ForeColor = System.Drawing.SystemColors.HighlightText;
			this.lbCaption.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.lbCaption.Name = "lbCaption";
			this.lbCaption.Size = new System.Drawing.Size(400, 24);
			this.lbCaption.TabIndex = 0;
			this.lbCaption.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.pnlMain.BorderStyle = DevExpress.XtraEditors.Controls.BorderStyles.NoBorder;
			this.pnlMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlMain.Location = new System.Drawing.Point(0, 28);
			this.pnlMain.Name = "pnlMain";
			this.pnlMain.Size = new System.Drawing.Size(400, 248);
			this.pnlMain.TabIndex = 1;
			this.horzSplitter.BorderStyle = DevExpress.XtraEditors.Controls.BorderStyles.NoBorder;
			this.horzSplitter.Dock = System.Windows.Forms.DockStyle.Top;
			this.horzSplitter.Location = new System.Drawing.Point(0, 24);
			this.horzSplitter.Name = "horzSplitter";
			this.horzSplitter.Size = new System.Drawing.Size(400, 4);
			this.horzSplitter.TabIndex = 2;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.pnlMain,
																		  this.horzSplitter,
																		  this.lbCaption});
			this.Name = "XtraFrame";
			this.Size = new System.Drawing.Size(400, 276);
			((System.ComponentModel.ISupportInitialize)(this.pnlMain)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.horzSplitter)).EndInit();
			this.ResumeLayout(false);
		}
		#endregion
		public bool SelectItem(ListBox lb, int n) {
			bool b = true;
			if(lb.Items.Count > n)
				lb.SelectedIndex = n;
			else if(lb.Items.Count > 0)
				lb.SelectedIndex = lb.Items.Count - 1;
			else
				b = false;
			return b;
		}
	}
	public delegate void RefreshWizardEventHandler(object sender, RefreshWizardEventArgs e);
	public class RefreshWizardEventArgs : EventArgs {
		string name = "";
		string condition = "";
		public string Name {
			get { return name; }
			set { name = value; }
		}
		public string Condition {
			get { return condition; }
			set { condition = value; }
		}
		public RefreshWizardEventArgs(string name, string condition) {
			this.name = name;
			this.condition = condition;
		}
	}
}
