#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{                                                                   }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Globalization;
using Microsoft.Win32;
namespace DevExpress.Utils.About {
	public class AboutSN : System.Windows.Forms.Form {
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button btnOk;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.LinkLabel linkLabel1;
		private System.Windows.Forms.LinkLabel linkLabel2;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.PictureBox pictureBox1;
		private Color[] colors = new Color[] {Color.White, Color.DeepSkyBlue, Color.FromArgb(213, 236, 255), Color.FromArgb(170, 214, 253)};
		public static void Show(string title, Type t) {
			AboutSN box = new AboutSN(title + " " + GetVersion(t), "free");
			box.ShowDialog();
		}
		public static void Show(string title, Type t, ProductKind kind, ProductInfoStage stage) {
			string sn;
			sn = "Unknown";
			Show(title, sn, t);
		}
		static void Show(string title, string sn, Type t) {
			AboutSN box = new AboutSN(title + " " + GetVersion(t), sn);
			box.ShowDialog();
		}
		static string GetVersion(Type t) {
			string versionText = "";
			string ver = t.Assembly.ToString();
			if(ver.IndexOf("Version=") != -1) {
				ver = ver.Substring(ver.IndexOf("Version=") + 8);
				if(ver.IndexOf(", ") != -1) ver = ver.Substring(0, ver.IndexOf(", "));
				versionText = ver;
			}
			return versionText;
		}
		Image backgroundImage;
		string text, demo = "Unregistered evaluation copy";
		Font font1, font2;
		Brush backBrush;
		Brush buttonBrush;
		bool IsDemo, IsFree;
		public AboutSN(string productInfo, string sn) : this(productInfo, sn, DateTime.Now.Year) {}
		public AboutSN(string productInfo, string sn, int year) {
			InitializeComponent();
			text = productInfo;
			textBox1.Text = sn;
			IsDemo = sn == null || sn == "";
			IsFree = sn == "free";
			textBox1.Visible = label1.Visible = (!IsDemo && !IsFree);
			textBox1.BackColor = colors[2];
			if(year < 2002) year = 2002;
			label5.Text = "Copyright  2000-" + year.ToString() + " Developer Express Inc. ALL RIGHTS RESERVED.";
			try {
				backgroundImage = Bitmap.FromStream(System.Reflection.Assembly.GetExecutingAssembly().GetManifestResourceStream("DevExpress.Utils.logo.gif"));
			} catch {}
			backBrush = buttonBrush = null;
			AcceptButton = btnOk;
			CancelButton = btnOk;
			btnOk.ForeColor = Color.FromArgb(26, 39, 99);
			try {
				label3.Font = label4.Font = linkLabel1.Font = linkLabel2.Font = new Font("Microsoft Sans Serif", 8);
				btnOk.Font = new Font("Arial", 9, FontStyle.Bold);
				font1 = SetFont(fontSize);
				font2 = new Font("Times New Roman", 11, FontStyle.Bold);
				label5.Font = new Font("Arial", 7, FontStyle.Bold);
			} catch {}
			pictureBox1.Location = new Point(5, 5);
			pictureBox1.Size = pictureBox1.Image.Size;	
		}
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		private void InitializeComponent() {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(AboutSN));
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.btnOk = new System.Windows.Forms.Button();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.linkLabel1 = new System.Windows.Forms.LinkLabel();
			this.linkLabel2 = new System.Windows.Forms.LinkLabel();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.SuspendLayout();
			this.textBox1.Location = new System.Drawing.Point(184, 36);
			this.textBox1.Name = "textBox1";
			this.textBox1.ReadOnly = true;
			this.textBox1.Size = new System.Drawing.Size(220, 20);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			this.textBox1.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			this.label1.BackColor = System.Drawing.Color.Transparent;
			this.label1.Location = new System.Drawing.Point(156, 36);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(24, 20);
			this.label1.TabIndex = 1;
			this.label1.Text = "s/n:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.label2.BackColor = System.Drawing.Color.Transparent;
			this.label2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.label2.Location = new System.Drawing.Point(8, 104);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(396, 2);
			this.label2.TabIndex = 2;
			this.btnOk.BackColor = System.Drawing.Color.Transparent;
			this.btnOk.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOk.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.btnOk.Location = new System.Drawing.Point(316, 124);
			this.btnOk.Name = "btnOk";
			this.btnOk.Size = new System.Drawing.Size(87, 27);
			this.btnOk.TabIndex = 3;
			this.btnOk.Text = "&Ok";
			this.label3.BackColor = System.Drawing.Color.Transparent;
			this.label3.Location = new System.Drawing.Point(156, 64);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(244, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Visit us online at: ";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			this.label4.BackColor = System.Drawing.Color.Transparent;
			this.label4.Location = new System.Drawing.Point(8, 112);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(308, 40);
			this.label4.TabIndex = 5;
			this.label4.Text = "If you have any questions regarding this product use, please feel free to contact" +
				" us at:";
			this.label5.BackColor = System.Drawing.Color.Transparent;
			this.label5.Location = new System.Drawing.Point(8, 84);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(396, 16);
			this.label5.TabIndex = 8;
			this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.linkLabel1.BackColor = System.Drawing.Color.Transparent;
			this.linkLabel1.Location = new System.Drawing.Point(260, 60);
			this.linkLabel1.Name = "linkLabel1";
			this.linkLabel1.Size = new System.Drawing.Size(144, 20);
			this.linkLabel1.TabIndex = 1;
			this.linkLabel1.TabStop = true;
			this.linkLabel1.Text = "www.devexpress.com";
			this.linkLabel1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.linkLabel1.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel1_LinkClicked);
			this.linkLabel1.MouseEnter += new System.EventHandler(this.linkLabel_MouseEnter);
			this.linkLabel1.MouseLeave += new System.EventHandler(this.linkLabel_MouseLeave);
			this.linkLabel2.BackColor = System.Drawing.Color.Transparent;
			this.linkLabel2.Location = new System.Drawing.Point(128, 132);
			this.linkLabel2.Name = "linkLabel2";
			this.linkLabel2.Size = new System.Drawing.Size(196, 20);
			this.linkLabel2.TabIndex = 2;
			this.linkLabel2.TabStop = true;
			this.linkLabel2.Text = "support@devexpress.com";
			this.linkLabel2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.linkLabel2.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel2_LinkClicked);
			this.linkLabel2.MouseEnter += new System.EventHandler(this.linkLabel_MouseEnter);
			this.linkLabel2.MouseLeave += new System.EventHandler(this.linkLabel_MouseLeave);
			this.pictureBox1.BackColor = System.Drawing.Color.Transparent;
			this.pictureBox1.Image = ((System.Drawing.Bitmap)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(8, 4);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(68, 32);
			this.pictureBox1.TabIndex = 6;
			this.pictureBox1.TabStop = false;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(410, 158);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label2,
																		  this.label5,
																		  this.linkLabel1,
																		  this.btnOk,
																		  this.linkLabel2,
																		  this.label4,
																		  this.label3,
																		  this.textBox1,
																		  this.label1,
																		  this.pictureBox1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "AboutSN";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "About";
			this.TopMost = true;
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.frmAboutSN_Paint);
			this.ResumeLayout(false);
		}
		#endregion
		SolidBrush textBrush = new SolidBrush(Color.FromArgb(167, 19, 2));
		private Font SetFont(int fontSize) {
			return new Font("Arial", fontSize, FontStyle.Bold);
		}
		int fontSize = 12;
		private void frmAboutSN_Paint(object sender, System.Windows.Forms.PaintEventArgs e) {
			int dx = label1.Left;
			int dw = label1.Width + textBox1.Width;
			if(buttonBrush == null)
				buttonBrush = new System.Drawing.Drawing2D.LinearGradientBrush(btnOk.Bounds, colors[0], colors[1], 90);
			if(backBrush == null)
				backBrush = new System.Drawing.Drawing2D.LinearGradientBrush(ClientRectangle, colors[3], colors[0], 90);
			e.Graphics.FillRectangle(backBrush, ClientRectangle);
			e.Graphics.DrawImageUnscaled(backgroundImage, 5, 5); 
			e.Graphics.FillRectangle(buttonBrush, btnOk.Bounds);
			if(font1 == null) return;
			StringFormat stf = new StringFormat();
			stf.Alignment = StringAlignment.Center;
			stf.FormatFlags |= StringFormatFlags.NoWrap;
			stf.Trimming = StringTrimming.EllipsisCharacter;
			for(; e.Graphics.MeasureString(text, font1).Width > dw && fontSize > 8;) 
				font1 = SetFont(--fontSize);
			e.Graphics.DrawString(text, font1, Brushes.White, new Rectangle(dx + 1, 11, dw + 1, 41), stf);
			e.Graphics.DrawString(text, font1, textBrush, new Rectangle(dx, 10, dw, 40), stf);
			if(IsDemo && !IsFree) {
				stf.Alignment = StringAlignment.Center;
				stf.LineAlignment = StringAlignment.Center;
				e.Graphics.DrawString(demo, font2, textBrush, new Rectangle(dx, label1.Top, dw, label1.Height), stf);
				e.Graphics.DrawRectangle(Pens.Black, dx, label1.Top, dw, label1.Height);
			}
		}
		private void linkLabel_MouseEnter(object sender, System.EventArgs e) {
			LinkLabel llb = sender as LinkLabel;
			llb.LinkColor = Color.FromArgb(100, 100, 255);
			try {
				llb.Font = new Font("Microsoft Sans Serif", 8, FontStyle.Bold);
			} catch {}	
		}
		private void linkLabel_MouseLeave(object sender, System.EventArgs e) {
			LinkLabel llb = sender as LinkLabel;
			llb.LinkColor = Color.FromArgb(0, 0, 255);
			try {
				llb.Font = new Font("Microsoft Sans Serif", 8);
			} catch {}
		}
		private void linkClicked(LinkLabel llb, string task) {
			llb.LinkVisited = true;
			System.Diagnostics.Process process = new System.Diagnostics.Process();
			process.StartInfo.FileName = task;
			process.StartInfo.Verb = "Open";
			process.StartInfo.WindowStyle = System.Diagnostics.ProcessWindowStyle.Normal;
			process.Start();
		}
		private void linkLabel1_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) {
			linkClicked(sender as LinkLabel, "http://www.devexpress.com"); 
		}
		private void linkLabel2_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) {
			linkClicked(sender as LinkLabel, "mailto:support@devexpress.com"); 
		}
	}
}
