#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{       XtraGrid                                                    }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System;
using System.Collections;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using DevExpress.Utils.Frames;
using DevExpress.XtraGrid;
using DevExpress.XtraGrid.Views.Base;
using DevExpress.XtraGrid.Views.Grid;
using DevExpress.XtraGrid.Views.Card;
using DevExpress.Utils;
using DevExpress.Utils.Design;
using DevExpress.XtraTab;
using DevExpress.XtraGrid.Views.Layout;
namespace DevExpress.XtraGrid.Frames {
	[ToolboxItem(false)]
	public class AppearancesDesigner : DevExpress.XtraEditors.Frames.AppearancesDesignerBase {
		private DevExpress.XtraEditors.PanelControl pcPaintStyle;
		private DevExpress.XtraEditors.ComboBoxEdit cbePaintStyle;
		private System.Windows.Forms.Label label2;
		private DevExpress.XtraEditors.PanelControl pcGridView;
		private DevExpress.XtraEditors.RadioGroup rgMode;
		private DevExpress.XtraEditors.CheckEdit ceEven;
		private DevExpress.XtraEditors.CheckEdit ceOdd;
		private DevExpress.XtraEditors.CheckEdit ceFocusedCell;
		private DevExpress.XtraEditors.CheckEdit ceFocusedRow;
		private System.ComponentModel.Container components = null;
		public AppearancesDesigner() {
			InitializeComponent();
			pgMain.BringToFront();
		}
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if(previewGrid != null) {
					previewGrid.AppearanceCollectionChanged -= new EventHandler(AppearanceCollectionChanged);
					previewGrid.Dispose();
					previewGrid = null;
				}
				if(components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		public override void StoreLocalProperties(PropertyStore localStore) {
			localStore.AddProperty("AppearancePanel", gcAppearances.Width);
			base.StoreLocalProperties(localStore);
		}
		public override void RestoreLocalProperties(PropertyStore localStore) {
			base.RestoreLocalProperties(localStore);
			gcAppearances.Width = localStore.RestoreIntProperty("AppearancePanel", gcAppearances.Width);
		}
		#region Component Designer generated code
		private void InitializeComponent() {
			this.pcPaintStyle = new DevExpress.XtraEditors.PanelControl();
			this.ceFocusedRow = new DevExpress.XtraEditors.CheckEdit();
			this.ceFocusedCell = new DevExpress.XtraEditors.CheckEdit();
			this.ceOdd = new DevExpress.XtraEditors.CheckEdit();
			this.ceEven = new DevExpress.XtraEditors.CheckEdit();
			this.cbePaintStyle = new DevExpress.XtraEditors.ComboBoxEdit();
			this.label2 = new System.Windows.Forms.Label();
			this.pcGridView = new DevExpress.XtraEditors.PanelControl();
			this.rgMode = new DevExpress.XtraEditors.RadioGroup();
			((System.ComponentModel.ISupportInitialize)(this.gcAppearances)).BeginInit();
			this.gcAppearances.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.gcPreview)).BeginInit();
			this.gcPreview.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.beAppearances.Properties)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.pnlButtons)).BeginInit();
			this.pnlButtons.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.lbcAppearances)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.pnlControl)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.pnlMain)).BeginInit();
			this.pnlMain.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.horzSplitter)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.pcPaintStyle)).BeginInit();
			this.pcPaintStyle.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.ceFocusedRow.Properties)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.ceFocusedCell.Properties)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.ceOdd.Properties)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.ceEven.Properties)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.cbePaintStyle.Properties)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.pcGridView)).BeginInit();
			this.pcGridView.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.rgMode.Properties)).BeginInit();
			this.SuspendLayout();
			this.gcPreview.Controls.Add(this.pcGridView);
			this.gcPreview.Location = new System.Drawing.Point(166, 0);
			this.gcPreview.Size = new System.Drawing.Size(302, 312);
			this.beAppearances.Size = new System.Drawing.Size(156, 20);
			this.pnlButtons.Location = new System.Drawing.Point(2, 20);
			this.pnlButtons.Size = new System.Drawing.Size(156, 25);
			this.lbcAppearances.Location = new System.Drawing.Point(2, 45);
			this.lbcAppearances.Size = new System.Drawing.Size(156, 265);
			this.splMain.Location = new System.Drawing.Point(468, 60);
			this.pgMain.Location = new System.Drawing.Point(474, 60);
			this.pgMain.Size = new System.Drawing.Size(286, 312);
			this.pnlMain.Size = new System.Drawing.Size(468, 312);
			this.pcPaintStyle.BorderStyle = DevExpress.XtraEditors.Controls.BorderStyles.NoBorder;
			this.pcPaintStyle.Controls.Add(this.ceFocusedRow);
			this.pcPaintStyle.Controls.Add(this.ceFocusedCell);
			this.pcPaintStyle.Controls.Add(this.ceOdd);
			this.pcPaintStyle.Controls.Add(this.ceEven);
			this.pcPaintStyle.Controls.Add(this.cbePaintStyle);
			this.pcPaintStyle.Controls.Add(this.label2);
			this.pcPaintStyle.Location = new System.Drawing.Point(536, 92);
			this.pcPaintStyle.Name = "pcPaintStyle";
			this.pcPaintStyle.Size = new System.Drawing.Size(204, 192);
			this.pcPaintStyle.TabIndex = 4;
			this.pcPaintStyle.Resize += new System.EventHandler(this.pcPaintStyle_Resize);
			this.ceFocusedRow.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
						| System.Windows.Forms.AnchorStyles.Right)));
			this.ceFocusedRow.Location = new System.Drawing.Point(8, 116);
			this.ceFocusedRow.Name = "ceFocusedRow";
			this.ceFocusedRow.Properties.Caption = "Enable Appearance FocusedRow";
			this.ceFocusedRow.Size = new System.Drawing.Size(188, 18);
			this.ceFocusedRow.TabIndex = 9;
			this.ceFocusedRow.CheckedChanged += new System.EventHandler(this.ceFocusedRow_CheckedChanged);
			this.ceFocusedCell.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
						| System.Windows.Forms.AnchorStyles.Right)));
			this.ceFocusedCell.Location = new System.Drawing.Point(8, 92);
			this.ceFocusedCell.Name = "ceFocusedCell";
			this.ceFocusedCell.Properties.Caption = "Enable Appearance FocusedCell";
			this.ceFocusedCell.Size = new System.Drawing.Size(188, 18);
			this.ceFocusedCell.TabIndex = 8;
			this.ceFocusedCell.CheckedChanged += new System.EventHandler(this.ceFocusedCell_CheckedChanged);
			this.ceOdd.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
						| System.Windows.Forms.AnchorStyles.Right)));
			this.ceOdd.Location = new System.Drawing.Point(8, 68);
			this.ceOdd.Name = "ceOdd";
			this.ceOdd.Properties.Caption = "Enable Appearance OddRow";
			this.ceOdd.Size = new System.Drawing.Size(188, 18);
			this.ceOdd.TabIndex = 7;
			this.ceOdd.CheckedChanged += new System.EventHandler(this.ceOdd_CheckedChanged);
			this.ceEven.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
						| System.Windows.Forms.AnchorStyles.Right)));
			this.ceEven.Location = new System.Drawing.Point(8, 44);
			this.ceEven.Name = "ceEven";
			this.ceEven.Properties.Caption = "Enable Appearance EvenRow";
			this.ceEven.Size = new System.Drawing.Size(188, 18);
			this.ceEven.TabIndex = 6;
			this.ceEven.CheckedChanged += new System.EventHandler(this.ceEven_CheckedChanged);
			this.cbePaintStyle.EditValue = "";
			this.cbePaintStyle.Location = new System.Drawing.Point(80, 12);
			this.cbePaintStyle.Name = "cbePaintStyle";
			this.cbePaintStyle.Properties.Buttons.AddRange(new DevExpress.XtraEditors.Controls.EditorButton[] {
			new DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)});
			this.cbePaintStyle.Properties.Items.AddRange(new object[] {
			"Default"});
			this.cbePaintStyle.Properties.TextEditStyle = DevExpress.XtraEditors.Controls.TextEditStyles.DisableTextEditor;
			this.cbePaintStyle.Size = new System.Drawing.Size(112, 20);
			this.cbePaintStyle.TabIndex = 4;
			this.cbePaintStyle.SelectedIndexChanged += new System.EventHandler(this.cbePaintStyle_SelectedIndexChanged);
			this.label2.BackColor = System.Drawing.Color.Transparent;
			this.label2.Location = new System.Drawing.Point(8, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(84, 20);
			this.label2.TabIndex = 5;
			this.label2.Text = "Paint Style:";
			this.pcGridView.BorderStyle = DevExpress.XtraEditors.Controls.BorderStyles.NoBorder;
			this.pcGridView.Controls.Add(this.rgMode);
			this.pcGridView.Dock = System.Windows.Forms.DockStyle.Top;
			this.pcGridView.Location = new System.Drawing.Point(2, 20);
			this.pcGridView.Name = "pcGridView";
			this.pcGridView.Size = new System.Drawing.Size(298, 33);
			this.pcGridView.TabIndex = 5;
			this.rgMode.Dock = System.Windows.Forms.DockStyle.Top;
			this.rgMode.EditValue = 0;
			this.rgMode.Location = new System.Drawing.Point(0, 0);
			this.rgMode.Name = "rgMode";
			this.rgMode.Properties.Columns = 2;
			this.rgMode.Properties.Items.AddRange(new DevExpress.XtraEditors.Controls.RadioGroupItem[] {
			new DevExpress.XtraEditors.Controls.RadioGroupItem(0, "Group Mode"),
			new DevExpress.XtraEditors.Controls.RadioGroupItem(1, "Table Mode")});
			this.rgMode.Size = new System.Drawing.Size(298, 28);
			this.rgMode.TabIndex = 0;
			this.rgMode.SelectedIndexChanged += new System.EventHandler(this.rgMode_SelectedIndexChanged);
			this.Controls.Add(this.pcPaintStyle);
			this.Name = "AppearancesDesigner";
			this.Controls.SetChildIndex(this.lbCaption, 0);
			this.Controls.SetChildIndex(this.pnlControl, 0);
			this.Controls.SetChildIndex(this.horzSplitter, 0);
			this.Controls.SetChildIndex(this.pnlMain, 0);
			this.Controls.SetChildIndex(this.splMain, 0);
			this.Controls.SetChildIndex(this.pgMain, 0);
			this.Controls.SetChildIndex(this.pcPaintStyle, 0);
			((System.ComponentModel.ISupportInitialize)(this.gcAppearances)).EndInit();
			this.gcAppearances.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.gcPreview)).EndInit();
			this.gcPreview.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.beAppearances.Properties)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.pnlButtons)).EndInit();
			this.pnlButtons.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.lbcAppearances)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.pnlControl)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.pnlMain)).EndInit();
			this.pnlMain.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.horzSplitter)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.pcPaintStyle)).EndInit();
			this.pcPaintStyle.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.ceFocusedRow.Properties)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.ceFocusedCell.Properties)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.ceOdd.Properties)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.ceEven.Properties)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.cbePaintStyle.Properties)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.pcGridView)).EndInit();
			this.pcGridView.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.rgMode.Properties)).EndInit();
			this.ResumeLayout(false);
		}
		#endregion
		#region Init & Ctor
		protected override string DescriptionText { get { return "Click on any of the XtraGrid's elements in the preview pane to display the Appearance objects associated with that element. Then select one or more of the Appearance objects to access and modify their settings via the property grid. Note that specific appearances are ignored when the Skin, WindowsXP or Office2003 paint schemes are applied. "; } }
		private DevExpress.XtraGrid.Views.Base.BaseView EditingView { get { return EditingObject as DevExpress.XtraGrid.Views.Base.BaseView; } }
		public override void InitComponent() {
			CreateTabControl();
			CreatePreviewControl();
			InitPreviewControl();
			InitAppearanceList(previewGrid.MainView.Appearance);
			InitPaintStyles();
		}
		protected override Image AppearanceImage { get { return EditingView.GridControl.BackgroundImage; } }
		protected override XtraTabControl CreateTab() {
			return DevExpress.XtraEditors.Design.FramesUtils.CreateTabProperty(this, new Control[] {pgMain, pcPaintStyle}, new string[] {"Properties", "Paint Style"});
		}
		void InitPaintStyles() {
			for(int i = 0; i < previewGrid.MainView.BaseInfo.PaintStyles.Count; i++) 
				cbePaintStyle.Properties.Items.Add(EditingView.BaseInfo.PaintStyles[i].Name);
			cbePaintStyle.EditValue = previewGrid.MainView.PaintStyleName;
		}
		GridControlAppearences previewGrid = null;
		protected override void CreatePreviewControl() {
			previewGrid = new GridControlAppearences();
			previewGrid.TabStop = false;
			AssignGrid(previewGrid);
			previewGrid.Dock = DockStyle.Fill;
			gcPreview.Controls.Add(previewGrid);
			previewGrid.AppearanceCollectionChanged += new EventHandler(AppearanceCollectionChanged);
			previewGrid.BringToFront();
		}
		void InitPreviewControlEx() {
			GridView view = previewGrid.MainView as GridView;
			pcGridView.Visible = ceEven.Visible = ceOdd.Visible = ceFocusedCell.Visible = ceFocusedRow.Visible = view != null;
			if(view != null) {
				view.BeginUpdate();
				view.ClearGrouping();
				view.OptionsView.AutoCalcPreviewLineCount = true;
				view.OptionsView.ShowPreview = true;
				view.CalcPreviewText += new DevExpress.XtraGrid.Views.Grid.CalcPreviewTextEventHandler(CalcPreviewText);
				view.GroupSummary.Add(DevExpress.Data.SummaryItemType.Average, "Unit Price", view.Columns[2], "AVG={0:c}");
				view.Columns["Discontinued"].Visible = false;
				view.Columns["Category"].OptionsFilter.AllowFilter = false;
				InitGroupMode();
				ceEven.Checked = view.OptionsView.EnableAppearanceEvenRow;
				ceOdd.Checked = view.OptionsView.EnableAppearanceOddRow;
				ceFocusedCell.Checked = view.OptionsSelection.EnableAppearanceFocusedCell;
				ceFocusedRow.Checked = view.OptionsSelection.EnableAppearanceFocusedRow;
				view.RowSeparatorHeight = ((GridView)EditingView).RowSeparatorHeight;
				view.EndUpdate();
			}
			CardView cView = previewGrid.MainView as CardView;
			if(cView != null) {
				cView.OptionsView.ShowQuickCustomizeButton = false;
				cView.OptionsView.ShowHorzScrollBar = false;
				cView.OptionsBehavior.AutoHorzWidth = false;
			}
			LayoutView lView = previewGrid.MainView as LayoutView;
			if(lView != null) {
				lView.OptionsView.ShowFilterPanelMode = ShowFilterPanelMode.ShowAlways;
				lView.OptionsView.ViewMode = LayoutViewMode.Column;
			}
		}
		bool IsGroup { get { return rgMode.EditValue.Equals(0); } }
		void InitGroupMode() {
			GridView view = previewGrid.MainView as GridView;
			if(view == null) return;
			view.BestFitColumns();
			view.Columns["Category"].Visible = !IsGroup;
			view.Columns["Category"].GroupIndex = IsGroup ? 0 : -1;
			view.OptionsView.ColumnAutoWidth = !IsGroup;
			if(IsGroup) {
				view.Columns["Product Name"].Width += 30;
				view.Columns["Unit Price"].Width += 20;
			}
			view.FocusedRowHandle = 0;
		}
		protected override void InitPreviewControl() {
			DevExpress.XtraGrid.Design.XViewsPrinting xv = new DevExpress.XtraGrid.Design.XViewsPrinting(previewGrid, true);
			InitPreviewControlEx();
		}
		void AssignGrid(GridControl grid) {
			string viewName = EditingView.BaseInfo.ViewName;
			System.Reflection.MethodInfo method = typeof(GridControl).GetMethod("RegisterAvailableViewsCore", System.Reflection.BindingFlags.Instance | System.Reflection.BindingFlags.NonPublic);
			method.Invoke(EditingView.GridControl, new Object[] { grid.AvailableViews });
			BaseView oldView = grid.MainView;
			grid.MainView = EditingView.BaseInfo.CreateView(grid);
			if(grid.MainView == null) {
				grid.MainView = oldView;
				return;
			}
			if(oldView != null) oldView.Dispose();
			DevExpress.XtraGrid.Views.BandedGrid.BandedGridView bv = grid.MainView as DevExpress.XtraGrid.Views.BandedGrid.BandedGridView;
			if(bv != null) {
				if(bv.Bands.Count == 0)
					bv.Bands.Add();
			}
			DevExpress.XtraGrid.Design.GridAssign.AppearanceAssign(EditingView, grid.MainView);
		}
		#endregion
		#region Editing
		protected string[] SelectedObjectNames {
			get {
				if(SelectedObjects == null) return null;
				ArrayList list = new ArrayList();
				for(int i = 0; i < SelectedObjects.Length; i ++) {
					string name = (SelectedObjects[i] as AppearanceObject).Name;
					if(list.IndexOf(name) < 0)
						list.Add(name);
				}
				return (string[])list.ToArray(typeof(string));
			}
		}
		protected override void SetSelectedObject() {
			if(Preview == null) return;
			ArrayList arr = new ArrayList();
			if(SelectedObjects != null) {
				foreach(AppearanceObject obj in this.SelectedObjects) {
					AppearanceObject app = EditingView.PaintAppearance.GetAppearance(obj.Name);
					if(arr.IndexOf(app) < 0)
						arr.Add(EditingView.PaintAppearance.GetAppearance(obj.Name));
				}
				Preview.SetAppearance(arr.ToArray());
			}
			previewGrid.SelectedAppearanceNames = SelectedObjectNames;
		}
		protected override void AddObject(ArrayList ret, string item) {
			object obj = GetAppearanceObjectByName(previewGrid.MainView.Appearance, item);
			ret.Add(obj);
			object obj2 = GetAppearanceObjectByName(EditingView.Appearance, item);
			ret.Add(obj2); 
		}
		void AppearanceCollectionChanged(object sender, EventArgs e) {
			string[] appearances = sender as string[];
				if(appearances == null || appearances.Length < 1) 
					InitAppearanceList(previewGrid.MainView.Appearance);
				else {
					lbcAppearances.Items.Clear();
					foreach(string name in appearances) {
						if(previewGrid.MainView.Appearance.GetAppearance(name) != null)
							lbcAppearances.Items.Add(name);
					}
					lbcAppearances.SelectedValue = appearances[0];
					if(lbcAppearances.SelectedIndex == -1 && lbcAppearances.Items.Count > 0)
						lbcAppearances.SelectedIndex = 0;
				}
		}
		void CalcPreviewText(object sender, DevExpress.XtraGrid.Views.Grid.CalcPreviewTextEventArgs e) {
			if(e.RowHandle == 1)
				e.PreviewText = "The preview text...\r\nThe second line of the preview text.";
		}
		protected override void SetDefault() {
			previewGrid.MainView.BeginUpdate();
			EditingView.BeginUpdate();
			base.SetDefault();
			previewGrid.MainView.EndUpdate();
			EditingView.EndUpdate();
		}
		protected override void beAppearances_ButtonClick(object sender, DevExpress.XtraEditors.Controls.ButtonPressedEventArgs e) {
			if(e.Button.Tag == null) return;
			switch(e.Button.Tag.ToString()) {
				case "show":
					InitAppearanceList(previewGrid.MainView.Appearance);
					if(previewGrid != null) previewGrid.ResetFocusedElement();
					break;
				case "select":
					SelectAll();
					break;
				case "default":
					SetDefault();
					break;
			}
		}
		protected override void lbcAppearances_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e) {
			if(!e.Control) return;
			if(e.KeyCode == Keys.A) SelectAll();
			if(e.KeyCode == Keys.Z)	InitAppearanceList(previewGrid.MainView.Appearance);
			if(e.KeyCode == Keys.D)	SetDefault();
		}
		void cbePaintStyle_SelectedIndexChanged(object sender, System.EventArgs e) {
			string styleName = cbePaintStyle.EditValue.ToString();
			previewGrid.MainView.PaintStyleName = styleName;
			EditingView.PaintStyleName = styleName;
			SetSelectedObject();
		}
		private void rgMode_SelectedIndexChanged(object sender, System.EventArgs e) {
			InitGroupMode();
		}
		private void ceEven_CheckedChanged(object sender, System.EventArgs e) {
			if(EditingView is GridView) 
				((GridView)EditingView).OptionsView.EnableAppearanceEvenRow = 
					((GridView)previewGrid.MainView).OptionsView.EnableAppearanceEvenRow = ceEven.Checked;
		}
		private void ceOdd_CheckedChanged(object sender, System.EventArgs e) {
			if(EditingView is GridView) 
				((GridView)EditingView).OptionsView.EnableAppearanceOddRow = 
					((GridView)previewGrid.MainView).OptionsView.EnableAppearanceOddRow = ceOdd.Checked;
		}
		private void ceFocusedCell_CheckedChanged(object sender, System.EventArgs e) {
			if(EditingView is GridView) 
				((GridView)EditingView).OptionsSelection.EnableAppearanceFocusedCell = 
					((GridView)previewGrid.MainView).OptionsSelection.EnableAppearanceFocusedCell = ceFocusedCell.Checked;
		}
		private void ceFocusedRow_CheckedChanged(object sender, System.EventArgs e) {
			if(EditingView is GridView) 
				((GridView)EditingView).OptionsSelection.EnableAppearanceFocusedRow = 
					((GridView)previewGrid.MainView).OptionsSelection.EnableAppearanceFocusedRow = ceFocusedRow.Checked;
		}
		#endregion
		#region Load&Save Layout
		protected override void LoadAppearances(string name) {
			previewGrid.MainView.Appearance.RestoreLayoutFromXml(name);
			EditingView.Appearance.RestoreLayoutFromXml(name);
		}
		protected override void SaveAppearances(string name) {
			previewGrid.MainView.Appearance.SaveLayoutToXml(name);
		}
		#endregion
		private void pcPaintStyle_Resize(object sender, EventArgs e) {
			cbePaintStyle.Width = pcPaintStyle.Width - cbePaintStyle.Left - 10;
		}
	}
}
