#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{       XtraGrid                                                    }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System.ComponentModel;
using DevExpress.Utils;
using DevExpress.XtraGrid.Views.Base;
namespace DevExpress.XtraGrid.Views.Layout {
	public class LayoutViewAppearances : ColumnViewAppearances {
		AppearanceObject viewBackground, cardCaption, card, headerPanel;
		AppearanceObject fieldCaption, fieldValue, fieldEditingValue;
		AppearanceObject focusedCardCaption, selectedCardCaption, hideSelectionCardCaption;
		AppearanceObject separatorLine;
		AppearanceObject selectionFrame;
		public LayoutViewAppearances(BaseView view) : base(view) { }
		protected override void CreateAppearances() {
			base.CreateAppearances();
			this.viewBackground = CreateAppearance("ViewBackground");
			this.cardCaption = CreateAppearance("CardCaption");
			this.fieldCaption = CreateAppearance("FieldCaption");
			this.fieldValue = CreateAppearance("FieldValue");
			this.fieldEditingValue = CreateAppearance("FieldEditingValue");
			this.focusedCardCaption = CreateAppearance("FocusedCardCaption");
			this.selectedCardCaption = CreateAppearance("SelectedCardCaption");
			this.hideSelectionCardCaption = CreateAppearance("HideSelectionCardCaption");
			this.separatorLine = CreateAppearance("SeparatorLine");
			this.card = CreateAppearance("Card");
			this.selectionFrame = CreateAppearance("SelectionFrame");
			this.headerPanel = CreateAppearance("HeaderPanel");
		}
		void ResetSelectionFrame() { SelectionFrame.Reset(); }
		bool ShouldSerializeSelectionFrame() { return SelectionFrame.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint a marquee selection frame, when selecting multiple cards by a mouse drag."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject SelectionFrame { get { return selectionFrame; } }
		void ResetViewBackground() { ViewBackground.Reset(); }
		bool ShouldSerializeViewBackground() { return ViewBackground.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint a LayoutView's background."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject ViewBackground { get { return viewBackground; } }
		void ResetCard() { Card.Reset(); }
		bool ShouldSerializeCard() { return Card.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the background of cards."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject Card { get { return card; } }
		void ResetCardCaption() { CardCaption.Reset(); }
		bool ShouldSerializeCardCaption() { return CardCaption.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint card captions in a LayoutView."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject CardCaption { get { return cardCaption; } }
		void ResetHeaderPanel() { HeaderPanel.Reset(); }
		bool ShouldSerializeHeaderPanel() { return HeaderPanel.ShouldSerialize(); }
		[Description("Contains appearance settings used to paint the Header Panel."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject HeaderPanel { get { return headerPanel; } }
		void ResetFieldCaption() { FieldCaption.Reset(); }
		bool ShouldSerializeFieldCaption() { return FieldCaption.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint field captions in a LayoutView's cards."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject FieldCaption { get { return fieldCaption; } }
		void ResetFieldValue() { FieldValue.Reset(); }
		bool ShouldSerializeFieldValue() { return FieldValue.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint field values in a LayoutView's cards."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject FieldValue { get { return fieldValue; } }
		void ResetFieldEditingValue() { FieldEditingValue.Reset(); }
		bool ShouldSerializeFieldEditingValue() { return FieldEditingValue.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint field values in edit mode."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject FieldEditingValue { get { return fieldEditingValue; } }
		void ResetSelectedCardCaption() { SelectedCardCaption.Reset(); }
		bool ShouldSerializeSelectedCardCaption() { return SelectedCardCaption.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the captions of selected cards."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject SelectedCardCaption { get { return selectedCardCaption; } }
		void ResetFocusedCardCaption() { FocusedCardCaption.Reset(); }
		bool ShouldSerializeFocusedCardCaption() { return FocusedCardCaption.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint a focused card's caption in a LayoutView."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject FocusedCardCaption { get { return focusedCardCaption; } }
		void ResetHideSelectionCardCaption() { HideSelectionCardCaption.Reset(); }
		bool ShouldSerializeHideSelectionCardCaption() { return HideSelectionCardCaption.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the captions of selected cards when the grid control is not focused."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject HideSelectionCardCaption { get { return hideSelectionCardCaption; } }
		void ResetSeparatorLine() { SeparatorLine.Reset(); }
		bool ShouldSerializeSeparatorLine() { return SeparatorLine.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint card separators."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject SeparatorLine { get { return separatorLine; } }
	}
	public class LayoutViewPrintAppearances : ColumnViewPrintAppearances {
		public LayoutViewPrintAppearances(BaseView view) : base(view) { }
		AppearanceObject card,cardCaption, fieldCaption, fieldValue;
		protected override void CreateAppearances() { 
			base.CreateAppearances();
			this.card = CreateAppearance("Card");
			this.cardCaption = CreateAppearance("CardCaption");
			this.fieldCaption = CreateAppearance("FieldCaption");
			this.fieldValue = CreateAppearance("FieldValue");
		}
		void ResetCard() { Card.Reset(); }
		bool ShouldSerializeCard() { return Card.ShouldSerialize(); }
		[Description(""), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject Card { get { return card; } }
		void ResetCardCaption() { CardCaption.Reset(); }
		bool ShouldSerializeCardCaption() { return CardCaption.ShouldSerialize(); }
		[Description(""), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject CardCaption { get { return cardCaption; } }
		void ResetFieldCaption() { FieldCaption.Reset(); }
		bool ShouldSerializeFieldCaption() { return FieldCaption.ShouldSerialize(); }
		[Description(""), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject FieldCaption { get { return fieldCaption; } }
		void ResetFieldValue() { FieldValue.Reset(); }
		bool ShouldSerializeFieldValue() { return FieldValue.ShouldSerialize(); }
		[Description(""), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject FieldValue { get { return fieldValue; } }
	}
}
