#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{       XtraGrid                                                    }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System;
using System.Collections.Generic;
using System.Text;
using DevExpress.XtraGrid.Views.Base;
using DevExpress.XtraGrid.Views.Card;
using System.ComponentModel;
using DevExpress.Utils.Serializing;
using DevExpress.Utils.Controls;
using DevExpress.XtraGrid.Views;
using DevExpress.XtraGrid.Views.Layout.ViewInfo;
using DevExpress.XtraLayout;
using System.Drawing.Drawing2D;
using System.Drawing;
namespace DevExpress.XtraGrid.Views.Layout {
	public class LayoutViewOptionsHeaderPanel : ViewBaseOptions {
		LayoutView viewCore = null;
		bool showSingleModeButtonCore;
		bool showRowModeButtonCore;
		bool showColumnModeButtonCore;
		bool showMultiRowModeButtonCore;
		bool showMultiColumnModeButtonCore;
		bool showCarouselModeButtonCore;
		bool showPanButtonCore;
		bool showCustomizeButtonCore;
		bool enableSingleModeButtonCore;
		bool enableRowModeButtonCore;
		bool enableColumnModeButtonCore;
		bool enableMultiRowModeButtonCore;
		bool enableMultiColumnModeButtonCore;
		bool enableCarouselModeButtonCore;
		bool enablePanButtonCore;
		bool enableCustomizeButtonCore;
		public LayoutViewOptionsHeaderPanel(LayoutView view) {
			this.viewCore = view;
			this.showSingleModeButtonCore = true;
			this.showRowModeButtonCore = true;
			this.showColumnModeButtonCore = true;
			this.showMultiRowModeButtonCore = true;
			this.showMultiColumnModeButtonCore = true;
			this.showCarouselModeButtonCore = true;
			this.showPanButtonCore = true;
			this.showCustomizeButtonCore = true;
			this.enableSingleModeButtonCore = true;
			this.enableRowModeButtonCore = true;
			this.enableColumnModeButtonCore = true;
			this.enableMultiRowModeButtonCore = true;
			this.enableMultiColumnModeButtonCore = true;
			this.enableCarouselModeButtonCore = true;
			this.enablePanButtonCore = true;
			this.enableCustomizeButtonCore = true;
		}
		public override void Assign(BaseOptions options) {
			base.Assign(options);
			LayoutViewOptionsHeaderPanel source = options as LayoutViewOptionsHeaderPanel;
			this.showSingleModeButtonCore = source.showSingleModeButtonCore;
			this.showRowModeButtonCore = source.showRowModeButtonCore;
			this.showColumnModeButtonCore = source.showColumnModeButtonCore;
			this.showMultiRowModeButtonCore = source.showMultiRowModeButtonCore;
			this.showMultiColumnModeButtonCore = source.showMultiColumnModeButtonCore;
			this.showCarouselModeButtonCore = source.showCarouselModeButtonCore;
			this.showPanButtonCore = source.showPanButtonCore;
			this.showCustomizeButtonCore = source.showCustomizeButtonCore;
			this.enableSingleModeButtonCore = source.enableSingleModeButtonCore;
			this.enableRowModeButtonCore = source.enableRowModeButtonCore;
			this.enableColumnModeButtonCore = source.enableColumnModeButtonCore;
			this.enableMultiRowModeButtonCore = source.enableMultiRowModeButtonCore;
			this.enableMultiColumnModeButtonCore = source.enableMultiColumnModeButtonCore;
			this.enableCarouselModeButtonCore = source.enableCarouselModeButtonCore;
			this.enablePanButtonCore = source.enablePanButtonCore;
			this.enableCustomizeButtonCore = source.enableCustomizeButtonCore;
		}
		[Description("Gets or sets whether the One Card button is displayed within the Header Panel."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowSingleModeButton {
			get { return showSingleModeButtonCore; }
			set {
				if(ShowSingleModeButton == value) return;
				bool prevValue = ShowSingleModeButton;
				showSingleModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowSingleModeButton", prevValue, ShowSingleModeButton));
			}
		}
		[Description("Gets or sets whether the One Card view mode can be enabled via the corresponding button within the Header Panel and keyboard shortcut (ALT+1)."), DefaultValue(true), XtraSerializableProperty()]
		public bool EnableSingleModeButton {
			get { return enableSingleModeButtonCore; }
			set {
				if(EnableSingleModeButton == value) return;
				bool prevValue = EnableSingleModeButton;
				enableSingleModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("EnableSingleModeButton", prevValue, EnableSingleModeButton));
			}
		}
		[Description("Gets or sets whether the One Row button is displayed within the Header Panel."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowRowModeButton {
			get { return showRowModeButtonCore; }
			set {
				if(ShowRowModeButton == value) return;
				bool prevValue = ShowRowModeButton;
				showRowModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowRowModeButton", prevValue, ShowRowModeButton));
			}
		}
		[Description("Gets or sets whether the One Row view mode can be enabled via the corresponding button within the Header Panel and keyboard shortcut (ALT+2)."), DefaultValue(true), XtraSerializableProperty()]
		public bool EnableRowModeButton {
			get { return enableRowModeButtonCore; }
			set {
				if(EnableRowModeButton == value) return;
				bool prevValue = EnableRowModeButton;
				enableRowModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("EnableRowModeButton", prevValue, EnableRowModeButton));
			}
		}
		[Description("Gets or sets whether the One Column button is displayed within the Header Panel."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowColumnModeButton {
			get { return showColumnModeButtonCore; }
			set {
				if(ShowColumnModeButton == value) return;
				bool prevValue = ShowColumnModeButton;
				showColumnModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowColumnModeButton", prevValue, ShowColumnModeButton));
			}
		}
		[Description("Gets or sets whether the One Column view mode can be enabled via the corresponding button within the Header Panel and keyboard shortcut (ALT+3)."), DefaultValue(true), XtraSerializableProperty()]
		public bool EnableColumnModeButton {
			get { return enableColumnModeButtonCore; }
			set {
				if(EnableColumnModeButton == value) return;
				bool prevValue = EnableColumnModeButton;
				enableColumnModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("EnableColumnModeButton", prevValue, EnableColumnModeButton));
			}
		}
		[Description("Gets or sets whether the Multiple Rows button is displayed within the Header Panel."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowMultiRowModeButton {
			get { return showMultiRowModeButtonCore; }
			set {
				if(ShowMultiRowModeButton == value) return;
				bool prevValue = ShowMultiRowModeButton;
				showMultiRowModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowMultiRowModeButton", prevValue, ShowMultiRowModeButton));
			}
		}
		[Description("Gets or sets whether the Multiple Rows view mode can be enabled via the corresponding button within the Header Panel and keyboard shortcut (ALT+4)."), DefaultValue(true), XtraSerializableProperty()]
		public bool EnableMultiRowModeButton {
			get { return enableMultiRowModeButtonCore; }
			set {
				if(EnableMultiRowModeButton == value) return;
				bool prevValue = EnableMultiRowModeButton;
				enableMultiRowModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("EnableMultiRowModeButton", prevValue, EnableMultiRowModeButton));
			}
		}
		[Description("Gets or sets whether the Multiple Columns button is displayed within the Header Panel."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowMultiColumnModeButton {
			get { return showMultiColumnModeButtonCore; }
			set {
				if(ShowMultiColumnModeButton == value) return;
				bool prevValue = ShowMultiColumnModeButton;
				showMultiColumnModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowMultiColumnModeButton", prevValue, ShowMultiColumnModeButton));
			}
		}
		[Description("Gets or sets whether the Multiple Columns view mode can be enabled via the corresponding button within the Header Panel and keyboard shortcut (ALT+5)."), DefaultValue(true), XtraSerializableProperty()]
		public bool EnableMultiColumnModeButton {
			get { return enableMultiColumnModeButtonCore; }
			set {
				if(EnableMultiColumnModeButton == value) return;
				bool prevValue = EnableMultiColumnModeButton;
				enableMultiColumnModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("EnableMultiColumnModeButton", prevValue, EnableMultiColumnModeButton));
			}
		}
		[Description("Gets or sets whether the Carousel Mode button is displayed within the Header Panel."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowCarouselModeButton {
			get { return showCarouselModeButtonCore; }
			set {
				if(ShowCarouselModeButton == value) return;
				bool prevValue = ShowCarouselModeButton;
				showCarouselModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowCarouselModeButton", prevValue, ShowCarouselModeButton));
			}
		}
		[Description("Gets or sets whether the Carousel view mode can be enabled via the corresponding button within the Header Panel and keyboard shortcut (ALT+6)."), DefaultValue(true), XtraSerializableProperty()]
		public bool EnableCarouselModeButton {
			get { return enableCarouselModeButtonCore; }
			set {
				if(EnableCarouselModeButton == value) return;
				bool prevValue = EnableCarouselModeButton;
				enableCarouselModeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("EnableCarouselModeButton", prevValue, EnableCarouselModeButton));
			}
		}
		[Description("Gets or sets whether the Panning button is displayed within the Header Panel."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowPanButton {
			get { return showPanButtonCore; }
			set {
				if(ShowPanButton == value) return;
				bool prevValue = ShowPanButton;
				showPanButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowPanButton", prevValue, ShowPanButton));
			}
		}
		[Description("Gets or sets whether the Panning mode can be enabled via the corresponding button within the Header Panel and keyboard shortcut (F10)."), DefaultValue(true), XtraSerializableProperty()]
		public bool EnablePanButton {
			get { return enablePanButtonCore; }
			set {
				if(EnablePanButton == value) return;
				bool prevValue = EnablePanButton;
				enablePanButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("EnablePanButton", prevValue, EnablePanButton));
			}
		}
		[Description("Gets or sets whether the Customize button is displayed within the Header Panel. "), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowCustomizeButton {
			get { return showCustomizeButtonCore; }
			set {
				if(ShowCustomizeButton == value) return;
				bool prevValue = ShowCustomizeButton;
				showCustomizeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowCustomizeButton", prevValue, ShowCustomizeButton));
			}
		}
		[Description("Gets or sets whether the Customization Form can be enabled via the Customize button within the Header Panel and keyboard shortcut (F6)."), DefaultValue(true), XtraSerializableProperty()]
		public bool EnableCustomizeButton {
			get { return enableCustomizeButtonCore; }
			set {
				if(EnableCustomizeButton == value) return;
				bool prevValue = EnableCustomizeButton;
				enableCustomizeButtonCore = value;
				OnChanged(new BaseOptionChangedEventArgs("EnableCustomizeButton", prevValue, EnableCustomizeButton));
			}
		}
	}
	public class LayoutViewOptionsCustomization : ViewBaseOptions {
		LayoutView viewCore = null;
		bool allowSortCore;
		bool allowFilterCore;
		bool useAdvancedRuntimeCustomizationCore;
		bool showGroupHiddenItemsCore;
		bool showGroupLayoutTreeViewCore;
		bool showGroupPropertyGridCore;
		bool showUndoRedoButtonsCore;
		bool showResetShrinkButtonsCore;
		bool showGroupCardIndentsCore;
		bool showGroupCardCaptionsCore;
		bool showSaveLoadLayoutButtonsCore;
		bool showGroupViewCore;
		bool showGroupLayoutCore;
		bool showGroupCardsCore;
		bool showGroupFieldsCore;
		public LayoutViewOptionsCustomization(LayoutView view) {
			this.viewCore = view;
			this.allowSortCore = true;
			this.allowFilterCore = true;
			this.useAdvancedRuntimeCustomizationCore = false;
			this.showGroupHiddenItemsCore = true;
			this.showGroupLayoutTreeViewCore = true;
			this.showGroupPropertyGridCore = true;
			this.showUndoRedoButtonsCore = true;
			this.showResetShrinkButtonsCore = true;
			this.showGroupCardIndentsCore = true;
			this.showGroupCardCaptionsCore = true;
			this.showSaveLoadLayoutButtonsCore = true;
			this.showGroupViewCore = true;
			this.showGroupLayoutCore = true;
			this.showGroupCardsCore = true;
			this.showGroupFieldsCore = true;
		}
		public override void Assign(BaseOptions options) {
			base.Assign(options);
			LayoutViewOptionsCustomization source = options as LayoutViewOptionsCustomization;
			this.allowSortCore = source.allowSortCore;
			this.allowFilterCore = source.allowFilterCore;
			this.useAdvancedRuntimeCustomizationCore = source.useAdvancedRuntimeCustomizationCore;
			this.showGroupHiddenItemsCore = source.showGroupHiddenItemsCore;
			this.showGroupLayoutTreeViewCore = source.showGroupLayoutTreeViewCore;
			this.showGroupPropertyGridCore = source.showGroupPropertyGridCore;
			this.showUndoRedoButtonsCore = source.showUndoRedoButtonsCore;
			this.showResetShrinkButtonsCore = source.showResetShrinkButtonsCore;
			this.showGroupCardIndentsCore = source.showGroupCardIndentsCore;
			this.showGroupCardCaptionsCore = source.showGroupCardCaptionsCore;
			this.showSaveLoadLayoutButtonsCore = source.showSaveLoadLayoutButtonsCore;
			this.showGroupViewCore = source.showGroupViewCore;
			this.showGroupLayoutCore = source.showGroupLayoutCore;
			this.showGroupCardsCore = source.showGroupCardsCore;
			this.showGroupFieldsCore = source.showGroupFieldsCore;
		}
		[Description("Gets or sets a value specifying whether end-users can sort data."), DefaultValue(true), XtraSerializableProperty()]
		public bool AllowSort {
			get { return allowSortCore; }
			set {
				if(AllowSort == value) return;
				bool prevValue = AllowSort;
				allowSortCore = value;
				OnChanged(new BaseOptionChangedEventArgs("AllowSort", prevValue, AllowSort));
			}
		}
		[Description("Gets or sets a value which specifies whether end-users can filter data in the View."), DefaultValue(true), XtraSerializableProperty()]
		public bool AllowFilter {
			get { return allowFilterCore; }
			set {
				if(AllowFilter == value) return;
				bool prevValue = AllowFilter;
				allowFilterCore = value;
				OnChanged(new BaseOptionChangedEventArgs("AllowFilter", prevValue, AllowFilter));
			}
		}
		[Description("Gets or sets whether additional edit controls providing advanced customization capabilities can be displayed within the LayoutView's Customization Form."), DefaultValue(false), XtraSerializableProperty()]
		public bool UseAdvancedRuntimeCustomization {
			get { return useAdvancedRuntimeCustomizationCore; } 
			set {
				if(UseAdvancedRuntimeCustomization == value) return;
				bool prevValue = UseAdvancedRuntimeCustomization;
				useAdvancedRuntimeCustomizationCore = value;
				OnChanged(new BaseOptionChangedEventArgs("UseAdvancedRuntimeCustomization", prevValue, UseAdvancedRuntimeCustomization));
			}
		}
		[Description("Gets or sets whether the Layout Tree View is displayed within the Template Card tab in the Customization Form in advanced customization mode."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowGroupLayoutTreeView {
			get { return showGroupLayoutTreeViewCore; }
			set {
				if(ShowGroupLayoutTreeView == value) return;
				bool prevValue = ShowGroupLayoutTreeView;
				showGroupLayoutTreeViewCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowGroupLayoutTreeView", prevValue, ShowGroupLayoutTreeView));
			}
		}
		[Description("Gets or sets whether the Hidden Items list is displayed within the Template Card tab in the Customization Form in advanced customization mode."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowGroupHiddenItems {
			get { return showGroupHiddenItemsCore; }
			set {
				if(ShowGroupHiddenItems == value) return;
				bool prevValue = ShowGroupHiddenItems;
				showGroupHiddenItemsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowGroupHiddenItems", prevValue, ShowGroupHiddenItems));
			}
		}
		protected internal bool ShowGroupPropertyGrid {
			get { return showGroupPropertyGridCore; }
			set {
				if(ShowGroupPropertyGrid == value) return;
				bool prevValue = ShowGroupPropertyGrid;
				showGroupPropertyGridCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowGroupPropertyGrid", prevValue, ShowGroupPropertyGrid));
			}
		}
		[Description("Gets or sets whether the Reset Template Card and Shrink Template Card buttons are displayed within the Template Card tab in the Customization Form in advanced customization mode."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowResetShrinkButtons {
			get { return showResetShrinkButtonsCore; }
			set {
				if(ShowResetShrinkButtons == value) return;
				bool prevValue = ShowResetShrinkButtons;
				showResetShrinkButtonsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowResetShrinkButtons", prevValue, ShowResetShrinkButtons));
			}
		}
		[Description("Gets or sets whether the Indents group of edit controls is displayed within the Template Card tab in the Customization Form in advanced customization mode."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowGroupCardIndents {
			get { return showGroupCardIndentsCore; }
			set {
				if(ShowGroupCardIndents == value) return;
				bool prevValue = ShowGroupCardIndents;
				showGroupCardIndentsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowGroupCardIndents", prevValue, ShowGroupCardIndents));
			}
		}
		[Description("Gets or sets whether the Captions group of edit controls is displayed within the Template Card tab in the Customization Form in advanced customization mode."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowGroupCardCaptions {
			get { return showGroupCardCaptionsCore; }
			set {
				if(ShowGroupCardCaptions == value) return;
				bool prevValue = ShowGroupCardCaptions;
				showGroupCardCaptionsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowGroupCardCaptions", prevValue, ShowGroupCardCaptions));
			}
		}
		[Description("Gets or sets whether the Load Layout and Save Layout buttons are displayed within the View Layout tab in the Customization Form in advanced customization mode."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowSaveLoadLayoutButtons {
			get { return showSaveLoadLayoutButtonsCore; }
			set {
				if(ShowSaveLoadLayoutButtons == value) return;
				bool prevValue = ShowSaveLoadLayoutButtons;
				showSaveLoadLayoutButtonsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowSaveLoadLayoutButtons", prevValue, ShowSaveLoadLayoutButtons));
			}
		}
		[Description("Gets or sets whether the View group of edit controls is displayed within the View Layout tab in the Customization Form in advanced customization mode."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowGroupView {
			get { return showGroupViewCore; }
			set {
				if(ShowGroupView == value) return;
				bool prevValue = ShowGroupView;
				showGroupViewCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowGroupView", prevValue, ShowGroupView));
			}
		}
		[Description("Gets or sets whether the Layout group of edit controls is displayed within the View Layout tab in the Customization Form in advanced customization mode."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowGroupLayout {
			get { return showGroupLayoutCore; }
			set {
				if(ShowGroupLayout == value) return;
				bool prevValue = ShowGroupLayout;
				showGroupLayoutCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowGroupLayout", prevValue, ShowGroupLayout));
			}
		}
		[Description("Gets or sets whether the Cards group of edit controls is displayed within the View Layout tab in the Customization Form in advanced customization mode."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowGroupCards {
			get { return showGroupCardsCore; }
			set {
				if(ShowGroupCards == value) return;
				bool prevValue = ShowGroupCards;
				showGroupCardsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowGroupCards", prevValue, ShowGroupCards));
			}
		}
		[Description("Gets or sets whether the Fields group of edit controls is displayed within the View Layout tab in the Customization Form in advanced customization mode."), DefaultValue(true), XtraSerializableProperty()]
		public bool ShowGroupFields {
			get { return showGroupFieldsCore; }
			set {
				if(ShowGroupFields == value) return;
				bool prevValue = ShowGroupFields;
				showGroupFieldsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowGroupFields", prevValue, ShowGroupFields));
			}
		}
	}
	public enum ScrollBarOrientation { Default, Horizontal, Vertical }
	public class LayoutViewOptionsMultiRecordMode : ViewBaseOptions {
		LayoutView viewCore = null;
		bool stretchCardToViewWidthCore;
		bool stretchCardToViewHeightCore;
		int maxCardRowsCore;
		int maxCardColumnsCore;
		ScrollBarOrientation multiRowScrollOrientationCore;
		ScrollBarOrientation multiColumnScrollOrientationCore;
		public LayoutViewOptionsMultiRecordMode(LayoutView view) {
			this.viewCore = view;
			this.stretchCardToViewWidthCore = false;
			this.stretchCardToViewHeightCore = false;
			this.maxCardRowsCore = 0;
			this.maxCardColumnsCore = 0;
			this.multiRowScrollOrientationCore = ScrollBarOrientation.Default;
			this.multiColumnScrollOrientationCore = ScrollBarOrientation.Default;
		}
		public override void Assign(BaseOptions options) {
			base.Assign(options);
			LayoutViewOptionsMultiRecordMode source = options as LayoutViewOptionsMultiRecordMode;
			this.stretchCardToViewWidthCore = source.stretchCardToViewWidthCore;
			this.stretchCardToViewHeightCore = source.stretchCardToViewHeightCore;
			this.maxCardRowsCore = source.maxCardRowsCore;
			this.maxCardColumnsCore = source.maxCardColumnsCore;
			this.multiRowScrollOrientationCore = source.multiRowScrollOrientationCore;
			this.multiColumnScrollOrientationCore = source.multiColumnScrollOrientationCore;
		}
		[Description("Gets or sets the scroll bar's orientation in multi column display mode."), DefaultValue(ScrollBarOrientation.Default), XtraSerializableProperty()]
		public virtual ScrollBarOrientation MultiColumnScrollBarOrientation {
			get { return multiColumnScrollOrientationCore; }
			set {
				if(MultiColumnScrollBarOrientation == value) return;
				ScrollBarOrientation prevValue = MultiColumnScrollBarOrientation;
				multiColumnScrollOrientationCore = value;
				OnChanged(new BaseOptionChangedEventArgs("MultiColumnScrollBarOrientation", prevValue, MultiColumnScrollBarOrientation));
			}
		}
		[Description("Gets or sets the scroll bar's orientation in multi row display mode."), DefaultValue(ScrollBarOrientation.Default), XtraSerializableProperty()]
		public virtual ScrollBarOrientation MultiRowScrollBarOrientation {
			get { return multiRowScrollOrientationCore; }
			set {
				if(MultiRowScrollBarOrientation == value) return;
				ScrollBarOrientation prevValue = MultiRowScrollBarOrientation;
				multiRowScrollOrientationCore = value;
				OnChanged(new BaseOptionChangedEventArgs("MultiRowScrollBarOrientation", prevValue, MultiRowScrollBarOrientation));
			}
		}
		[Description("Gets or sets whether cards are stretched horizontally to fully fill the View's width. This option is in effect when cards are arranged in columns (in Column and MultiColumn view modes)."), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool StretchCardToViewWidth {
			get { return stretchCardToViewWidthCore; }
			set {
				if(StretchCardToViewWidth == value) return;
				bool prevValue = StretchCardToViewWidth;
				stretchCardToViewWidthCore = value;
				OnChanged(new BaseOptionChangedEventArgs("StretchCardToViewWidth", prevValue, StretchCardToViewWidth));
			}
		}
		[Description("Gets or sets whether cards are stretched vertically to fully fill the View's height. This option is in effect when cards are arranged in rows (in Row and MultiRow view modes)."), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool StretchCardToViewHeight {
			get { return stretchCardToViewHeightCore; }
			set {
				if(StretchCardToViewHeight == value) return;
				bool prevValue = StretchCardToViewHeight;
				stretchCardToViewHeightCore = value;
				OnChanged(new BaseOptionChangedEventArgs("StretchCardToViewHeight", prevValue, StretchCardToViewHeight));
			}
		}
		[Description("Gets or sets the maximum number of rows displayed in the View. This option is in effect when multiple rows are allowed to be displayed (in Column, MultiColumn and MultiRow view modes)."), DefaultValue(0), XtraSerializableProperty()]
		public virtual int MaxCardRows {
			get { return maxCardRowsCore; }
			set {
				if(MaxCardRows == value) return;
				int prevValue = MaxCardRows;
				maxCardRowsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("MaxCardRows", prevValue, MaxCardRows));
			}
		}
		[Description("Gets or sets the maximum number of columns displayed in the View. This option is in effect when multiple columns are allowed to be displayed (in Row, MultiRow and MultiColumn view modes)."), DefaultValue(0), XtraSerializableProperty()]
		public virtual int MaxCardColumns {
			get { return maxCardColumnsCore; }
			set {
				if(MaxCardColumns == value) return;
				int prevValue = MaxCardColumns;
				maxCardColumnsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("MaxCardColumns", prevValue, MaxCardColumns));
			}
		}
	}
	public class LayoutViewOptionsSingleRecordMode : ViewBaseOptions {
		LayoutView viewCore = null;
		CardsAlignment cardAlignmentCore;
		bool stretchCardToViewWidthCore;
		bool stretchCardToViewHeightCore;
		public LayoutViewOptionsSingleRecordMode(LayoutView view) {
			this.viewCore = view;
			this.stretchCardToViewWidthCore = false;
			this.stretchCardToViewHeightCore = false;
			this.cardAlignmentCore = CardsAlignment.Center;
		}
		public override void Assign(BaseOptions options) {
			base.Assign(options);
			LayoutViewOptionsSingleRecordMode source = options as LayoutViewOptionsSingleRecordMode;
			this.stretchCardToViewWidthCore = source.stretchCardToViewWidthCore;
			this.stretchCardToViewHeightCore = source.stretchCardToViewHeightCore;
			this.cardAlignmentCore = source.cardAlignmentCore;
		}
		[Description("Gets or sets whether the currently visible card is stretched horizontally to fully fill the View's width. This option is in effect in Single Record view mode."), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool StretchCardToViewWidth {
			get { return stretchCardToViewWidthCore; }
			set {
				if(StretchCardToViewWidth == value) return;
				bool prevValue = StretchCardToViewWidth;
				stretchCardToViewWidthCore = value;
				OnChanged(new BaseOptionChangedEventArgs("StretchCardToViewWidth", prevValue, StretchCardToViewWidth));
			}
		}
		[Description("Gets or sets whether the currently visible card is stretched vertically to fully fill the View's height. This option is in effect in Single Record view mode."), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool StretchCardToViewHeight {
			get { return stretchCardToViewHeightCore; }
			set {
				if(StretchCardToViewHeight == value) return;
				bool prevValue = StretchCardToViewHeight;
				stretchCardToViewHeightCore = value;
				OnChanged(new BaseOptionChangedEventArgs("StretchCardToViewHeight", prevValue, StretchCardToViewHeight));
			}
		}
		[Description("Gets or sets the card's alignment within the View when the card is stretched to fully fill the View's width or height. This option is in effect when the LayoutViewOptionsSingleRecordMode.StretchCardToViewHeight or LayoutViewOptionsSingleRecordMode.StretchCardToViewWidth property is enabled (not both)."), DefaultValue(CardsAlignment.Center), XtraSerializableProperty()]
		public virtual CardsAlignment CardAlignment {
			get { return cardAlignmentCore; }
			set {
				if(CardAlignment == value) return;
				CardsAlignment prevValue = CardAlignment;
				cardAlignmentCore = value;
				OnChanged(new BaseOptionChangedEventArgs("CardAlignment", prevValue, CardAlignment));
			}
		}
	}
	public class LayoutViewOptionsCarouselMode : ViewBaseOptions {
		LayoutView viewCore = null;
		int cardCountCore;
		int radiusCore;
		float pitchAngleCore;
		float bottomCardScaleCore;
		float bottomCardAlphaLevelCore;
		float bottomCardFadingCore;
		float rollAngleCore;
		int frameCountCore;
		int frameDelayCore;
		Point centerOffsetCore;
		InterpolationMode interpolationModeCore;
		bool stretchCardToViewWidthCore;
		bool stretchCardToViewHeightCore;
		public LayoutViewOptionsCarouselMode(LayoutView view) {
			this.viewCore = view;
			this.cardCountCore = 15;
			this.pitchAngleCore = (float)Math.PI / 2;
			this.radiusCore = 0;
			this.bottomCardScaleCore = 0.2f;
			this.bottomCardAlphaLevelCore = 0.0f;
			this.bottomCardFadingCore = 0.0f;
			this.rollAngleCore = (float)Math.PI;
			this.frameCountCore = 250;
			this.frameDelayCore = 10000;
			this.interpolationModeCore = InterpolationMode.Default;
			this.centerOffsetCore = Point.Empty;
			this.stretchCardToViewWidthCore = false;
			this.stretchCardToViewHeightCore = false;
		}
		public override void Assign(BaseOptions options) {
			base.Assign(options);
			LayoutViewOptionsCarouselMode source = options as LayoutViewOptionsCarouselMode;
			this.cardCountCore = source.cardCountCore;
			this.pitchAngleCore = source.pitchAngleCore;
			this.radiusCore = source.radiusCore;
			this.bottomCardScaleCore = source.bottomCardScaleCore;
			this.bottomCardAlphaLevelCore = source.bottomCardAlphaLevelCore;
			this.bottomCardFadingCore = source.bottomCardFadingCore;
			this.rollAngleCore = source.rollAngleCore;
			this.frameCountCore = source.frameCountCore;
			this.frameDelayCore = source.frameDelayCore;
			this.interpolationModeCore = source.interpolationModeCore;
			this.stretchCardToViewWidthCore = source.stretchCardToViewWidthCore;
			this.stretchCardToViewHeightCore = source.stretchCardToViewHeightCore;
			this.centerOffsetCore = source.centerOffsetCore;
		}
		[Description("Gets or sets whether the active card is stretched to the LayoutView's width. "), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool StretchCardToViewWidth {
			get { return stretchCardToViewWidthCore; }
			set {
				if(StretchCardToViewWidth == value) return;
				bool prevValue = StretchCardToViewWidth;
				stretchCardToViewWidthCore = value;
				OnChanged(new BaseOptionChangedEventArgs("StretchCardToViewWidth", prevValue, StretchCardToViewWidth));
			}
		}
		[Description("Gets or sets whether the active card is stretched to the LayoutView's height. "), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool StretchCardToViewHeight {
			get { return stretchCardToViewHeightCore; }
			set {
				if(StretchCardToViewHeight == value) return;
				bool prevValue = StretchCardToViewHeight;
				stretchCardToViewHeightCore = value;
				OnChanged(new BaseOptionChangedEventArgs("StretchCardToViewHeight", prevValue, StretchCardToViewHeight));
			}
		}
		[Description("Gets or sets the interpolation mode used to render background cards."), DefaultValue(InterpolationMode.Default), XtraSerializableProperty()]
		public InterpolationMode InterpolationMode {
			get { return interpolationModeCore; }
			set {
				if(InterpolationMode == value) return;
				InterpolationMode prevValue = InterpolationMode;
				interpolationModeCore = value;
				OnChanged(new BaseOptionChangedEventArgs("InterpolationMode", prevValue, InterpolationMode));
			}
		}
		bool ShouldSerializeCenterOffset() { return CenterOffset != Point.Empty; }
		void ResetCenterOffset() {
			CenterOffset = Point.Empty;
		}
		[Description("Gets or sets the coordinates of the ellipse, in pixels."), XtraSerializableProperty()]
		public Point CenterOffset {
			get { return centerOffsetCore; }
			set {
				if(CenterOffset == value) return;
				Point prevValue = CenterOffset;
				centerOffsetCore = value;
				OnChanged(new BaseOptionChangedEventArgs("CenterOffset", prevValue, CenterOffset));
			}
		}
		[Description("Gets or sets the number of frames in the card scrolling animation effect."), DefaultValue(250), XtraSerializableProperty()]
		public int FrameCount {
			get { return frameCountCore; }
			set {
				if(FrameCount == value) return;
				int prevValue = FrameCount;
				frameCountCore = value;
				OnChanged(new BaseOptionChangedEventArgs("FrameCount", prevValue, FrameCount));
			}
		}
		[Description("Gets or sets the delay between frames in the card scrolling animation effect, in system timer ticks."), DefaultValue(10000), XtraSerializableProperty()]
		public int FrameDelay {
			get { return frameDelayCore; }
			set {
				if(FrameDelay == value) return;
				int prevValue = FrameDelay;
				frameDelayCore = value;
				OnChanged(new BaseOptionChangedEventArgs("FrameDelay", prevValue, FrameDelay));
			}
		}
		[Description("Gets or sets the number of cards constituting the ellipse."), DefaultValue(15), XtraSerializableProperty()]
		public int CardCount {
			get { return cardCountCore; }
			set {
				if(CardCount == value) return;
				int prevValue = CardCount;
				cardCountCore = value;
				OnChanged(new BaseOptionChangedEventArgs("RecordCount", prevValue, CardCount));
			}
		}
		[Description("Gets or sets the roll angle, in radians, ranging from 0 to 2@pi;."), DefaultValue((float)Math.PI), XtraSerializableProperty()]
		public float RollAngle {
			get { return rollAngleCore; }
			set {
				if(RollAngle == value) return;
				float prevValue = RollAngle;
				rollAngleCore = value;
				OnChanged(new BaseOptionChangedEventArgs("RollAngle", prevValue, RollAngle));
			}
		}
		[Description("Gets or sets the longest radius of the ellipse, in pixels."), DefaultValue(0), XtraSerializableProperty()]
		public int Radius {
			get { return radiusCore; }
			set {
				if(Radius == value) return;
				int prevValue = Radius;
				radiusCore = value;
				OnChanged(new BaseOptionChangedEventArgs("Radius", prevValue, Radius));
			}
		}
		[Description("Gets or sets the pitch angle, in radians, ranging from 0 to @pi;."), DefaultValue((float)Math.PI / 2), XtraSerializableProperty()]
		public float PitchAngle {
			get { return pitchAngleCore; }
			set {
				if(PitchAngle == value) return;
				float prevValue = PitchAngle;
				pitchAngleCore = value;
				OnChanged(new BaseOptionChangedEventArgs("PitchAngle", prevValue, PitchAngle));
			}
		}
		[Description("Gets or sets the scaling factor for background cards."), DefaultValue(0.2f), XtraSerializableProperty()]
		public float BottomCardScale {
			get { return bottomCardScaleCore; }
			set {
				if(BottomCardScale == value) return;
				float prevValue = BottomCardScale;
				bottomCardScaleCore = value;
				OnChanged(new BaseOptionChangedEventArgs("BottomCardScale", prevValue, BottomCardScale));
			}
		}
		[Description("Gets or sets the fading factor for background cards."), DefaultValue(0.0f), XtraSerializableProperty()]
		public float BottomCardFading {
			get { return bottomCardFadingCore; }
			set {
				if(BottomCardFading == value) return;
				float prevValue = BottomCardFading;
				bottomCardFadingCore = value;
				OnChanged(new BaseOptionChangedEventArgs("BottomCardFading", prevValue, BottomCardFading));
			}
		}
		[Description("Gets or sets the transparency level for background cards."), DefaultValue(0.0f), XtraSerializableProperty()]
		public float BottomCardAlphaLevel {
			get { return bottomCardAlphaLevelCore; }
			set {
				if(BottomCardAlphaLevel == value) return;
				float prevValue = BottomCardAlphaLevel;
				bottomCardAlphaLevelCore = value;
				OnChanged(new BaseOptionChangedEventArgs("BottomCardAlphaLevel", prevValue, BottomCardAlphaLevel));
			}
		}
	}
	public enum FieldTextAlignMode { AlignGlobal, AutoSize, CustomSize }
	public class LayoutViewOptionsItemText : ViewBaseOptions {
		LayoutView viewCore = null;
		FieldTextAlignMode alignModeCore;
		int textToControlDistanceCore;
		public LayoutViewOptionsItemText(LayoutView view) {
			this.viewCore = view;
			this.alignModeCore = FieldTextAlignMode.AlignGlobal;
			this.textToControlDistanceCore = 5;
		}
		public override void Assign(BaseOptions options) {
			base.Assign(options);
			LayoutViewOptionsItemText source = options as LayoutViewOptionsItemText;
			this.viewCore = source.viewCore;
			this.alignModeCore = source.alignModeCore;
			this.textToControlDistanceCore = source.textToControlDistanceCore;
		}
		[Description("Gets or sets the alignment mode for fields' text labels."), DefaultValue(FieldTextAlignMode.AlignGlobal), XtraSerializableProperty()]
		public FieldTextAlignMode AlignMode {
			get { return alignModeCore; }
			set {
				if(AlignMode == value) return;
				FieldTextAlignMode prevValue = AlignMode;
				alignModeCore = value;
				OnChanged(new BaseOptionChangedEventArgs("AlignMode", prevValue, AlignMode));
			}
		}
		[Description("Gets or sets the default distance between card fields' text labels and corresponding edit boxes."), DefaultValue(5), XtraSerializableProperty()]
		public int TextToControlDistance {
			get { return textToControlDistanceCore; }
			set {
				if(TextToControlDistance == value) return;
				int prevValue = TextToControlDistance;
				textToControlDistanceCore = value;
				OnChanged(new BaseOptionChangedEventArgs("TextToControlDistance", prevValue, TextToControlDistance));
			}
		}
		protected internal FieldTextAlignMode ConvertFrom(TextAlignMode mode) {
			switch(mode) {
				case TextAlignMode.AlignInGroups: return FieldTextAlignMode.AlignGlobal;
				case TextAlignMode.AlignInLayoutControl: return FieldTextAlignMode.AlignGlobal;
				case TextAlignMode.AutoSize: return FieldTextAlignMode.AutoSize;
				default:
					return FieldTextAlignMode.CustomSize;
			}
		}
		protected internal TextAlignMode ConvertTo(FieldTextAlignMode mode) {
			switch(mode) {
				case FieldTextAlignMode.AlignGlobal: return TextAlignMode.AlignInGroups;
				case FieldTextAlignMode.AutoSize: return TextAlignMode.AutoSize;
				default:
					return TextAlignMode.CustomSize;
			}
		}
	}
	public class LayoutViewOptionsBehavior : ColumnViewOptionsBehavior {
		bool allowExpandCollapseCore;
		bool allowPanCardsCore;
		bool allowRuntimeCustomizationCore;
		bool allowSwitchViewModesCore;
		bool autoFocusNewCardCore;
		bool autoFocusCardOnScrollingCore;
		bool useTabKeyCore;
		bool overrideLayoutControlRestoreBehaviorCore;
		ScrollVisibility scrollVisibilityCore;
		public LayoutViewOptionsBehavior(LayoutView view)
			: base(view) {
			this.allowExpandCollapseCore = true;
			this.allowPanCardsCore = true;
			this.allowRuntimeCustomizationCore = true;
			this.allowSwitchViewModesCore = true;
			this.autoFocusNewCardCore = false;
			this.autoFocusCardOnScrollingCore = false;
			this.scrollVisibilityCore = ScrollVisibility.Always;
			this.overrideLayoutControlRestoreBehaviorCore = false;
			this.useTabKeyCore = true;
		}
		public override void Assign(BaseOptions options) {
			base.Assign(options);
			LayoutViewOptionsBehavior source = options as LayoutViewOptionsBehavior;
			this.allowExpandCollapseCore = source.allowExpandCollapseCore;
			this.allowPanCardsCore = source.allowPanCardsCore;
			this.allowRuntimeCustomizationCore = source.allowRuntimeCustomizationCore;
			this.allowSwitchViewModesCore = source.allowSwitchViewModesCore;
			this.autoFocusNewCardCore = source.autoFocusNewCardCore;
			this.autoFocusCardOnScrollingCore = source.autoFocusCardOnScrollingCore;
			this.scrollVisibilityCore = source.scrollVisibilityCore;
			this.useTabKeyCore = source.useTabKeyCore;
			this.overrideLayoutControlRestoreBehaviorCore = source.overrideLayoutControlRestoreBehaviorCore;
		}
		[Obsolete("You don't need OverrideLayoutControlRestoreBehavior property anymore.")]
		[Browsable(false), EditorBrowsable(EditorBrowsableState.Never), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public virtual bool OverrideLayoutControlRestoreBehavior {
			get { return overrideLayoutControlRestoreBehaviorCore; }
			set { overrideLayoutControlRestoreBehaviorCore = true; }
		}
		[Description("Gets or sets a value specifying whether the TAB/SHIFT+TAB key combinations move focus within the Layout View, or to the next/previous control in tab order."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool UseTabKey {
			get { return useTabKeyCore; }
			set {
				if(UseTabKey == value) return;
				bool prevValue = UseTabKey;
				useTabKeyCore = value;
				OnChanged(new BaseOptionChangedEventArgs("UseTabKey", prevValue, UseTabKey));
			}
		}
		[Description("Gets or sets a value specifying when the scrollbar should be displayed. "), DefaultValue(ScrollVisibility.Always), XtraSerializableProperty()]
		public virtual ScrollVisibility ScrollVisibility {
			get { return scrollVisibilityCore; }
			set {
				if(ScrollVisibility == value) return;
				ScrollVisibility prevValue = ScrollVisibility;
				scrollVisibilityCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ScrollVisibility", prevValue, ScrollVisibility));
			}
		}
		[Description("Gets or sets a value specifying whether adding a new record  focuses the new card."), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool AutoFocusNewCard {
			get { return autoFocusNewCardCore; }
			set {
				if(AutoFocusNewCard == value) return;
				bool prevValue = AutoFocusNewCard;
				autoFocusNewCardCore = value;
				OnChanged(new BaseOptionChangedEventArgs("AutoFocusNewCard", prevValue, AutoFocusNewCard));
			}
		}
		[Description("Gets or sets whether the top visible card is automatically focused when scrolling the View."), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool AutoFocusCardOnScrolling {
			get { return autoFocusCardOnScrollingCore; }
			set {
				if(AutoFocusCardOnScrolling == value) return;
				bool prevValue = AutoFocusCardOnScrolling;
				autoFocusCardOnScrollingCore = value;
				OnChanged(new BaseOptionChangedEventArgs("AutoFocusCardOnScroll", prevValue, AutoFocusCardOnScrolling));
			}
		}
		[Description("Gets or sets whether cards can be collapsed."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool AllowExpandCollapse {
			get { return allowExpandCollapseCore; }
			set {
				if(AllowExpandCollapse == value) return;
				bool prevValue = AllowExpandCollapse;
				allowExpandCollapseCore = value;
				OnChanged(new BaseOptionChangedEventArgs("AllowExpandCollapse", prevValue, AllowExpandCollapse));
			}
		}
		[Description("Gets or sets whether the card panning feature can be enabled."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool AllowPanCards {
			get { return allowPanCardsCore; }
			set {
				if(AllowPanCards == value) return;
				bool prevValue = AllowPanCards;
				allowPanCardsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("AllowPanCards", prevValue, AllowPanCards));
			}
		}
		[Description("Gets or sets whether an end-user can customize the card layout at runtime via the Customization Form."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool AllowRuntimeCustomization {
			get { return allowRuntimeCustomizationCore; }
			set {
				if(AllowRuntimeCustomization == value) return;
				bool prevValue = AllowRuntimeCustomization;
				allowRuntimeCustomizationCore = value;
				OnChanged(new BaseOptionChangedEventArgs("AllowRuntimeCustomization", prevValue, AllowRuntimeCustomization));
			}
		}
		[Description("Gets or sets whether the view mode can be changed via the LayoutViewOptionsView.ViewMode property."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool AllowSwitchViewModes {
			get { return allowSwitchViewModesCore; }
			set {
				if(AllowSwitchViewModes == value) return;
				bool prevValue = AllowSwitchViewModes;
				allowSwitchViewModesCore = value;
				OnChanged(new BaseOptionChangedEventArgs("AllowSwitchViewModes", prevValue, AllowSwitchViewModes));
			}
		}
	}
	public enum CardsAlignment { Near, Center, Far }
	public enum LayoutViewMode { SingleRecord, Row, Column, MultiRow, MultiColumn, Carousel }
	public enum LayoutCardArrangeRule { ShowWholeCards, AllowPartialCards }
	public enum SortFilterButtonShowMode {
		Default,
		InFieldCaption,
		InFieldValue,
		Nowhere
	}
	public enum SortFilterButtonLocation {
		Default,
		MiddleLeft, MiddleCenter, MiddleRight,
		TopCenter, TopLeft, TopRight,
		BottomCenter, BottomLeft, BottomRight
	}
	public class OptionsField : ViewBaseOptions {
		SortFilterButtonLocation buttonLocationCore;
		SortFilterButtonShowMode buttonShowModeCore;
		public OptionsField() {
			this.buttonLocationCore = SortFilterButtonLocation.Default;
			this.buttonShowModeCore = SortFilterButtonShowMode.Default;
		}
		public override void Assign(BaseOptions options) {
			base.Assign(options);
			OptionsField source = options as OptionsField;
			if(options != null) {
				this.buttonLocationCore = source.buttonLocationCore;
				this.buttonShowModeCore = source.buttonShowModeCore;
			}
		}
		[Description("Gets or sets the location of sort and filter buttons within the region where these buttons are displayed."), DefaultValue(SortFilterButtonLocation.Default), XtraSerializableProperty()]
		public virtual SortFilterButtonLocation SortFilterButtonLocation {
			get { return buttonLocationCore; }
			set {
				if(SortFilterButtonLocation == value) return;
				SortFilterButtonLocation prevValue = SortFilterButtonLocation;
				this.buttonLocationCore = value;
				OnChanged(new BaseOptionChangedEventArgs("SortFilterButtonLocation", prevValue, SortFilterButtonLocation));
			}
		}
		[Description("Gets or sets the region where sort and filter buttons are displayed."), DefaultValue(SortFilterButtonShowMode.Default), XtraSerializableProperty()]
		public virtual SortFilterButtonShowMode SortFilterButtonShowMode {
			get { return buttonShowModeCore; }
			set {
				if(SortFilterButtonShowMode == value) return;
				SortFilterButtonShowMode prevValue = SortFilterButtonShowMode;
				this.buttonShowModeCore = value;
				OnChanged(new BaseOptionChangedEventArgs("SortFilterButtonShowMode", prevValue, SortFilterButtonShowMode));
			}
		}
	}
	public enum FocusRectStyle {
		Default,
		None
	}
	public class LayoutViewOptionsView : ColumnViewOptionsView {
		bool showFieldHints, showCardExpandButton;
		bool showHeaderPanel;
		bool showCardCaption;
		bool showCardBorderIfCaptionHidden;
		bool showCardLines;
		bool showCardFieldBorders;
		CardsAlignment cardsAlignment;
		LayoutViewMode viewMode;
		LayoutCardArrangeRule cardArrangeRule;
		int partialCardWrapThresholdCore;
		bool allowHotTrackFields;
		ContentAlignment contentAlignmentCore;
		FocusRectStyle focusRectStyleCore;
		LayoutView viewCore = null;
		public LayoutViewOptionsView(LayoutView view)
			: base() {
			this.viewCore = view;
			this.showCardExpandButton = true;
			this.showFieldHints = true;
			this.showHeaderPanel = true;
			this.showCardCaption = true;
			this.showCardLines = true;
			this.showCardFieldBorders = false;
			this.showCardBorderIfCaptionHidden = true;
			this.cardsAlignment = CardsAlignment.Center;
			this.viewMode = LayoutViewMode.SingleRecord;
			this.cardArrangeRule = LayoutCardArrangeRule.ShowWholeCards;
			this.partialCardWrapThresholdCore = 10;
			this.allowHotTrackFields = true;
			this.contentAlignmentCore = ContentAlignment.MiddleCenter;
			this.focusRectStyleCore = FocusRectStyle.Default;
		}
		public override void Assign(BaseOptions options) {
			base.Assign(options);
			LayoutViewOptionsView source = options as LayoutViewOptionsView;
			this.showCardExpandButton = source.showCardExpandButton;
			this.showFieldHints = source.showFieldHints;
			this.showHeaderPanel = source.showHeaderPanel;
			this.showCardCaption = source.showCardCaption;
			this.showCardLines = source.showCardLines;
			this.showCardFieldBorders = source.showCardFieldBorders;
			this.showCardBorderIfCaptionHidden = source.showCardBorderIfCaptionHidden;
			this.cardsAlignment = source.cardsAlignment;
			this.viewMode = source.viewMode;
			this.cardArrangeRule = source.cardArrangeRule;
			this.partialCardWrapThresholdCore = source.partialCardWrapThresholdCore;
			this.allowHotTrackFields = source.allowHotTrackFields;
			this.contentAlignmentCore = source.contentAlignmentCore;
			this.focusRectStyleCore = source.focusRectStyleCore;
		}
		[Description("Gets or sets whether card fields are highlighted when hovering over them with the mouse cursor."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool AllowHotTrackFields {
			get { return allowHotTrackFields; }
			set {
				if(AllowHotTrackFields == value) return;
				bool prevValue = AllowHotTrackFields;
				allowHotTrackFields = value;
				OnChanged(new BaseOptionChangedEventArgs("AllowHotTrackFields", prevValue, AllowHotTrackFields));
			}
		}
		[Description("Gets or sets whether the Header Panel is visible."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool ShowHeaderPanel {
			get { return showHeaderPanel; }
			set {
				if(ShowHeaderPanel == value) return;
				bool prevValue = ShowHeaderPanel;
				showHeaderPanel = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowHeaderPanel", prevValue, ShowHeaderPanel));
			}
		}
		[Description("Gets or sets whether only entire cards can be displayed at the same time, or allow cards to be partially displayed."),
		DefaultValue(LayoutCardArrangeRule.ShowWholeCards), XtraSerializableProperty()]
		public virtual LayoutCardArrangeRule CardArrangeRule {
			get { return cardArrangeRule; }
			set {
				if(CardArrangeRule == value) return;
				LayoutCardArrangeRule prevValue = CardArrangeRule;
				cardArrangeRule = value;
				OnChanged(new BaseOptionChangedEventArgs("CardArrangeRule", prevValue, CardArrangeRule));
			}
		}
		[Description("Gets or sets the threshold for partially displayed cards, in pixels."),
		DefaultValue(10), XtraSerializableProperty()]
		public virtual int PartialCardWrapThreshold {
			get { return partialCardWrapThresholdCore; }
			set {
				if(PartialCardWrapThreshold == value) return;
				int prevValue = PartialCardWrapThreshold;
				partialCardWrapThresholdCore = value;
				OnChanged(new BaseOptionChangedEventArgs("PartialCardWrapThreshold", prevValue, PartialCardWrapThreshold));
			}
		}
		[Description("Gets or sets whether a card's caption bar is visible."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool ShowCardCaption {
			get { return showCardCaption; }
			set {
				if(ShowCardCaption == value) return;
				bool prevValue = ShowCardCaption;
				showCardCaption = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowCardCaption", prevValue, ShowCardCaption));
			}
		}
		[Description("Gets or sets whether a card's border is painted when the card caption is hidden."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool ShowCardBorderIfCaptionHidden {
			get { return showCardBorderIfCaptionHidden; }
			set {
				if(showCardBorderIfCaptionHidden == value) return;
				bool prevValue = ShowCardBorderIfCaptionHidden;
				showCardBorderIfCaptionHidden = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowCardBorderIfCaptionHidden", prevValue, ShowCardBorderIfCaptionHidden));
			}
		}
		[Description("Gets or sets a value specifying whether card separators are displayed."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool ShowCardLines {
			get { return showCardLines; }
			set {
				if(ShowCardLines == value) return;
				bool prevValue = ShowCardLines;
				showCardLines = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowCardLines", prevValue, ShowCardLines));
			}
		}
		[Description("Gets or sets whether borders are displayed for card fields."), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool ShowCardFieldBorders {
			get { return showCardFieldBorders; }
			set {
				if(ShowCardFieldBorders == value) return;
				bool prevValue = ShowCardFieldBorders;
				showCardFieldBorders = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowCardFieldBorders", prevValue, ShowCardFieldBorders));
			}
		}
		[Description("Gets or sets whether expand/collapse buttons are displayed within card captions."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool ShowCardExpandButton {
			get { return showCardExpandButton; }
			set {
				if(ShowCardExpandButton == value) return;
				bool prevValue = ShowCardExpandButton;
				showCardExpandButton = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowCardExpandButton", prevValue, ShowCardExpandButton));
			}
		}
		[Description("Gets or sets whether the top, center or bottom of cards are aligned when they have different heights."), DefaultValue(CardsAlignment.Center), XtraSerializableProperty()]
		public virtual CardsAlignment CardsAlignment {
			get { return cardsAlignment; }
			set {
				if(CardsAlignment == value) return;
				CardsAlignment prevValue = CardsAlignment;
				cardsAlignment = value;
				OnChanged(new BaseOptionChangedEventArgs("CardsAlignment", prevValue, CardsAlignment));
			}
		}
		[Description("Gets or sets whether cards are centered within the View, or aligned to its specific edge."), DefaultValue(ContentAlignment.MiddleCenter), XtraSerializableProperty()]
		public virtual ContentAlignment ContentAlignment {
			get { return contentAlignmentCore; }
			set {
				if(ContentAlignment == value) return;
				ContentAlignment prevValue = ContentAlignment;
				contentAlignmentCore = value;
				OnChanged(new BaseOptionChangedEventArgs("ContentAlignment", prevValue, CardsAlignment));
			}
		}
		[Description("Gets or sets how the focus rectangle is painted around fields."), DefaultValue(FocusRectStyle.Default), XtraSerializableProperty()]
		public virtual FocusRectStyle FocusRectStyle {
			get { return focusRectStyleCore; }
			set {
				if(FocusRectStyle == value) return;
				FocusRectStyle prevValue = FocusRectStyle;
				focusRectStyleCore = value;
				OnChanged(new BaseOptionChangedEventArgs("FocusRectStyle", prevValue, FocusRectStyle));
			}
		}
		[Description("Gets or sets the card layout."), DefaultValue(LayoutViewMode.SingleRecord), XtraSerializableProperty()]
		public virtual LayoutViewMode ViewMode {
			get { return viewMode; }
			set {
				if(ViewMode == value || !viewCore.OptionsBehavior.AllowSwitchViewModes) return;
				LayoutViewMode prevValue = ViewMode;
				viewMode = value;
				OnChanged(new BaseOptionChangedEventArgs("ViewMode", prevValue, ViewMode));
			}
		}
		[Description("Gets or sets a value specifying whether hints are displayed for card fields with truncated content. "), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool ShowFieldHints {
			get { return showFieldHints; }
			set {
				if(ShowFieldHints == value) return;
				bool prevValue = ShowFieldHints;
				showFieldHints = value;
				OnChanged(new BaseOptionChangedEventArgs("ShowFieldHints", prevValue, ShowFieldHints));
			}
		}
	}
	public enum LayoutViewPrintOptionsFlags {
		PrintFilterInfo,
		PrintCardCaption,
		PrintSelectedCardOnly,
		UsePrintStyles
	}
	public enum LayoutViewPrintMode {
		Default, Row, Column, MultiRow, MultiColumn
	}
	public class LayoutViewOptionsPrint : ViewPrintOptionsBase {
		bool printCardCaptionCore, printSelectedCardsOnlyCore, usePrintStylesCore, printFilterInfoCore;
		int maxCardRowsCore;
		int maxCardColumnsCore;
		LayoutViewPrintMode printModeCore;
		public LayoutViewOptionsPrint()
			: base() {
			this.printFilterInfoCore = false;
			this.printCardCaptionCore = true;
			this.printSelectedCardsOnlyCore = false;
			this.usePrintStylesCore = false;
			this.maxCardRowsCore = 0;
			this.maxCardColumnsCore = 0;
			this.printModeCore = LayoutViewPrintMode.Default;
		}
		[Description("Gets or sets the card layout when the View is printed/exported."), DefaultValue(LayoutViewPrintMode.Default), XtraSerializableProperty()]
		public virtual LayoutViewPrintMode PrintMode {
			get { return printModeCore; }
			set {
				if(PrintMode == value) return;
				LayoutViewPrintMode prevValue = PrintMode;
				printModeCore = value;
				OnChanged(new BaseOptionChangedEventArgs("PrintMode", prevValue, PrintMode));
			}
		}
		[Description("Gets or sets the maximum number of rows in the print/export output. This option is in effect when cards are arranged in multiple rows (the LayoutViewOptionsPrint.PrintMode property is set to MultiRow)."), DefaultValue(0), XtraSerializableProperty()]
		public virtual int MaxCardRows {
			get { return maxCardRowsCore; }
			set {
				if(MaxCardRows == value) return;
				int prevValue = MaxCardRows;
				maxCardRowsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("MaxCardRows", prevValue, MaxCardRows));
			}
		}
		[Description("Gets or sets the maximum number of columns in the print/export output. This option is in effect when cards are arranged in multiple columns (the LayoutViewOptionsPrint.PrintMode property is set to MultiColumn)."), DefaultValue(0), XtraSerializableProperty()]
		public virtual int MaxCardColumns {
			get { return maxCardColumnsCore; }
			set {
				if(MaxCardColumns == value) return;
				int prevValue = MaxCardColumns;
				maxCardColumnsCore = value;
				OnChanged(new BaseOptionChangedEventArgs("MaxCardColumns", prevValue, MaxCardColumns));
			}
		}
		[Description("Gets or sets a value specifying whether card captions are displayed in the print/export output."), DefaultValue(true), XtraSerializableProperty()]
		public virtual bool PrintCardCaption {
			get { return printCardCaptionCore; }
			set {
				if(PrintCardCaption == value) return;
				bool prevValue = PrintCardCaption;
				printCardCaptionCore = value;
				OnChanged(new BaseOptionChangedEventArgs("PrintCardCaption", prevValue, PrintCardCaption));
			}
		}
		[Description("Gets or sets a value specifying whether the filter panel is displayed in the print/export output."), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool PrintFilterInfo {
			get { return printFilterInfoCore; }
			set {
				if(PrintFilterInfo == value) return;
				bool prevValue = PrintFilterInfo;
				printFilterInfoCore = value;
				OnChanged(new BaseOptionChangedEventArgs("PrintFilterInfo", prevValue, PrintFilterInfo));
			}
		}
		[Browsable(false), EditorBrowsable(EditorBrowsableState.Never), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden),
		Obsolete(ObsoleteText.SRCardOptionsPrint_PrintSelectedCardOnly)]
		public bool PrintSelectedCardOnly {
			get { return PrintSelectedCardsOnly; }
			set { PrintSelectedCardsOnly = value; }
		}
		[Description("Gets or sets whether only the focused/selected cards are printed/exported."), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool PrintSelectedCardsOnly {
			get { return printSelectedCardsOnlyCore; }
			set {
				if(PrintSelectedCardsOnly == value) return;
				bool prevValue = PrintSelectedCardsOnly;
				printSelectedCardsOnlyCore = value;
				OnChanged(new BaseOptionChangedEventArgs("PrintSelectedCardsOnly", prevValue, PrintSelectedCardsOnly));
			}
		}
		[Description("Gets or sets whether print styles or the View's appearance settings are used when printing/exporting the View."), DefaultValue(false), XtraSerializableProperty()]
		public virtual bool UsePrintStyles {
			get { return usePrintStylesCore; }
			set {
				if(UsePrintStyles == value) return;
				bool prevValue = UsePrintStyles;
				usePrintStylesCore = value;
				OnChanged(new BaseOptionChangedEventArgs("UsePrintStyles", prevValue, UsePrintStyles));
			}
		}
		public override void Assign(BaseOptions options) {
			BeginUpdate();
			try {
				base.Assign(options);
				LayoutViewOptionsPrint source = options as LayoutViewOptionsPrint;
				if(source == null) return;
				this.printModeCore = source.printModeCore;
				this.printFilterInfoCore = source.printFilterInfoCore;
				this.printCardCaptionCore = source.printCardCaptionCore;
				this.printSelectedCardsOnlyCore = source.printSelectedCardsOnlyCore;
				this.usePrintStylesCore = source.usePrintStylesCore;
				this.maxCardRowsCore = source.maxCardRowsCore;
				this.maxCardColumnsCore = source.maxCardColumnsCore;
			}
			finally { EndUpdate(); }
		}
		internal void ConvertFromFlags(LayoutViewPrintOptionsFlags flags) {
			PrintFilterInfo = (flags & LayoutViewPrintOptionsFlags.PrintFilterInfo) != 0;
			PrintCardCaption = (flags & LayoutViewPrintOptionsFlags.PrintCardCaption) != 0;
			PrintSelectedCardsOnly = (flags & LayoutViewPrintOptionsFlags.PrintSelectedCardOnly) != 0;
			UsePrintStyles = (flags & LayoutViewPrintOptionsFlags.UsePrintStyles) != 0;
		}
		public override string ToString() {
			string mode = PrintMode.ToString();
			string flags = base.ToString();
			if(flags.Length == 0) return mode;
			return mode + ", " + flags;
		}
	}
}
