#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{       XtraGrid                                                    }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System;
using System.Data;
using System.Collections;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;
using System.Resources;
using System.Globalization;
using DevExpress.Data;
using DevExpress.Utils;
using DevExpress.Utils.Drawing;
namespace DevExpress.XtraGrid.Localization {
	[ToolboxItem(false)]
	public class GridLocalizer {
		public static event EventHandler ActiveChanged;
		static GridLocalizer active = CreateDefaultLocalizer();
		[Browsable(false)]
		public static GridLocalizer Active {
			get { return active; }
			set {
				if(value == null)
					active = CreateDefaultLocalizer();
				else
					active = value;
				RaiseActiveChanged();
			}
		}
		public static void RaiseActiveChanged() {
			if(ActiveChanged != null)
				ActiveChanged(Active, EventArgs.Empty);
		}
		public static GridLocalizer CreateDefaultLocalizer() { return new GridResLocalizer(); }
		public virtual string Language { get { return "English"; } }
		#region string GetLocalizedString(GridStringId)
		public virtual string GetLocalizedString(GridStringId id) {
			string ret = "";
			switch (id) {
				case GridStringId.FileIsNotFoundError: return "File {0} is not found";
				case GridStringId.FilterPanelCustomizeButton: return "Edit Filter";
				case GridStringId.ColumnViewExceptionMessage: return " Do you want to correct the value ?";
				case GridStringId.CustomizationCaption: return "Customization";
				case GridStringId.CustomizationColumns: return "Columns";
				case GridStringId.CustomizationBands: return "Bands";
				case GridStringId.PopupFilterAll: return "(All)";
				case GridStringId.PopupFilterCustom: return "(Custom)";
				case GridStringId.PopupFilterBlanks: return "(Blanks)";
				case GridStringId.PopupFilterNonBlanks: return "(Non blanks)";
				case GridStringId.CustomFilterDialogFormCaption: return "Custom AutoFilter";
				case GridStringId.CustomFilterDialogCaption: return "Show rows where:";
				case GridStringId.CustomFilterDialogRadioAnd: return "&And";
				case GridStringId.CustomFilterDialogRadioOr: return "O&r";
				case GridStringId.CustomFilterDialogOkButton: return "&OK";
				case GridStringId.CustomFilterDialogClearFilter: return "C&lear Filter";
				case GridStringId.CustomFilterDialogCancelButton: return "&Cancel";
				case GridStringId.CustomFilterDialog2FieldCheck: return "Field";
				case GridStringId.CustomFilterDialogConditionEQU: return "equals";
				case GridStringId.CustomFilterDialogConditionNEQ: return "does not equal";
				case GridStringId.CustomFilterDialogConditionGT: return "is greater than";
				case GridStringId.CustomFilterDialogConditionGTE: return "is greater than or equal to";
				case GridStringId.CustomFilterDialogConditionLT: return "is less than";
				case GridStringId.CustomFilterDialogConditionLTE: return "is less than or equal to";
				case GridStringId.CustomFilterDialogConditionBlanks: return "blanks";
				case GridStringId.CustomFilterDialogConditionNonBlanks: return "non blanks";
				case GridStringId.CustomFilterDialogConditionLike: return "like";
				case GridStringId.CustomFilterDialogConditionNotLike: return "not like";
				case GridStringId.CustomFilterDialogEmptyValue: return "(Enter a value)";
				case GridStringId.CustomFilterDialogEmptyOperator: return "(Select an operator)";
				case GridStringId.CustomFilterDialogHint: return "Use _ to represent any single character#Use % to represent any series of characters";
				case GridStringId.MenuFooterSum: return "Sum";
				case GridStringId.MenuFooterMin: return "Min";
				case GridStringId.MenuFooterMax: return "Max";
				case GridStringId.MenuFooterCount: return "Count";
				case GridStringId.MenuFooterAverage: return "Average";
				case GridStringId.MenuFooterNone: return "None";
				case GridStringId.MenuFooterSumFormat: return "SUM={0:0.##}";
				case GridStringId.MenuFooterMinFormat: return "MIN={0}";
				case GridStringId.MenuFooterMaxFormat: return "MAX={0}";
				case GridStringId.MenuFooterCountFormat: return "{0}";
				case GridStringId.MenuFooterCountGroupFormat: return "Count={0}";
				case GridStringId.MenuFooterAverageFormat: return "AVG={0:0.##}";
				case GridStringId.MenuFooterCustomFormat: return "Custom={0}";
				case GridStringId.MenuColumnSortAscending: return "Sort Ascending";
				case GridStringId.MenuColumnSortDescending: return "Sort Descending";
				case GridStringId.MenuColumnRemoveColumn: return "Remove This Column";
				case GridStringId.MenuColumnShowColumn: return "Show This Column";
				case GridStringId.MenuColumnClearSorting: return "Clear Sorting";
				case GridStringId.MenuColumnGroup: return "Group By This Column";
				case GridStringId.MenuColumnUnGroup: return "UnGroup";
				case GridStringId.MenuColumnColumnCustomization: return "Column Chooser";
				case GridStringId.MenuColumnBandCustomization: return "Column/Band Chooser";
				case GridStringId.MenuColumnBestFit: return "Best Fit";
				case GridStringId.MenuColumnFilter: return "Can Filter";
				case GridStringId.MenuColumnFilterEditor: return "Filter Editor...";
				case GridStringId.MenuColumnAutoFilterRowShow: return "Show Auto Filter Row";
				case GridStringId.MenuColumnAutoFilterRowHide: return "Hide Auto Filter Row";
				case GridStringId.MenuColumnFindFilterShow: return "Show Find Panel";
				case GridStringId.MenuColumnFindFilterHide: return "Hide Find Panel";
				case GridStringId.MenuColumnClearFilter: return "Clear Filter";
				case GridStringId.MenuColumnBestFitAllColumns: return "Best Fit (all columns)";
				case GridStringId.MenuColumnResetGroupSummarySort: return "Clear Summary Sorting";
				case GridStringId.MenuColumnGroupSummarySortFormat: return "{1} by '{0}' - {2}";
				case GridStringId.MenuColumnSumSummaryTypeDescription : return "Sum";
				case GridStringId.MenuColumnMinSummaryTypeDescription : return "Min";
				case GridStringId.MenuColumnMaxSummaryTypeDescription : return "Max";
				case GridStringId.MenuColumnCountSummaryTypeDescription : return "Count";
				case GridStringId.MenuColumnAverageSummaryTypeDescription : return "Average";
				case GridStringId.MenuColumnCustomSummaryTypeDescription: return "Custom";
				case GridStringId.MenuGroupPanelShow: return "Show Group By Box";
				case GridStringId.MenuGroupPanelHide: return "Hide Group By Box";
				case GridStringId.MenuColumnSortGroupBySummaryMenu: return "Sort by Summary";
				case GridStringId.MenuColumnGroupIntervalMenu: return "Group Interval";
				case GridStringId.MenuColumnGroupIntervalNone: return "None";
				case GridStringId.MenuColumnGroupIntervalDay: return "Day";
				case GridStringId.MenuColumnGroupIntervalMonth: return "Month";
				case GridStringId.MenuColumnGroupIntervalYear: return "Year";
				case GridStringId.MenuColumnGroupIntervalSmart: return "Smart";
				case GridStringId.MenuColumnGroupSummaryEditor: return "Group Summary Editor...";
				case GridStringId.MenuColumnExpressionEditor: return "Expression Editor...";
				case GridStringId.MenuColumnFilterMode: return "Filter Mode";
				case GridStringId.MenuColumnFilterModeValue: return "Value";
				case GridStringId.MenuColumnFilterModeDisplayText: return "Display Text";
				case GridStringId.MenuGroupPanelFullExpand: return "Full Expand";
				case GridStringId.MenuGroupPanelFullCollapse: return "Full Collapse";
				case GridStringId.MenuGroupPanelClearGrouping: return "Clear Grouping";
				case GridStringId.PrintDesignerBandedView: return "Print Settings (Banded View)";
				case GridStringId.PrintDesignerGridView: return "Print Settings (Grid View)";
				case GridStringId.PrintDesignerCardView: return "Print Settings (Card View)";
				case GridStringId.PrintDesignerLayoutView: return "Print Settings (Layout View)";
				case GridStringId.PrintDesignerDescription: return "Set up various printing options for the current view.";
				case GridStringId.PrintDesignerBandHeader: return "Band Header";
				case GridStringId.MenuColumnGroupBox: return "Group By Box";
				case GridStringId.CardViewNewCard: return "New Card";
				case GridStringId.CardViewQuickCustomizationButton: return "Customize";
				case GridStringId.CardViewQuickCustomizationButtonFilter: return "Filter";
				case GridStringId.CardViewQuickCustomizationButtonSort: return "Sort:";
				case GridStringId.CardViewCaptionFormat: return "Record N {0}";
				case GridStringId.GridGroupPanelText: return "Drag a column header here to group by that column";
				case GridStringId.GridNewRowText: return "Click here to add a new row";
				case GridStringId.GridOutlookIntervals: return
				   "Older;Last Month;Earlier this Month;Three Weeks Ago;Two Weeks Ago;Last Week;;;;;;;;Yesterday;Today;Tomorrow;;;;;;;;Next Week;Two Weeks Away;Three Weeks Away;Later this Month;Next Month;Beyond Next Month;";
				case GridStringId.FilterBuilderOkButton: return "&OK";
				case GridStringId.FilterBuilderCancelButton: return "&Cancel";
				case GridStringId.FilterBuilderApplyButton: return "&Apply";
				case GridStringId.FilterBuilderCaption: return "Filter Editor";
				case GridStringId.CustomizationFormColumnHint: return "Drag and drop columns here to customize layout";
				case GridStringId.CustomizationFormBandHint: return "Drag and drop bands here to customize layout";
				case GridStringId.LayoutViewSingleModeBtnHint: return "One card";
				case GridStringId.LayoutViewRowModeBtnHint: return "One Row";
				case GridStringId.LayoutViewColumnModeBtnHint: return "One Column";
				case GridStringId.LayoutViewMultiRowModeBtnHint: return "Multiple Rowss";
				case GridStringId.LayoutViewMultiColumnModeBtnHint: return "Multiple Columns";
				case GridStringId.LayoutViewCarouselModeBtnHint: return "Carousel Mode";
				case GridStringId.LayoutViewPanBtnHint: return "Panning";
				case GridStringId.LayoutViewCustomizeBtnHint: return "Customization";
				case GridStringId.LayoutViewCloseZoomBtnHintClose: return "Restore View";
				case GridStringId.LayoutViewCloseZoomBtnHintZoom: return "Maximize Detail";
				case GridStringId.LayoutViewButtonApply: return @"&Apply";
				case GridStringId.LayoutViewButtonPreview: return @"Show &More Cards";
				case GridStringId.LayoutViewButtonSaveLayout: return @"Sa&ve Layout...";
				case GridStringId.LayoutViewButtonLoadLayout: return @"&Load Layout...";
				case GridStringId.LayoutViewPageTemplateCard: return @"Template Card";
				case GridStringId.LayoutViewPageViewLayout: return @"View Layout";
				case GridStringId.LayoutViewButtonCustomizeShow: return @"&Show Customization";
				case GridStringId.LayoutViewButtonCustomizeHide: return @"Hide Customi&zation";
				case GridStringId.LayoutViewButtonReset: return @"&Reset Template Card";
				case GridStringId.LayoutViewButtonShrinkToMinimum: return @"&Shrink Template Card";
				case GridStringId.LayoutViewGroupCustomization: return @"Customization";
				case GridStringId.LayoutViewGroupCaptions: return @"Captions";
				case GridStringId.LayoutViewGroupIndents: return @"Indents";
				case GridStringId.LayoutViewGroupHiddenItems: return @"Hidden Items";
				case GridStringId.LayoutViewGroupTreeStructure: return @"Layout Tree View";
				case GridStringId.LayoutViewGroupPropertyGrid: return @"Property Grid";
				case GridStringId.LayoutViewLabelTextIndent: return @"Text Indents";
				case GridStringId.LayoutViewLabelPadding: return @"Padding";
				case GridStringId.LayoutViewLabelSpacing: return @"Spacing";
				case GridStringId.LayoutViewLabelCaptionLocation: return @"Field Caption Location:";
				case GridStringId.LayoutViewLabelGroupCaptionLocation: return @"Group Caption Location:";
				case GridStringId.LayoutViewLabelTextAlignment: return @"Field Caption Text Alignment:";
				case GridStringId.LayoutViewGroupView: return @"View";
				case GridStringId.LayoutViewGroupLayout: return @"Layout";
				case GridStringId.LayoutViewGroupCards: return @"Cards";
				case GridStringId.LayoutViewGroupFields: return @"Fields";
				case GridStringId.LayoutViewLabelShowLines: return @"Show Lines";
				case GridStringId.LayoutViewLabelShowHeaderPanel: return @"Show Header Panel";
				case GridStringId.LayoutViewLabelShowFilterPanel: return @"Show Filter Panel:";
				case GridStringId.LayoutViewLabelScrollVisibility: return @"Scroll Visibility:";
				case GridStringId.LayoutViewLabelViewMode: return @"View Mode:";
				case GridStringId.LayoutViewLabelCardArrangeRule: return @"Arrange Rule:";
				case GridStringId.LayoutViewLabelCardEdgeAlignment: return @"Card Edge Alignment:";
				case GridStringId.LayoutViewGroupIntervals: return @"Intervals";
				case GridStringId.LayoutViewLabelHorizontal: return @"Horizontal Interval";
				case GridStringId.LayoutViewLabelVertical: return @"Vertical Interval";
				case GridStringId.LayoutViewLabelShowCardCaption: return @"Show Caption";
				case GridStringId.LayoutViewLabelShowCardExpandButton: return @"Show Expand Button";
				case GridStringId.LayoutViewLabelShowCardBorder: return @"Show Border";
				case GridStringId.LayoutViewLabelAllowFieldHotTracking: return @"Allow Hot-Tracking";
				case GridStringId.LayoutViewLabelShowFieldBorder: return @"Show Border";
				case GridStringId.LayoutViewLabelShowFieldHint: return @"Show Hint";
				case GridStringId.LayoutViewCustomizationFormCaption: return @"LayoutView Customization";
				case GridStringId.LayoutViewButtonOk: return @"Ok";
				case GridStringId.LayoutViewButtonCancel: return @"Cancel";
				case GridStringId.LayoutViewCustomizationFormDescription: return @"Customize the card layout using drag-and-drop and customization menu, and preview data in the View Layout page.";
				case GridStringId.LayoutModifiedWarning: return "The layout has been modified.\r\nDo you want to save the changes?";
				case GridStringId.LayoutViewCardCaptionFormat: return "Record [{0} of {1}]";
				case GridStringId.LayoutViewFieldCaptionFormat: return "{0}:";
				case GridStringId.GroupSummaryEditorFormCaption: return "Group Summary Editor"; 
				case GridStringId.GroupSummaryEditorFormOkButton: return "OK";  
				case GridStringId.GroupSummaryEditorFormCancelButton: return "Cancel";
				case GridStringId.GroupSummaryEditorFormItemsTabCaption: return "Items";
				case GridStringId.GroupSummaryEditorFormOrderTabCaption: return "Order";
				case GridStringId.GroupSummaryEditorSummaryMin: return "Min";
				case GridStringId.GroupSummaryEditorSummaryMax: return "Max";
				case GridStringId.GroupSummaryEditorSummaryAverage: return "Average";
				case GridStringId.GroupSummaryEditorSummarySum: return "Sum";
				case GridStringId.GroupSummaryEditorSummaryCount: return "Count";
				case GridStringId.WindowErrorCaption: return "Error";
				case GridStringId.FindControlFindButton: return "Find";
				case GridStringId.FindControlClearButton: return "Close";
				case GridStringId.SearchLookUpAddNewButton: return "Add New";
				case GridStringId.MenuFooterAddSummaryItem: return "Add New Summary";
				case GridStringId.MenuFooterClearSummaryItems: return "Clear Summary Items";
				default:
					ret = "";
					break;
			}
			return ret;
		}
		#endregion
	}
	public class GridResLocalizer : GridLocalizer {
		ResourceManager manager = null;
		public GridResLocalizer() {
			CreateResourceManager();
		}
		protected virtual void CreateResourceManager() {
			if(manager != null) this.manager.ReleaseAllResources();
			this.manager = new ResourceManager("DevExpress.XtraGrid.LocalizationRes", typeof(GridResLocalizer).Assembly);
		}
		protected virtual ResourceManager Manager { get { return manager; } }
		public override string Language { get { return CultureInfo.CurrentUICulture.Name; }}
		public override string GetLocalizedString(GridStringId id) {
			string resStr = "GridStringId." + id.ToString();
			string ret = Manager.GetString(resStr);
			if(ret == null) ret = "";
			return ret;
		}
	}
	#region enum GridStringId
	public enum GridStringId {
		FileIsNotFoundError,
		ColumnViewExceptionMessage,
		CustomizationCaption,
		CustomizationColumns,
		CustomizationBands,
		FilterPanelCustomizeButton,
		PopupFilterAll,
		PopupFilterCustom,
		PopupFilterBlanks,
		PopupFilterNonBlanks,
		CustomFilterDialogFormCaption,
		CustomFilterDialogCaption,
		CustomFilterDialogRadioAnd,
		CustomFilterDialogRadioOr,
		CustomFilterDialogOkButton,
		CustomFilterDialogClearFilter,
		CustomFilterDialog2FieldCheck,
		CustomFilterDialogCancelButton,
		CustomFilterDialogConditionEQU,
		CustomFilterDialogConditionNEQ,
		CustomFilterDialogConditionGT,
		CustomFilterDialogConditionGTE,
		CustomFilterDialogConditionLT,
		CustomFilterDialogConditionLTE,
		CustomFilterDialogConditionBlanks,
		CustomFilterDialogConditionNonBlanks,
		CustomFilterDialogConditionLike,
		CustomFilterDialogConditionNotLike,
		CustomFilterDialogEmptyValue, 
		CustomFilterDialogEmptyOperator, 
		CustomFilterDialogHint,
		WindowErrorCaption,
		MenuFooterSum,
		MenuFooterMin, 
		MenuFooterMax, 
		MenuFooterCount, 
		MenuFooterAverage,
		MenuFooterNone,
		MenuFooterSumFormat,
		MenuFooterMinFormat, 
		MenuFooterMaxFormat, 
		MenuFooterCountFormat, 
		MenuFooterAverageFormat,
		MenuColumnSortAscending, 
		MenuColumnSortDescending,
		MenuColumnShowColumn,
		MenuColumnRemoveColumn,
		MenuColumnGroup, 
		MenuColumnUnGroup, 
		MenuColumnColumnCustomization,
		MenuColumnBandCustomization, 
		MenuColumnBestFit, 
		MenuColumnFilter, 
		MenuColumnClearFilter, 
		MenuColumnBestFitAllColumns, 
		MenuColumnResetGroupSummarySort,
		MenuColumnGroupSummarySortFormat,
		MenuColumnSumSummaryTypeDescription,
		MenuColumnMinSummaryTypeDescription,
		MenuColumnMaxSummaryTypeDescription,
		MenuColumnCountSummaryTypeDescription,
		MenuColumnAverageSummaryTypeDescription,
		MenuColumnCustomSummaryTypeDescription,
		MenuColumnSortGroupBySummaryMenu,
		MenuColumnGroupIntervalMenu,
		MenuColumnGroupIntervalNone,
		MenuColumnGroupIntervalDay,
		MenuColumnGroupIntervalMonth,
		MenuColumnGroupIntervalYear,
		MenuColumnGroupIntervalSmart,
		MenuColumnGroupSummaryEditor,
		MenuColumnExpressionEditor,
		MenuColumnFilterMode,
		MenuColumnFilterModeValue,
		MenuColumnFilterModeDisplayText, 
		MenuGroupPanelFullExpand, 
		MenuGroupPanelFullCollapse,
		MenuGroupPanelClearGrouping,
		MenuGroupPanelShow,
		MenuGroupPanelHide,
		PrintDesignerGridView,
		PrintDesignerCardView,
		PrintDesignerLayoutView,
		PrintDesignerBandedView,
		PrintDesignerBandHeader,
		MenuColumnGroupBox,
		CardViewNewCard,
		CardViewQuickCustomizationButton,
		CardViewQuickCustomizationButtonFilter,
		CardViewQuickCustomizationButtonSort,
		CardViewCaptionFormat,
		GridGroupPanelText,
		GridNewRowText,
		GridOutlookIntervals, 
		PrintDesignerDescription,
		MenuFooterCustomFormat,
		MenuFooterCountGroupFormat,
		MenuColumnClearSorting,
		MenuColumnFilterEditor,
		MenuColumnAutoFilterRowHide,
		MenuColumnAutoFilterRowShow,
		MenuColumnFindFilterHide,
		MenuColumnFindFilterShow,
		FilterBuilderOkButton,
		FilterBuilderCancelButton,
		FilterBuilderApplyButton,
		FilterBuilderCaption,
		CustomizationFormColumnHint,
		CustomizationFormBandHint,
		LayoutViewSingleModeBtnHint,
		LayoutViewRowModeBtnHint,
		LayoutViewColumnModeBtnHint,
		LayoutViewMultiRowModeBtnHint,
		LayoutViewMultiColumnModeBtnHint,
		LayoutViewCarouselModeBtnHint,
		LayoutViewPanBtnHint,
		LayoutViewCustomizeBtnHint,
		LayoutViewCloseZoomBtnHintClose,
		LayoutViewCloseZoomBtnHintZoom,
		LayoutViewButtonApply,
		LayoutViewButtonPreview,
		LayoutViewButtonOk,
		LayoutViewButtonCancel,
		LayoutViewButtonSaveLayout,
		LayoutViewButtonLoadLayout,
		LayoutViewButtonCustomizeShow,
		LayoutViewButtonCustomizeHide,
		LayoutViewButtonReset,
		LayoutViewButtonShrinkToMinimum,
		LayoutViewPageTemplateCard,
		LayoutViewPageViewLayout,
		LayoutViewGroupCustomization,
		LayoutViewGroupCaptions,
		LayoutViewGroupIndents,
		LayoutViewGroupHiddenItems,
		LayoutViewGroupTreeStructure,
		LayoutViewGroupPropertyGrid,
		LayoutViewLabelTextIndent,
		LayoutViewLabelPadding,
		LayoutViewLabelSpacing,
		LayoutViewLabelCaptionLocation,
		LayoutViewLabelGroupCaptionLocation,
		LayoutViewLabelTextAlignment,
		LayoutViewGroupView,
		LayoutViewGroupLayout,
		LayoutViewGroupCards,
		LayoutViewGroupFields,
		LayoutViewLabelShowLines,
		LayoutViewLabelShowHeaderPanel,
		LayoutViewLabelShowFilterPanel,
		LayoutViewLabelScrollVisibility,
		LayoutViewLabelViewMode,
		LayoutViewLabelCardArrangeRule,
		LayoutViewLabelCardEdgeAlignment,
		LayoutViewGroupIntervals,
		LayoutViewLabelHorizontal,
		LayoutViewLabelVertical,
		LayoutViewLabelShowCardCaption,
		LayoutViewLabelShowCardExpandButton,
		LayoutViewLabelShowCardBorder,
		LayoutViewLabelAllowFieldHotTracking,
		LayoutViewLabelShowFieldBorder,
		LayoutViewLabelShowFieldHint,
		LayoutViewCustomizationFormCaption,
		LayoutViewCustomizationFormDescription,
		LayoutModifiedWarning,
		LayoutViewCardCaptionFormat,
		LayoutViewFieldCaptionFormat,
		GroupSummaryEditorFormCaption,
		GroupSummaryEditorFormOkButton,
		GroupSummaryEditorFormCancelButton,
		GroupSummaryEditorFormItemsTabCaption,
		GroupSummaryEditorFormOrderTabCaption,
		GroupSummaryEditorSummaryMin,
		GroupSummaryEditorSummaryMax,
		GroupSummaryEditorSummaryAverage,
		GroupSummaryEditorSummarySum,
		GroupSummaryEditorSummaryCount,
		FindControlFindButton,
		FindControlClearButton,
		SearchLookUpMissingRows,
		SearchLookUpAddNewButton,
		MenuFooterAddSummaryItem,
		MenuFooterClearSummaryItems
	}
	#endregion
}
