#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{       XtraGrid                                                    }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using DevExpress.XtraGrid.Columns;
using DevExpress.LookAndFeel;
using DevExpress.XtraEditors;
using DevExpress.XtraEditors.Repository;
using DevExpress.XtraEditors.Controls;
using DevExpress.XtraGrid.Filter.Parser;
using DevExpress.XtraGrid.Localization;
using DevExpress.Data.Filtering;
using DevExpress.Utils;
namespace DevExpress.XtraGrid.Filter {
	public class FilterCustomDialog : XtraForm {
		enum AccessType {All, StringOnly, Calculable, AllArray};
		GridColumn column;
		internal BaseEdit e1, e2;
		CriteriaOperator _OldFilter = null;
		internal object[,] operators = new object[,] {{
			ExpressionOperators.Equals, ExpressionOperators.NotEquals, 
			ExpressionOperators.Like,ExpressionOperators.NotLike,
			ExpressionOperators.Greater, ExpressionOperators.GreaterOrEqual,
			ExpressionOperators.Less, ExpressionOperators.LessOrEqual,
			ExpressionOperators.Blanks, ExpressionOperators.NonBlanks}, { 
			GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogConditionEQU),
			GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogConditionNEQ),
			GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogConditionLike),
			GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogConditionNotLike),
			GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogConditionGT),
			GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogConditionGTE),
			GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogConditionLT),
			GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogConditionLTE),
			GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogConditionBlanks),
			GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogConditionNonBlanks)}, 
			{"=", "<>", "Like", "Not Like", ">", ">=", "<", "<=", "Is Null", "Is Not Null"}, { 
			AccessType.All, AccessType.All, AccessType.StringOnly, AccessType.StringOnly, AccessType.Calculable, AccessType.Calculable, AccessType.Calculable, AccessType.Calculable, AccessType.AllArray, AccessType.AllArray}};
		private System.Windows.Forms.Label label1;
		protected GroupControl grbMain;
		private SimpleButton btnOK;
		private SimpleButton btnCancel;
		protected DevExpress.XtraEditors.ComboBoxEdit piFirst;
		protected DevExpress.XtraEditors.CheckEdit rbAnd;
		protected DevExpress.XtraEditors.CheckEdit rbOr;
		protected DevExpress.XtraEditors.ComboBoxEdit piSecond;
		protected DevExpress.XtraEditors.PanelControl pnlMain;
		private PictureEdit peInfo;
		private System.ComponentModel.Container components = null;
		protected override void Dispose( bool disposing ) {
			if(disposing) {
				if(e1 != null) e1.InplaceType = InplaceType.Grid;
				if(e2 != null) e2.InplaceType = InplaceType.Grid;
				if(components != null) components.Dispose();
				if(peInfo.ToolTipController != null)
					peInfo.ToolTipController.Dispose();
			}
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		private void InitializeComponent() {
			this.label1 = new System.Windows.Forms.Label();
			this.grbMain = new DevExpress.XtraEditors.GroupControl();
			this.rbOr = new DevExpress.XtraEditors.CheckEdit();
			this.rbAnd = new DevExpress.XtraEditors.CheckEdit();
			this.piSecond = new DevExpress.XtraEditors.ComboBoxEdit();
			this.piFirst = new DevExpress.XtraEditors.ComboBoxEdit();
			this.btnOK = new DevExpress.XtraEditors.SimpleButton();
			this.btnCancel = new DevExpress.XtraEditors.SimpleButton();
			this.pnlMain = new DevExpress.XtraEditors.PanelControl();
			this.peInfo = new DevExpress.XtraEditors.PictureEdit();
			((System.ComponentModel.ISupportInitialize)(this.grbMain)).BeginInit();
			this.grbMain.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.rbOr.Properties)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.rbAnd.Properties)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.piSecond.Properties)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.piFirst.Properties)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.pnlMain)).BeginInit();
			this.pnlMain.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.peInfo.Properties)).BeginInit();
			this.SuspendLayout();
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(96, 13);
			this.label1.TabIndex = 0;
			this.label1.Text = "Show rows where:";
			this.grbMain.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
						| System.Windows.Forms.AnchorStyles.Right)));
			this.grbMain.CaptionImage = null;
			this.grbMain.CaptionImageLocation = DevExpress.Utils.GroupElementLocation.Default;
			this.grbMain.Controls.Add(this.rbOr);
			this.grbMain.Controls.Add(this.rbAnd);
			this.grbMain.Controls.Add(this.piSecond);
			this.grbMain.Controls.Add(this.piFirst);
			this.grbMain.Location = new System.Drawing.Point(8, 24);
			this.grbMain.Name = "grbMain";
			this.grbMain.Size = new System.Drawing.Size(372, 108);
			this.grbMain.TabIndex = 1;
			this.rbOr.Location = new System.Drawing.Point(94, 52);
			this.rbOr.Name = "rbOr";
			this.rbOr.Properties.Caption = "&Or";
			this.rbOr.Properties.CheckStyle = DevExpress.XtraEditors.Controls.CheckStyles.Radio;
			this.rbOr.Properties.RadioGroupIndex = 0;
			this.rbOr.Size = new System.Drawing.Size(56, 19);
			this.rbOr.TabIndex = 14;
			this.rbOr.TabStop = false;
			this.rbAnd.Location = new System.Drawing.Point(38, 52);
			this.rbAnd.Name = "rbAnd";
			this.rbAnd.Properties.Caption = "&And";
			this.rbAnd.Properties.CheckStyle = DevExpress.XtraEditors.Controls.CheckStyles.Radio;
			this.rbAnd.Properties.RadioGroupIndex = 0;
			this.rbAnd.Size = new System.Drawing.Size(56, 19);
			this.rbAnd.TabIndex = 13;
			this.rbAnd.TabStop = false;
			this.piSecond.EditValue = "";
			this.piSecond.Location = new System.Drawing.Point(12, 76);
			this.piSecond.Name = "piSecond";
			this.piSecond.Properties.Buttons.AddRange(new DevExpress.XtraEditors.Controls.EditorButton[] {
			new DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)});
			this.piSecond.Properties.TextEditStyle = DevExpress.XtraEditors.Controls.TextEditStyles.DisableTextEditor;
			this.piSecond.Size = new System.Drawing.Size(164, 20);
			this.piSecond.TabIndex = 25;
			this.piFirst.EditValue = "";
			this.piFirst.Location = new System.Drawing.Point(12, 28);
			this.piFirst.Name = "piFirst";
			this.piFirst.Properties.Buttons.AddRange(new DevExpress.XtraEditors.Controls.EditorButton[] {
			new DevExpress.XtraEditors.Controls.EditorButton(DevExpress.XtraEditors.Controls.ButtonPredefines.Combo)});
			this.piFirst.Properties.TextEditStyle = DevExpress.XtraEditors.Controls.TextEditStyles.DisableTextEditor;
			this.piFirst.Size = new System.Drawing.Size(164, 20);
			this.piFirst.TabIndex = 2;
			this.btnOK.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnOK.Location = new System.Drawing.Point(188, 140);
			this.btnOK.Name = "btnOK";
			this.btnOK.Size = new System.Drawing.Size(92, 25);
			this.btnOK.TabIndex = 0;
			this.btnOK.Text = "&OK";
			this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
			this.btnCancel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnCancel.Location = new System.Drawing.Point(288, 140);
			this.btnCancel.Name = "btnCancel";
			this.btnCancel.Size = new System.Drawing.Size(92, 25);
			this.btnCancel.TabIndex = 1;
			this.btnCancel.Text = "&Cancel";
			this.btnCancel.CausesValidation = false;
			this.pnlMain.BorderStyle = DevExpress.XtraEditors.Controls.BorderStyles.NoBorder;
			this.pnlMain.Controls.Add(this.peInfo);
			this.pnlMain.Controls.Add(this.btnCancel);
			this.pnlMain.Controls.Add(this.btnOK);
			this.pnlMain.Controls.Add(this.grbMain);
			this.pnlMain.Controls.Add(this.label1);
			this.pnlMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pnlMain.Location = new System.Drawing.Point(0, 0);
			this.pnlMain.Name = "pnlMain";
			this.pnlMain.Size = new System.Drawing.Size(388, 175);
			this.pnlMain.TabIndex = 0;
			this.peInfo.Location = new System.Drawing.Point(11, 145);
			this.peInfo.Name = "peInfo";
			this.peInfo.Properties.AllowFocused = false;
			this.peInfo.Properties.Appearance.BackColor = System.Drawing.Color.Transparent;
			this.peInfo.Properties.Appearance.Options.UseBackColor = true;
			this.peInfo.Properties.BorderStyle = DevExpress.XtraEditors.Controls.BorderStyles.NoBorder;
			this.peInfo.Properties.NullText = " ";
			this.peInfo.Properties.ShowMenu = false;
			this.peInfo.Size = new System.Drawing.Size(16, 16);
			this.peInfo.TabIndex = 2;
			this.peInfo.Click += new System.EventHandler(this.peInfo_Click);
			this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
			this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
			this.AcceptButton = this.btnOK;
			this.CancelButton = this.btnCancel;
			this.ClientSize = new System.Drawing.Size(386, 173);
			this.Controls.Add(this.pnlMain);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "FilterCustomDialog";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Custom AutoFilter";
			((System.ComponentModel.ISupportInitialize)(this.grbMain)).EndInit();
			this.grbMain.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.rbOr.Properties)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.rbAnd.Properties)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.piSecond.Properties)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.piFirst.Properties)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.pnlMain)).EndInit();
			this.pnlMain.ResumeLayout(false);
			this.pnlMain.PerformLayout();
			((System.ComponentModel.ISupportInitialize)(this.peInfo.Properties)).EndInit();
			this.ResumeLayout(false);
		}
		#endregion
		#region Events
		internal void ChangeValues() {
			bool clear = (piFirst.SelectedItem.Equals(DBNull.Value) && piSecond.SelectedItem.Equals(DBNull.Value) && !ReferenceEquals(_OldFilter, null));
			string caption = (clear ? GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogClearFilter) : GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogOkButton));
			btnOK.Enabled = IsFilterExist(piFirst, e1) || clear;
			if(btnOK.Text != caption) btnOK.Text = caption;
		}
		void SetColor(object sender) { 
		}
		bool IsImmediatePopup(object sender) { 
			if(sender is LookUpEditBase && ((LookUpEditBase)sender).Properties.ImmediatePopup) return true;
			return false;
		}
		private void OnValidated(object sender, EventArgs e) {
			SetColor(sender);
		}
		private void EditValueChanged(object sender, EventArgs e) {
			if(IsImmediatePopup(sender)) return;
			SetColor(sender);
			ChangeValues();
		}
		private void EditorKeyDown(object sender, KeyEventArgs e) {
			if(e.KeyCode == Keys.Delete && e.Control)  
				((BaseEdit)sender).EditValue = null;
		}
		bool LikeSelected(ComboBoxEdit pi) {
			return pi.SelectedItem.Equals(operators[1, 2]) || pi.SelectedItem.Equals(operators[1, 3]); 
		}
		void UpdateInfo() {
			peInfo.Visible = LikeSelected(piFirst) || LikeSelected(piSecond);
		}
		internal void comboBox_SelectedValueChanged(object sender, System.EventArgs e) {
			ComboBoxEdit edit = sender as ComboBoxEdit;
			UpdateInfo();
			ChangeValues();
		}
		Color GetEnabledColor() {
			return LookAndFeelHelper.GetSystemColor(this.CurrentColumn.View.ElementsLookAndFeel, SystemColors.Window);
		}
		Color GetDisabledColor() {
			if(this.CurrentColumn.View.ElementsLookAndFeel.ActiveStyle != ActiveLookAndFeelStyle.Skin) return DevExpress.Utils.ColorUtils.FlatTabBackColor;
			return LookAndFeelHelper.GetSystemColor(this.CurrentColumn.View.ElementsLookAndFeel, SystemColors.Control);
		}
		#endregion
		#region Creators
		protected internal GridColumn CurrentColumn { 
			get {
				if(column == null) return null;
				return column.View.GetColumnFieldNameSortGroup(column);
			} 
		}
		protected bool IsLookUpEditors() {
			return (CurrentColumn.ColumnEdit is RepositoryItemImageComboBox || CurrentColumn.ColumnEdit is RepositoryItemLookUpEditBase || CurrentColumn.ColumnEdit is RepositoryItemPopupContainerEdit || CurrentColumn.ColumnEdit is RepositoryItemRadioGroup);
		}
		protected bool IsTextEditors() {
			return !IsDisplayTextFilter() && (CurrentColumn.RealColumnEdit is RepositoryItemTextEdit || CurrentColumn.RealColumnEdit is RepositoryItemMemoEdit || CurrentColumn.RealColumnEdit is RepositoryItemMemoExEdit);
		}
		protected virtual BaseEdit CreateEditorEx(BaseEdit e) {
			BaseEdit ret;
			if(CurrentColumn.RealColumnEdit is DevExpress.XtraEditors.Repository.RepositoryItemProgressBar)
				ret = new SpinEdit();
			else if(CurrentColumn.RealColumnEdit is DevExpress.XtraEditors.Repository.RepositoryItemMemoEdit ||
				DevExpress.XtraGrid.FilterEditor.GridCriteriaHelper.IsRichTextEditItem(CurrentColumn.RealColumnEdit)) {
				ret = new MemoExEdit();
				((MemoExEdit)ret).Properties.ShowIcon = false;
			}
			else {
				if( IsDisplayTextFilter()) {
					RepositoryItem ri = DevExpress.XtraGrid.FilterEditor.GridCriteriaHelper.CreateDisplayTextEditor(CurrentColumn);
					ret = ri.CreateEditor();
					ret.Properties.Assign(ri);
				}
				else {
					ret = CurrentColumn.RealColumnEdit.CreateEditor();
					ret.Properties.ResetEvents();
					ret.Properties.Assign(CurrentColumn.RealColumnEdit);
				}
			}
			if(ret is ComboBoxEdit)
				((ComboBoxEdit)ret).Properties.UseCtrlScroll = false;
			if(ret is ImageComboBoxEdit)
				((ImageComboBoxEdit)ret).Properties.UseCtrlScroll = false;
			if(ret is LookUpEditBase)
				((LookUpEditBase)ret).Properties.ImmediatePopup = false;
			TextEdit edit = ret as TextEdit;
			if(edit != null)
				edit.Properties.AllowNullInput = DevExpress.Utils.DefaultBoolean.True;
			return ret;
		} 
		private void CreateEditor(ref BaseEdit e, ComboBoxEdit pi, int index) {
			e = CreateEditorEx(e);
			e.Properties.BorderStyle = BorderStyles.Default;
			e.Properties.AllowFocused = true;
			e.Properties.AutoHeight = false;
			e.Properties.ReadOnly = false;
			e.Enabled = true;
			e.Location = new System.Drawing.Point(pi.Left + pi.Width + 20, pi.Top);
			e.Size = new System.Drawing.Size(grbMain.Width - e.Left - pi.Left, piFirst.Height);
			e.TabIndex = index == 1 ? 3 : 26;
			e.EditValue = null;
			e.EditValueChanged += new EventHandler(EditValueChanged);
			pi.SelectedValueChanged += new System.EventHandler(comboBox_SelectedValueChanged);
			e.Validated += new EventHandler(OnValidated);
			pi.Tag = index;
			e.KeyDown += new KeyEventHandler(EditorKeyDown);
			SetColor(e);
			comboBox_SelectedValueChanged(pi, null);
			grbMain.Controls.Add((Control)e);
			if(e is ButtonEdit)
				((ButtonEdit)e).Properties.TextEditStyle = TextEditStyles.Standard;
			if(e is TextEdit)
				((TextEdit)e).Properties.NullValuePrompt = GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogEmptyValue);
		}
		protected Type GetColumnType() {
			if(IsDisplayTextFilter()) return typeof(string);
			return CurrentColumn.ColumnType;
		}
		protected bool IsDisplayTextFilter() {
			return CurrentColumn.GetFilterMode() == ColumnFilterMode.DisplayText;
		}
		bool IsLikeType { get { return GetColumnType().Equals(typeof(System.String)); } } 
		bool IsObject { get { return GetColumnType().Equals(typeof(System.Boolean)) || GetColumnType().Equals(typeof(System.Object)); } }
		bool IsArray { get { return GetColumnType().Equals(typeof(System.Byte[])); } }
		private void AddPickItems(ComboBoxEdit pi) {
			pi.Properties.Items.Clear();
			pi.Properties.Items.Add(DBNull.Value);
			bool skip = false;
			string description;
			for(int i = 0; i <= operators.GetUpperBound(1); i++) {
				AccessType accessType = (AccessType)operators[3, i];
				if(!IsLikeType) skip = accessType == AccessType.StringOnly;
				if(IsObject) skip = accessType != AccessType.All && accessType != AccessType.AllArray;
				if(IsArray) skip = accessType != AccessType.AllArray;
				if(!skip) {
					description = operators[1, i].ToString();
					object pii = description; 
					pi.Properties.Items.Add(pii);
				}
			}
		}
		#endregion
		#region Init
		public FilterCustomDialog(GridColumn col) : this(col, true) {}
		public FilterCustomDialog(GridColumn col, bool setFilterValue) {
			column = col;
			InitializeComponent();
			btnOK.Enabled = false;
			this.Icon = null;
			_OldFilter = CriteriaOperator.Clone(column.FilterInfo.FilterCriteria);
			AddPickItems(piFirst);
			piFirst.SelectedIndex = IsLikeType && IsTextEditors() ? 3 : 1;
			rbAnd.Checked = true; 
			AddPickItems(piSecond);
			piSecond.SelectedItem = DBNull.Value;
			CreateEditor(ref e1, piFirst, 1);
			CreateEditor(ref e2, piSecond, 2);
			grbMain.Text = GetSpaceString(column.GetTextCaption());
			if(setFilterValue) SetFilter();
			SetLookAndFeel(CurrentColumn.View.ElementsLookAndFeel);
			this.Text = GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogFormCaption);
			this.label1.Text = GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogCaption);
			this.rbOr.Properties.Caption = GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogRadioOr);
			this.rbAnd.Properties.Caption = GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogRadioAnd);
			this.btnOK.Text = GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogOkButton);
			this.btnCancel.Text = GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogCancelButton);
			piFirst.Properties.NullValuePrompt = piSecond.Properties.NullValuePrompt = GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogEmptyOperator);
			peInfo.Image = DevExpress.Utils.ResourceImageHelper.CreateImageFromResources("DevExpress.XtraGrid.Images.info-16x16.png", typeof(FilterCustomDialog).Assembly);
			peInfo.ToolTipController = new ToolTipController();
			peInfo.ToolTipController.ToolTipType = ToolTipType.SuperTip;
			string toolTip = GridLocalizer.Active.GetLocalizedString(GridStringId.CustomFilterDialogHint);
			toolTip = toolTip.Replace("#", "\r\n");
			peInfo.ToolTip = toolTip;
			UpdateInfo();
		}
		string GetSpaceString(string ret) {
			ret = ret.Replace("\n", " ");
			ret = ret.Replace("\r", "");
			ret = ret.Replace("\t", " ");
			return ret;
		}
		internal void SetLookAndFeel(DevExpress.LookAndFeel.UserLookAndFeel lookAndFeel) {
			if(column.View.GridControl != null && column.View.GridControl.FormsUseDefaultLookAndFeel) return;
			this.LookAndFeel.Assign(lookAndFeel);
			pnlMain.LookAndFeel.Assign(lookAndFeel);
			grbMain.LookAndFeel.Assign(lookAndFeel);
			foreach(Control c in this.pnlMain.Controls) SetLookAndFeelControl(c, lookAndFeel);
			foreach(Control c in this.grbMain.Controls) SetLookAndFeelControl(c, lookAndFeel); 
		}
		private void SetLookAndFeelControl(Control c, DevExpress.LookAndFeel.UserLookAndFeel lookAndFeel) {
			BaseControl bc = c as BaseControl;
			if(bc != null) bc.LookAndFeel.Assign(lookAndFeel);
		}
		internal void SetFilter() {
			CriteriaOperator opa = _OldFilter;
			if(ReferenceEquals(opa, null))
				return;
			GroupOperator gropa = opa as GroupOperator;
			if(ReferenceEquals(gropa, null) || gropa.Operands.Count < 2) {
				AssignFirstFilter(opa);
			} else {
				rbAnd.Checked = (gropa.OperatorType == GroupOperatorType.And);
				rbOr.Checked = (gropa.OperatorType == GroupOperatorType.Or);
				if(AssignFirstFilter((CriteriaOperator)gropa.Operands[0]))
					AssignSecondFilter((CriteriaOperator)gropa.Operands[1]);
			}
		}
		bool AssignFirstFilter(CriteriaOperator op) {
			return SetValue(op, piFirst, e1);
		}
		bool AssignSecondFilter(CriteriaOperator op) {
			return SetValue(op, piSecond, e2);
		}
		bool ExtractOpa(CriteriaOperator op, out ExpressionOperators eopa, out CriteriaOperator operand) {
			UnaryOperator notOpa = op as UnaryOperator;
			bool isNot = (!ReferenceEquals(notOpa, null)) && notOpa.OperatorType == UnaryOperatorType.Not;
			if(isNot)
				op = notOpa.Operand;
			UnaryOperator unOpa = op as UnaryOperator;
			if(!ReferenceEquals(unOpa, null)) {
				operand = null;
				switch(unOpa.OperatorType) {
					case UnaryOperatorType.IsNull:
						eopa = isNot ? ExpressionOperators.NonBlanks : ExpressionOperators.Blanks;
						return true;
				}
			}
			BinaryOperator binOpa = op as BinaryOperator;
			if(!ReferenceEquals(binOpa, null)) {
				operand = binOpa.RightOperand;
				if(isNot) {
					switch(binOpa.OperatorType) {
						case BinaryOperatorType.Equal:
							eopa = ExpressionOperators.NotEquals;
							return true;
						case BinaryOperatorType.NotEqual:
							eopa = ExpressionOperators.Equals;
							return true;
						case BinaryOperatorType.Less:
							eopa = ExpressionOperators.GreaterOrEqual;
							return true;
						case BinaryOperatorType.LessOrEqual:
							eopa = ExpressionOperators.Greater;
							return true;
						case BinaryOperatorType.Greater:
							eopa = ExpressionOperators.LessOrEqual;
							return true;
						case BinaryOperatorType.GreaterOrEqual:
							eopa = ExpressionOperators.Less;
							return true;
						case BinaryOperatorType.Like:
							eopa = ExpressionOperators.NotLike;
							return true;
					}
				} else {
					switch(binOpa.OperatorType) {
						case BinaryOperatorType.Equal:
							eopa = ExpressionOperators.Equals;
							return true;
						case BinaryOperatorType.NotEqual:
							eopa = ExpressionOperators.NotEquals;
							return true;
						case BinaryOperatorType.Less:
							eopa = ExpressionOperators.Less;
							return true;
						case BinaryOperatorType.LessOrEqual:
							eopa = ExpressionOperators.LessOrEqual;
							return true;
						case BinaryOperatorType.Greater:
							eopa = ExpressionOperators.Greater;
							return true;
						case BinaryOperatorType.GreaterOrEqual:
							eopa = ExpressionOperators.GreaterOrEqual;
							return true;
						case BinaryOperatorType.Like:
							eopa = ExpressionOperators.Like;
							return true;
					}
				}
			}
			operand = null;
			eopa = ExpressionOperators.Blanks;
			return false;
		}
		bool SetValue(CriteriaOperator opa, ComboBoxEdit pi, BaseEdit e) {
			ExpressionOperators eopa;
			CriteriaOperator operand;
			if(!ExtractOpa(opa, out eopa, out operand))
				return false;
			pi.SelectedItem = DescriptionByExOperator(eopa);
			return SetEditorValue(pi, e, operand);
		}
		protected virtual bool SetEditorValue(ComboBoxEdit pi, BaseEdit e, CriteriaOperator operand) {
			OperandValue val = operand as OperandValue;
			if(BlankSelected(pi)) return true;
			if(!ReferenceEquals(val, null)) {
				e.EditValue = val.Value;
				return true;
			}
			return false;
		}
		#endregion
		#region CreateFilter
		private ExpressionOperators ExOperatorByDescription(object o) {
			string s = o.ToString();
			int i = 0;
			for(i = 0; i <= operators.GetUpperBound(1); i++) {
				if(operators[1, i].ToString() == s) 
					break;
			}
			return (ExpressionOperators)operators[0, i];
		}
		internal string DescriptionByExOperator(ExpressionOperators o) {
			int i = 0;
			for(i = 0; i <= operators.GetUpperBound(1); i++) {
				if(operators[0, i].Equals(o)) 
					break;
			}
			return operators[1, i].ToString();
		}
		private int OperationNumber(object exo) {
			int result = -1;
			for(int i = 0; i <= operators.GetUpperBound(1); i++) {
				if(operators[1, i].Equals(exo)) {
					result = i;
					break;
				} 
			}
			return result;
		}
		protected bool BlankSelected(ComboBoxEdit pi) {
			return pi.SelectedItem.Equals(operators[1, 8]) || pi.SelectedItem.Equals(operators[1, 9]); 
		}
		protected virtual bool IsFilterExist(ComboBoxEdit pi, BaseEdit e) {
			bool result = true;
			if(pi.SelectedItem == null || pi.SelectedItem.Equals(DBNull.Value) ||
				CurrentColumn.FieldName == "" || (!BlankSelected(pi) && e.EditValue == null)) 
				result = false;
			return result;
		}
		protected CriteriaOperator GetFilterCriterion(ComboBoxEdit pi, BaseEdit e) {
			return GetFilterCriterion(pi, e, false, string.Empty);
		}
		CriteriaOperator GetRightOperand(BaseEdit e, bool IsField, string FieldName) {
			if(IsField) {
				return new OperandProperty(FieldName);
			} else {
				Type columnType = GetColumnType();
				object value = DevExpress.Data.Helpers.FilterHelper.CorrectFilterValueType(columnType, e.EditValue);
				return new OperandValue(value);
			}
		}
		protected CriteriaOperator GetFilterCriterion(ComboBoxEdit pi, BaseEdit e, bool IsField, string FieldName) {
			if(!IsFilterExist(pi, e))
				return null;
			OperandProperty leftOperand = new OperandProperty(CurrentColumn.FieldName);
			int OpNum = OperationNumber(pi.SelectedItem);
			if(OpNum < 0)
				return null;
			ExpressionOperators opa = (ExpressionOperators)(operators[0, OpNum]);
			switch(opa) {
				case ExpressionOperators.Blanks:
					return leftOperand.IsNull();
				case ExpressionOperators.Equals:
					return leftOperand == GetRightOperand(e, IsField, FieldName);
				case ExpressionOperators.Greater:
					return leftOperand > GetRightOperand(e, IsField, FieldName);
				case ExpressionOperators.GreaterOrEqual:
					return leftOperand >= GetRightOperand(e, IsField, FieldName);
				case ExpressionOperators.Less:
					return leftOperand < GetRightOperand(e, IsField, FieldName);
				case ExpressionOperators.LessOrEqual:
					return leftOperand <= GetRightOperand(e, IsField, FieldName);
				case ExpressionOperators.Like:
					return new BinaryOperator(leftOperand, PatchLikeOperand(GetRightOperand(e, IsField, FieldName)), BinaryOperatorType.Like);
				case ExpressionOperators.NonBlanks:
					return leftOperand.IsNotNull();
				case ExpressionOperators.NotEquals:
					return leftOperand != GetRightOperand(e, IsField, FieldName);
				case ExpressionOperators.NotLike:
					return !new BinaryOperator(leftOperand, PatchLikeOperand(GetRightOperand(e, IsField, FieldName)), BinaryOperatorType.Like);
				default:
					return null;
			}
		}
		CriteriaOperator PatchLikeOperand(CriteriaOperator op) {
			OperandValue ov = op as OperandValue;
			if(!ReferenceEquals(ov, null)) {
				if(ov.Value != null) {
					string msk = ov.Value.ToString();
					msk = msk.Replace('*', '%');
					msk = msk.Replace('?', '_');
					return new OperandValue(msk);
				}
			}
			return op;
		}
		internal GroupOperatorType GroupOperatorType {
			get {
				return rbAnd.Checked ? GroupOperatorType.And : GroupOperatorType.Or;
			}
		}
		protected virtual CriteriaOperator GetFiltersCriterion() {
			return GroupOperator.Combine(GroupOperatorType,
				GetFilterCriterion(piFirst, e1),
				GetFilterCriterion(piSecond, e2));
		}
		[Obsolete("Use GetFiltersCriterion instead")]
		protected virtual string FilterConditions() {
			CriteriaOperator op = GetFiltersCriterion();
			if(ReferenceEquals(op, null))
				return string.Empty;
			return op.ToString();
		}
		private void CreateFilter(CriteriaOperator filterCriteria) {
			try {
				if(!ReferenceEquals(filterCriteria, null)) {
					ColumnFilterInfo info = new ColumnFilterInfo(filterCriteria);
					info.SetFilterKind(ColumnFilterKind.Predefined);
					column.FilterInfo = info;
				}
				else
					column.FilterInfo = new ColumnFilterInfo();
			} 
			catch (Exception ex) {
				XtraMessageBox.Show(this.CurrentColumn.View.ElementsLookAndFeel, FindForm(), ex.Message, GridLocalizer.Active.GetLocalizedString(GridStringId.WindowErrorCaption));
				CreateFilter(_OldFilter);
			}
		}
		private void btnOK_Click(object sender, System.EventArgs e) {
			CriteriaOperator filter = GetFiltersCriterion();
			CreateFilter(filter);
		}
		#endregion
		private void peInfo_Click(object sender, EventArgs e) {
			ToolTipControllerShowEventArgs args = peInfo.ToolTipController.CreateShowArgs();
			args.ToolTip = peInfo.ToolTip;
			peInfo.ToolTipController.ShowHint(args);
		}
	}
}
