#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{       XtraGrid                                                    }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System;
using System.ComponentModel;
using System.Collections;
using System.Windows.Forms;
using DevExpress.Utils;
using DevExpress.Utils.Design;
using DevExpress.Utils.Controls;
using DevExpress.XtraGrid.Views.Base;
using System.Drawing.Design;
namespace DevExpress.XtraGrid.Views.Grid {
	public class GridViewAppearances : ColumnViewAppearances {
		public GridViewAppearances(BaseView view) : base(view) { }
		AppearanceObject headerPanel, groupPanel, 
			footerPanel, topNewRow, row, rowSeparator, groupRow, evenRow, oddRow, horzLine, vertLine, preview, focusedRow, focusedCell, 
			groupButton, detailTip, groupFooter, empty, selectedRow, hideSelectionRow, columnFilterButton, 
			columnFilterButtonActive, fixedLine, customizationFormHint;
		protected override void CreateAppearances() {
			base.CreateAppearances();
			this.headerPanel = CreateAppearance("HeaderPanel"); 
			this.groupPanel = CreateAppearance("GroupPanel"); 
			this.footerPanel = CreateAppearance("FooterPanel");
			this.row = CreateAppearance("Row"); 
			this.rowSeparator = CreateAppearance("RowSeparator"); 
			this.groupRow = CreateAppearance("GroupRow"); 
			this.topNewRow = CreateAppearance("TopNewRow"); 
			this.evenRow = CreateAppearance("EvenRow"); 
			this.oddRow = CreateAppearance("OddRow"); 
			this.horzLine = CreateAppearance("HorzLine"); 
			this.vertLine = CreateAppearance("VertLine"); 
			this.preview = CreateAppearance("Preview"); 
			this.focusedRow = CreateAppearance("FocusedRow"); 
			this.focusedCell = CreateAppearance("FocusedCell"); 
			this.groupButton = CreateAppearance("GroupButton"); 
			this.detailTip = CreateAppearance("DetailTip"); 
			this.groupFooter = CreateAppearance("GroupFooter"); 
			this.empty = CreateAppearance("Empty"); 
			this.selectedRow = CreateAppearance("SelectedRow"); 
			this.hideSelectionRow = CreateAppearance("HideSelectionRow"); 
			this.columnFilterButton = CreateAppearance("ColumnFilterButton"); 
			this.columnFilterButtonActive = CreateAppearance("ColumnFilterButtonActive"); 
			this.fixedLine = CreateAppearance("FixedLine");
			this.customizationFormHint = CreateAppearance("CustomizationFormHint");
		}
		void ResetHeaderPanel() { HeaderPanel.Reset(); }
		bool ShouldSerializeHeaderPanel() { return HeaderPanel.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint column headers and row indicator panel."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject HeaderPanel { get { return headerPanel; } }
		void ResetGroupPanel() { GroupPanel.Reset(); }
		bool ShouldSerializeGroupPanel() { return GroupPanel.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the group panel."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject GroupPanel { get { return groupPanel; } }
		void ResetFooterPanel() { FooterPanel.Reset(); }
		bool ShouldSerializeFooterPanel() { return FooterPanel.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the view footer."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject FooterPanel { get { return footerPanel; } }
		void ResetRow() { Row.Reset(); }
		bool ShouldSerializeRow() { return Row.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the data rows."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject Row { get { return row; } }
		void ResetTopNewRow() { TopNewRow.Reset(); }
		bool ShouldSerializeTopNewRow() { return TopNewRow.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the new item row when it is displayed at the top of a View."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject TopNewRow { get { return topNewRow; } }
		void ResetRowSeparator() { RowSeparator.Reset(); }
		bool ShouldSerializeRowSeparator() { return RowSeparator.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the row separators."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject RowSeparator { get { return rowSeparator; } }
		void ResetGroupRow() { GroupRow.Reset(); }
		bool ShouldSerializeGroupRow() { return GroupRow.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint group rows (and the corresponding indents)."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject GroupRow { get { return groupRow; } }
		void ResetEvenRow() { EvenRow.Reset(); }
		bool ShouldSerializeEvenRow() { return EvenRow.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint even data rows."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject EvenRow { get { return evenRow; } }
		void ResetOddRow() { OddRow.Reset(); }
		bool ShouldSerializeOddRow() { return OddRow.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint odd data rows."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject OddRow { get { return oddRow; } }
		void ResetHorzLine() { HorzLine.Reset(); }
		bool ShouldSerializeHorzLine() { return HorzLine.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the horizontal lines."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject HorzLine { get { return horzLine; } }
		void ResetVertLine() { VertLine.Reset(); }
		bool ShouldSerializeVertLine() { return VertLine.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the vertical lines."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject VertLine { get { return vertLine; } }
		void ResetPreview() { Preview.Reset(); }
		bool ShouldSerializePreview() { return Preview.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the preview sections."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject Preview { get { return preview; } }
		void ResetFocusedRow() { FocusedRow.Reset(); }
		bool ShouldSerializeFocusedRow() { return FocusedRow.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the currently focused row."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject FocusedRow { get { return focusedRow; } }
		void ResetFocusedCell() { FocusedCell.Reset(); }
		bool ShouldSerializeFocusedCell() { return FocusedCell.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the currently focused row cell."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject FocusedCell { get { return focusedCell; } }
		void ResetGroupButton() { GroupButton.Reset(); }
		bool ShouldSerializeGroupButton() { return GroupButton.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint group expand buttons."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject GroupButton { get { return groupButton; } }
		void ResetDetailTip() { DetailTip.Reset(); }
		bool ShouldSerializeDetailTip() { return DetailTip.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the detail tooltips."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject DetailTip { get { return detailTip; } }
		void ResetGroupFooter() { GroupFooter.Reset(); }
		bool ShouldSerializeGroupFooter() { return GroupFooter.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the group footer."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject GroupFooter { get { return groupFooter; } }
		void ResetEmpty() { Empty.Reset(); }
		bool ShouldSerializeEmpty() { return Empty.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the View's empty space."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject Empty { get { return empty; } }
		void ResetSelectedRow() { SelectedRow.Reset(); }
		bool ShouldSerializeSelectedRow() { return SelectedRow.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the selected data rows."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject SelectedRow { get { return selectedRow; } }
		void ResetHideSelectionRow() { HideSelectionRow.Reset(); }
		bool ShouldSerializeHideSelectionRow() { return HideSelectionRow.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the selected row(s) when the grid control is not focused."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject HideSelectionRow { get { return hideSelectionRow; } }
		void ResetColumnFilterButton() { ColumnFilterButton.Reset(); }
		bool ShouldSerializeColumnFilterButton() { return ColumnFilterButton.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint filter buttons."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject ColumnFilterButton { get { return columnFilterButton; } }
		void ResetColumnFilterButtonActive() { ColumnFilterButtonActive.Reset(); }
		bool ShouldSerializeColumnFilterButtonActive() { return ColumnFilterButtonActive.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the filter buttons displayed within columns that are involved in filtering."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject ColumnFilterButtonActive { get { return columnFilterButtonActive; } }
		void ResetFixedLine() { FixedLine.Reset(); }
		bool ShouldSerializeFixedLine() { return FixedLine.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the fixed lines."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject FixedLine { get { return fixedLine; } }
		void ResetCustomizationFormHint() { CustomizationFormHint.Reset(); }
		bool ShouldSerializeCustomizationFormHint() { return CustomizationFormHint.ShouldSerialize(); }
		[Description("Gets or sets the appearance of the hint text displayed within an empty Customization Form."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject CustomizationFormHint { get { return customizationFormHint; } }
	}
	public class GridViewPrintAppearances : ColumnViewPrintAppearances {
		public GridViewPrintAppearances(BaseView view) : base(view) { }
		AppearanceObject headerPanel,  footerPanel, row, evenRow, oddRow, groupRow, lines, preview, groupFooter;
		protected override void CreateAppearances() {
			base.CreateAppearances();
			this.headerPanel = CreateAppearance("HeaderPanel"); 
			this.footerPanel = CreateAppearance("FooterPanel"); 
			this.row = CreateAppearance("Row"); 
			this.evenRow = CreateAppearance("EvenRow"); 
			this.oddRow = CreateAppearance("OddRow"); 
			this.groupRow = CreateAppearance("GroupRow"); 
			this.lines = CreateAppearance("Lines"); 
			this.preview = CreateAppearance("Preview"); 
			this.groupFooter = CreateAppearance("GroupFooter"); 
		}
		void ResetHeaderPanel() { HeaderPanel.Reset(); }
		bool ShouldSerializeHeaderPanel() { return HeaderPanel.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint column headers when the grid is printed."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject HeaderPanel { get { return headerPanel; } }
		void ResetFooterPanel() { FooterPanel.Reset(); }
		bool ShouldSerializeFooterPanel() { return FooterPanel.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the view footer when the grid is printed."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject FooterPanel { get { return footerPanel; } }
		void ResetRow() { Row.Reset(); }
		bool ShouldSerializeRow() { return Row.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the data rows when the grid control is printed."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject Row { get { return row; } }
		void ResetOddRow() { OddRow.Reset(); }
		bool ShouldSerializeOddRow() { return OddRow.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint odd data rows when the grid control is printed."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject OddRow { get { return oddRow; } }
		void ResetEvenRow() { EvenRow.Reset(); }
		bool ShouldSerializeEvenRow() { return EvenRow.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the even data rows when the grid control is printed."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject EvenRow { get { return evenRow; } }
		void ResetGroupRow() { GroupRow.Reset(); }
		bool ShouldSerializeGroupRow() { return GroupRow.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint group rows when the grid is printed."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject GroupRow { get { return groupRow; } }
		void ResetLines() { Lines.Reset(); }
		bool ShouldSerializeLines() { return Lines.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the horizontal and vertical lines when the grid is printed."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject Lines { get { return lines; } }
		void ResetPreview() { Preview.Reset(); }
		bool ShouldSerializePreview() { return Preview.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the preview sections when the grid is printed."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject Preview { get { return preview; } }
		void ResetGroupFooter() { GroupFooter.Reset(); }
		bool ShouldSerializeGroupFooter() { return GroupFooter.ShouldSerialize(); }
		[Description("Gets the appearance settings used to paint the group footer when the grid is printed."), DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		public AppearanceObject GroupFooter { get { return groupFooter; } }
	}
}
