#region Copyright (c) 2000-2011 Developer Express Inc.
/*
{*******************************************************************}
{                                                                   }
{       Developer Express .NET Component Library                    }
{       XtraGrid                                                    }
{                                                                   }
{       Copyright (c) 2000-2011 Developer Express Inc.              }
{       ALL RIGHTS RESERVED                                         }
{                                                                   }
{   The entire contents of this file is protected by U.S. and       }
{   International Copyright Laws. Unauthorized reproduction,        }
{   reverse-engineering, and distribution of all or any portion of  }
{   the code contained in this file is strictly prohibited and may  }
{   result in severe civil and criminal penalties and will be       }
{   prosecuted to the maximum extent possible under the law.        }
{                                                                   }
{   RESTRICTIONS                                                    }
{                                                                   }
{   THIS SOURCE CODE AND ALL RESULTING INTERMEDIATE FILES           }
{   ARE CONFIDENTIAL AND PROPRIETARY TRADE                          }
{   SECRETS OF DEVELOPER EXPRESS INC. THE REGISTERED DEVELOPER IS   }
{   LICENSED TO DISTRIBUTE THE PRODUCT AND ALL ACCOMPANYING .NET    }
{   CONTROLS AS PART OF AN EXECUTABLE PROGRAM ONLY.                 }
{                                                                   }
{   THE SOURCE CODE CONTAINED WITHIN THIS FILE AND ALL RELATED      }
{   FILES OR ANY PORTION OF ITS CONTENTS SHALL AT NO TIME BE        }
{   COPIED, TRANSFERRED, SOLD, DISTRIBUTED, OR OTHERWISE MADE       }
{   AVAILABLE TO OTHER INDIVIDUALS WITHOUT EXPRESS WRITTEN CONSENT  }
{   AND PERMISSION FROM DEVELOPER EXPRESS INC.                      }
{                                                                   }
{   CONSULT THE END USER LICENSE AGREEMENT FOR INFORMATION ON       }
{   ADDITIONAL RESTRICTIONS.                                        }
{                                                                   }
{*******************************************************************}
*/
#endregion Copyright (c) 2000-2011 Developer Express Inc.

using System;
using System.Text;
using System.Data;
using System.Collections;
using System.Collections.Specialized;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;
using DevExpress.Accessibility;
using DevExpress.Data;
using DevExpress.Data.Filtering;
using DevExpress.Data.Helpers;
using DevExpress.Data.Details;
using DevExpress.Utils;
using DevExpress.Utils.Menu;
using DevExpress.Utils.Controls;
using DevExpress.Utils.Drawing;
using DevExpress.XtraGrid.Helpers;
using DevExpress.XtraGrid.Menu;
using DevExpress.XtraGrid.Drawing;
using DevExpress.XtraGrid.Columns;
using DevExpress.XtraGrid.Scrolling;
using DevExpress.XtraGrid.Views.Base;
using DevExpress.XtraGrid.Views.Base.ViewInfo;
using DevExpress.XtraGrid.Views.Grid;
using DevExpress.XtraGrid.Views.Grid.ViewInfo;
using DevExpress.XtraGrid.Views.Grid.Drawing;
using DevExpress.XtraEditors;
using DevExpress.XtraEditors.ViewInfo;
using DevExpress.XtraEditors.Controls;
using DevExpress.XtraEditors.Repository;
using DevExpress.XtraEditors.Container;
using DevExpress.Utils.Serializing;
using DevExpress.XtraGrid.Tab;
using DevExpress.XtraGrid.Views.Grid.Handler;
using DevExpress.XtraGrid.Views.Grid.Customization;
using DevExpress.XtraGrid.Views.Printing;
using DevExpress.XtraGrid.Localization;
using DevExpress.Utils.Drawing.Animation;
using DevExpress.Utils.Text;
using DevExpress.XtraGrid.FilterEditor;
using DevExpress.Data.Filtering.Helpers;
using DevExpress.XtraGrid.GroupSummaryEditor;
using System.Collections.Generic;
using DevExpress.Data.Summary;
using DevExpress.Utils.Serializing.Helpers;
namespace DevExpress.XtraGrid.Views.Grid {
	[DesignTimeVisible(false), ToolboxItem(false)]
	public class GridView : DevExpress.XtraGrid.Views.Base.ColumnView, IGridDesignTime, IDataControllerRelationSupport, 
		IDataControllerValidationSupport, IAccessibleGrid, IGridLookUp, ISummaryItemsOwner, IXtraSupportDeserializeCollection {
		Timer scrollTimer;
		Rectangle customizationFormBounds;
		DrawFocusRectStyle focusRectStyle;
		internal DetailTip detailTip;
		bool destroying;
		CustomizationForm customizationForm;
		int topRowIndex, leftCoord, detailVerticalIndent,
			fixedLineWidth;
		GridState state;
		int internalUpdateCount, rowHeight, footerPanelHeight, groupRowHeight, indicatorWidth, columnPanelRowHeight, rowSeparatorHeight, defaultRelationIndex;
		string groupFormat, groupPanelText, previewFieldName, vertScrollTipFieldName, childGridLevelName, newItemRowText;
		GroupFooterShowMode groupFooterShowMode;
		int previewLineCount, previewFieldHandle, bestFitMaxRowCount, lockSummary, horzScrollStep, previewIndent, levelIndent;
		bool requireCheckTopRowIndex = false;
		protected GridCellInfo fEditingCell;
		GroupSummarySortInfoCollection groupSummarySortInfo;
		ScrollVisibility horzScrollVisibility, vertScrollVisibility;
		ScrollStyleFlags scrollStyle;
		GridTotalSummaryCollection totalSummary;
		protected GridGroupSummaryItemCollection fGroupSummary;
		protected MasterRowEmptyEventArgs isMasterRowEmptyEventArgs = new MasterRowEmptyEventArgs(0, 0, true);
		ScrollInfo scrollInfo;
		protected Rectangle fViewRect, fSavedNormalRectangle;
		private static readonly object rowClick = new object();
		private static readonly object rowCellClick = new object();
		private static readonly object customDrawHeader = new object();
		private static readonly object customDrawGroupPanel = new object();
		private static readonly object customDrawColumnHeader= new object();
		private static readonly object customDrawRowIndicator= new object();
		private static readonly object customDrawCell= new object(), customDrawRowFooterCell= new object(), customDrawFooterCell= new object();
		private static readonly object customDrawRowPreview= new object(), customDrawGroupRow= new object(), customDrawRowFooter= new object(), customDrawFooter= new object();
		private static readonly object customColumnGroup = new object();
		private static readonly object groupLevelStyle= new object();
		private static readonly object rowCellStyle= new object();
		private static readonly object rowStyle= new object();
		private static readonly object masterRowEmpty= new object();
		private static readonly object masterRowExpanding = new object();
		private static readonly object masterRowExpanded = new object();
		private static readonly object masterRowCollapsing = new object();
		private static readonly object masterRowCollapsed = new object();
		private static readonly object groupRowExpanding = new object();
		private static readonly object groupRowExpanded = new object();
		private static readonly object groupRowCollapsing = new object();
		private static readonly object groupRowCollapsed = new object();
		private static readonly object masterRowGetLevelDefaultView= new object();
		private static readonly object masterRowGetChildList= new object();
		private static readonly object masterRowGetRelationName= new object();
		private static readonly object masterRowGetRelationDisplayCaption = new object();
		private static readonly object masterRowGetRelationCount= new object();
		private static readonly object dragObjectStart = new object();
		private static readonly object dragObjectOver = new object();
		private static readonly object dragObjectDrop = new object();
		private static readonly object beforePrintRow = new object();
		private static readonly object afterPrintRow = new object();
		private static readonly object leftCoordChanged= new object(), topRowChanged= new object();
		private static readonly object columnWidthChanged= new object();
		private static readonly object customRowCellEdit = new object();
		private static readonly object customRowCellEditForEditing = new object();
		private static readonly object gridMenuItemClick= new object();
		private static readonly object showGridMenu= new object();
		private static readonly object onPopupMenuShowing = new object();
		private static readonly object cellMerge = new object();
		private static readonly object showCustomizationForm = new object();
		private static readonly object hideCustomizationForm = new object();
		private static readonly object calcRowHeight= new object();
		private static readonly object customSummaryCalculate= new object();
		private static readonly object customSummaryExists= new object();
		private static readonly object calcPreviewText= new object();
		private static readonly object measurePreviewHeight= new object();
		const string defaultGroupFormat = "{0}: [#image]{1} {2}"; 
		const int ScrollTimerInterval = 10;
		GridOptionsHint _optionsHint;
		GridOptionsDetail _optionsDetail;
		GridOptionsCustomization _optionsCustomization;
		GridOptionsNavigation _optionsNavigation;
		GridOptionsMenu _optionsMenu;
		RowCellStyleEventArgs styleEventArgs = new RowCellStyleEventArgs(0, null, GridRowCellState.Default, null);
		public GridView(GridControl ownerGrid) : this() {
			SetGridControl(ownerGrid);
		}
		public GridView() {
			this.defaultRelationIndex = 0;
			this.customizationFormBounds = Rectangle.Empty;
			this.scrollTimer = new Timer();
			this.scrollTimer.Interval = ScrollTimerInterval;
			this.scrollTimer.Tick += new EventHandler(OnScrollTimer_Tick);
			this.horzScrollStep = 3;
			this.fixedLineWidth = 2;
			this.indicatorWidth = -1;
			this.lockSummary = 0;
			this.childGridLevelName = "";
			this.groupSummarySortInfo = new GroupSummarySortInfoCollection(this);
			this._optionsHint = CreateOptionsHint();
			this._optionsDetail = CreateOptionsDetail();
			this._optionsCustomization = CreateOptionsCustomization();
			this._optionsNavigation = CreateOptionsNavigation();
			this._optionsMenu = CreateOptionsMenu();
			this._optionsDetail.Changed += new BaseOptionChangedEventHandler(OnOptionChanged); 
			this._optionsCustomization.Changed += new BaseOptionChangedEventHandler(OnOptionChanged); 
			this._optionsNavigation.Changed += new BaseOptionChangedEventHandler(OnOptionChanged); 
			this._optionsMenu.Changed += new BaseOptionChangedEventHandler(OnMiscOptionChanged); 
			this._optionsHint.Changed += new BaseOptionChangedEventHandler(OnMiscOptionChanged); 
			this.vertScrollTipFieldName = "";
			this.footerPanelHeight = this.columnPanelRowHeight = -1;
			horzScrollVisibility = vertScrollVisibility = ScrollVisibility.Auto;
			scrollStyle = DefaultScrollStyle;
			groupRowHeight = rowHeight = -1;
			focusRectStyle = DrawFocusRectStyle.CellFocus;
			bestFitMaxRowCount = -1;
			fGroupSummary = new GridGroupSummaryItemCollection(this);
			fGroupSummary.CollectionChanged += new CollectionChangeEventHandler(OnSummaryCollectionChanged);
			this.totalSummary = new GridTotalSummaryCollection(this);
			this.newItemRowText = this.groupPanelText = string.Empty;
			detailTip = new DetailTip(this, DevExpress.Data.DataController.InvalidRow);
			destroying = false;
			customizationForm = null;
			previewFieldName = "";
			this.fEditingCell = null;
			this.leftCoord = 0;
			this.detailVerticalIndent = 0;
			this.topRowIndex = 0;
			this.state = GridState.Normal;
			internalUpdateCount = 0;
			this.previewFieldHandle = -1;
			this.groupFormat = defaultGroupFormat;
			this.groupFooterShowMode = GroupFooterShowMode.VisibleIfExpanded;
			this.previewIndent = -1;
			this.levelIndent = -1;
			this.previewLineCount = -1;
			this.fSavedNormalRectangle = Rectangle.Empty;
			this.fViewRect = Rectangle.Empty;
			this.scrollInfo = CreateScrollInfo();
			this.scrollInfo.VScroll_Scroll += new ScrollEventHandler(OnVertScroll);
			this.scrollInfo.HScroll_Scroll += new ScrollEventHandler(OnHorzScroll);
			this.scrollInfo.VScroll_ValueChanged += new EventHandler(OnVScroll);
			this.scrollInfo.HScroll_ValueChanged += new EventHandler(OnHScroll);
		}
		protected override void SetupDataController() {
			base.SetupDataController();
			this.DataController.RelationSupport = this;
			this.DataController.ValidationClient = this;
			DataControllerCore.GroupSummary.CollectionChanged += new CollectionChangeEventHandler(OnSummaryChanged);
			DataControllerCore.TotalSummary.CollectionChanged += new CollectionChangeEventHandler(OnSummaryChanged);
			DataControllerCore.CustomSummary += new CustomSummaryEventHandler(OnDataManager_CustomSummaryEvent);
			DataControllerCore.CustomSummaryExists += new CustomSummaryExistEventHandler(OnDataManager_CustomSummaryExistEvent);
		}
		protected internal override void DestroyDataController() {
			if(DataControllerCore != null) {
				DataControllerCore.GroupSummary.CollectionChanged -= new CollectionChangeEventHandler(OnSummaryChanged);
				DataControllerCore.TotalSummary.CollectionChanged -= new CollectionChangeEventHandler(OnSummaryChanged);
				DataControllerCore.CustomSummary -= new CustomSummaryEventHandler(OnDataManager_CustomSummaryEvent);
				DataControllerCore.CustomSummaryExists -= new CustomSummaryExistEventHandler(OnDataManager_CustomSummaryExistEvent);
			}
			base.DestroyDataController();
		}
		protected override bool CanLeaveFocusOnTab(bool moveForward) {
			int focusedHandle = FocusedRowHandle;
			if(this.RowCount == 0) return true; 
			if(moveForward && focusedHandle == (this.RowCount - 1)) return true;
			if(!moveForward && focusedHandle == 0) return true;
			return false;
		}
		protected override void LeaveFocusOnTab(bool moveForward) { this.GridControl.ProcessControlTab(moveForward); }
		protected override BaseViewInfo CreateNullViewInfo() { return new NullGridViewInfo(this); }
		protected internal virtual bool FootersIgnoreColumnFormat { get { return false; } }
		protected override BaseViewAppearanceCollection CreateAppearancesPrint() { return new GridViewPrintAppearances(this); }
		void ResetAppearancePrint() { AppearancePrint.Reset(); }
		[Description("Provides access to the properties that specify the appearances of the Grid View's elements when they are printed/exported."), Category("Appearance"), DesignerSerializationVisibility(DesignerSerializationVisibility.Content),
		XtraSerializableProperty(XtraSerializationVisibility.Content, XtraSerializationFlags.DefaultValue),
		XtraSerializablePropertyId(LayoutIdAppearance)
		]
		public new GridViewPrintAppearances AppearancePrint { get { return base.AppearancePrint as GridViewPrintAppearances; } }
		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public new GridViewAppearances PaintAppearance { get { return base.PaintAppearance as GridViewAppearances; } }
		protected override BaseViewAppearanceCollection CreateAppearances() { return new GridViewAppearances(this); }
		void ResetAppearance() { Appearance.Reset(); }
		[Description("Provides access to the properties that control the appearance of the Grid View's elements."), Category("Appearance"), DesignerSerializationVisibility(DesignerSerializationVisibility.Content),
		XtraSerializableProperty(XtraSerializationVisibility.Content, XtraSerializationFlags.DefaultValue),
		XtraSerializablePropertyId(LayoutIdAppearance)
		]
		public new GridViewAppearances Appearance { get { return base.Appearance as GridViewAppearances; } }
		protected virtual GridOptionsHint CreateOptionsHint() { return new GridOptionsHint(); }
		protected virtual GridOptionsDetail CreateOptionsDetail() { return new GridOptionsDetail(); }
		protected virtual GridOptionsCustomization CreateOptionsCustomization() { return new GridOptionsCustomization(); }
		protected virtual GridOptionsNavigation CreateOptionsNavigation() { return new GridOptionsNavigation(); }
		protected override ColumnViewOptionsView CreateOptionsView() { return new GridOptionsView(); }
		protected override ViewPrintOptionsBase CreateOptionsPrint() { return new GridOptionsPrint(); }
		protected virtual GridOptionsMenu CreateOptionsMenu() { return new GridOptionsMenu(); }
		protected override ColumnViewOptionsSelection CreateOptionsSelection() { return new GridOptionsSelection(); }
		protected override ColumnViewOptionsBehavior CreateOptionsBehavior() { return new GridOptionsBehavior(this); }
		protected virtual ScrollInfo CreateScrollInfo() {
			return 	new ScrollInfo(this);
		}
		protected override void OnMiscOptionChanged(object sender, BaseOptionChangedEventArgs e) {
			if(CanSynchronized) {
				OnViewPropertiesChanged(SynchronizationMode.Visual);
			}
			if(sender == OptionsHint) LayoutChangedSynchronized();
			FireChanged();
		}
		public override bool IsDataRow(int rowHandle) {
			if(IsGroupRow(rowHandle) || IsFilterRow(rowHandle)) return false;
			return base.IsDataRow(rowHandle);
		}
		public override bool IsValidRowHandle(int rowHandle) {
			if(IsFilterRow(rowHandle) && OptionsView.ShowAutoFilterRow) return true;
			bool res = DataController.IsValidControllerRowHandle(rowHandle);
			if(res) return true;
			if(rowHandle == CurrencyDataController.NewItemRow) {
				if(OptionsView.NewItemRowPosition != NewItemRowPosition.None || DataController.IsNewItemRowEditing) return true;
			}
			return false;
		}
		protected override int GetValidSelectionAnchor(int rowHandle) {
			if(IsFilterRow(rowHandle)) return GetVisibleRowHandle(0);
			if(IsNewItemRow(rowHandle) && OptionsView.NewItemRowPosition == NewItemRowPosition.Top) 
				return GetVisibleRowHandle(0);
			return base.GetValidSelectionAnchor(rowHandle);
		}
		protected override void OnOptionChanged(object sender, BaseOptionChangedEventArgs e) {
			if(sender == OptionsBehavior) {
				DataController.AutoUpdateTotalSummary = OptionsBehavior.AutoUpdateTotalSummary;
				DataController.SummariesIgnoreNullValues = OptionsBehavior.SummariesIgnoreNullValues;
				if(DataController.AutoExpandAllGroups != OptionsBehavior.AutoExpandAllGroups) {
					DataController.AutoExpandAllGroups = OptionsBehavior.AutoExpandAllGroups;
					if(OptionsBehavior.AutoExpandAllGroups) DataController.ExpandAll();
				}
			}
			if(sender == OptionsDetail) {
				if(e.Name == "EnableMasterViewMode" && !((bool)e.NewValue)) CollapseAllDetails();
				DataController.DetailEmptyHash.Clear();
			}
			base.OnOptionChanged(sender, e);
		}
		protected internal override ViewDrawArgs CreateDrawArgs(DXPaintEventArgs e, GraphicsCache cache) {
			if(cache == null) cache = new GraphicsCache(e, Painter.Paint);
			return new GridViewDrawArgs(cache, ViewInfo, ViewInfo.ViewRects.Bounds);
		}
		protected override void InvalidateSelection(SelectionChangedEventArgs e) {
			if(!this.lockSelectionInvalidate) {
				if(e.Action == CollectionChangeAction.Refresh) 
					InvalidateRows();
				else 
					InvalidateRow(e.ControllerRow);
			}
		}
		protected internal override void InvertFocusedRowSelectionCore(BaseHitInfo hitInfo) {
			GridHitInfo gridInfo = hitInfo as GridHitInfo;
			if(IsCellSelect && (gridInfo == null || gridInfo.HitTest != GridHitTest.RowIndicator)) {
				InvertCellSelection(FocusedRowHandle, FocusedColumn);
				return;
			}
			base.InvertFocusedRowSelectionCore(hitInfo);
		}
		protected internal override void SelectFocusedRowCore() {
			if(IsCellSelect) 
				SelectFocusedCellCore();
			else
				base.SelectFocusedRowCore();
		}
		public virtual void InvertCellSelection(int rowHandle, GridColumn focusedColumn) {
			if(!IsCellSelect) return;
			if(IsValidRowHandle(rowHandle)) {
				if(IsGroupRow(rowHandle)) {
					InvertRowSelection(rowHandle);
					return;
				}
				if(IsCellSelected(rowHandle, focusedColumn))
					UnselectCell(rowHandle, focusedColumn);
				else
					SelectCell(rowHandle, focusedColumn);
			}
		}
		protected internal virtual void SelectFocusedCellRangeCore(GridCell start, GridCell end, KeyEventArgs e) {
			if(!IsCellSelect || (Control.ModifierKeys & Keys.Control) != 0) return;
			if((Control.ModifierKeys & Keys.Shift) != 0 && e.KeyCode != Keys.Tab) {
				if(SelectionAnchorRowHandle == InvalidRowHandle) {
					SelectionAnchor = new GridCell(start.RowHandle, start.Column);
				}
				if(SelectionAnchorRowHandle != InvalidRowHandle) {
					VisualSelectRowsCore(SelectionAnchor, end, false, true);
					return;
				}
				if(end.RowHandle == start.RowHandle) 
					VisualSelectRowsCore(start, end, true, true);
				else
					SelectFocusedCellCore(e);
			} else {
				SelectFocusedCellCore(e);
			}
		}
		internal void SelectFocusedCellCore() { SelectFocusedCellCore(new KeyEventArgs(Control.ModifierKeys)); }
		protected internal virtual void SelectFocusedCellCore(KeyEventArgs e) {
			if(!IsCellSelect || e.Control) return;
			if(!e.Shift || e.KeyCode == Keys.Tab) SmartClearSelection();
			if(IsGroupRow(FocusedRowHandle)) {
				base.SelectFocusedRowCore();
				return;
			}
			SelectFocusedCell();
		}
		void SmartClearSelection() {
			if(this.lockSelectionInvalidate) {
				ClearSelectionCore();
				return;
			}
			bool[] old = GetVisibleSelectionInfo();
			this.lockSelectionInvalidate = true;
			try {
				ClearSelectionCore();
			}
			finally {
				this.lockSelectionInvalidate = false;
			}
			InvalidateVisibleSelectionChanges(old);
		}
		protected override void OnSelectionAnchorChanged() { 
			if(SelectionAnchorRowHandle == InvalidRowHandle)
				SetSelectionBounds(InvalidRowHandle, InvalidRowHandle, 0, 0);
			else {
				int index = SelectionAnchor.Column == null ? 0 : SelectionAnchor.Column.VisibleIndex;
				SetSelectionBounds(index, SelectionAnchorRowHandle, index, SelectionAnchorRowHandle);
			}
			base.OnSelectionAnchorChanged();
		}
		public virtual void SelectCellAnchorRange(int startRowHandle, GridColumn startColumn, int endRowHandle, GridColumn endColumn) {
			SelectCellAnchorRange(new GridCell(startRowHandle, startColumn), new GridCell(endRowHandle, endColumn));
		}
		public virtual void SelectCellAnchorRange(GridCell start, GridCell end) {
			VisualSelectRowsCore(start, end, true, true);
		}
		protected override void DoAfterFocusedColumnChanged(GridColumn prevFocusedColumn, GridColumn focusedColumn) {
			if(focusedColumn != null)
				MakeColumnVisible(focusedColumn);
			if(prevFocusedColumn != null && prevFocusedColumn.View != null)
				UpdateCellViewInfo(FocusedRowHandle, prevFocusedColumn, BaseViewInfo.EmptyPoint);
			UpdateCellViewInfo(FocusedRowHandle, focusedColumn, BaseViewInfo.EmptyPoint);
			UpdateRowViewInfo(FocusedRowHandle);
			base.DoAfterFocusedColumnChanged(prevFocusedColumn, focusedColumn);
			if((Control.ModifierKeys & Keys.Shift) == 0) SelectionAnchorRowHandle = InvalidRowHandle;
		}
		protected override void DoAfterMoveFocusedRowColumn(Keys byKey, int prevFocusedHandle, GridColumn prevFocusedColumn) {
			if(!IsCellSelect) return;
			bool shiftPressed = (Control.ModifierKeys & Keys.Shift) != 0,
				controlPressed = (Control.ModifierKeys & Keys.Control) != 0;
			if(byKey == Keys.LButton) {
				if(!shiftPressed) {
					if(!controlPressed) SelectFocusedCellCore();
					return;
				}
				if(SelectionAnchorRowHandle == InvalidRowHandle)
					SetSelectionAnchor(prevFocusedHandle, prevFocusedColumn);
				SelectAnchorRangeCore(controlPressed, true);
			}
		}
		protected override bool IsFocusedRowSelectedCore() { 
			if(IsCellSelect) return IsCellSelected(FocusedRowHandle, FocusedColumn);
			return base.IsFocusedRowSelectedCore();
		}
		protected void ValidateIndexes(GridCell start, GridCell end, out int startIndex, out int colStart, out int endIndex, out int colEnd) {
			colStart = colEnd = endIndex = startIndex = -1;
			if(start == null || end == null || !start.IsColumnValid || !end.IsColumnValid) return;
			startIndex = GetVisibleIndex(start.RowHandle);
			endIndex = GetVisibleIndex(end.RowHandle);
			colStart = start.Column.VisibleIndex;
			colEnd = end.Column.VisibleIndex;
			if(colStart > colEnd) {
				int a = colEnd; colEnd = colStart; colStart = a;
			}
			if(startIndex > endIndex) {
				int a = endIndex;
				endIndex = startIndex;
				startIndex = a;
			} 
		}
		class ColumnIndexesComparer : IComparer {
			int IComparer.Compare(object a, object b) {
				GridColumn c1 = (GridColumn)a, c2 = (GridColumn)b;
				return Comparer.Default.Compare(c1.VisibleIndex, c2.VisibleIndex);
			}
		}
		ColumnIndexesComparer indexesComparer = new ColumnIndexesComparer();
		public virtual GridColumn[] GetSelectedCells(int rowHandle) {
			if(!IsCellSelect) return new GridColumn[] { };
			GridRowSelectionInfo info = GetSelectionInfo(rowHandle);
			if(info == null || info.IsEmpty) return new GridColumn[] { };
			GridColumn[] cols = info.GetColumns();
			if(cols.Length > 1)
				Array.Sort(cols, indexesComparer);
			return cols;
		}
		public virtual GridCell[] GetSelectedCells() {
			if(!IsCellSelect) { 
				return new GridCell[] { };
			}
			ArrayList list = new ArrayList();
			int[] rows = GetSelectedRows();
			if(rows.Length == 0) return new GridCell[] { };
			for(int n = 0; n < rows.Length; n++) {
				GridColumn[] cols = GetSelectedCells(rows[n]);
				for(int c = 0; c < cols.Length; c++) {
					list.Add(new GridCell(rows[n], cols[c]));
				}
			}
			return list.ToArray(typeof(GridCell)) as GridCell[];
		}
		public void SelectRows(int startRowHandle, int endRowHandle) { SelectRange(startRowHandle, endRowHandle); }
		public void SelectCells(GridCell start, GridCell end) { SetCellSelection(start, end, true);	}
		public void UnSelectCells(GridCell start, GridCell end) { SetCellSelection(start, end, false);	}
		public void SelectCells(int startRowHandle, GridColumn startColumn, int endRowHandle, GridColumn endColumn) {
			SelectCells(new GridCell(startRowHandle, startColumn), new GridCell(endRowHandle, endColumn));
		}
		protected override bool CompareSelection(object prev, object current) {
			if(!IsCellSelect) return base.CompareSelection(prev, current);
			GridCell[] rows1 = prev as GridCell[];
			GridCell[] rows2 = current as GridCell[];
			if(rows1 == rows2) return true;
			if(rows1 == null) return false;
			if(rows2 == null) return false;
			if(rows1.Length != rows2.Length) return false;
			for(int n = 0; n < rows1.Length; n++) {
				GridCell c1 = rows1[n];
				GridCell c2 = rows2[n];
				if(c1.RowHandle != c2.RowHandle) return false;
				if(c1.Column != c2.Column) return false;
			}
			return true;
		}
		protected override object GetCurrentSelection() {
			if(!IsCellSelect) return base.GetCurrentSelection();
			return GetSelectedCells();
		}
		protected virtual void SetCellSelection(GridCell start, GridCell end, bool setSelected) {
			if(start == null || end == null || !start.IsColumnValid || !end.IsColumnValid) return;
			int startIndex, endIndex, colStart, colEnd;
			ValidateIndexes(start, end, out startIndex, out colStart, out endIndex, out colEnd);
			if(startIndex < 0 || endIndex < 0) return;
			BeginSelection();
			try {
				for(int n = startIndex; n < endIndex + 1; n++) {
					for(int c = colStart; c < colEnd + 1; c++) {
						GridColumn col = VisibleColumns[c];
						int row = GetVisibleRowHandle(n);
						if(col != null && IsValidRowHandle(row)) {
							if(setSelected)
								SelectCell(row, col);
							else
								UnselectCell(row, col);
						}
					}
				}
			} finally {
				EndSelection();
			}
		}
		protected virtual void SelectCellAnchorRangeCore(GridCell start, GridCell end, bool clearSelection, Rectangle prevSelection) {
			if(start == null || end == null || !start.IsColumnValid || !end.IsColumnValid) {
				if(clearSelection) ClearSelectionCore();
				return;
			}
			SetSelectionBounds(start.Column.VisibleIndex, start.RowHandle, end.Column.VisibleIndex, end.RowHandle);
			int startIndex, endIndex, colStart, colEnd;
			ValidateIndexes(start, end, out startIndex, out colStart, out endIndex, out colEnd);
			if(startIndex < 0 || endIndex < 0) {
				if(clearSelection) ClearSelectionCore();
				return;
			}
			BeginSelection();
			try {
				if(prevSelection.X != InvalidRowHandle) {
					if(SelectionBounds.IntersectsWith(prevSelection)) {
						UnselectCellsBlock(prevSelection, SelectionBounds);
						clearSelection = false;
					} 
				}
				if(clearSelection) ClearSelectionCore();
				SelectCell(start); 
				for(int n = startIndex; n < endIndex + 1; n++) {
					if(prevSelection.Y != InvalidRowHandle && prevSelection.Contains(colStart, n) && prevSelection.Contains(colEnd, n)) continue;
					int rowHandle = GetVisibleRowHandle(n);
					GridRowSelectionInfo info = GetSelectionInfo(rowHandle);
					bool exists = info != null;
					bool changed = false;
					if(info == null) info = new GridRowSelectionInfo();
					for(int c = colStart; c < colEnd + 1; c++) {
						if(prevSelection.Y != InvalidRowHandle && prevSelection.Contains(c, n)) continue;
						GridColumn col = VisibleColumns[c];
						if(col != null) {
							changed = true;
							info.AddReference(col);
							DataController.Selection.RaiseChanged();
						}
					}
					if(!exists && changed) DataController.Selection.SetSelected(rowHandle, true, info);
				}
			}
			finally {
				EndSelection();
			}
		}
		protected void UnselectCellsBlock(Rectangle prevBlock, Rectangle newBlock) {
			Point i1 = new Point(prevBlock.X, newBlock.X);
			Point i2 = new Point(newBlock.Right, prevBlock.Right);
			Point r1 = new Point(prevBlock.X, prevBlock.Right);
			Point rows = new Point(prevBlock.Y, prevBlock.Y + prevBlock.Height);
			bool requireUnselectCells = i1.X < i1.Y || i2.X < i2.Y,
				requireUnselectRows = r1.X < r1.Y;
			int c;
			for(int n = rows.X; n < rows.Y; n++) {
				int row = GetVisibleRowHandle(n);
				if(n < newBlock.Y || n >= newBlock.Bottom) {
					if(!requireUnselectRows || GetSelectionInfo(row) == null) continue;
					for(c = r1.X; c < r1.Y; c++) UnselectCellRelease(row, VisibleColumns[c]);
				} else {
					if(!requireUnselectCells || GetSelectionInfo(row) == null) continue;
					for(c = i1.X; c < i1.Y; c++) UnselectCellRelease(row, VisibleColumns[c]);
					for(c = i2.X; c < i2.Y; c++) UnselectCellRelease(row, VisibleColumns[c]);
				}
			}
		}
		void UnselectRowRelease(int rowHandle) {
			GridRowSelectionInfo info = GetSelectionInfo(rowHandle);
			if(info == null) return;
			info.ReleaseRow();
			if(info.IsEmpty) UnselectRow(rowHandle);
		}
		void UnselectCellRelease(int rowHandle, GridColumn column) {
			GridRowSelectionInfo info = GetSelectionInfo(rowHandle);
			if(info == null) return;
			info.Release(column);
			if(info.IsEmpty)
				UnselectRow(rowHandle);
			else
				DataController.Selection.RaiseChanged();
		}
		protected internal void SelectFocusedCell() {
			if(IsGroupRow(FocusedRowHandle)) {
				base.SelectFocusedRowCore();
				return;
			}
			SelectCell(FocusedRowHandle, FocusedColumn);
		}
		public void SelectCell(GridCell cell) {
			if(cell == null) return;
			SelectCell(cell.RowHandle, cell.Column);
		}
		public virtual void SelectCell(int rowHandle, GridColumn column) {
			if(column == null || !IsCellSelect) return;
			GridRowSelectionInfo info = GetSelectionInfo(rowHandle);
			if(info == null) 
				info = new GridRowSelectionInfo(column);
			else {
				if(info.Contains(column)) return;
				info.Add(column);
				DataController.Selection.SetActuallyChanged();
			}
			SetCellSelection(rowHandle, info);
		}
		protected virtual void SetCellSelection(int rowHandle, GridRowSelectionInfo info) {
			GridRowSelectionInfo current = GetSelectionInfo(rowHandle);
			if(current == null || current.Count != info.Count) {
				DataController.Selection.SetSelected(rowHandle, true, info);
				return;
			}
			OnDataController_SelectionChanged(this, new SelectionChangedEventArgs(CollectionChangeAction.Add, rowHandle));
		}
		Rectangle selectionBounds = new Rectangle(InvalidRowHandle, InvalidRowHandle, 0, 0);
		protected Rectangle SelectionBounds {
			get { return selectionBounds; }
		}
		protected void SetSelectionBounds(int colIndex1, int rowHandle1, int colIndex2, int rowHandle2) {
			if(colIndex1 > colIndex2) {
				int a = colIndex1; colIndex1 = colIndex2; colIndex2 = a;
			}
			int r1 = GetVisibleIndex(rowHandle1), r2 = GetVisibleIndex(rowHandle2);
			if(r1 != InvalidRowHandle) {
				if(r1 > r2) { 
					int a = r1; r1 = r2; r2 = a;
				}
			}
			rowHandle1 = r1; rowHandle2 = r2;
			selectionBounds = new Rectangle(colIndex1, rowHandle1, (colIndex2 - colIndex1) + 1, (rowHandle2 - rowHandle1) + 1);
		}
		protected virtual void VisualSelectRowsCore(GridCell start, GridCell end, bool controlPressed, bool cells) {
			if(!IsMultiSelect) return;
			if(!IsValidRowHandle(start.RowHandle)) return;
			bool[] oldRows = null;
			Rectangle prevSelection = SelectionBounds;
			if(ViewInfo.RowsInfo != null && ViewInfo.RowsInfo.Count > 0) {
				oldRows = GetVisibleSelectionInfo();
			}
			BeginSelection();
			try {
				if(!IsCellSelect || !cells) {
					if(!controlPressed) ClearSelectionCore();
					SelectRow(start.RowHandle);
					SelectRange(start.RowHandle, end.RowHandle);
				} else {
					SelectCellAnchorRangeCore(start, end, !controlPressed, prevSelection);
				}
			} finally {
				EndSelection();
			}
			if(oldRows != null) InvalidateVisibleSelectionChanges(oldRows);
			else InvalidateRows();
		}
		protected override void SelectAnchorRangeCore(bool controlPressed, bool allowCells) {
			VisualSelectRowsCore(SelectionAnchor, new GridCell(FocusedRowHandle, FocusedColumn), controlPressed, allowCells);
		}
		public override void SelectAll() {
			if(!IsCellSelect) {
				base.SelectAll();
				return;
			}
			BeginSelection();
			try {
				ClearSelectionCore();
				for(int n = 0; n < RowCount; n++) {
					SelectRow(GetVisibleRowHandle(n));
				}
			}
			finally {
				EndSelection();
			}
		}
		public override void SelectRow(int rowHandle) {
			if(IsCellSelect) {
				if(IsGroupRow(rowHandle)) {
					base.SelectRow(rowHandle);
					return;
				}
				GridRowSelectionInfo info = new GridRowSelectionInfo();
				info.AddRange(VisibleColumns);
				SetCellSelection(rowHandle, info);
				return;
			}
			base.SelectRow(rowHandle);
		}
		public virtual void UnselectCell(int rowHandle, GridColumn column) {
			if(!IsCellSelect) return;
			GridRowSelectionInfo info = GetSelectionInfo(rowHandle);
			if(info == null) return;
			if(!info.Remove(column)) return;
			DataController.Selection.SetActuallyChanged();
			if(info.IsEmpty) {
				DataController.Selection.SetSelected(rowHandle, false);
				return;
			}
			OnDataController_SelectionChanged(this, new SelectionChangedEventArgs(CollectionChangeAction.Refresh, rowHandle));
		}
		public void UnselectCell(GridCell cell) {
			if(cell == null) return;
			UnselectCell(cell.RowHandle, cell.Column);
		}
		public bool IsCellSelected(GridCell cell) {
			if(cell == null) return false;
			return IsCellSelected(cell.RowHandle, cell.Column);
		}
		public virtual bool IsCellSelected(int rowHandle, GridColumn column) {
			if(!IsCellSelect || column == null) return false;
			GridRowSelectionInfo info = GetSelectionInfo(rowHandle);
			if(info == null) return false;
			return info.Contains(column);
		}
		protected virtual GridRowSelectionInfo GetSelectionInfo(int rowHandle) {
			return DataController.Selection.GetSelectedObject(rowHandle) as GridRowSelectionInfo;
		}
		protected override bool IsAutoHeight { get { return OptionsView.RowAutoHeight; } }
		protected override void OnGridControlChanged(GridControl prevControl) {
			base.OnGridControlChanged(prevControl);
			if(ScrollInfo != null) {
				ScrollInfo.RemoveControls(prevControl);
				ScrollInfo.AddControls(GridControl);
			}
		}
		protected Timer ScrollTimer { get { return scrollTimer; } }
		protected virtual void OnScrollTimer_Tick(object sender, EventArgs e) {
			if(State != GridState.Selection && State != GridState.CellSelection) {
				ScrollTimer.Enabled = false;
				return;
			}
			Rectangle r = ViewInfo.ViewRects.Rows;
			Point p = PointToClient(Control.MousePosition);
			int vScrollDelta = 0, hScrollDelta = 0;
			if(p.Y < r.Top + 10) {
				vScrollDelta = -1;
			} 
			if(p.Y > r.Bottom - 10) {
				vScrollDelta = 1;
			}
			if(IsCellSelect && !OptionsView.ColumnAutoWidth) {
				if(p.X <= r.Left && State != GridState.Selection) hScrollDelta = -10;
				if(p.X >= r.Right) hScrollDelta = 10;
			}
			int prevIndex = TopRowIndex;
			TopRowIndex += vScrollDelta;
			LeftCoord += hScrollDelta;
			if(prevIndex != TopRowIndex && ViewInfo.RowsInfo.Count > 0) {
				if(vScrollDelta == -1) 
					UpdateAccessSelection(ViewInfo.RowsInfo[0].RowHandle, ViewInfo.GetNearestColumn(p));
				else {
					UpdateAccessSelection(ViewInfo.RowsInfo[ViewInfo.RowsInfo.Count - 1].RowHandle, ViewInfo.GetNearestColumn(p));
				}
			}
		}
		public override EditorShowMode GetShowEditorMode() {
			EditorShowMode res = OptionsBehavior.EditorShowMode;
			if(res == EditorShowMode.Default) {
				res = IsCellSelect ? EditorShowMode.Click : EditorShowMode.MouseDown;
			}
			return res;
		}
		protected internal virtual void StartAccessSelectionCore(int rowHandle, GridColumn column, bool indicator) {
			SetDefaultState();
			if(!IsDefaultState) return;
			if(IsFilterRow(rowHandle) || IsNewItemRow(rowHandle)) return;
			if(indicator && !OptionsSelection.UseIndicatorForSelection) return;
			try {
				BeginSelection();
				if(indicator) {
					ClearSelectionCore();
				}
				if(DataRowCount == 0 || rowHandle == InvalidRowHandle) return;
				if(IsCellSelect && !indicator) 
					SelectCell(rowHandle, column);
				else
					SelectRow(rowHandle);
			} finally {
				EndSelection();
			}
			SetSelectionAnchor(rowHandle, column);
			SetStateCore(indicator || !IsCellSelect ? GridState.Selection : GridState.CellSelection);
			if((Control.MouseButtons & MouseButtons.Left) == 0 || !GridControl.Capture) {
				SetDefaultState();
				return;
			}
		}
		protected internal virtual void StartAccessSelection() {
			StartAccessSelectionCore(FocusedRowHandle, VisibleColumns.Count > 0 ? VisibleColumns[0] : null, true);
		}
		protected internal virtual void EndAccessSelection() {
			SelectionAnchorRowHandle = InvalidRowHandle;
			if(ScrollTimer != null) ScrollTimer.Enabled = false;
		}
		protected internal override void OnColumnSummaryCollectionChanged(GridColumn column, CollectionChangeEventArgs e) {
			TotalSummary.SetDirty();
			OnSummaryCollectionChanged(TotalSummary, e);
		}
		protected virtual void OnSummaryCollectionChanged(object sender, CollectionChangeEventArgs e) {
			if(IsLoading) return;
			SynchronizeSummary();
		}
		public void BeginSummaryUpdate() {
			this.lockSummary++;
		}
		public void EndSummaryUpdate() {
			if(--this.lockSummary == 0)
				SynchronizeSummary();
		}
		protected override void InternalSynchronizeGroupSummary() {
			if(lockSummary != 0) return;
			if(IsNeedUpdate(GroupSummary, DataController.GroupSummary, GroupSummary.ActiveCount)) {
				SynchronizeSummary(GroupSummary, DataController.GroupSummary);
				DataController.UpdateGroupSummary();
				SetLayoutDirty();
				if(CanSynchronized) OnViewPropertiesChanged(SynchronizationMode.Data);
			}
		}
		protected internal virtual void SynchronizeSummary() {
			if(lockSummary != 0) return;
			bool isNeedUpdate = false;
			TotalSummary.CheckDirty();
			if(IsNeedUpdate(TotalSummary, DataController.TotalSummary, TotalSummary.ActiveCount)) {
				SynchronizeSummary(TotalSummary, DataController.TotalSummary);
				DataController.UpdateTotalSummary();
				isNeedUpdate = true;
			}
			if(IsNeedUpdate(GroupSummary, DataController.GroupSummary, GroupSummary.ActiveCount)) {
				SynchronizeSummary(GroupSummary, DataController.GroupSummary);
				isNeedUpdate = true;
				DataController.UpdateGroupSummary();
			}
			if(isNeedUpdate) {
				SetLayoutDirty();
				ViewInfo.IsReady = false;
				if(CanSynchronized) OnViewPropertiesChanged(SynchronizationMode.Data);
			}
			else {
				LayoutChangedSynchronized();
			}
		}
		protected virtual void SynchronizeSummary(IList gridSum, SummaryItemCollection summary) {
			summary.BeginUpdate();
			try {
				for(int n = gridSum.Count - 1; n >= 0; n--) {
					GridSummaryItem item = gridSum[n] as GridSummaryItem;
					if(item.SummaryItem != null && !summary.Contains(item.SummaryItem)) item.SummaryItem = null;
				}
				for(int n = summary.Count - 1; n >= 0; n--) {
					if(((IGridSummaryFind)gridSum).FindSummaryItem(summary[n]) == null) summary.RemoveAt(n);
				}
				for(int n = 0; n < gridSum.Count; n++) {
					GridSummaryItem sItem = gridSum[n] as GridSummaryItem;
					if(sItem.SummaryItem == null) {
						sItem.SummaryItem = summary.Add(new SummaryItem(DataController.Columns[sItem.FieldName], sItem.SummaryType));
						sItem.SummaryItem.Tag = sItem;
					}
					else
						sItem.AssignSummaryItem();
				}
			}
			finally {
				summary.CancelUpdate();
			}
		}
		protected virtual bool IsNeedUpdate(IList gridSum, SummaryItemCollection summary, int activeCount) {
			if(gridSum.Count != summary.Count) {
				if(gridSum == TotalSummary) { 
					if(summary.Count == 0 && TotalSummary.ActiveCount == 0) return false;
				}
				return true;
			}
			if(gridSum.Count == 0) return false;
			foreach(GridSummaryItem gItem in gridSum) {
				SummaryItem sItem = summary.GetSummaryItemByTag(gItem);
				if(sItem == null || gItem.SummaryItem != sItem || !gItem.IsEqualsSummaryItem(sItem)) return true;
			}
			return false;
		}
		public void UpdateSummary() {
			DataController.CalcSummary();
			LayoutChanged();
		}
		public void UpdateTotalSummary() {
			DataController.UpdateTotalSummary();
			ViewInfo.UpdateFooterDrawInfo();
			InvalidateFooter();
		}
		public void UpdateGroupSummary() {
			DataController.UpdateGroupSummary();
			LayoutChanged();
		}
		protected override void OnActiveEditor_ValueModified(object sender, EventArgs e) {
			if(this.EditingValueModified) {
				if(IsNewItemRow(FocusedRowHandle) && !DataController.IsNewItemRowEditing) {
					try {
						fAllowCloseEditor = false;
						this.fEditingCell = null;
						DataController.AddNewRow();
					}
					finally {
						fAllowCloseEditor = true;
					}
					DataController.BeginCurrentRowEdit();
					this.fEditingCell = ViewInfo.GetGridCellInfo(FocusedRowHandle, FocusedColumn);
					if(this.fEditingCell != null) {
						ActiveEditor.Location = this.fEditingCell.CellValueRect.Location;
						ActiveEditor.Size = this.fEditingCell.CellValueRect.Size;
					}
					RefreshRow(FocusedRowHandle, false, false);
					SetFocusedRowModified();
				}
			}
			InvalidateRow(FocusedRowHandle); 
			base.OnActiveEditor_ValueModified(sender, e);
		}
		public override int GetVisibleIndex(int rowHandle) {
			if(rowHandle == CurrencyDataController.NewItemRow) {
				if(OptionsView.NewItemRowPosition == NewItemRowPosition.Top) return -1;
				if(OptionsView.NewItemRowPosition == NewItemRowPosition.Bottom) return RowCount - 1;
				if(OptionsView.NewItemRowPosition == NewItemRowPosition.None && DataController.IsNewItemRowEditing) return RowCount - 1;
			}
			return base.GetVisibleIndex(rowHandle);
		}
		public override int GetVisibleRowHandle(int rowVisibleIndex) {
			if(rowVisibleIndex == -1 && OptionsView.NewItemRowPosition == NewItemRowPosition.Top) {
				return CurrencyDataController.NewItemRow;
			}
			if(rowVisibleIndex == RowCount - 1) {
				if(OptionsView.NewItemRowPosition == NewItemRowPosition.Bottom) return CurrencyDataController.NewItemRow;
				if(OptionsView.NewItemRowPosition == NewItemRowPosition.None && DataController.IsNewItemRowEditing) return CurrencyDataController.NewItemRow;
			}
			return base.GetVisibleRowHandle(rowVisibleIndex);
		}
		[Description("Gets the number of visible rows within the current View.")]
		public override int RowCount {
			get {
				if(DesignMode) return base.RowCount;
				int res = base.RowCount;
				if(OptionsView.NewItemRowPosition == NewItemRowPosition.Bottom) res++;
				if(OptionsView.NewItemRowPosition == NewItemRowPosition.None && DataController.IsNewItemRowEditing) res++;
				return res;
			}
		}
		public override int GetNextVisibleRow(int rowVisibleIndex) {
			return base.GetNextVisibleRow(rowVisibleIndex);
		}
		protected internal override void OnColumnOptionsChanged(GridColumn column, BaseOptionChangedEventArgs e) {
			base.OnColumnOptionsChanged(column, e);
			if(IsDeserializing) return;
			if(FocusedColumn == column) FocusedColumn = GetNearestCanFocusedColumn(column, 0, false);
		}
		protected override void OnColumnAdded(GridColumn column) {
			base.OnColumnAdded(column);
			TotalSummary.SetDirty();
			if(DataController.IsReady) {
				OnSummaryCollectionChanged(TotalSummary, new CollectionChangeEventArgs(CollectionChangeAction.Refresh, null));
			}
		}
		protected override void OnColumnDeleted(GridColumn column) {
			BeginUpdate();
			try {
				base.OnColumnDeleted(column);
				if(ViewInfo != null && ViewInfo.IsReady) ViewInfo.Clear();
				TotalSummary.SetDirty();
				if(DataController.IsReady) {
					OnSummaryCollectionChanged(TotalSummary, new CollectionChangeEventArgs(CollectionChangeAction.Refresh, null));
				}
			}
			finally {
				EndUpdate();
			}
		}
		protected override void InitializeDataParameters() {
			base.InitializeDataParameters();
			TotalSummary.SetDirty();
		}
		protected internal override void SynchronizeLookDataControllerSettings() {
			SynchronizeSummary();
			base.SynchronizeLookDataControllerSettings();
		}
		protected override void UpdateDataControllerOptions() {
			base.UpdateDataControllerOptions();
			DataController.KeepGroupRowsExpandedOnRefresh = OptionsBehavior.KeepGroupExpandedOnSorting;
			DataController.AutoUpdateTotalSummary = OptionsBehavior.AutoUpdateTotalSummary;
			DataController.AutoExpandAllGroups = OptionsBehavior.AutoExpandAllGroups;
			DataController.SummariesIgnoreNullValues = OptionsBehavior.SummariesIgnoreNullValues;
		}
		protected override void InitializeDataController() {
			base.InitializeDataController();
			SynchronizeSummary();
		}
		protected  virtual void OnDataManager_CustomSummaryEvent(object sender, CustomSummaryEventArgs e) {
			CustomSummaryEventHandler handler = (CustomSummaryEventHandler)this.Events[customSummaryCalculate];
			if(handler != null) handler(this, e);
		}
		protected  virtual void OnDataManager_CustomSummaryExistEvent(object sender, CustomSummaryExistEventArgs e) {
			CustomSummaryExistEventHandler handler = (CustomSummaryExistEventHandler)this.Events[customSummaryExists];
			if(handler != null) handler(this, e);
		}
		protected virtual void OnSummaryChanged(object sender, CollectionChangeEventArgs e) {
			FireChanged();
			BeginSynchronization();
			try {
				OnPropertiesChanged();
			}
			finally {
				EndSynchronization();
			}
		}
		internal void XtraClearGroupSummary(XtraItemEventArgs e) {
			if(e.Item.ChildProperties == null || e.Item.ChildProperties.Count == 0) {
				GroupSummary.Clear();
				return;
			}
			ArrayList list = new ArrayList();
			foreach(DevExpress.Utils.Serializing.Helpers.XtraPropertyInfo xp in e.Item.ChildProperties) {
				object col = XtraFindGroupSummaryItem(new XtraItemEventArgs(this, GroupSummary, xp));
				if(col != null) list.Add(col);
			}
			for(int n = GroupSummary.Count - 1; n >= 0; n--) {
				GridSummaryItem item = GroupSummary[n];
				if(!list.Contains(item)) GroupSummary.RemoveAt(n);
			}
		}
		internal object XtraCreateGroupSummaryItem(XtraItemEventArgs e) { return GroupSummary.XtraCreateSummaryItem(e); }
		internal void XtraSetIndexGroupSummaryItem(XtraSetItemIndexEventArgs e) { GroupSummary.XtraSetIndexSummaryItem(e); }
		internal object XtraFindGroupSummaryItem(XtraItemEventArgs e) { return GroupSummary.XtraFindSummaryItem(e); }
		protected override void OnPopulateColumns() { 
			base.OnPopulateColumns();
			if(GroupSummary.Count > 0) {
				GroupSummary.Refresh();
				SynchronizeSummary();
			}
		}
		[Localizable(true), DesignerSerializationVisibility(DesignerSerializationVisibility.Content), Browsable(false), XtraSerializableProperty(true, true, true, 1000)]
		public virtual GridGroupSummaryItemCollection GroupSummary { get { return fGroupSummary; } }
		protected internal virtual GridTotalSummaryCollection TotalSummary { get { return totalSummary; } }
		protected virtual ScrollStyleFlags DefaultScrollStyle {
			get { return ScrollStyleFlags.LiveVertScroll | ScrollStyleFlags.LiveHorzScroll; }
		}
		protected virtual void UpdateRowViewInfo(int rowHandle) {
			if(IsLockUpdate) return;
			if(ViewDisposing) return;
			GridRowInfo ri = ViewInfo.GetGridRowInfo(rowHandle);
			if(ri == null) return;
			ViewInfo.UpdateRowData(ri, true, false);
		}
		protected virtual void UpdateCellViewInfo(int rowHandle, GridColumn column, Point mousePos) {
			if(IsLockUpdate) return;
			if(column == null || rowHandle == DevExpress.Data.DataController.InvalidRow) return;
			GridCellInfo cell = ViewInfo.GetGridCellInfo(rowHandle, column);
			if(cell == null) return;
			if(cell.ViewInfo != null && cell.ViewInfo is IAnimatedItem) 
				XtraAnimator.RemoveObject( ViewInfo, new GridCellId(this, cell));
			cell.ViewInfo = null;
			ViewInfo.RequestCellEditViewInfo(cell);
			ViewInfo.UpdateCellEditViewInfo(cell, mousePos, true, true);
			InvalidateRowCell(rowHandle, column);
		}
		public override void InvalidateHitObject(DevExpress.XtraGrid.Views.Base.ViewInfo.BaseHitInfo hit) {
			GridHitInfo hitInfo = hit as GridHitInfo;
			if(hitInfo.InGroupPanel) 
				InvalidateGroupPanel();
			if(hitInfo.InColumn) {
				InvalidateColumnHeader(hitInfo.Column);
				return;
			}
			if(hitInfo.HitTest == GridHitTest.ColumnButton) { 
				InvalidateColumnHeader(null);
				return;
			}
			if(hitInfo.InFilterPanel) {
				InvalidateFilterPanel();
				return;
			}
			if(hitInfo.InRowCell) {
				InvalidateRowCell(hitInfo.RowHandle, hitInfo.Column);
				return;
			}
		}
		protected override void OnRowMouseEnter(int rowHandle) {
			base.OnRowMouseEnter(rowHandle);
			if(IsDefaultState && WorkAsLookup) {
				if(this.firstMouseEnter) {
					this.firstMouseEnter = false;
					return;
				}
				if(IsDataRow(rowHandle)) {
					if(IsRowVisible(rowHandle) == RowVisibleState.Visible)
						FocusedRowHandle = rowHandle;
				}
			}
		}
		protected internal virtual void VisualExpandGroup(int rowHandle, bool expanded) {
			GridRowInfo row = ViewInfo.RowsInfo.FindRow(rowHandle);
			SetRowExpanded(rowHandle, expanded);
			if(!AllowFixedGroups || expanded) return;
			if(row != null && row.ForcedRow && DataController.IsRowVisible(row.RowHandle)) {
				MakeRowVisible(row.RowHandle, false);
			}
		}
		protected virtual int GetSelectionRowHandle(int rowHandle) {
			if(IsFilterRow(rowHandle) || (IsNewItemRow(rowHandle) && OptionsView.NewItemRowPosition == NewItemRowPosition.Top)) {
				return GetVisibleRowHandle(TopRowIndex);
			}
			if(IsNewItemRow(rowHandle)) {
				return GetVisibleRowHandle(RowCount - 1);
			}
			return rowHandle;
		}
		protected internal virtual void UpdateAccessSelection(int rowHandle, GridColumn column) {
			rowHandle = GetSelectionRowHandle(rowHandle);
			try {
				ScrollTimer.Enabled = false;
				VisualSelectRowsCore(SelectionAnchor, new GridCell(rowHandle, column), false, IsCellSelect && State == GridState.CellSelection);
			}
			finally {
				ScrollTimer.Enabled = true;
			}
		}
		bool[] GetVisibleSelectionInfo() {
			bool[] rows = new bool[ViewInfo.RowsInfo.Count];
			for(int n = 0; n < ViewInfo.RowsInfo.Count; n++) {
				GridRowInfo row = ViewInfo.RowsInfo[n];
				rows[n] = IsRowSelected(row.RowHandle);
			}
			return rows;
		}
		void InvalidateVisibleSelectionChanges(bool[] prevRows) {
			bool[] newRows = GetVisibleSelectionInfo();
			int count = Math.Min(newRows.Length, prevRows.Length);
			for(int n = 0; n < count; n++) {
				if(newRows[n] != prevRows[n] || (IsCellSelect && prevRows[n])) InvalidateRow(ViewInfo.RowsInfo[n].RowHandle);
			}
		}
		protected override void VisualClientUpdateRow(int controllerRowHandle) {
			GridRowInfo row = ViewInfo.GetGridRowInfo(controllerRowHandle) as GridRowInfo;
			GridDataRowInfo dataRow = row as GridDataRowInfo;
			GridGroupRowInfo groupRow = row as GridGroupRowInfo;
			if(dataRow != null && (dataRow.HasMergedCells || IsCellMerge || (OptionsView.ShowPreview && OptionsView.AutoCalcPreviewLineCount))) {
				SetLayoutDirty();
				return;
			}
			if(dataRow == null && OptionsView.NewItemRowPosition != NewItemRowPosition.None) {
				SetLayoutDirty();
				return;
			}
			if(GroupCount > 0 && GroupSummary.ActiveCount > 0) {
				SetLayoutDirty();
				return;
			}
			base.VisualClientUpdateRow(controllerRowHandle);
		}
		protected override Point GetCellPoint(object cellInfo, Point point) { 
			GridCellInfo cell = cellInfo as GridCellInfo;
			if(cell != null) point.Offset(-cell.CellValueRect.X, -cell.CellValueRect.Y);
			return point; 
		}
		protected override object GetCellInfo(BaseHitInfo hitInfo) { 
			GridHitInfo grid = hitInfo as GridHitInfo;
			return grid != null ? grid.CellInfo : null;
		}
		protected override BaseEditViewInfo GetCellEditInfo(object cellInfo) { 
			GridCellInfo cell = cellInfo as GridCellInfo;
			return cell != null ? cell.ViewInfo : null;
		}
		protected override void OnRowMouseLeave(int rowHandle) {
			base.OnRowMouseLeave(rowHandle);
		}
		protected override void OnHotTrackLeave(BaseHitInfo hitInfo) {
			GridHitInfo hit = hitInfo as GridHitInfo;
			bool needInvalidate = false;
			if(hit.InRowCell) OnCellMouseLeave(hitInfo);
			else 
				needInvalidate = true;
			if(needInvalidate) {
				InvalidateHitObject(hit);
			}
		}
		protected override void OnHotTrackEnter(BaseHitInfo hitInfo) {
			GridHitInfo hit = hitInfo as GridHitInfo;
			bool needInvalidate = false;
			if(hit.InRowCell) OnCellMouseEnter(hitInfo);
			else 
				needInvalidate = true;
			if(needInvalidate)
				InvalidateHitObject(hit);
		}
		protected internal override void OnLostCapture() {
			((GridHandler)Handler).DownPointHitInfo = null;
			if(State == GridState.Selection || State == GridState.CellSelection || IsSizingState) {
				SetDefaultState();
			}
			base.OnLostCapture();
		}
		protected internal override bool CanShowHint { get { return base.CanShowHint || IsScrolling; } }
		protected internal override bool CanIncrementalSearch(GridColumn column) {
			bool res = base.CanIncrementalSearch(column);
			if(res && OptionsBehavior.AllowIncrementalSearch) return true;
			return false;
		}
		protected override ToolTipControlInfo GetToolTipObjectInfoCore(GraphicsCache cache, Point p) {
			if(IsScrolling) {
				return new ToolTipControlInfo("ViewScrollBar", GetVertScrollTip(ScrollInfo.VScrollPosition));
			}
			GridHitInfo ht = GetHintObjectInfo() as GridHitInfo;
			if(ht == null) return null;
			if(ht.InColumn) {
				if(GridControl.IsDesignMode) return new ToolTipControlInfo(ht.Column, GetToolTipText(ht.Column, p));
				if(!OptionsHint.ShowColumnHeaderHints) return null;
				if(ht.Column.ToolTip != string.Empty) return new ToolTipControlInfo(ht.Column, GetToolTipText(ht.Column, p));
				if(!ht.Column.OptionsColumn.ShowCaption) return null;
				GridColumnInfoArgs ci = ViewInfo.ColumnsInfo[ht.Column];
				if(ci != null) {
					bool fit = Painter.ElementsPainter.Column.IsCaptionFit(cache, ci);
					if(!fit) return new ToolTipControlInfo(ht.Column, GetToolTipText(ht.Column, p));
				}
			}
			if(ht.HitTest == GridHitTest.RowIndicator) {
				GridDataRowInfo ri = ViewInfo.GetGridRowInfo(ht.RowHandle) as GridDataRowInfo;
				if(ri != null && ri.ErrorText != null && ri.ErrorText.Length > 0) {
					ToolTipControlInfo res = new ToolTipControlInfo(string.Format("Indicator:{0}", ri.RowHandle), ri.ErrorText, true, ToolTipIconType.None);
					res.ToolTipImage = ri.ErrorIcon;
					return res;
				}
			}
			if(ht.InRowCell && ht.CellInfo != null) {
				ViewInfo.RequestCellEditViewInfo(ht.CellInfo);
				if(ht.CellInfo.ViewInfo != null) {
					Point cellPoint = GetCellPoint(ht.CellInfo, p);
					return GetCellEditToolTipInfo(ht.CellInfo.ViewInfo, cellPoint, ht.RowHandle, ht.Column);
				}
			}
			if((ht.HitTest == GridHitTest.Footer || ht.HitTest == GridHitTest.RowFooter) && ht.FooterCell != null && OptionsHint.ShowFooterHints) {
				FooterCellPainter painter = ht.HitTest == GridHitTest.Footer ? Painter.ElementsPainter.FooterCell : Painter.ElementsPainter.GroupFooterCell;
				if(!painter.IsCaptionFit(cache, ht.FooterCell)) {
					return new ToolTipControlInfo(ht.FooterCell, ht.FooterCell.DisplayText);
				}
			}
			return null;
		}
		protected internal override string GetToolTipText(object hintObject, Point p) {
			if(IsScrolling) return GetVertScrollTip(ScrollInfo.VScrollPosition);
			GridColumn column = hintObject as GridColumn;
			if(column != null) {
				if(GridControl.IsDesignMode) {
					return GridDesignTimeHints.DTColumn;
				}
				return column.ToolTip != string.Empty ? column.ToolTip : column.GetTextCaption();
			}
			return ""; 
		}
		protected override BaseHitInfo GetHintObjectInfo() { 
			if(IsScrolling) {
				GridHitInfo hitInfo = new GridHitInfo();
				hitInfo.HitTest = GridHitTest.VScrollBar;
				return hitInfo;
			}
			return ViewInfo.SelectionInfo.HotTrackedInfo; 
		} 
		protected override bool UpdateCellHotInfo(BaseHitInfo hitInfo, Point hitPoint) {
			GridHitInfo hit = hitInfo as GridHitInfo;
			GridCellInfo cell = ViewInfo.GetGridCellInfo(hit);
			if(cell == null || cell.Column == null || cell.Column.View == null) return false;
			ViewInfo.RequestCellEditViewInfo(cell);
			if(cell.ViewInfo == null || cell.Editor == null || !cell.ViewInfo.IsRequiredUpdateOnMouseMove) return false;
			hitPoint = GetCellPoint(cell, hitPoint);
			if(cell.ViewInfo.UpdateObjectState(MouseButtons.None, hitPoint)) return true;
			return false;
		}
		protected internal override bool OnCheckHotTrackMouseMove(BaseHitInfo hitInfo) {
			GridHitInfo hit = hitInfo as GridHitInfo;
			if(hit.InRowCell) return OnCellMouseMove(hitInfo);
			return base.OnCheckHotTrackMouseMove(hitInfo);
		}
		protected internal virtual AppearanceObject GetRowCellStyle(int rowHandle, GridColumn column, GridRowCellState state, AppearanceObject appearance) {
			return RaiseGetRowCellStyle(rowHandle, column, state, appearance);
		}
		protected internal bool IsSameColumnEditor {
			get { return this.Events[customRowCellEdit] == null; }
		}
		protected internal override RepositoryItem GetRowCellRepositoryItem(int rowHandle, GridColumn column) {
			if(column == null) return null;
			DevExpress.XtraEditors.Repository.RepositoryItem ce = column.ColumnEdit;
			if(ce == null) ce = GetColumnDefaultRepositoryItem(column);
			if(IsFilterRow(rowHandle)) {
				if(IsColumnFieldNameSortGroupExist(column)) {
					ce = this.GetColumnFieldNameSortGroup(column).ColumnEdit;
					if(ce == null) ce = GetColumnDefaultRepositoryItem(this.GetColumnFieldNameSortGroup(column));
				}
				ce = GetFilterRowRepositoryItem(this.GetColumnFieldNameSortGroup(column), ce);
			}
			CustomRowCellEditEventHandler handler = (CustomRowCellEditEventHandler)this.Events[customRowCellEdit];
			if(handler != null) {
				CustomRowCellEditEventArgs e = new CustomRowCellEditEventArgs(rowHandle, column, ce);
				handler(this, e);
				if(e.RepositoryItem == null) e.RepositoryItem = ce;
				ce = e.RepositoryItem;
			}
			return ce;
		}
		protected virtual PropertyDescriptorCollection GetSourceProperties(object list) {
			if(list is IXtraList) return (list as IXtraList).GetColumns();
			if(list is ITypedList)
				return (list as ITypedList).GetItemProperties(null);
			IList l = list as IList;
			if(l != null && l.Count > 0) {
				PropertyDescriptorCollection col = TypeDescriptor.GetProperties(l[0]);
				if(col == null || col.Count == 0) return null;
				return col;
			}
			return null;
		}
		protected internal override void CheckInfo() {
			base.CheckInfo();
			if(GridControl == null) return;
			CollapseAllDetails();
			ScrollInfo.UpdateLookAndFeel(ElementsLookAndFeel);
			UpdateColumnsCustomization();
		}
		protected internal virtual GridView ChildGridView {
			get { 
				if(ChildGridLevelName == "" || GridControl == null) return null;
				GridLevelNode levelNode = GetLevelNode();
				if(levelNode == null || !levelNode.HasChildren) return null;
				GridLevelNode child = levelNode.Nodes[ChildGridLevelName];
				GridView res = child != null ? child.LevelTemplate as GridView : null;
				if(res != null && res.SynchronizeClones) return res;
				return null;
			}
		}
		protected internal virtual bool HasAsChild(GridView view) {
			if(view.ParentView == null || view.SourceView == null) return false;
			GridView gv = view;
			while(true) {
				GridView parent = gv.ParentView as GridView;
				if(parent == null || gv.SourceView == null) return false;
				if(parent.ChildGridView != gv.SourceView) return false;
				if(parent == this) return true;
				gv = parent;
			}
		}
		protected internal override void SetDefaultState() {
			SetState((int)GridState.Normal);
		}
		public override void ShowFilterPopup(GridColumn column) {
			GridColumnInfoArgs ci = ViewInfo.ColumnsInfo[column];
			if(ci == null) {
				ci = ViewInfo.GroupPanel.Rows.GetColumnInfo(column);
			}
			if(ci == null) return;
			Focus();
			ShowFilterPopup(ci);
		}
		protected internal void ShowFilterPopup(GridColumnInfoArgs ci) {
			if(ci == null || ci.Column == null) return;
			Rectangle bounds = ci.Bounds;
			if(OptionsView.GetHeaderFilterButtonShowMode() == FilterButtonShowMode.SmartTag) {
				DrawElementInfo info = ci.InnerElements.Find(typeof(DevExpress.XtraEditors.Drawing.GridFilterButtonInfoArgs));
				if(info != null) {
					if(!info.ElementInfo.Bounds.IsEmpty) {
						bounds = info.ElementInfo.Bounds;
					}
				}
			}
			ShowFilterPopup(ci.Column, bounds, GridControl, ci);
		}
		public override object GetFocusedValue() {
			if(IsGroupRow(FocusedRowHandle)) return GetGroupRowValue(FocusedRowHandle);
			return base.GetFocusedValue();
		}
		public override string GetFocusedDisplayText() {
			if(IsGroupRow(FocusedRowHandle)) return GetGroupRowDisplayText(FocusedRowHandle);
			return base.GetFocusedDisplayText();
		}
		public virtual object GetRowCellValue(int rowHandle, string fieldName, OperationCompleted completed) {
			if(IsFilterRow(rowHandle)) return GetFilterRowValue(fieldName);
			return DataController.GetRowValue(rowHandle, fieldName, completed);
		}
		public virtual object GetRowCellValue(int rowHandle, GridColumn column, OperationCompleted completed) {
			column = CheckColumn(column);
			if(column == null) return null;
			if(IsFilterRow(rowHandle)) return GetFilterRowValue(column);
			if(DesignMode) return GetDesignTimeRowCellValue(rowHandle, column);
			return DataController.GetRowValue(rowHandle, column.ColumnHandle, completed);
		}
		public override object GetRowCellValue(int rowHandle, string fieldName) {
			return GetRowCellValue(rowHandle, fieldName, null);
		}
		public override object GetRowCellValue(int rowHandle, GridColumn column) {
			return GetRowCellValue(rowHandle, column, null);
		}
		protected override void SetRowCellValueCore(int rowHandle, GridColumn column, object _value, bool fromEditor) {
			column = CheckColumn(column);
			if(column == null) return;
			if(IsFilterRow(rowHandle)) {
				SetFilterRowValue(column, _value);
				return;
			}
			base.SetRowCellValueCore(rowHandle, column, _value, fromEditor);
			UpdateRowViewInfo(rowHandle);
			InvalidateRowCell(rowHandle, column);
		}
		protected override object GetSelectedData() { 
			int[] rows = GetSelectedRows();
			if(rows == null) return null;
			ArrayList list = new ArrayList();
			for(int n = 0; n < rows.Length; n++) {
				if(!IsGroupRow(rows[n])) {
					list.Add(GetRow(rows[n]));
				}
			}
			return list;
		}
		protected override string GetText() { 
			int[] rows = IsMultiSelect ? DataController.Selection.GetNormalizedSelectedRowsEx() : GetSelectedRows();
			if(rows == null) return string.Empty;
			int minGroupLevel = 100, dataLevel = 0;
			for(int n = 0; n < rows.Length; n++) {
				if(IsGroupRow(rows[n])) {
					int level = GetRowLevel(rows[n]);
					minGroupLevel = Math.Min(level, minGroupLevel);
					dataLevel = Math.Max(dataLevel, level);
				}
			}
			if(minGroupLevel == 100) {
				minGroupLevel = -1; dataLevel = 0; 
			} else {
				dataLevel = (dataLevel - minGroupLevel) + 1;
			}
			StringBuilder sb = new StringBuilder();
			GetHeadersText(sb);
			int maxCopyRowCount = GetMaxRowCopyCount(rows.Length);
			for(int n = 0; n < maxCopyRowCount; n++) {
				if(!GetRowText(sb, rows[n], minGroupLevel, dataLevel)) continue;
				if(maxCopyRowCount > 1) sb.Append(crlf);
			}
			return sb.ToString();
		}
		protected virtual void GetHeadersText(StringBuilder sb) {
			if(!OptionsBehavior.CopyToClipboardWithColumnHeaders) return;
			if(!GetDataRowText(sb, InvalidRowHandle)) return;
			sb.Append(crlf);
		}
		protected virtual int GetMaxRowCopyCount(int rowsCount) {
			if(MaxRowCopyCount <= 0) return rowsCount;
			return Math.Min(MaxRowCopyCount, rowsCount);
		}
		protected virtual void AppendRowIndent(StringBuilder sb, int count) {
			for(int n = 0; n < count; n++) sb.Append('\t');
		}
		protected virtual bool GetRowText(StringBuilder sb, int rowHandle, int minGroupLevel, int dataLevel) {
			if(!IsValidRowHandle(rowHandle)) return false;
			if(IsGroupRow(rowHandle)) {
				AppendRowIndent(sb, GetRowLevel(rowHandle) - minGroupLevel);
				sb.Append(GetGroupRowDisplayText(rowHandle));
				return true;
			}
			AppendRowIndent(sb, dataLevel);
			return GetDataRowText(sb, rowHandle);
		}
		int GetAnySelectedDataRow() {
			int[] rows = GetSelectedRows();
			if(rows == null || rows.Length == 0) return InvalidRowHandle;
			for(int n = 0; n < rows.Length; n++) {
				if(rows[n] >= 0) return rows[n];
			}
			return rows[0];
		}
		protected virtual bool GetDataRowText(StringBuilder sb, int rowHandle) {
			GridRowSelectionInfo info = null;
			if(rowHandle == InvalidRowHandle) {
				info = GetSelectionInfo(GetAnySelectedDataRow());
			} else 
				info = GetSelectionInfo(rowHandle);
			GridColumnReadOnlyCollection columns = VisibleColumns;
			if(IsCellSelect) {
				columns = new GridColumnReadOnlyCollection(null);
				for(int n = 0; n < VisibleColumns.Count; n++) {
					if(info == null || !info.Contains(VisibleColumns[n])) continue;
					columns.AddCore(VisibleColumns[n]);
				}
			}
			bool containsData = false;
			for(int n = 0; n < columns.Count; n++) {
				string cellText = rowHandle == InvalidRowHandle ? columns[n].GetTextCaption() : GetRowCellDisplayText(rowHandle, columns[n]);
				if(cellText == null) cellText = string.Empty;
				if(cellText.Contains(Environment.NewLine))
					cellText = "\"" + cellText.Replace("\"", "\"\"").Replace(Environment.NewLine, "\x0A") + "\"";
				cellText = cellText.Replace("\t", " ");
				sb.Append(cellText);
				if(n < columns.Count - 1) sb.Append(columnSeparator);
				containsData = true;
			}
			return containsData;
		}
		protected virtual RepositoryItem GetFilterRowRepositoryItem(GridColumn column, RepositoryItem current) {
			if(current is RepositoryItemCheckEdit) return current;
			if(column.GetFilterMode() != ColumnFilterMode.DisplayText) {
				if(current is RepositoryItemImageComboBox) return current;
				if(current is RepositoryItemLookUpEditBase) return current;
				if(column.FilterFieldName != column.FieldName) {
					return GridControl.EditorHelper.DefaultRepository.GetRepositoryItem(typeof(string));
				}
			} 
			else {
				return GridControl.EditorHelper.DefaultRepository.GetRepositoryItem(typeof(string));
			}
			if(current is RepositoryItemDateEdit) 
				return IsServerMode ? current : GridControl.EditorHelper.DefaultRepository.GetRepositoryItem(typeof(string));
			if((current is RepositoryItemButtonEdit)) return GridControl.EditorHelper.DefaultRepository.GetRepositoryItem(typeof(string));
			return current;
		}
		protected override void OnActiveEditor_ValueChanged(object sender, EventArgs e) {
			if(IsFilterRow(FocusedRowHandle)) {
				OnFilterRowValueChanging(FocusedColumn, EditingValue);
				return;
			}
			base.OnActiveEditor_ValueChanged(sender, e);
		}
		protected virtual bool IsAllowImmediateUpdateAutoFilter(GridColumn column) {
			if(IsServerMode && GetRowCellRepositoryItem(GridControl.AutoFilterRowHandle, column) is RepositoryItemDateEdit) return false;
			return true;
		}
		protected virtual void OnFilterRowValueChanging(GridColumn column, object _value) {
			if(column == null) return;
			if(!column.OptionsFilter.ImmediateUpdateAutoFilter) return;
			if(!IsAllowImmediateUpdateAutoFilter(column)) return;
			try {
				this.postingEditorValue++;
			SetFilterRowValue(column, _value);
			} finally {
				this.postingEditorValue--;
			}
		}
		protected object GetFilterRowValue(string fieldName) {
			return GetFilterRowValue(Columns[fieldName]);
		}
		protected virtual object GetFilterRowValue(GridColumn column) {
			if(column == null) return null;
			if(column.FilterInfo.Type == ColumnFilterType.AutoFilter ||
				column.FilterInfo.Type == ColumnFilterType.Value)
				return column.FilterInfo.Value;
			return null;
		}
		protected override bool AllowUpdateMRUFilters { get { return this.lockFilterSetRowValue == 0; } }
		protected virtual void UpdateActiveEditorBounds() {
			if(ActiveEditor == null || FocusedColumn == null) return;
			GridCellInfo info = ViewInfo.GetGridCellInfo(FocusedRowHandle, FocusedColumn);
			if(info == null) {
				HideEditor();
				return;
			}
			this.fEditingCell = info;
			Rectangle bounds = GetEditorBounds(info);
			if(bounds.IsEmpty) 
				HideEditor();
			else {
				if(ActiveEditor.Bounds == bounds) return;
				ActiveEditor.Bounds = bounds;
			}
		}
		protected override void UpdateEditorProperties(BaseEdit editor) { 
			if(IsFilterRow(FocusedRowHandle)) {
				editor.Properties.BeginUpdate();
				try {
					if(IsServerMode) editor.Properties.EditValueChangedFiringMode = EditValueChangedFiringMode.Buffered;
					editor.Properties.NullText = "";
					editor.Properties.ReadOnly = false;
					CheckEdit check = editor as CheckEdit;
					if(check != null) {
						check.Properties.AllowGrayed = true;
						check.Properties.ValueGrayed = null;
					}
					ImageComboBoxEdit image = editor as ImageComboBoxEdit;
					if(image != null) 
						image.Properties.Items.Insert(0, new ImageComboBoxItem("", null));
					TextEdit textEdit = editor as TextEdit;
					if(textEdit != null)
						textEdit.Properties.Mask.MaskType = DevExpress.XtraEditors.Mask.MaskType.None;
				} finally {
					editor.Properties.EndUpdate();
				}
			}
			base.UpdateEditorProperties(editor);
		}
		protected override void UpdateRowAutoHeight(int rowHandle) {
			if(!IsAutoHeight) return;
			if(!IsFilterRow(FocusedRowHandle) || ActiveEditor == null) {
				LayoutChanged();
				return;
			}
			ViewInfo.SetDataDirty();
			CheckViewInfo();
		}
		int lockFilterSetRowValue = 0;
		protected virtual void SetFilterRowValue(GridColumn column, object _value) {
			if(column == null || this.lockFilterSetRowValue != 0) return;
			this.lockFilterSetRowValue ++; 
			BeginLockFocusedRowChange();
			try {
				if(ActiveEditor != null) {
					ActiveEditor.ErrorText = "";
					HideHint();
				}
				if(_value == DBNull.Value) _value = null;
				bool prev = this.fAllowCloseEditor;
				this.fAllowCloseEditor = false;
				try {
					column.FilterInfo = CreateFilterRowInfo(column, _value);
					if(IsDetailView) CalculateLayoutSynchronized();
				}
				finally {
					this.fAllowCloseEditor = prev;
				}
				UpdateActiveEditorBounds();
			} 
			catch(Exception e) {
				if(ActiveEditor != null && IsFilterRow(FocusedRowHandle) ) {
					string text = e.Message;
					if(text == null || text.Length == 0) text = "Filter Error";
					GridControl.EditorHelper.ShowEditorError(e.Message);
				} else {
					XtraMessageBox.Show(ElementsLookAndFeel, GridControl.FindForm(), e.Message, "Filter Error");
				}
			}
			finally {
				this.lockFilterSetRowValue --;
				EndLockFocusedRowChange();
			}
		}
		protected virtual ColumnFilterInfo CreateFilterRowInfo(GridColumn column, object _value) {
			string strVal = _value == null ? null : _value.ToString();
			if(_value == null || strVal == string.Empty) return ColumnFilterInfo.Empty;
			AutoFilterCondition condition = ResolveAutoFilterCondition(column);
			CriteriaOperator op = CreateAutoFilterCriterion(column, condition, _value, strVal);
			return new ColumnFilterInfo(ColumnFilterType.AutoFilter, _value, op, string.Empty);
		}
		protected AutoFilterCondition ResolveAutoFilterCondition(GridColumn column) {
			RepositoryItem item = GetRowCellRepositoryItem(GridControl.AutoFilterRowHandle, column);
			AutoFilterCondition condition = column.OptionsFilter.AutoFilterCondition;
			if(condition == AutoFilterCondition.Default) condition = AutoFilterCondition.Like;
			if(column.GetFilterMode() == ColumnFilterMode.DisplayText) {
				if(condition == AutoFilterCondition.Contains) return condition;
				return AutoFilterCondition.Like;
			}
			if(item is RepositoryItemCheckEdit || item is RepositoryItemDateEdit || item is RepositoryItemLookUpEditBase || item is RepositoryItemImageComboBox)
				condition = AutoFilterCondition.Equals;
			return condition;
		}
		protected virtual CriteriaOperator CreateAutoFilterCriterion(GridColumn column, AutoFilterCondition condition, object _value, string strVal) {
			if(condition == AutoFilterCondition.Equals) {
				return DataController.CalcColumnFilterCriteriaByValue(column.FilterFieldName, _value, true, IsRoundDateTime(column), null);
			} else {
				if(string.IsNullOrEmpty(strVal))
					return null;
				OperandProperty prop = new OperandProperty(column.FilterFieldName);
				if(condition == AutoFilterCondition.Contains)
					return new FunctionOperator(FunctionOperatorType.Contains, prop, strVal);
				switch(strVal[0]) {
					case '_':
					case '?':
					case '*':
					case '%':
						return new FunctionOperator(FunctionOperatorType.Contains, prop, strVal.Substring(1));
				}
				return new FunctionOperator(FunctionOperatorType.StartsWith, prop, strVal);
			}
		}
		internal bool ShouldSerializeOptionsBehavior() { return OptionsBehavior.ShouldSerializeCore(this); }
		[Description("Provides access to the View's behavior options."), Category("Options"), DesignerSerializationVisibility(DesignerSerializationVisibility.Content),
		XtraSerializableProperty(XtraSerializationVisibility.Content, XtraSerializationFlags.DefaultValue)]
		public new GridOptionsBehavior OptionsBehavior { get { return base.OptionsBehavior as GridOptionsBehavior; } }
		bool ShouldSerializeOptionsHint() { return OptionsHint.ShouldSerializeCore(this); }
		[Description("Provides access to the View's hint options."), Category("Options"), DesignerSerializationVisibility(DesignerSerializationVisibility.Content),
		XtraSerializableProperty(XtraSerializationVisibility.Content, XtraSerializationFlags.DefaultValue)]
		public GridOptionsHint OptionsHint {
			get { return _optionsHint; }
		}
		bool ShouldSerializeOptionsDetail() { return OptionsDetail.ShouldSerializeCore(this); }
		[Description("Provides access to the View's master-detail options."), Category("Options"), DesignerSerializationVisibility(DesignerSerializationVisibility.Content),
		XtraSerializableProperty(XtraSerializationVisibility.Content, XtraSerializationFlags.DefaultValue)]
		public GridOptionsDetail OptionsDetail {
			get { return _optionsDetail; }
		}
		bool ShouldSerializeOptionsCustomization() { return OptionsCustomization.ShouldSerializeCore(this); }
		[Description("Provides access to the View's customization options."), Category("Options"), DesignerSerializationVisibility(DesignerSerializationVisibility.Content),
		XtraSerializableProperty(XtraSerializationVisibility.Content, XtraSerializationFlags.DefaultValue)]
		public GridOptionsCustomization OptionsCustomization {
			get { return _optionsCustomization; }
		}
		bool ShouldSerializeOptionsNavigation() { return OptionsNavigation.ShouldSerializeCore(this); }
		[Description("Gets options regarding cell navigation."), Category("Options"), DesignerSerializationVisibility(DesignerSerializationVisibility.Content),
		XtraSerializableProperty(XtraSerializationVisibility.Content, XtraSerializationFlags.DefaultValue)]
		public GridOptionsNavigation OptionsNavigation {
			get { return _optionsNavigation; }
		}
		bool ShouldSerializeOptionsSelection() { return OptionsSelection.ShouldSerializeCore(this); }
		[Description("Provides access to the View's selection options."), Category("Options"), DesignerSerializationVisibility(DesignerSerializationVisibility.Content),
		XtraSerializableProperty(XtraSerializationVisibility.Content, XtraSerializationFlags.DefaultValue)]
		public new GridOptionsSelection OptionsSelection {
			get { return base.OptionsSelection as GridOptionsSelection; }
		}
		bool ShouldSerializeOptionsView() { return OptionsView.ShouldSerializeCore(this); }
		[Description("Provides access to the View's display options."), Category("Options"), DesignerSerializationVisibility(DesignerSerializationVisibility.Content),
		XtraSerializableProperty(XtraSerializationVisibility.Content, XtraSerializationFlags.DefaultValue),
		XtraSerializablePropertyId(LayoutIdOptionsView)]
		public new GridOptionsView OptionsView { get { return base.OptionsView as GridOptionsView; } }
		bool ShouldSerializeOptionsMenu() { return OptionsMenu.ShouldSerializeCore(this); }
		[Description("Provides access to the View's menu options."), Category("Options"), DesignerSerializationVisibility(DesignerSerializationVisibility.Content),
		XtraSerializableProperty(XtraSerializationVisibility.Content, XtraSerializationFlags.DefaultValue)]
		public GridOptionsMenu OptionsMenu {
			get { return _optionsMenu; }
		}
		bool ShouldSerializeOptionsPrint() { return OptionsPrint.ShouldSerializeCore(this); }
		[Description("Provides options that control how the View is printed/exported."), Category("Options"), DesignerSerializationVisibility(DesignerSerializationVisibility.Content),
		XtraSerializableProperty(XtraSerializationVisibility.Content, XtraSerializationFlags.DefaultValue)]
		public new GridOptionsPrint OptionsPrint {
			get { return (GridOptionsPrint)base.OptionsPrint; }
		}
		[Description("Gets or sets the distance between master rows and Detail Sections, in pixels."), Category("Appearance"), DefaultValue(0)]
		public int DetailVerticalIndent {
			get { return detailVerticalIndent; }
			set {
				if(value < 0) value = 0;
				if(value > 100) value = 100;
				if(DetailVerticalIndent == value) return;
				detailVerticalIndent = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the width of frozen panel separators."), DefaultValue(2), Category("Appearance"), XtraSerializableProperty()]
		public virtual int FixedLineWidth {
			get { return fixedLineWidth; }
			set {
				if(value < 1) value = 1;
				if(value > 12) value = 12;
				if(FixedLineWidth == value) return;
				this.fixedLineWidth = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the width of the row indicator panel."), DefaultValue(-1), Category("Appearance"), XtraSerializableProperty()]
		public virtual int IndicatorWidth {
			get { return indicatorWidth; }
			set {
				if(value < 4) value = -1;
				if(IndicatorWidth == value) return;
				indicatorWidth = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the column header row height."), DefaultValue(-1), Category("Appearance"), XtraSerializableProperty()]
		public virtual int ColumnPanelRowHeight {
			get { return columnPanelRowHeight; }
			set {
				if(value < -1) value = -1;
				if(ColumnPanelRowHeight == value) return;
				columnPanelRowHeight = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the distance between rows."), DefaultValue(0), Category("Appearance"), XtraSerializableProperty()]
		public virtual int RowSeparatorHeight {
			get { return rowSeparatorHeight; }
			set {
				if(value < 0) value = 0;
				if(value > 100) value = 100;
				if(RowSeparatorHeight == value) return;
				rowSeparatorHeight = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the height of the  view footer."), DefaultValue(-1), Category("Appearance"), XtraSerializableProperty()]
		public virtual int FooterPanelHeight {
			get { return footerPanelHeight; }
			set {
				if(value < -1) value = -1;
				if(FooterPanelHeight == value) return;
				footerPanelHeight = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets a value specifying when the horizontal scrollbar should be displayed. "), DefaultValue(ScrollVisibility.Auto), XtraSerializableProperty(), Category("Behavior")]
		public ScrollVisibility HorzScrollVisibility {
			get { return horzScrollVisibility; }
			set {
				if(HorzScrollVisibility == value) return;
				horzScrollVisibility = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets a value specifying when the View's vertical scrollbar is visible."), DefaultValue(ScrollVisibility.Auto), XtraSerializableProperty(), Category("Behavior")]
		public ScrollVisibility VertScrollVisibility {
			get { return vertScrollVisibility; }
			set {
				if(VertScrollVisibility == value) return;
				vertScrollVisibility = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the height of cells within data rows."), DefaultValue(-1), XtraSerializableProperty(), Category("Appearance")]
		public int RowHeight {
			get { return rowHeight; }
			set {
				if(value < 0) value = -1;
				if(RowHeight != value) {
					rowHeight = value;
					OnPropertiesChanged();
				}
			}
		}
		[Description("Gets or sets the height of group rows."), DefaultValue(-1), XtraSerializableProperty(), Category("Appearance")]
		public int GroupRowHeight {
			get { return groupRowHeight; }
			set {
				if(value < 0) value = -1;
				if(value > 100) value = 100;
				if(GroupRowHeight != value) {
					groupRowHeight = value;
					OnPropertiesChanged();
				}
			}
		}
		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden), EditorBrowsable(EditorBrowsableState.Never), Obsolete(ObsoleteText.SRGridView_CustomizationRowCount)]
		public int CustomizationRowCount {
			get { return 7; }
			set { }
		}
		[Description("Gets or sets the text pattern for group rows."), DefaultValue(defaultGroupFormat), XtraSerializableProperty(), Category("Appearance"), Localizable(true)]
		public string GroupFormat {
			get { return groupFormat; }
			set {
				if(value == null) value = string.Empty;
				if(GroupFormat != value) {
					groupFormat = value;
					OnPropertiesChanged();
				}
			}
		}
		[Description("Gets or sets the name of the child level whose grouping state is displayed by the joined group panel."), DefaultValue(""), Category("Appearance"), XtraSerializableProperty(), Localizable(true)]
		public string ChildGridLevelName {
			get { return childGridLevelName; }
			set {
				if(value == null) value = string.Empty;
				if(ChildGridLevelName == value) return;
				childGridLevelName = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the field whose values are displayed within the vertical scrollbar's tooltip."), DefaultValue(""),
		Editor("DevExpress.XtraGrid.Design.GridColumnNameEditor, " + AssemblyInfo.SRAssemblyGridDesign, typeof(System.Drawing.Design.UITypeEditor)),
		TypeConverter("DevExpress.XtraGrid.TypeConverters.FieldNameTypeConverter, " + AssemblyInfo.SRAssemblyGridDesign), XtraSerializableProperty(),
		Category("Appearance")]
		public string VertScrollTipFieldName {
			get { return vertScrollTipFieldName; }
			set {
				if(value == null) value = "";
				if(VertScrollTipFieldName == value) return;
				vertScrollTipFieldName = value;
			}
		}
		[Description("Gets or sets the name of the field whose values are displayed within preview sections."), DefaultValue(""), Category("Appearance"),
		Editor("DevExpress.XtraGrid.Design.GridColumnNameEditor, " + AssemblyInfo.SRAssemblyGridDesign, typeof(System.Drawing.Design.UITypeEditor)),
		TypeConverter("DevExpress.XtraGrid.TypeConverters.FieldNameTypeConverter, " + AssemblyInfo.SRAssemblyGridDesign), XtraSerializableProperty()]
		public string PreviewFieldName {
			get { return previewFieldName; }
			set {
				if(value == null) value = "";
				if(PreviewFieldName == value) return;
				previewFieldName = value;
				previewFieldHandle = -1;
				OnPropertiesChanged();
			}
		}
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden), Browsable(false),
		 EditorBrowsable(EditorBrowsableState.Never), XtraSerializableProperty(1001), XtraSerializablePropertyId(LayoutIdData)]
		public string GroupSummarySortInfoState {
			get { return GroupSummarySortInfo.GetStateInfo(); }
			set { GroupSummarySortInfo.RestoreState(value); }
		}
		[DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden), Browsable(false)]
		public GroupSummarySortInfoCollection GroupSummarySortInfo { get { return groupSummarySortInfo; } }
		[Description("Gets or sets the text displayed within the group panel."), DefaultValue(""), XtraSerializableProperty(), Category("Appearance"), Localizable(true)]
		public string GroupPanelText {
			get { return groupPanelText; }
			set {
				if(value == null) value = string.Empty;
				if(GroupPanelText == value) return;
				groupPanelText = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the text displayed within the new item row."), DefaultValue(""), XtraSerializableProperty(), Category("Appearance"), Localizable(true)]
		public string NewItemRowText {
			get { return newItemRowText; }
			set {
				if(value == null) value = string.Empty;
				if(NewItemRowText == value) return;
				newItemRowText = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets which groups display footers."), DefaultValue(GroupFooterShowMode.VisibleIfExpanded), XtraSerializableProperty(), Category("Appearance")]
		public GroupFooterShowMode GroupFooterShowMode {
			get { return groupFooterShowMode; }
			set {
				if(value == GroupFooterShowMode) return;
				groupFooterShowMode = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the indent between group rows located at neighboring group levels."), DefaultValue(-1), XtraSerializableProperty(), Category("Appearance")]
		public virtual int LevelIndent {
			get { return levelIndent; }
			set {
				value = Math.Max(-1, value);
				if(LevelIndent == value) return;
				levelIndent = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the horizontal offset of preview text."), DefaultValue(-1), XtraSerializableProperty(), Category("Appearance")]
		public virtual int PreviewIndent {
			get { return previewIndent; }
			set {
				value = Math.Max(-1, value);
				if(PreviewIndent == value) return;
				previewIndent = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the number of text lines within preview sections."), DefaultValue(-1), XtraSerializableProperty(), Category("Appearance")]
		public int PreviewLineCount {
			get { return previewLineCount; }
			set {
				if(value < 1) value = -1;
				if(previewLineCount != value) {
					previewLineCount = value;
					OnPropertiesChanged();
				}
			}
		}
		[Description("Gets or sets the number of data rows whose contents are processed to apply best fit to columns."), DefaultValue(-1), XtraSerializableProperty(), Category("Behavior")]
		public int BestFitMaxRowCount {
			get { return bestFitMaxRowCount; } 
			set {
				if(value < 0) value = -1;
				bestFitMaxRowCount = value;
			}
		}
		[Browsable(false)]
		public override bool IsDefaultState {
			get { return State == GridState.Normal; }
		}
		[Browsable(false)]
		public override bool IsDraggingState { 
			get { 
				if(State == GridState.ColumnDragging) return true;
				return false;
			}
		}
		[Browsable(false)]
		public override bool IsSizingState { get { return State == GridState.ColumnSizing || State == GridState.RowDetailSizing || State == GridState.RowSizing; } }
		[Browsable(false)]
		public override bool IsEditing {
			get { return State == GridState.Editing;	}
		}
		bool ShouldSerializeCustomizationFormBounds() { return !CustomizationFormBounds.IsEmpty; }
		[Browsable(false), XtraSerializableProperty(XtraSerializationVisibility.Hidden)]
		public Rectangle CustomizationFormBounds {
			get { return customizationFormBounds; }
			set {
				if(value != Rectangle.Empty) {
					Size size = value.Size;
					if(value.Width < 200) value.Width = 0;
					if(value.Height < 100) value.Height = 0;
					size.Width = Math.Max(200, value.Width);
					size.Height = Math.Max(100, value.Height);
					value.Location = DevExpress.Utils.ControlUtils.CalcLocation(value.Location, value.Location, size);
				}
				if(CustomizationFormBounds == value) return;
				customizationFormBounds = value;
				if(CustomizationForm != null && !value.IsEmpty) {
					if(value.Width == 0) value.Width = CustomizationForm.Bounds.Width;
					if(value.Height == 0) value.Height = CustomizationForm.Bounds.Height;
					CustomizationForm.Bounds = value;
				}
			}
		}
		[Browsable(false)]
		public CustomizationForm CustomizationForm { get { return customizationForm; } }
		[Category("Behavior"), Description("Gets or sets the value indicating which detail level is processed by default."), DefaultValue(0)]
		public virtual int DefaultRelationIndex {
			get { return defaultRelationIndex; }
			set {
				if(value < 0) value = 0;
				if(DefaultRelationIndex == value) return;
				defaultRelationIndex = value;
				OnPropertiesChanged();
			}
		}
		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public override object EditingValue {
			get {
				if(!IsEditing || ActiveEditor == null) return null;
				return base.EditingValue;
			}
			set {
				base.EditingValue = value;
			}
		}
		[Browsable(false)]
		public bool IsShowDetailButtons {
			get { 
				return AllowMasterDetail && 
					OptionsView.ShowDetailButtons && GetDetailInfo(InvalidRowHandle, true) != null; 
			}
		}
		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public int LeftCoord {
			get { 
				if(OptionsView.ColumnAutoWidth) return 0;
				return leftCoord; 
			}
			set { 
				value = Math.Min(CalcHScrollRange() - CalcHScrollableRange(), value);
				if(value < 0 || OptionsView.ColumnAutoWidth) value = 0;
				if(LeftCoord != value) {
					CloseActiveEditor();
					leftCoord = value;
					DoLeftCoordChanged();
				}
			}
		}
		[Browsable(false)]
		public GridColumn PressedColumn {
			get { 
				if(State == GridState.ColumnDown)
					return ((GridHandler)Handler).DownPointHitInfo.Column;
				return null;
			}
		}
		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public int TopRowIndex {
			get { return topRowIndex; }
			set {
				if(value > 0 && value >= RowCount) value = RowCount - 1;
				if(value < 0) value = 0;
				if(value == TopRowIndex) return;
				this.requireCheckTopRowIndex = false;
				InternalSetTopRowIndex(CheckTopRowIndex(value));
			}
		}
		public override void SynchronizeData(BaseView viewSource) {
			if(viewSource == null) return;
			BeginSynchronization();
			BeginDataUpdate();
			try {
				lockSummary ++;
				try {
					base.SynchronizeData(viewSource);
					GridView gv = viewSource as GridView;
					if(gv == null) return;
					GroupSummary.Assign(gv.GroupSummary);
					TotalSummary.SetDirty();
				}
				finally {
					lockSummary--;
					SynchronizeSummary();
				}
			}
			finally {
				EndDataUpdateCore(true);
				EndSynchronization();
			}
		}
		public override void SynchronizeVisual(BaseView viewSource) {
			if(viewSource == null) return;
			BeginSynchronization();
			BeginUpdate();
			try {
				base.SynchronizeVisual(viewSource);
				GridView gv = viewSource as GridView;
				if(gv == null) return;
				SyncGridProperties(gv);
			}
			finally {
				EndUpdate();
				EndSynchronization();
			}
		}
		protected override void OnResetSerializationProperties(OptionsLayoutBase options) {
			base.OnResetSerializationProperties(options);
			OptionsLayoutGrid optGrid = options as OptionsLayoutGrid;
			if(optGrid == null || optGrid.StoreAllOptions) {
				OptionsHint.Reset();
				OptionsDetail.Reset();
				OptionsCustomization.Reset();
				OptionsNavigation.Reset();
				OptionsMenu.Reset();
			}
		}
		void SyncGridProperties(GridView gv) {
			this.bestFitMaxRowCount = gv.BestFitMaxRowCount;
			this.childGridLevelName = gv.ChildGridLevelName;
			this.columnPanelRowHeight = gv.ColumnPanelRowHeight;
			this.customizationFormBounds = gv.CustomizationFormBounds;
			this.detailVerticalIndent = gv.DetailVerticalIndent;
			this.fixedLineWidth = gv.FixedLineWidth;
			this.focusRectStyle = gv.FocusRectStyle;
			this.footerPanelHeight = gv.FooterPanelHeight;
			this.groupFooterShowMode = gv.GroupFooterShowMode;
			this.groupFormat = gv.GroupFormat;
			this.newItemRowText = gv.NewItemRowText;
			this.groupPanelText = gv.GroupPanelText;
			this.groupRowHeight = gv.GroupRowHeight;
			this.horzScrollStep = gv.HorzScrollStep;
			this.horzScrollVisibility = gv.HorzScrollVisibility;
			this.indicatorWidth = gv.IndicatorWidth;
			this.previewFieldName = gv.PreviewFieldName;
			this.previewLineCount = gv.PreviewLineCount;
			this.levelIndent = gv.LevelIndent;
			this.previewIndent = gv.PreviewIndent;
			this.rowHeight = gv.RowHeight;
			this.rowSeparatorHeight = gv.RowSeparatorHeight;
			this.scrollStyle = gv.ScrollStyle;
			this.vertScrollTipFieldName = gv.VertScrollTipFieldName;
			this.vertScrollVisibility = gv.VertScrollVisibility;
			this.defaultRelationIndex = gv.DefaultRelationIndex;
			this.OptionsCustomization.Assign(gv.OptionsCustomization);
			this.OptionsDetail.Assign(gv.OptionsDetail);
			this.OptionsHint.Assign(gv.OptionsHint);
			this.OptionsMenu.Assign(gv.OptionsMenu);
			this.OptionsNavigation.Assign(gv.OptionsNavigation);
			this.OptionsPrint.Assign(gv.OptionsPrint);
		}
		protected internal override void ResetLookUp(bool sameDataSource) {
			this.extraFilter = this.extraFilterText = string.Empty;
			base.ResetLookUp(sameDataSource);
		}
		public override void Assign(BaseView v, bool copyEvents) {
			if(v == null) return;
			BeginUpdate();
			try {
				this.lockSummary ++;
				try {
					base.Assign(v, copyEvents);
				}
				finally {
					this.lockSummary --;
				}
				GridView gv = v as GridView;
				if(gv != null) {
					this.lockSummary ++;
					try {
						SyncGridProperties(gv);
						if(this.GroupSummary.Count != gv.GroupSummary.Count || gv.GroupSummary.Count > 0) {
							GroupSummary.Assign(gv.GroupSummary);
						}
					}
					finally {
						this.lockSummary --;
						SynchronizeSummary();
					}
					AssignGroupSummary(gv);
					if(copyEvents) {
						Events.AddHandler(cellMerge, gv.Events[cellMerge]);
						Events.AddHandler(rowClick, gv.Events[rowClick]);
						Events.AddHandler(rowCellClick, gv.Events[rowCellClick]);
						Events.AddHandler(customColumnGroup, gv.Events[customColumnGroup]);
						Events.AddHandler(dragObjectDrop, gv.Events[dragObjectDrop]);
						Events.AddHandler(dragObjectStart, gv.Events[dragObjectStart]);
						Events.AddHandler(dragObjectOver, gv.Events[dragObjectOver]);
						Events.AddHandler(calcPreviewText, gv.Events[calcPreviewText]);
						Events.AddHandler(measurePreviewHeight, gv.Events[measurePreviewHeight]);
						Events.AddHandler(calcRowHeight, gv.Events[calcRowHeight]);
						Events.AddHandler(customDrawCell, gv.Events[customDrawCell]);
						Events.AddHandler(customDrawColumnHeader, gv.Events[customDrawColumnHeader]);
						Events.AddHandler(customDrawFooter, gv.Events[customDrawFooter]);
						Events.AddHandler(customDrawFooterCell, gv.Events[customDrawFooterCell]);
						Events.AddHandler(customDrawGroupPanel, gv.Events[customDrawGroupPanel]);
						Events.AddHandler(customDrawGroupRow, gv.Events[customDrawGroupRow]);
						Events.AddHandler(customDrawRowFooter, gv.Events[customDrawRowFooter]);
						Events.AddHandler(customDrawRowFooterCell, gv.Events[customDrawRowFooterCell]);
						Events.AddHandler(customDrawRowIndicator, gv.Events[customDrawRowIndicator]);
						Events.AddHandler(customDrawRowPreview, gv.Events[customDrawRowPreview]);
						Events.AddHandler(customRowCellEdit, gv.Events[customRowCellEdit]);
						Events.AddHandler(customRowCellEditForEditing, gv.Events[customRowCellEditForEditing]);
						Events.AddHandler(customSummaryCalculate, gv.Events[customSummaryCalculate]);
						Events.AddHandler(customSummaryExists, gv.Events[customSummaryExists]);
						Events.AddHandler(gridMenuItemClick, gv.Events[gridMenuItemClick]);
						Events.AddHandler(groupLevelStyle, gv.Events[groupLevelStyle]);
						Events.AddHandler(groupRowCollapsed, gv.Events[groupRowCollapsed]);
						Events.AddHandler(groupRowCollapsing, gv.Events[groupRowCollapsing]);
						Events.AddHandler(groupRowExpanded, gv.Events[groupRowExpanded]);
						Events.AddHandler(groupRowExpanding, gv.Events[groupRowExpanding]);
						Events.AddHandler(leftCoordChanged, gv.Events[leftCoordChanged]);
						Events.AddHandler(columnWidthChanged, gv.Events[columnWidthChanged]);
						Events.AddHandler(masterRowCollapsed, gv.Events[masterRowCollapsed]);
						Events.AddHandler(masterRowCollapsing, gv.Events[masterRowCollapsing]);
						Events.AddHandler(masterRowEmpty, gv.Events[masterRowEmpty]);
						Events.AddHandler(masterRowExpanded, gv.Events[masterRowExpanded]);
						Events.AddHandler(masterRowExpanding, gv.Events[masterRowExpanding]);
						Events.AddHandler(masterRowGetChildList, gv.Events[masterRowGetChildList]);
						Events.AddHandler(masterRowGetLevelDefaultView, gv.Events[masterRowGetLevelDefaultView]);
						Events.AddHandler(masterRowGetRelationCount, gv.Events[masterRowGetRelationCount]);
						Events.AddHandler(masterRowGetRelationName, gv.Events[masterRowGetRelationName]);
						Events.AddHandler(masterRowGetRelationDisplayCaption, gv.Events[masterRowGetRelationDisplayCaption]);
						Events.AddHandler(rowCellStyle, gv.Events[rowCellStyle]);
						Events.AddHandler(rowStyle, gv.Events[rowStyle]);
						Events.AddHandler(hideCustomizationForm, gv.Events[hideCustomizationForm]);
						Events.AddHandler(showCustomizationForm, gv.Events[showCustomizationForm]);
						Events.AddHandler(showGridMenu, gv.Events[showGridMenu]);
						Events.AddHandler(onPopupMenuShowing, gv.Events[onPopupMenuShowing]);
						Events.AddHandler(topRowChanged, gv.Events[topRowChanged]);
						Events.AddHandler(beforePrintRow, gv.Events[beforePrintRow]);
						Events.AddHandler(afterPrintRow, gv.Events[afterPrintRow]);
					}
				}
			}
			finally {
				EndUpdate();
			}
		}
		void AssignGroupSummary(GridView gv) {
			if(gv.GroupSummarySortInfo.Count == 0) return;
			GroupSummarySortInfo.BeginUpdate();
			try {
				foreach(GroupSummarySortInfo info in gv.GroupSummarySortInfo) {
					int index = info.SummaryItem.Index;
					int colIndex = info.GroupColumn.AbsoluteIndex;
					if(index >= GroupSummary.Count || colIndex >= Columns.Count) continue;
					GroupSummarySortInfo.Add(GroupSummary[index], info.SortOrder, Columns[colIndex]);
				}
			}
			finally {
				GroupSummarySortInfo.EndUpdate();
			}
		}
		public virtual void BestFitColumns() {
			Cursor currentCursor = GetCursor();
			SetCursor(Cursors.WaitCursor);
			try {
				CheckLoaded();
				foreach(GridColumn col in Columns) {
					if(!CanResizeColumn(col)) continue;
					int w = ViewInfo.CalcColumnBestWidth(col);
					if(w == 0) continue;
					w = Math.Max(GetColumnMinWidth(col), w);
					if(GetColumnMaxWidth(col) > 0) w = Math.Min(GetColumnMaxWidth(col), w);
					col.width = w;
				}
				ViewInfo.RecalcColumnWidthes();
				LayoutChanged();
			} finally {
				SetCursor(currentCursor);
			}
		}
		public new GridHitInfo CalcHitInfo(Point pt) { return base.CalcHitInfo(pt) as GridHitInfo; }
		public new GridHitInfo CalcHitInfo(int x, int y) { return CalcHitInfo(new Point(x, y)); }
		protected override BaseHitInfo CalcHitInfoCore(Point pt) { return ViewInfo.CalcHitInfo(pt); }
		protected internal bool IsAllowBusyIndicator {
			get {
				return CheckAllowNotifications() &&
					(GetWaitOptions() == WaitAnimationOptions.Indicator);
			}
		}
		protected internal bool IsAllowBusyPanel {
			get {
				return CheckAllowNotifications() &&
					(GetWaitOptions() == WaitAnimationOptions.Panel);
			}
		}
		WaitAnimationOptions GetWaitOptions() {
			if(OptionsView.WaitAnimationOptions == WaitAnimationOptions.Default)
				return WorkAsLookup ? WaitAnimationOptions.Panel : WaitAnimationOptions.Indicator;
			return OptionsView.WaitAnimationOptions;
		}
		public virtual bool CanDragColumn(GridColumn column) {
			if(!GridControl.IsDesignMode && (!column.OptionsColumn.AllowMove || !OptionsCustomization.AllowColumnMoving)) return false;
			if(this.VisibleColumns.Count > 1 || SortInfo.GroupCount == 0) 
				return true;
			if(column.GroupIndex > -1 || column.VisibleIndex < 0) 
				return true;
			return false;
		}
		public virtual bool CanExpandMasterRow(int rowHandle) {
			return CanExpandMasterRowEx(rowHandle, CalcDefaultRelationIndex(rowHandle));
		}
		public virtual bool CanExpandMasterRowEx(int rowHandle, int relationIndex) {
			if(!IsMasterRow(rowHandle)) return false;
			bool result = true;
			if(!OptionsDetail.AllowExpandEmptyDetails) {
				result = false;
				if(!IsMasterRowEmptyEx(rowHandle, relationIndex)) {
					IList list = DataController.GetDetailList(rowHandle, relationIndex);
					if(list != null && list.Count > 0) result = true;
				}
			}
			if(GridControl.ShowOnlyPredefinedDetails) {
				GridDetailInfo[] details = GetDetailInfo(rowHandle, true);
				if(details == null || details.Length == 0) result = false;
				else {
					bool prevResult = result;
					result = false;
					foreach(GridDetailInfo detail in details) {
						if(detail.RelationIndex == relationIndex) {
							result = prevResult;
							break;
						}
					}
				}
			}
			MasterRowCanExpandEventHandler handler = (MasterRowCanExpandEventHandler)this.Events[masterRowExpanding];
			if(handler != null) {
				MasterRowCanExpandEventArgs e = new MasterRowCanExpandEventArgs(rowHandle, relationIndex, result);
				handler(this, e);
				result = e.Allow;
			}
			return result;
		}
		protected internal override bool CanCollapseMasterRow(int rowHandle) {
			if(!GetMasterRowExpandedEx(rowHandle, -1)) return true;
			return CanCollapseMasterRowEx(rowHandle, -1);
		}
		public virtual bool CanCollapseMasterRowEx(int rowHandle, int relationIndex) {
			if(!GetMasterRowExpandedEx(rowHandle, relationIndex)) return false;
			MasterRowCanExpandEventHandler handler = (MasterRowCanExpandEventHandler)this.Events[masterRowCollapsing];
			if(handler != null) {
				MasterRowCanExpandEventArgs e = new MasterRowCanExpandEventArgs(rowHandle, relationIndex, true);
				handler(this, e);
				return e.Allow;
			}
			return true;
		}
		public override bool CanResizeColumn(GridColumn column) {
			if(column == null || !OptionsCustomization.AllowColumnResizing) return false;
			return column.OptionsColumn.AllowSize || IsDesignMode;
		}
		public virtual bool CanResizeRow(int rowHandle) {
			if(!OptionsCustomization.AllowRowSizing) return false;
			if(IsGroupRow(rowHandle)) return false;
			return true;
		}
		public virtual bool CanResizeDetailRow(int rowHandle) {
			return true;
		}
		public virtual bool CanShowFilterButton(GridColumn column) {
			if(DataController.IsReady) {
				return OptionsCustomization.AllowFilter && (column == null ||
					IsColumnAllowFilter(column) && 
					(column.VisibleIndex > -1 || column.GroupIndex > -1));
			}
			return false;
		}
		public override bool CanSortColumn(GridColumn column) { 
			if(!OptionsCustomization.AllowSort) return false;
			return base.CanSortColumn(column);
		}
		public override bool CanGroupColumn(GridColumn column) {
			if(!CanSortColumn(column)) return false;
			if(!OptionsCustomization.AllowGroup) return false;
			if(!column.GetAllowGroup()) return false;
			if(column.GroupIndex == -1 && Columns.Count - 1 == SortInfo.GroupCount) return false;
			return column.GroupIndex > -1 || (Columns.Count > 1 && (VisibleColumns.Count > 1 || column.VisibleIndex == -1));
		}
		protected override void OnBeforeMouseSortColumn() {
			GroupSummarySortInfo.Clear();
		}
		protected internal override bool CanDataSortColumn(GridColumn column) {
			return IsLevelDefault || base.CanDataSortColumn(column);
		}
		protected override bool CanShowColumn(GridColumn column) {
			return column.GroupIndex < 0 || OptionsView.ShowGroupedColumns;
		}
		public void ClearGrouping() {
			BeginDataUpdate();
			try {
				GroupSummarySortInfo.Clear();
				ArrayList list = new ArrayList();
				foreach(GridColumn column in Columns) {
					if(column.GroupIndex == -1) continue;
					column.UnGroup();
					list.Add(column);
				}
				foreach(GridColumn column in list) {
					if(!column.Visible) column.Visible = true;
				}
			}
			finally {
				EndDataUpdateCore(true);
			}
		}
		public void CollapseAllDetails() { CollapseAllDetailsCore(); }
		protected internal override void CollapseAllDetailsCore() {
			DataController.CollapseDetailRows();
			LayoutChanged();
		}
		public virtual void ExpandAllGroups() {
			CheckLoaded();
			if(!RaiseGroupRowExpanding(InvalidRowHandle)) return;
			DataController.ExpandAll();
			RaiseGroupRowExpanded(InvalidRowHandle);
			UpdateNavigator();
		}
		public virtual void CollapseAllGroups() {
			CheckLoaded();
			if(!RaiseGroupRowCollapsing(InvalidRowHandle)) return;
			DataController.CollapseAll();
			RaiseGroupRowCollapsed(InvalidRowHandle);
			UpdateNavigator();
		}
		public virtual void ColumnsCustomization(Point showPoint) {
			DestroyCustomization();
			if(GridControl == null) return;
			customizationForm = CreateCustomizationForm();
			customizationForm.ShowCustomization(showPoint);
			RaiseShowCustomizationForm(EventArgs.Empty);
		}
		public void ColumnsCustomization() {
			ColumnsCustomization(BaseViewInfo.EmptyPoint);
		}
		public void ShowCustomization() {
			ColumnsCustomization(BaseViewInfo.EmptyPoint);
		}
		public void HideCustomization() {
			DestroyCustomization();
		}
		public void DestroyCustomization() {
			if(customizationForm != null) {
				SaveCustomizationFormBounds();
				Form form = customizationForm;
				customizationForm = null;
				form.Visible = false;
				form.Parent = null;
				form.Dispose();
				RaiseHideCustomizationForm(EventArgs.Empty);
			}
		}
		void SaveCustomizationFormBounds() {
			this.customizationFormBounds = CustomizationForm.Bounds;
		}
		protected override void OnLocalizer_Changed(object sender, EventArgs e) {
			if(CustomizationForm != null) {
				DestroyCustomization();
				ColumnsCustomization();
			}
			base.OnLocalizer_Changed(sender, e);
		}
		protected virtual void RecreateColumnsCustomization() {
			if(CustomizationForm == null) return;
			DestroyCustomization();
			ColumnsCustomization();
		}
		protected virtual CustomizationForm CreateCustomizationForm() {
			return new CustomizationForm(this);
		}
		protected internal override bool OnContextMenuClick() {
			GridHitInfo hitInfo = ViewInfo.CreateHitInfo();
			GridRowInfo rowInfo = ViewInfo.GetGridRowInfo(FocusedRowHandle);
			Point hitPoint = ViewInfo.ViewRects.Rows.Location;
			if(rowInfo != null) hitPoint = new Point(rowInfo.DataBounds.Left, rowInfo.DataBounds.Bottom); 
			hitInfo.HitPoint = hitPoint;
			if(IsValidRowHandle(FocusedRowHandle)) {
			hitInfo.HitTest = GridHitTest.Row;
			hitInfo.RowHandle = FocusedRowHandle;
				return DoShowGridMenu(GridMenuType.Row, new GridViewMenu(this), hitInfo, true);
			}
			else {
				return DoShowGridMenu(null, hitInfo);
			}
		}
		protected internal override int ScrollPageSize { 
			get {
				int res = ViewInfo.RowsInfo.GetScrollableRowsCount(this);
				bool isLastRowOnPageVisiblePartially = IsRowVisible(GetVisibleRowHandle(ViewInfo.RowsInfo.GetLastVisibleRowIndex())) == RowVisibleState.Partially;
				if(res > 0 && isLastRowOnPageVisiblePartially) res--;
				if(res < 0) res = 0;
				if(res < 1 && ViewInfo.RowsInfo.Count > 0) res = 1;
				return res; 
			} 
		}
		protected internal override void AddToGridControl() {
			if(GridControl != null) {
				ScrollInfo.AddControls(GridControl);
			}
			base.AddToGridControl();
		}
		protected internal override void RemoveFromGridControl() {
			if(GridControl != null) {
				if(detailTip != null) detailTip.HideTip();
				DestroyCustomization();
				if(DataController != null)
					DataController.CollapseDetailRows();
				ScrollInfo.RemoveControls(GridControl);
			}
			base.RemoveFromGridControl();
		}
		protected override void Dispose(bool disposing) {
			if(disposing) {
				fViewDisposing = true;
				if(destroying) return;
				GroupSummarySortInfo.Clear();
				if(ScrollTimer != null) ScrollTimer.Dispose();
				destroying = true;
				detailTip.Dispose();
				BeginUpdate();
				if(DataController != null)
					DataController.CollapseDetailRows();
				HideEditor();
				DestroyCustomization();
				if(ScrollInfo != null) {
					this.scrollInfo.VScroll_Scroll -= new ScrollEventHandler(OnVertScroll);
					this.scrollInfo.HScroll_Scroll -= new ScrollEventHandler(OnHorzScroll);
					this.scrollInfo.VScroll_ValueChanged -= new EventHandler(OnVScroll);
					this.scrollInfo.HScroll_ValueChanged -= new EventHandler(OnHScroll);
					this.scrollInfo.Dispose();
					this.scrollInfo = null;
				}
			}
			base.Dispose(disposing);
		}
		public int GetDataRowHandleByGroupRowHandle(int groupRowHandle) {
			return DataController.GetControllerRowByGroupRow(groupRowHandle);
		}
		public int GetParentRowHandle(int rowHandle) {
			if(IsGroupRow(rowHandle)) return DataController.GroupInfo.GetParentRow(rowHandle);
			GroupRowInfo group = DataController.GroupInfo.GetGroupRowInfoByControllerRowHandle(rowHandle);
			return group != null ? group.Handle : InvalidRowHandle;
		}
		public int GetChildRowCount(int rowHandle) {
			return DataController.GroupInfo.GetChildCount(rowHandle);
		}
		public int GetChildRowHandle(int rowHandle, int childIndex) {
			return DataController.GroupInfo.GetChildRow(rowHandle, childIndex);
		}
		protected internal BaseView GetDetailViewByKey(object rowKey, int relationIndex) {
			if(DataController == null) return null;
			MasterRowInfo masterRow = DataController.FindRowDetailInfo(rowKey);
			if(masterRow == null) return null;
			DetailInfo di = masterRow.FindDetail(relationIndex);
			if(di != null) return di.DetailOwner as BaseView;
			return null;
		}
		protected internal BaseView GetVisibleDetailViewByKey(object rowKey) {
			return GetDetailViewByKey(rowKey, -1);
		}
		public BaseView GetDetailView(int rowHandle, int relationIndex) {
			if(DataController == null) return null;
			MasterRowInfo masterRow = DataController.GetRowDetailInfo(rowHandle);
			if(masterRow == null) return null;
			DetailInfo di = masterRow.FindDetail(relationIndex);
			if(di != null) return di.DetailOwner as BaseView;
			return null;
		}
		public BaseView GetVisibleDetailView(int rowHandle) {
			return GetDetailView(rowHandle, -1);
		}
		public int GetVisibleDetailRelationIndex(int rowHandle) {
			if(DataController == null) return -1;
			MasterRowInfo rowInfo = DataController.GetRowDetailInfo(rowHandle);
			if(rowInfo == null) return -1;
			DetailInfo di = rowInfo.FindDetail(-1);
			return di == null ? -1 : di.RelationIndex;
		}
		public bool GetMasterRowExpanded(int rowHandle) {
			if(DataController == null) return false;
			return DataController.IsDetailRowExpanded(rowHandle);
		}
		public bool GetMasterRowExpandedEx(int rowHandle, int relationIndex) {
			if(DataController == null) return false;
			return DataController.IsDetailRowExpanded(rowHandle, relationIndex);
		}
		public bool GetRowExpanded(int rowHandle) {
			return DataController.IsRowExpanded(rowHandle);
		}
		protected void MoveTopRowIndex(int delta) {
			int prevTopIndex = TopRowIndex, prevHandle = FocusedRowHandle;
			TopRowIndex = TopRowIndex + delta;
			if(prevTopIndex == TopRowIndex) {
				if(delta > 0)
					FocusedRowHandle = GetVisibleRowHandle(RowCount - 1);
				else {
					FocusedRowHandle = GetVisibleRowHandle(0);
				}
			}
			else
				FocusedRowHandle = GetVisibleRowHandle(TopRowIndex);
			DoAfterMoveFocusedRow(Keys.PageDown, prevHandle, null, null);
		}
		int GetFocusedRowIndex() { return GetVisibleIndex(FocusedRowHandle); }
		public override void MoveNextPage() {
			int prevHandle = FocusedRowHandle, newFocusedIndex;
			if(OptionsNavigation.UseOfficePageNavigation && ScrollPageSize > 0) {
				if(GetFocusedRowIndex() < TopRowIndex + ScrollPageSize - 1) {
					newFocusedIndex = TopRowIndex + ScrollPageSize - 1;
				}
				else {
					TopRowIndex  = GetFocusedRowIndex() + 1;
					newFocusedIndex = TopRowIndex + ScrollPageSize - 1;
				}
				if(newFocusedIndex >= RowCount) newFocusedIndex = RowCount - 1;
				FocusedRowHandle = GetVisibleRowHandle(newFocusedIndex);
				DoAfterMoveFocusedRow(Keys.PageDown, prevHandle, null, null);
				return;
			}
			MoveTopRowIndex(ScrollPageSize);
		}
		public override void MovePrevPage() {
			int prevHandle = FocusedRowHandle;
			if(OptionsNavigation.UseOfficePageNavigation) {
				if(TopRowIndex < GetFocusedRowIndex()) {
					FocusedRowHandle = GetVisibleRowHandle(TopRowIndex);
					DoAfterMoveFocusedRow(Keys.PageUp, prevHandle, null, null);
					return;
				}
			}
			MoveTopRowIndex(-ScrollPageSize); 
		}
		public override void HideEditor() {
			if(!IsEditing || !fAllowCloseEditor) return;
			base.HideEditor();
			if(destroying) return;
			GridCellInfo cell = this.fEditingCell;
			this.fEditingCell = null;
			if(cell != null) {
				if(cell.ViewInfo is IAnimatedItem) XtraAnimator.RemoveObject(ViewInfo, new GridCellId(this, cell));
				cell.ViewInfo = null;
			}
			SetStateInt((int)GridState.Normal);
			if(cell != null) {
				ViewInfo.UpdateCellAppearance(cell, true);
				InvalidateRow(cell.RowHandle);
			}
			UpdateNavigator();
		}
		public virtual void InvalidateColumnHeader(GridColumn column) {
			if(!ViewInfo.IsReady) return;
			ViewInfo.PaintAnimatedItems = false;
			if(column == null) 
				InvalidateRect(ViewInfo.ViewRects.ColumnPanel);
			else {
				GridColumnInfoArgs ci = ViewInfo.ColumnsInfo[column];
				if(ci != null)
					InvalidateRect(ci.Bounds);
			}
		}
		public virtual void InvalidateFilterPanel() {
			if(!IsViewInfoReady || !IsShowFilterPanel) return;
			ViewInfo.PaintAnimatedItems = false;
			InvalidateRect(ViewInfo.FilterPanel.Bounds);
		}
		public virtual void InvalidateFooter() {
			if(!IsViewInfoReady) return;
			ViewInfo.PaintAnimatedItems = false;
			InvalidateRect(ViewInfo.ViewRects.Footer);
		}
		public virtual void InvalidateGroupPanel() {
			if(!IsViewInfoReady || !OptionsView.ShowGroupPanel) return;
			InvalidateRect(ViewInfo.ViewRects.GroupPanel);
		}
		public virtual void InvalidateRow(int rowHandle) {
			if(!IsViewInfoReady) return;
			ViewInfo.PaintAnimatedItems = false;
			InvalidateRow(ViewInfo.GetGridRowInfo(rowHandle));
		}
		protected void InvalidateRow(GridRowInfo rowInfo) {
			if(rowInfo == null) return;
			ViewInfo.PaintAnimatedItems = false;
			GridDataRowInfo dataRow = rowInfo as GridDataRowInfo;
			if(dataRow != null && dataRow.HasMergedCells) {
				InvalidateRows();
				return;
			}
			Rectangle r = rowInfo.TotalBounds;
			if(ViewInfo.ShouldInflateRowOnInvalidate) r.Inflate(0, 1);
			InvalidateRect(r);
		}
		public virtual void InvalidateRowIndicator(int rowHandle) {
			GridRowInfo ri = ViewInfo.GetGridRowInfo(rowHandle);
			if(ri != null) {
				ViewInfo.PaintAnimatedItems = false;
				InvalidateRect(ri.IndicatorRect);
			}
		}
		public virtual void RefreshRowCell(int rowHandle, GridColumn column) {
			if(column == null) return;
			GridCellInfo cell = ViewInfo.GetGridCellInfo(rowHandle, column);
			if(cell != null && cell.MergedCell != null) cell = cell.MergedCell;
			if(cell != null) {
				cell.CellValue = GetRowCellValue(rowHandle, column);
				cell.ViewInfo = null;
				cell.State = GridRowCellState.Dirty;
				ViewInfo.PaintAnimatedItems = false;
				InvalidateRect(cell.Bounds);
			}
		}
		public virtual void InvalidateRowCell(int rowHandle, GridColumn column) {
			if(column == null) return;
			GridCellInfo cell = ViewInfo.GetGridCellInfo(rowHandle, column);
			if(cell != null && cell.MergedCell != null) cell = cell.MergedCell;
			if(cell != null) {
				ViewInfo.PaintAnimatedItems = false;
				InvalidateRect(cell.Bounds);
			}
		}
		public virtual void InvalidateRows() {
			if(!IsViewInfoReady) return;
			ViewInfo.PaintAnimatedItems = false;
			InvalidateRect(ViewInfo.ViewRects.Rows);
		}
		public bool IsGroupRow(int rowHandle) {
			if(IsFilterRow(rowHandle)) return false;
			return DataController.IsGroupRowHandle(rowHandle);
		}
		public bool IsFilterRow(int rowHandle) {
			return rowHandle == GridControl.AutoFilterRowHandle;
		}
		protected internal virtual bool AllowMasterDetail { get { return OptionsDetail.EnableMasterViewMode && !WorkAsLookup; } }
		public bool IsMasterRow(int rowHandle) {
			if(rowHandle == GridControl.AutoFilterRowHandle) return false;
			return AllowMasterDetail &&
				(DataController != null && DataController.IsDetailRow(rowHandle));
		}
		protected internal bool IsMasterRowEmptyCached(int rowHandle) {
			return AllowMasterDetail &&
				DataController.IsDetailRowEmptyCached(rowHandle, CalcDefaultRelationIndex(rowHandle));
		}
		protected internal bool IsAllMasterRowEmptyCached(int rowHandle) {
			return AllowMasterDetail &&
				DataController.IsDetailRowEmptyCached(rowHandle, -1);
		}
		public bool IsMasterRowEmpty(int rowHandle) {
			return AllowMasterDetail &&
				IsMasterRowEmptyEx(rowHandle, CalcDefaultRelationIndex(rowHandle));
		}
		public virtual bool IsMasterRowEmptyEx(int rowHandle, int relationIndex) {
			if(DesignMode) return true;
			return DataController != null && DataController.IsDetailRowEmpty(rowHandle, relationIndex);
		}
		public RowVisibleState IsRowVisible(int rowHandle) {
			GridRowInfo ri = ViewInfo.GetGridRowInfo(rowHandle);
			if(ri == null || ri.TotalBounds.Height < 1) return RowVisibleState.Hidden;
			if(ri.TotalBounds.Bottom > ViewInfo.ViewRects.Rows.Bottom || ri.Bounds.Bottom > ViewInfo.ViewRects.Rows.Bottom)
				return RowVisibleState.Partially;
			return RowVisibleState.Visible;
		}
		protected bool CheckDetailLayout() {
			if(ViewRect.IsEmpty) {
				if(IsLevelDefault) {
					if(CanSynchronized) OnViewPropertiesChanged(SynchronizationMode.Visual);
					return true;
				}
				if(ViewInfo.ViewRects.Bounds.IsEmpty) {
					return true;
				}
			}
			return false;
		}
		protected virtual bool CalculateDataCore() {
			if(!CanCalculateLayout) return false;
			ViewInfo.AutoRowHeightCache.Clear();
			this.calculatedRealViewHeight = -1;
			RefreshRows(false, false);
			ViewInfo.UpdateFooterDrawInfo();
			UpdateScrollBars();
			ViewInfo.IsDataDirty = false;
			TopRowIndex = CheckTopRowIndex(TopRowIndex);
			return true;
		}
		protected override bool CalculateData() {
			if(IsEditing && EditingCell != null) { 
					GridCellInfo editingCell = EditingCell;
					if(!CalculateDataCore()) return false;
					GridCellInfo cell = ViewInfo.GetGridCellInfo(editingCell.RowHandle, editingCell.Column);
					if(cell == null || cell.Bounds != editingCell.Bounds) {
						if(IsFilterRow(FocusedRowHandle) && IsServerMode) {
							if(cell != null) {
								UpdateActiveEditorBounds();
								return true;
							}
						}
						HideEditor();
					}
					return true;
			}
			HideEditor();
			return CalculateDataCore();
		}
		protected override bool CheckCalculateLayout() { 
			ViewInfo.AutoRowHeightCache.Clear();
			if(CheckDetailLayout()) return true;
			return false; 
		}
		int SafeVisibleCount { get { return DataController.IsReady && !DataController.IsUpdateLocked ? RowCount : 0; } }
		int lastVisibleCount = 0;
		protected override void OnBeginUpdate() {
			this.lastVisibleCount = SafeVisibleCount;
			base.OnBeginUpdate();
		}
		protected override void OnEndUpdate() {
			base.OnEndUpdate();
			if(lastVisibleCount != SafeVisibleCount) SetTopRowIndexDirty();
		}
		public override void LayoutChanged() {
			if(!CalculateLayout()) return;
			if(this.requireCheckTopRowIndex) {
				this.requireCheckTopRowIndex = false;
				TopRowIndex = CheckTopRowIndex(TopRowIndex);
			}
			if(CustomizationForm != null) {
				SaveCustomizationFormBounds();
				CustomizationForm.CheckAndUpdate();
			}
			base.LayoutChanged();
		}
		protected internal override void ClearMasterCache() {
			base.ClearMasterCache();
			calculatedRealViewHeight = -1;
		}
		public virtual void MakeColumnVisible(GridColumn column) {
			if(column.VisibleIndex < 0 || OptionsView.ColumnAutoWidth) return;
			GridColumnInfoArgs ci = ViewInfo.ColumnsInfo[column];
			if(ci != null && (ViewInfo.IsFixedLeftPaint(ci) || ViewInfo.IsFixedRightPaint(ci))) return;
			if(column.Fixed != FixedStyle.None) return;
			int colLeft = ViewInfo.GetColumnLeftCoord(column),
				colRight, maxRight, minLeft = 0;
			if(ViewInfo.HasFixedLeft) {
				minLeft = (ViewInfo.ViewRects.FixedLeft.Right - ViewInfo.ViewRects.IndicatorWidth) - ViewInfo.ViewRects.Rows.Left;
				colLeft -= (minLeft - FixedLineWidth);
			} else {
				minLeft = 0;
			}
			colRight = colLeft + column.VisibleWidth;
			if(colLeft < LeftCoord) {
				LeftCoord = colLeft;
				return;
			}
			maxRight = ViewInfo.ViewRects.Rows.Width - minLeft - ViewInfo.ViewRects.IndicatorWidth - 1;
			if(ViewInfo.HasFixedRight)
				maxRight = (ViewInfo.ViewRects.FixedRight.Left - ViewInfo.ViewRects.Rows.Left)- FixedLineWidth - ViewInfo.ViewRects.IndicatorWidth - minLeft;
			if(colRight > LeftCoord + maxRight) {
				if(colRight - colLeft >= maxRight)
					LeftCoord = colLeft;
				else
					LeftCoord = colLeft - maxRight + column.VisibleWidth;
			}
		}
		public void MakeRowVisible(int rowHandle) {
			if(IsInitialized && !ViewInfo.IsReady) LayoutChanged();
			MakeRowVisible(rowHandle, false);
		}
		public void MakeRowVisible(int rowHandle, bool invalidate) {
			MakeRowVisibleCore(rowHandle, invalidate);
		}
		protected override void MakeRowVisibleCore(int rowHandle, bool invalidate) {
			if(rowHandle == GridControl.InvalidRowHandle) return;
			bool isReady = IsInitialized && ViewInfo.IsReady && !ViewRect.IsEmpty;
			RowVisibleState rs = IsRowVisible(rowHandle);
			int vIndex = GetVisibleIndex(rowHandle);
			if(vIndex == TopRowIndex && vIndex >= 0) return;
			if(fLockUpdate == 0 && isReady) {
				if(rs == RowVisibleState.Visible) {
					if(invalidate) InvalidateRow(rowHandle);
					return;
				}
				if(rs == RowVisibleState.Partially) {
					while(IsRowVisible(rowHandle) == RowVisibleState.Partially) {
						int prevTopRowIndex = TopRowIndex + 1;
						InternalSetTopRowIndex(TopRowIndex + 1);
						if(TopRowIndex != prevTopRowIndex) break;
					}
					return;
				}
			}
			DataController.MakeRowVisible(rowHandle);
			if(fLockUpdate != 0 || !isReady) return;
			vIndex = GetVisibleIndex(rowHandle);
			if(vIndex != -1) 
				TopRowIndex = CheckTopRowIndex(vIndex);
		}
		int postingEditorValue = 0;
		protected internal override bool PostEditor(bool causeValidation) {
			if(this.postingEditorValue != 0) return true;
			try {
				this.postingEditorValue ++;
				if(ActiveEditor == null || !EditingValueModified || this.fEditingCell == null) return true;
				if((causeValidation && !ValidateEditor()) || this.fEditingCell == null) return false;
				object value = ExtractEditingValue(this.fEditingCell.ColumnInfo.Column, EditingValue);
				SetRowCellValueCore(this.fEditingCell.RowHandle, this.fEditingCell.ColumnInfo.Column, value, true);
			}
			finally {
				this.postingEditorValue --;
			}
			return true;
		}
		protected virtual BaseView GetLevelDefault(int rowHandle, int relationIndex, out string levelName) {
			levelName = GetRelationName(rowHandle, relationIndex);
			GridLevelNode level = GetLevelNode();
			BaseView view = level != null ? level.GetChildTemplate(levelName) : null;
			MasterRowGetLevelDefaultViewEventHandler handler = (MasterRowGetLevelDefaultViewEventHandler)this.Events[masterRowGetLevelDefaultView];
			if(handler != null) {
				MasterRowGetLevelDefaultViewEventArgs e = new MasterRowGetLevelDefaultViewEventArgs(rowHandle, relationIndex, view);
				handler(this, e);
				view = e.DefaultView;
			}
			return view;
		}
		protected internal override IList GetChildDataView(int rowHandle, int relationIndex) {
			IList res = base.GetChildDataView(rowHandle, relationIndex);
			MasterRowGetChildListEventHandler handler = (MasterRowGetChildListEventHandler)this.Events[masterRowGetChildList];
			if(handler != null) {
				MasterRowGetChildListEventArgs e = new MasterRowGetChildListEventArgs(rowHandle, relationIndex, res);
				handler(this, e);
				res = e.ChildList;
			}
			return res;
		}
		public virtual int GetRelationIndex(int rowHandle, string relationName) {
			return DataController.GetRelationIndex(rowHandle, relationName);
		}
		public virtual string GetRelationName(int rowHandle, int relationIndex) {
			return DataController.GetRelationName(rowHandle, relationIndex);
		}
		public virtual string GetRelationDisplayName(int rowHandle, int relationIndex) {
			return DataController.GetRelationDisplayName(rowHandle, relationIndex);
		}
		public virtual int GetRelationCount(int rowHandle) {
			if(DataController == null) return 0;
			return DataController.GetRelationCount(rowHandle);
		}
		protected internal override void ClearDataProperties() {
			base.ClearDataProperties();
			GroupSummary.Clear();
		}
		protected internal virtual BaseView CreateLevelDefault(int rowHandle, int relationIndex, out BaseView defaultView, out string levelName) {
			levelName = string.Empty;
			defaultView = null;
			BaseView newGV;
			defaultView = GetLevelDefault(rowHandle, relationIndex, out levelName); 
			bool copyEvents = true;
			if(defaultView != null) 
				newGV = defaultView.CreateInstance();
			else
				newGV = this.CreateInstance();
			if(defaultView == null) {
				defaultView = this;
				copyEvents = false;
			}
			newGV.BeginUpdate();
			try {
				newGV.Assign(defaultView, copyEvents);
				if(!copyEvents) newGV.ClearDataProperties();
			}
			finally {
				newGV.CancelUpdate();
			}
			return newGV;
		}
		protected internal override void ApplyLevelDefaults(BaseView newGV, BaseView defaultView, DetailInfo di, string levelName) {
			base.ApplyLevelDefaults(newGV, defaultView, di, levelName);
			if(defaultView == this) {
				GridView mgv = newGV as GridView;
				mgv.Columns.DestroyColumns();
				mgv.OptionsView.ShowGroupPanel = false;
			} else {
				GridView mgv = newGV as GridView;
			}
			newGV.DataController.SetDataSource(GridControl.BindingContext, di.DetailList, null);
			if(newGV is ColumnView) {
				ColumnView cgv = newGV as ColumnView;
				if(cgv.Columns.Count == 0) {
					cgv.PopulateColumns();
				}
			}
			if(newGV != null) newGV.Reload();
			if(newGV.TabControl != null) newGV.TabControl.Populate();
		}
		public void CollapseMasterRow(int rowHandle) { CollapseMasterRow(rowHandle, -1); }
		public void CollapseMasterRow(int rowHandle, int relationIndex) {
			if(DataController == null) return;
			if(relationIndex >= GetRelationCount(rowHandle)) return;
			if(!IsMasterRow(rowHandle)) return;
			HideDetailTip();
			bool expanded = GetMasterRowExpandedEx(rowHandle, relationIndex);
			if(!expanded) return;
			if(!CanCollapseMasterRowEx(rowHandle, relationIndex)) return;
			BeginUpdate();
			try {
				if(relationIndex == -1) DataController.CollapseDetailRow(rowHandle);
				else {
					DataController.CollapseDetailRow(rowHandle, relationIndex);
					UpdateActiveDetailView(rowHandle);
				}
			}
			finally {
				EndUpdateCore(true);
			}
			RaiseMasterRowCollapsed(rowHandle, relationIndex);
		}
		protected void UpdateActiveDetailView(int rowHandle) {
			BaseView bv = GetVisibleDetailView(rowHandle);
			if(bv != null) {
				if(bv.TabControl != null) bv.TabControl.Populate();
				if(OptionsDetail.AutoZoomDetail && OptionsDetail.AllowZoomDetail && (bv.IsAllowZoomDetail || bv.ViewRect.X == -10000)) { 
					bv.ZoomView(this);
				}
			}
		}
		internal int CalcDefaultRelationIndex(int rowHandle) {
			GridDetailInfo[] details = GetDetailInfo(rowHandle, true);
			if(details == null || details.Length == 0) return 0;
			GridDetailInfo detail = details[Math.Min(DefaultRelationIndex, details.Length - 1)];
			return detail.RelationIndex;
		}
		internal GridDetailInfo[] GetDetailInfo(int rowHandle, bool shortInfo) {
			if(!AllowMasterDetail || GridControl == null) return null;
			GridLevelNode levelNode = GetLevelNode();
			if(GridControl.ShowOnlyPredefinedDetails && (levelNode == null || !levelNode.HasChildren)) return null;
			ArrayList details = new ArrayList();
			if(GridControl.ShowOnlyPredefinedDetails) {
				foreach(GridLevelNode node in levelNode.Nodes) {
					int id = GetRelationIndex(rowHandle, node.RelationName);
					if(id < -1) continue;
					details.Add(new GridDetailInfo(id, node.RelationName, GetRelationDisplayName(rowHandle, id)));
				}
			} else {
				int count = GetRelationCount(rowHandle);
				for(int n = 0; n < count; n++) {
					string name = GetRelationName(rowHandle, n);
					details.Add(new GridDetailInfo(n, name, shortInfo ? name : GetRelationDisplayName(rowHandle, n)));
				}
			}
			if(details.Count == 0) return null;
			return details.ToArray(typeof(GridDetailInfo)) as GridDetailInfo[];
		}
		public void ExpandMasterRow(int rowHandle, string relationName) { SetMasterRowExpanded(rowHandle, relationName, true); }
		public void ExpandMasterRow(int rowHandle) { ExpandMasterRow(rowHandle, -1); }
		public void ExpandMasterRow(int rowHandle, int relationIndex) { SetMasterRowExpandedEx(rowHandle, relationIndex, true); }
		public void CollapseMasterRow(int rowHandle, string relationName) { SetMasterRowExpanded(rowHandle, relationName, false); }
		public void SetMasterRowExpanded(int rowHandle, string relationName, bool expand) {
			int index = GetRelationIndex(rowHandle, relationName);
			if(index < -1) return;
			SetMasterRowExpandedEx(rowHandle, index, expand);
		}
		public void SetMasterRowExpanded(int rowHandle, bool expand) {
			SetMasterRowExpandedEx(rowHandle, -1, expand);
		}
		public void SetMasterRowExpandedEx(int rowHandle, int relationIndex, bool expand) {
			CheckLoaded();
			if(IsNewItemRow(rowHandle)) return;
			if(!expand) {
				CollapseMasterRow(rowHandle, relationIndex);
				return;
			}
			if(DataController == null) return;
			if(relationIndex >= GetRelationCount(rowHandle)) return;
			if(!IsMasterRow(rowHandle)) return;
			HideDetailTip();
			CloseEditor();
			UpdateCurrentRow();
			bool collapseBeforeExpand = false;
			bool switchKeyboardFocusedView = false;
			if(relationIndex == -1) {
				if(GetMasterRowExpanded(rowHandle) == expand) return;
			}
			else {
				if(GetMasterRowExpandedEx(rowHandle, relationIndex) == expand) {
					MasterRowInfo rowInfo = DataController.GetRowDetailInfo(rowHandle);
					if(rowInfo == null) return;
					DetailInfo detailInfo = rowInfo.FindDetail(-1);
					if(detailInfo == null || detailInfo.RelationIndex == relationIndex) return;
					if(!CanExpandMasterRowEx(rowHandle, relationIndex)) return;
					BaseView prev = GetVisibleDetailView(rowHandle);
					if(prev != null) {
						switchKeyboardFocusedView = (GridControl != null && GridControl.FocusedView == prev);
						prev.CloseEditor();
						if(!prev.UpdateCurrentRow()) {
							prev.CheckTabPage();
							return;
						}
						prev.InternalSetViewRectCore(new Rectangle(BaseViewInfo.EmptyPoint, prev.ViewRect.Size));
					}
					BeginUpdate();
					try {
						this.AllowSynchronization = false;
						rowInfo.MakeDetailVisible(relationIndex);
						UpdateActiveDetailView(rowHandle);
						if(OptionsDetail.SmartDetailExpand) {
							Size size = ViewInfo.CalcDetailRowSize(rowHandle);
							CheckDetailVisibility(rowHandle, size);
						}
					}
					finally {
						EndUpdateCore(true);
						this.AllowSynchronization = true;
					}
					if(switchKeyboardFocusedView) {
						GridControl.FocusedView = GetVisibleDetailView(rowHandle);
					}
					RaiseMasterRowExpanded(rowHandle, relationIndex);
					return;
				}
				if(expand && GetMasterRowExpanded(rowHandle)) {
					collapseBeforeExpand = true;
				}
			}
			bool isCalled = false;								   
			bool res = false;										
			if(relationIndex == -1) {
				relationIndex = CalcDefaultRelationIndex(rowHandle);
				isCalled = true;									  
				res = CanExpandMasterRowEx(rowHandle, relationIndex); 
				if(!res) {
					bool found = false;
					int rc = GetRelationCount(rowHandle);
					for(int n = 0; n < rc; n++) {
						if(n == relationIndex) continue;
						res = CanExpandMasterRowEx(rowHandle, n);
						if(res) {
							found = true;
							relationIndex = n;
							break;
						}
					}
					if(!found) return;
				}
			}
			if(isCalled && !res) return;
			if(!isCalled && !CanExpandMasterRowEx(rowHandle, relationIndex)) return;
			BaseView newGV = null;
			try {
				if(collapseBeforeExpand) { 
					BeginUpdate();
					BaseView oldV = GetVisibleDetailView(rowHandle);
					if(oldV != null) {
						oldV.CloseEditor();
						try {
							CancelUpdate();
							if(!oldV.UpdateCurrentRow()) {
								oldV.CheckTabPage();
								return;
							}
						} finally {
							BeginUpdate();
						}
						oldV.InternalSetViewRectCore(new Rectangle(BaseViewInfo.EmptyPoint, oldV.ViewRect.Size));
						switchKeyboardFocusedView = (GridControl != null && oldV == GridControl.FocusedView);
					}
				}
					if(OptionsDetail.AllowOnlyOneMasterRowExpanded)
						CollapseAllDetails();
					DetailInfo di = DataController.ExpandDetailRow(rowHandle, relationIndex);
					if(di == null) return;
					BaseView defaultView;
					string levelName;
					newGV = CreateLevelDefault(rowHandle, relationIndex, out defaultView, out levelName);
					newGV.BeginUpdate();
					di.DetailOwner = newGV;
					di.MasterRow.MakeDetailVisible(di);
					if(di.DetailList == null ) {
						DataController.CollapseDetailRow(rowHandle);
						newGV.Dispose();
						newGV = null;
					}
					else {
						ApplyLevelDefaults(newGV, defaultView, di, levelName);
						GridControl.RegisterView(newGV);
						newGV.OnDetailInitialized();
					} 
				if(newGV == null) DataController.CollapseDetailRow(rowHandle);
			}
			finally {
				if(collapseBeforeExpand) CancelUpdate();
				if(newGV != null) {
					newGV.CancelUpdate();
					if(OptionsDetail.AutoZoomDetail && 
						OptionsDetail.AllowZoomDetail && newGV.IsAllowZoomDetail)
						newGV.ZoomView();
					else {
						Size size = ViewInfo.CalcDetailRowSize(rowHandle);
						newGV.InternalSetViewRectCore(new Rectangle(BaseViewInfo.EmptyPoint, size));
						BaseView view = GridControl.DefaultView;
						bool oldAllowSynchronization = view.AllowSynchronization;
						this.AllowSynchronization = false;
						try {
							try {
								BeginUpdate();
								if(OptionsDetail.SmartDetailExpand) CheckDetailVisibility(rowHandle, size);
							}
							finally {
								EndUpdateCore(true);
							}
						}
						finally {
							this.AllowSynchronization = true;
							view.AllowSynchronization = oldAllowSynchronization;
						}
					}
					newGV.AllowSynchronization = true;
				}
				else
					LayoutChangedSynchronized();
			}
			if(newGV != null && switchKeyboardFocusedView && GridControl != null) GridControl.FocusedView = newGV;
			RaiseMasterRowExpanded(rowHandle, relationIndex);
		}
		int visualExpander = 0;
		protected internal virtual void VisualSetMasterRowExpandedEx(int rowHandle, int relationIndex, bool expand) {
			GridDetailInfo[] info = GetDetailInfo(rowHandle, true);
			if(info == null || info.Length == 0) return;
			if(relationIndex != -1) {
				bool found = false;
				foreach(GridDetailInfo di in info) {
					if(di.RelationIndex == relationIndex) {
						found = true;
						break;
					}
				}
				if(!found) return;
			}
			try {
				this.visualExpander ++;
				SetMasterRowExpandedEx(rowHandle, relationIndex, expand);
			}
			finally {
				this.visualExpander --;
			}
		}
		protected virtual void CheckDetailVisibility(int rowHandle, Size detailSize) {
			if(this.visualExpander == 0) return;
			if(ParentView != null && this != GridControl.DefaultView) return;
			RowVisibleState rv = IsRowVisible(rowHandle);
			if(rv == RowVisibleState.Hidden) return;
			GridRowInfo rowInfo = ViewInfo.GetGridRowInfo(rowHandle);
			if(rowInfo == null) return;
			int vIndex = GetVisibleIndex(rowHandle);
			if(TopRowIndex == vIndex) return;
			Rectangle rows = ViewInfo.ViewRects.Rows;
			int h = rows.Bottom - (rowInfo.Bounds.Bottom + detailSize.Height);
			if(h >= 0) return;
			int newTopIndex = rowInfo.VisibleIndex;
			int ix = ViewInfo.RowsInfo.IndexOf(rowInfo);
			for(int n = 0; n < ix; n++) {
				GridRowInfo ri = ViewInfo.RowsInfo[n];
				if(ri is GridDataRowInfo && ((GridDataRowInfo)ri).IsSpecialRow) continue;
				h+= ri.Bounds.Height;
				if(h >= 0) {
					if(n + 1 < ViewInfo.RowsInfo.Count) newTopIndex = ViewInfo.RowsInfo[n + 1].VisibleIndex;
					break;
				}
			}
			TopRowIndex = newTopIndex;
		}
		public void CollapseGroupRow(int rowHandle) { CollapseGroupRow(rowHandle, false); }
		public void CollapseGroupRow(int rowHandle, bool recursive) { SetRowExpanded(rowHandle, false, recursive); }
		public void ExpandGroupRow(int rowHandle) { ExpandGroupRow(rowHandle, false); }
		public void ExpandGroupRow(int rowHandle, bool recursive) {
			SetRowExpanded(rowHandle, true, recursive);
		}
		public void SetRowExpanded(int rowHandle, bool expanded, bool recursive) {
			CheckLoaded();
			if(!IsGroupRow(rowHandle)) return;
			if(expanded) {
				if(!RaiseGroupRowExpanding(rowHandle)) return;
				DataController.ExpandRow(rowHandle, recursive);
				RaiseGroupRowExpanded(rowHandle);
			}
			else {
				if(!RaiseGroupRowCollapsing(rowHandle)) return;
				DataController.CollapseRow(rowHandle, recursive);
				RaiseGroupRowCollapsed(rowHandle);
			}
			UpdateNavigator();
			SetTopRowIndexDirty();
			LayoutChangedSynchronized(); 
		}
		protected internal override void SetTopRowIndexDirty() {
			this.requireCheckTopRowIndex = true;
		}
		public void SetRowExpanded(int rowHandle, bool expanded) {
			if(GetRowExpanded(rowHandle) == expanded) return;
			SetRowExpanded(rowHandle, expanded, false);
		}
		public override void ShowEditor() {
			if(!IsDefaultState || !GetCanShowEditor(FocusedColumn)) return;
			CheckViewInfo();
			MakeColumnVisible(FocusedColumn);
			if(!Focus() && lockEditorUpdatingByMouse) return;
			GridCellInfo cell = ViewInfo.GetGridCellInfo(FocusedRowHandle, FocusedColumn);
			if(cell == null) return;
			if(AsyncServerModeDataController.IsNoValue(cell.CellValue)) return;
			ActivateEditor(cell);
		}
		public void UpdateColumnsCustomization() {
			if(CustomizationForm != null) {
				CustomizationForm.UpdateListBox();
			}
		}
		internal bool ShouldSerializeScrollStyle() { return ScrollStyle != DefaultScrollStyle; }
		[Description("Gets or sets a value specifying the behavior of the View's scrollbars."), Editor(typeof(DevExpress.Utils.Editors.AttributesEditor), typeof(System.Drawing.Design.UITypeEditor)),
		Category("Behavior"), XtraSerializableProperty()]
		public ScrollStyleFlags ScrollStyle {
			get { return scrollStyle; }
			set {
				if(ScrollStyle != value) {
					scrollStyle = value;
				}
			}
		}
		[Description("Gets or sets a value specifying how the focus rectangle is painted."), DefaultValue(DrawFocusRectStyle.CellFocus), XtraSerializableProperty(), Category("Appearance")]
		public virtual DrawFocusRectStyle FocusRectStyle {
			get { return focusRectStyle; }
			set {
				if(FocusRectStyle == value) return;
				focusRectStyle = value;
				OnPropertiesChanged();
			}
		}
		[Description("Gets or sets the offset by which the View is scrolled horizontally when clicking scrollbar buttons."), DefaultValue(3), XtraSerializableProperty(), Category("Behavior")]
		public int HorzScrollStep {
			get { return horzScrollStep; }
			set {
				if(value < 1) value = 1;
				if(value > 100) value = 100;
				if(HorzScrollStep == value) return;
				horzScrollStep = value;
				OnPropertiesChanged();
			}
		}
		protected void OnHorzScroll(object sender, ScrollEventArgs e) {
			if((ScrollStyle & ScrollStyleFlags.LiveHorzScroll) != 0) return;
			switch(e.Type) {
				case ScrollEventType.EndScroll:
					LeftCoord = ScrollInfo.HScrollPosition;
					break;
			}
		}
		protected virtual string GetVertScrollTip(int visibleIndex) {
			int rowHandle = GetVisibleRowHandle(visibleIndex);
			string s = string.Empty;
			if(IsGroupRow(rowHandle)) {
				s = "Group: " + GetGroupRowDisplayText(rowHandle);
			} else {
				int fieldHandle = DataController.Columns.GetColumnIndex(VertScrollTipFieldName);
				string dt = string.Empty;
				if(fieldHandle != -1) {
					dt = DataController.GetRowDisplayText(rowHandle, fieldHandle);
				} else {
					dt = rowHandle.ToString();
					if(rowHandle == GridControl.InvalidRowHandle) {
						if(DataRowCount == 0) {
							s = "";
						} 
						else {
							dt = DataRowCount.ToString();
						}
					}
				}
				s = "DataRow: " + dt;
			}
			return s;
		}
		protected internal override BaseViewScroller CreateScroller() { return new GridViewScroller(this); }
		protected internal override void SetScrollingState() { 
			SetStateCore(GridState.Scrolling);
		}
		protected internal override bool IsScrollingState {
			get { return State == GridState.Scrolling; }
		}
		bool _isScrolling = false;
		protected bool IsScrolling { 
			get { return _isScrolling; }
			set {
				if(IsScrolling == value) return;
				this._isScrolling = value;
			}
		}
		protected virtual void OnVertScroll(object sender, ScrollEventArgs e) {
			if((ScrollStyle & ScrollStyleFlags.LiveVertScroll) != 0) return;
			switch(e.Type) {
				case ScrollEventType.EndScroll:
					this.IsScrolling = false;
					TopRowIndex = ScrollInfo.VScrollPosition;
					HideHint();
					break;
				default:
					this.IsScrolling = true;
					ShowHint(ScrollInfo.VScroll.PointToScreen(Point.Empty), ToolTipLocation.LeftBottom);
					break;
			}
		}
		protected virtual void OnHScroll(object sender, EventArgs e) {
			if((ScrollStyle & ScrollStyleFlags.LiveHorzScroll) == 0) return;
			try {
				GridControl.EditorHelper.BeginAllowHideException();
				LeftCoord = ScrollInfo.HScrollPosition;
			}
			catch(HideException) {
				UpdateHScrollBar();
			}
			finally {
				GridControl.EditorHelper.EndAllowHideException();
			}
		}
		bool lockVScroll = false;
		internal bool AllowFixedGroups { 
			get {
				if(OptionsBehavior.AllowFixedGroups == DefaultBoolean.False) return false;
				if(GroupCount == 0) return false;
				if(OptionsBehavior.AllowFixedGroups == DefaultBoolean.True) return true;
				if(IsServerMode) return true;
				return false;
			} 
		}
		private void OnVScroll(object sender, EventArgs e) {
			if(lockVScroll) return;
			lockVScroll = true;
			try {
			if((ScrollStyle & ScrollStyleFlags.LiveVertScroll) == 0) return;
			try {
				GridControl.EditorHelper.BeginAllowHideException();
				TopRowIndex = GetActualVScroll(ScrollInfo.VScrollPosition);
			}
			catch(HideException) {
				UpdateVScrollBar();
			}
			finally {
				GridControl.EditorHelper.EndAllowHideException();
			}
			} finally {
				lockVScroll = false;
			}
		}
		int GetActualVScroll(int newTopRowIndex) {
			if(!AllowFixedGroups) return newTopRowIndex;
			if(newTopRowIndex < 0) return newTopRowIndex;
			return ConvertScrollIndexToIndex(newTopRowIndex);
		}
		protected virtual int CalcHScrollableRange() {
			return Math.Max(ViewInfo.ViewRects.ColumnPanelWidth - (ViewInfo.ViewRects.FixedRight.Width + ViewInfo.ViewRects.FixedLeft.Width), 0);
		}
		protected virtual int CalcHScrollRange() {
			int res = ViewInfo.ViewRects.ColumnTotalWidth - (ViewInfo.ViewRects.FixedRight.Width + ViewInfo.ViewRects.FixedLeft.Width);
			if(ViewInfo.HasFixedLeft) res += FixedLineWidth;
			if(ViewInfo.HasFixedRight) res += FixedLineWidth;
			return res;
		}
		void UpdateHScrollBar() {
			ScrollInfo.HScrollVisible = IsVisible && ViewInfo.HScrollBarPresence == ScrollBarPresence.Visible; 
			if(ScrollInfo.HScrollVisible) {
				ScrollArgs args = new ScrollArgs();
				args.FireEventsOnAssign = false;
				args.Maximum = CalcHScrollRange();
				args.Value = LeftCoord;
				args.SmallChange = HorzScrollStep;
				if(ViewInfo.ViewRects.ColumnPanelWidth > 0) 
					args.LargeChange = Math.Max(0, Math.Min(CalcHScrollableRange(), args.Maximum)); 
				else {
					args.LargeChange = 0;
				}
				args.Enabled = args.Maximum > args.LargeChange && !OptionsView.ColumnAutoWidth;
				args.Check();
				ScrollArgs active = ScrollInfo.HScrollArgs;
				if(!args.IsEquals(active)) {
					ScrollInfo.HScrollArgs = args;
				}
				if(ScrollInfo.HScrollArgs.Value != LeftCoord) {
					UpdateLeftCoord(ScrollInfo.HScrollArgs.Value);
				}
			}
		}
		protected override void UpdateScrollBars() {
			ScrollInfo.ClientRect = ViewInfo.ViewRects.Scroll;
			UpdateVScrollBar();
			UpdateHScrollBar();
			ScrollInfo.UpdateScrollRects();
		}
		int ConvertIndexToScrollIndex(int index) {
			if(!AllowFixedGroups || index == 0) return index;
			VisibleIndexCollection vic = DataController.GetVisibleIndexes();
			if(vic.IsEmpty) return index;
			int i = Array.IndexOf<int>(vic.ScrollableIndexes, index, 0, vic.ScrollableIndexesCount);
			if(i < 0) {
				return FindScrollableIndex(index, vic);
			}
			return i;
		}
		int FindScrollableIndex(int index, VisibleIndexCollection vic) {
			int count = vic.ScrollableIndexesCount;
			if(count < 1) return count;
			if(vic.ScrollableIndexes[0] >= index) return vic.ScrollableIndexes[0];
			if(vic.ScrollableIndexes[count - 1] <= index) return vic.ScrollableIndexes[count - 1];
			for(int n = 0; n < count; n++) {
				int i = vic.ScrollableIndexes[n];
				if(i >= index) return n;
			}
			return index;
		}
		int ConvertScrollIndexToIndex(int scrollIndex) {
			if(!AllowFixedGroups) return scrollIndex;
			VisibleIndexCollection vic = DataController.GetVisibleIndexes();
			if(vic.IsEmpty || scrollIndex >= vic.ScrollableIndexesCount) return scrollIndex;
			return vic.ScrollableIndexes[scrollIndex];
		}
		int GetScrollableRowCount() {
			if(!AllowFixedGroups) return RowCount;
			VisibleIndexCollection vic = DataController.GetVisibleIndexes();
			if(vic.IsEmpty) return RowCount;
			int res = vic.ScrollableIndexesCount;
			if(OptionsView.NewItemRowPosition == NewItemRowPosition.Bottom) res++;
			return res;
		}
		protected internal void DoMouseWheelScroll(int delta) {
			if(!AllowFixedGroups || !ScrollInfo.VScrollVisible) {
				TopRowIndex += delta;
				return;
			}
			int value = ScrollInfo.VScroll.Value;
			if(delta > 0) {
				if(value + delta + ScrollInfo.VScroll.LargeChange >= ScrollInfo.VScroll.Maximum)
					delta = ScrollInfo.VScroll.Maximum - value - ScrollInfo.VScroll.LargeChange;
				if(delta < 0) delta = 0;
			}
			ScrollInfo.VScroll.Value += delta;
		}
		private void UpdateVScrollBar() {
			ScrollInfo.VScrollVisible = IsVisible && ViewInfo.VScrollBarPresence == ScrollBarPresence.Visible; 
			if(!ScrollInfo.VScrollVisible) return;
			ScrollArgs args = new ScrollArgs();
			args.FireEventsOnAssign = false;
			bool isLastRowVisible = RowCount > 0 && IsRowVisible(GetVisibleRowHandle(RowCount - 1)) == RowVisibleState.Visible;
			int scrollableRowsCount = ViewInfo.RowsInfo.GetScrollableRowsCount(this);
			bool isLastRowOnPageVisiblePartially = IsRowVisible(GetVisibleRowHandle(ViewInfo.RowsInfo.GetLastVisibleRowIndex())) == RowVisibleState.Partially;
			args.Maximum = Math.Max(0, GetScrollableRowCount() + (isLastRowVisible ? -1 : 0));
			bool forceEnable = false;
			if(!OptionsBehavior.SmartVertScrollBar) {
				args.Maximum += Math.Max(0, Math.Min(1, scrollableRowsCount - 1));
			} else {
				if(isLastRowVisible) {
					int lastRowHandle = GetVisibleRowHandle(RowCount - 1);
					if(GetMasterRowExpanded(lastRowHandle)) {
						if(scrollableRowsCount > 1) {
							forceEnable = true;
							GridDataRowInfo ri = ViewInfo.GetGridRowInfo(lastRowHandle) as GridDataRowInfo;
							if(ri != null && ri.DetailBounds.Bottom + ViewInfo.DetailVertIndent + 1 > ViewInfo.ViewRects.Rows.Bottom) args.Maximum++;
						}
					}
				}
			}
			if(VertScrollVisibility == ScrollVisibility.Always) {
				args.Enabled = TopRowIndex != 0 || !isLastRowVisible || forceEnable;
			}
			args.Value = ConvertIndexToScrollIndex(TopRowIndex);
			args.LargeChange = Math.Max(Math.Min(args.Maximum, scrollableRowsCount - (isLastRowOnPageVisiblePartially ? 1 : 0)), 1);
			ScrollInfo.VScrollArgs = args;
		}
		protected virtual int PreviewFieldHandle {
			get {
				if(previewFieldHandle == -1) {
					previewFieldHandle = DataController.Columns.GetColumnIndex(PreviewFieldName);
					if(previewFieldHandle == -1) previewFieldHandle = -2;
				}
				return previewFieldHandle;
			}
		}
		public void InvokeMenuItemClick(GridMenuItemClickEventArgs e) {
			GridMenuItemClickEventHandler handler = (GridMenuItemClickEventHandler)this.Events[gridMenuItemClick];
			if(handler != null) handler(this, e);
		}
#pragma warning disable 612 // Obsolete
#pragma warning disable 618 // Obsolete
		protected internal bool DoShowGridMenu(GridViewMenu menu, GridHitInfo hitInfo) {
			return DoShowGridMenu(new GridMenuEventArgs(menu, hitInfo));
		}
		protected internal bool DoShowGridMenu(GridMenuType menuType, GridViewMenu menu, GridHitInfo hitInfo, bool allow) {
			return DoShowGridMenu(new GridMenuEventArgs(menuType, menu, hitInfo, allow));
		}
		protected internal virtual bool DoShowGridMenu(GridMenuEventArgs e) {
			RaisePopupMenuShowing(e);
			RaiseShowGridMenu(e);
#pragma warning restore 618 // Obsolete
#pragma warning restore 612 // Obsolete
			if (e.Menu == null || !e.Allow || e.Menu.Items.Count == 0) return e.Allow;
			e.Menu.Show(e.Point);
			return true;
		}
		protected virtual void CheckMinColumnWidthes() {
			int colCount = VisibleColumns.Count;
			for(int i = 0; i < colCount; i++) {
				GridColumn col = GetVisibleColumn(i);
				int minWidth = GetColumnMinWidth(col);
				if(col.VisibleWidth < minWidth) 
					col.visibleWidth = minWidth;
				if(!OptionsView.ColumnAutoWidth) {
					if(col.Width < minWidth) 
						col.InternalSetWidth(minWidth);
				}
			}
		}
		protected internal virtual int CheckTopRowIndex(int newTopRowIndex) {
			if(!OptionsBehavior.SmartVertScrollBar ||
				newTopRowIndex == 0)
				return newTopRowIndex;
			int startTopRowIndex = newTopRowIndex;
			int maxHeight = ViewInfo.ViewRects.Rows.Height,
				prevRowsHeight = -1;
			Graphics g = GridControl.CreateGraphics();
			try {
				GridRowsLoadInfo rInfo = new GridRowsLoadInfo(g, newTopRowIndex, maxHeight, true, true);
				ViewInfo.LoadRows(rInfo);
				if(rInfo.ResultAllRowsFit) rInfo = null;
				for(;;) {
					if(newTopRowIndex < 0) {
						newTopRowIndex = 0;
						break;
					}
					if(prevRowsHeight != -1 || rInfo == null) {
						rInfo = new GridRowsLoadInfo(g, newTopRowIndex, maxHeight, true, false);
						ViewInfo.LoadRows(rInfo);
					}
					if(startTopRowIndex > newTopRowIndex && rInfo.ResultRowsHeight > maxHeight && newTopRowIndex + rInfo.ResultRowCount == RowCount) {
						newTopRowIndex ++;
						break;
					}
					if(prevRowsHeight != -1 && prevRowsHeight < maxHeight && (!rInfo.ResultAllRowsFit || rInfo.ResultRowsHeight > maxHeight)) {
						newTopRowIndex ++;
						break;
					}
					if(rInfo.ResultRowsHeight < maxHeight)
						newTopRowIndex --;
					else 
						break;
					prevRowsHeight = rInfo.ResultRowsHeight;
				}
			}
			finally {
				g.Dispose();
			}
			this.allowUpdateRowIndexes = TopRowIndex == newTopRowIndex;
			return newTopRowIndex;
		}
		protected override bool UpdateCurrentRowCore(bool force) {
			if(IsFilterRow(FocusedRowHandle)) return true;
			return base.UpdateCurrentRowCore(force);
		}
		protected override int CheckRowHandle(int currentRowHandle, int newRowHandle) {
			if(!IsValidRowHandle(newRowHandle) && IsFilterRow(currentRowHandle) && !WorkAsLookup) return currentRowHandle;
			return base.CheckRowHandle(currentRowHandle, newRowHandle);
		}
		protected override void DoChangeFocusedRow(int currentRowHandle, int newRowHandle, bool raiseUpdateCurrentRow) {
			if(!CheckCanLeaveRow(currentRowHandle, raiseUpdateCurrentRow)) return;
			newRowHandle = CheckRowHandle(currentRowHandle, newRowHandle);
			if(currentRowHandle == newRowHandle && IsValidRowHandle(DataController.CurrentControllerRow)) return;
			int prevFocused = FocusedRowHandle;
			SetFocusedRowHandleCore(newRowHandle);
			if(IsInitialized) {
				DataController.CurrentControllerRow = FocusedRowHandle;
				if(fLockUpdate == 0) {
					RefreshRow(currentRowHandle, false);
					RefreshRow(newRowHandle, false);
					if(currentRowHandle != prevFocused) 
						RefreshRow(prevFocused, false);
				}
				MakeRowVisible(FocusedRowHandle, true);
			}
			if(prevFocused == GridControl.AutoFilterRowHandle) UpdateMRU();
			base.DoChangeFocusedRow(prevFocused, FocusedRowHandle, raiseUpdateCurrentRow);
		}
		void UpdateLeftCoord(int value) {
			this.leftCoord = value;
			if(IsLockUpdate) return;
			ViewInfo.CalcAfterHorzScroll(null, ViewRect);
			Invalidate();
		}
		protected virtual void DoLeftCoordChanged() {
			CloseEditor();
			if(fLockUpdate != 0) return;
			ViewInfo.CalcAfterHorzScroll(null, ViewRect);
			UpdateScrollBars();
			InvalidateRows();
			InvalidateColumnHeader(null);
			InvalidateFooter();
			RaiseLeftCoordChanged();
		}
		protected virtual void DoTopRowIndexChanged(int prevTopRowIndex) {
			if(fLockUpdate != 0) return;
			CloseEditor();
			if(!IsScrolling) HideHint();
			if(GridControl != null && GridControl.IsHandleCreated) {
				OnHotTrackLeave(CalcHitInfo(PointToClient(Control.MousePosition)));
			}
			DataController.ScrollingCancelAllGetRows();
			RefreshRows(true, true);
			if(IsServerMode) {
				for(int n = 0; n < ViewInfo.RowsInfo.Count; n++) {
					DataController.ScrollingCheckRowLoaded(ViewInfo.RowsInfo[n].RowHandle);
				}
			}
			EventHandler handler = (EventHandler)this.Events[topRowChanged];
			if(handler != null) handler(this, EventArgs.Empty);
		}
		protected virtual void RefreshRows(bool useCache, bool afterScroll) {
			if(!IsInitialized) return;
			if(afterScroll) CheckViewInfo();
			if(ViewInfo.IsReady) {
				ViewInfo.CalcAfterVertScroll(null, ViewRect, useCache);
				UpdateScrollBars();
				if(afterScroll && Painter.DrawScrolledContents(ViewInfo)) return;
				Invalidate();
			} else {
				LayoutChangedSynchronized();
			}
		}
		bool isDataSourceChanged = false;
		protected internal override void SetDataSource(BindingContext context, object dataSource, string dataMember) {
			this.isDataSourceChanged = false;
			base.SetDataSource(context, dataSource, dataMember);
			if(!IsCellSelect && isDataSourceChanged) SelectRow(FocusedRowHandle);
		}
		protected override void OnDataController_DataSourceChanged(object sender, EventArgs e) {
			this.isDataSourceChanged = true;
			if(ViewInfo != null) ViewInfo.AutoRowHeightCache.Clear();
			previewFieldHandle = -1;
			this.topRowIndex = 0;
			base.OnDataController_DataSourceChanged(sender, e);
			if(DataController != null && !DataController.IsReady) {
				BeginUpdate();
				try {
					foreach(GridColumn col in Columns) {
						col.ResetDataSummaryItem();
					}
				} finally {
					EndUpdateCore(true);
				}
			}
		}
		protected internal override void RefreshVisibleColumnsList() {
			base.RefreshVisibleColumnsList();
			if(ViewInfo == null) return;
			ViewInfo.UpdateFixedColumnInfo();
		}
		protected override void RefreshRow(int rowHandle, bool updateEditor, bool updateEditorValue) {
			if(!IsInitialized) return;
			GridRowInfo ri = ViewInfo.GetGridRowInfo(rowHandle);
			if(ri == null) return;
			ri.SetDataDirty();
			ri.RowState = GridRowCellState.Dirty;
			InvalidateRow(ri);
			base.RefreshRow(rowHandle, updateEditor, updateEditorValue);
		}
		protected override void SetEditingState() {
			SetStateInt((int)GridState.Editing);
		}
		protected virtual void UpdateSorting() {
			DataController.DoRefresh();
		}
		protected internal override bool GetCanShowEditor(GridColumn column) {
			if(column != null && IsFilterRow(FocusedRowHandle)) {
				if(!IsColumnAllowAutoFilter(column)) return false;
				return true;
			}
			return base.GetCanShowEditor(column);
		}
		Rectangle GetEditorBounds(GridCellInfo cell) {
			Rectangle r = cell.CellValueRect;
			Rectangle bounds = ViewInfo.UpdateFixedRange(r, cell.ColumnInfo);
			if(bounds.Right > ViewInfo.ViewRects.Rows.Right) {
				bounds.Width = ViewInfo.ViewRects.Rows.Right - bounds.Left;
			}
			if(bounds.Bottom > ViewInfo.ViewRects.Rows.Bottom) {
				bounds.Height = ViewInfo.ViewRects.Rows.Bottom - bounds.Top;
			}
			if(bounds.Width < 1 || bounds.Height < 1) return Rectangle.Empty;;
			return bounds;
		}
		protected virtual AppearanceObject GetEditorAppearance() {
			if(OptionsSelection.EnableAppearanceFocusedCell)
				return ViewInfo.PaintAppearance.FocusedCell;
			if(OptionsSelection.EnableAppearanceFocusedRow)
				return ViewInfo.PaintAppearance.FocusedRow;
			return ViewInfo.PaintAppearance.Row;
		}
		protected virtual void ActivateEditor(GridCellInfo cell) {
			if(cell == null) return;
			if(cell.MergedCell != null) return;
			if(!cell.ColumnInfo.Column.OptionsColumn.AllowEdit && !IsFilterRow(FocusedRowHandle)) {
				return;
			}
			this.fEditingCell = cell;
			Rectangle bounds = GetEditorBounds(cell);
			if(bounds.IsEmpty) return;
			RepositoryItem cellEdit = RequestCellEditor(cell);
			ViewInfo.UpdateCellAppearance(cell);
			ViewInfo.RequestCellEditViewInfo(cell);
			AppearanceObject appearance = new AppearanceObject();
			AppearanceHelper.Combine(appearance, new AppearanceObject[] { GetEditorAppearance(), ViewInfo.PaintAppearance.Row, cell.Appearance } );
			if(cellEdit != cell.Editor && cellEdit.DefaultAlignment != HorzAlignment.Default) {
				appearance.TextOptions.HAlignment = cellEdit.DefaultAlignment;
			}
			UpdateEditor(cellEdit, new UpdateEditorInfoArgs(GetColumnReadOnly(cell.ColumnInfo.Column), bounds, appearance, cell.CellValue, ElementsLookAndFeel, cell.ViewInfo.ErrorIconText, cell.ViewInfo.ErrorIcon));
			ViewInfo.UpdateCellAppearance(cell, true);
			if(cell != null)
				InvalidateRow(cell.RowHandle);
		}
		protected virtual RepositoryItem RequestCellEditor(GridCellInfo cell) {
			CustomRowCellEditEventHandler handler = (CustomRowCellEditEventHandler)Events[customRowCellEditForEditing];
			if(handler == null) return cell.Editor;
			CustomRowCellEditEventArgs args = new CustomRowCellEditEventArgs(cell.RowHandle, cell.Column, cell.Editor);
			handler(this, args);
			return args.RepositoryItem;
		}
		protected internal override int CalcRealViewHeight(Rectangle viewRect) {
			if(RequireSynchronization != SynchronizationMode.None) {
				CheckSynchronize();
				calculatedRealViewHeight = -1;
			}
			if(calculatedRealViewHeight != -1 && viewRect.Size == ViewRect.Size)
				return calculatedRealViewHeight;
			int result = viewRect.Height;
			GridViewInfo tempViewInfo = BaseInfo.CreateViewInfo(this) as GridViewInfo,
				oldViewInfo = ViewInfo, copyFromInfo = ViewInfo;
			this.fViewInfo = tempViewInfo;
			RefreshVisibleColumnsList();
			for(int i = 0; i < (oldViewInfo.IsReady ? 1 : 2); i++) {
				try {
					ViewInfo.PrepareCalcRealViewHeight(viewRect, copyFromInfo);
					result = ViewInfo.CalcRealViewHeight(viewRect);
				}
				catch {
				}
				copyFromInfo = ViewInfo;
			}
			this.fViewInfo = oldViewInfo;
			calculatedRealViewHeight = result;
			return result;
		}
		protected internal override BaseView CanMoveFocusedRow(int delta) {
			int frh = FocusedRowHandle;
			if( frh == GridView.InvalidRowHandle) {
				frh = GetVisibleRowHandle(0);
				if(frh == GridView.InvalidRowHandle) 
					return null;
			}
			int fv = GetVisibleIndex(frh);
			fv += delta;
			BaseView result = this;
			if(fv < 0) result = null;
			if(fv >= RowCount) 
				result = null;
			if(result == null && IsDetailView) 
				result = ParentView.CanMoveFocusedRow(delta);
			return result;
		}
		protected internal override void OnChildLayoutChanged(BaseView childView) {
			if(internalUpdateCount > 0) {
				return;
			}
			internalUpdateCount ++;
			try {
				LayoutChanged();
				if(childView.NeedReLayout)
					childView.LayoutChanged();
			}
			finally {
				internalUpdateCount --;
			}
		}
		protected internal override void CollapseDetail(BaseView view) {
			if(DataController != null) {
				DataController.CollapseDetailRowByOwner(view);
				LayoutChanged();
			}
		}
		protected internal override void CollapseDetails(int rowHandle) {
			if(DataController != null) {
				bool expanded = GetMasterRowExpanded(rowHandle);
				DataController.CollapseDetailRow(rowHandle);
				LayoutChanged();
				if(expanded) RaiseMasterRowCollapsed(rowHandle, -1);
			}
		}
		protected internal override void OnColumnSizeChanged(GridColumn column) {
			if(IsDeserializing) return;
			if(column.VisibleIndex > -1) {
				if(!OptionsView.ColumnAutoWidth) {
					OnPropertiesChanged();
					return;
				}
				RecalcRealColumnWidthes();
				ViewInfo.RecalcColumnWidthes(column);
				RecalcRealColumnWidthes();
				OnPropertiesChanged();
			}
		}
		protected internal override bool CanShowColumnInCustomizationForm(GridColumn col) {
			if(!col.OptionsColumn.ShowInCustomizationForm) return false;
			if(!OptionsCustomization.AllowColumnMoving || !col.OptionsColumn.AllowMove || !col.OptionsColumn.AllowShowHide) return false;
			return (col.VisibleIndex < 0 && (col.GroupIndex < 0 || OptionsView.ShowGroupedColumns));
		}
		protected internal override GridColumn GetNearestCanFocusedColumn(GridColumn col, int delta, bool allowChangeFocusedRow, KeyEventArgs e) {
			GridColumn res = GetNearestCanFocusedColumnCore(col, delta, allowChangeFocusedRow, e);
			if(res == null && !allowChangeFocusedRow) {
				if(FocusedColumn != null && FocusedColumn.OptionsColumn.AllowFocus) return FocusedColumn;
				return GetNearestCanFocusedColumnCore(GetVisibleColumn(0), 0, false, e);
			}
			return res;
		}
		GridColumn GetNearestCanFocusedColumnCore(GridColumn col, int delta, bool allowChangeFocusedRow, KeyEventArgs e) {
			bool isFilter = IsFilterRow(FocusedRowHandle);
			GridColumn prevFocused = FocusedColumn;
			if(col == null) return FocusedColumn;
			if(delta == 0) {
				if((isFilter ? IsColumnAllowAutoFilter(col) : col.OptionsColumn.AllowFocus) && (e.KeyCode != Keys.Tab || col.OptionsColumn.TabStop)) {
					return col;
				}
				if(col.VisibleIndex == VisibleColumns.Count - 1)
					delta = -1;
				else
					delta = 1;
			}
			int vIndex = col.VisibleIndex;
			vIndex += delta;
			int oIndex = -100, stopCount = 0;
			for(;;) {
				if(vIndex >= VisibleColumns.Count) {
					vIndex = VisibleColumns.Count - 1; 
					stopCount ++;
				}
				if(vIndex < 0) { 
					vIndex = 0;
					stopCount ++;
				}
				if(stopCount > 2) {
					col = prevFocused;
					break;
				}
				if(oIndex == -100) oIndex = vIndex;
				else {
					if(vIndex == oIndex) break;
				}
				GridColumn c = GetVisibleColumn(vIndex);
				if(c == null) break;
				vIndex += delta;
				if((isFilter ? !IsColumnAllowAutoFilter(c) : !c.OptionsColumn.AllowFocus) || (e.KeyCode == Keys.Tab && !c.OptionsColumn.TabStop)) {
					if(vIndex == oIndex) break;
					continue;
				}
				col = c;
				break;
			}
			if(col != null && ((isFilter ? !IsColumnAllowAutoFilter(col) : !col.OptionsColumn.AllowFocus) || (e.KeyCode == Keys.Tab && !col.OptionsColumn.TabStop))) col = null;
			if(allowChangeFocusedRow && col != null && prevFocused == col) {
				int prevRow = FocusedRowHandle;
				Keys byKey = e.KeyCode;
				if(e.KeyValue == 0) byKey = delta < 0 ? Keys.Left : Keys.Right;
				DoMoveFocusedRow((delta < 0 ? -1 : 1), byKey, e);
				if(prevRow != FocusedRowHandle && !IsGroupRow(FocusedRowHandle))
					col = GetNearestCanFocusedColumn((delta > 0 ? GetVisibleColumn(0) : GetVisibleColumn(VisibleColumns.Count - 1)), 0, false, e);
			}
			return col;
		}
		protected internal override void OnEmbeddedNavigatorSizeChanged() {
			if(ViewDisposing || !IsInitialized) return;
			base.OnEmbeddedNavigatorSizeChanged();
			ScrollInfo.LayoutChanged();
		}
		protected internal override void DoMoveFocusedRow(int delta, Keys byKey, KeyEventArgs e) {
			int prevFocusedHandle = FocusedRowHandle;
			GridColumn prevFocusedColumn = FocusedColumn;
			if(!DoBeforeMoveFocusedRow(delta, byKey, e)) return;
			try {
				if(FocusedRowHandle == DevExpress.Data.DataController.InvalidRow && RowCount > 0) {
					FocusedRowHandle = GetVisibleRowHandle(0);
					return;
				}
				int minVisibleIndex = OptionsView.NewItemRowPosition == NewItemRowPosition.Top ? -1 : 0;
				int fv = Math.Max(GetVisibleIndex(FocusedRowHandle), minVisibleIndex);
				if(FocusedRowHandle == GridControl.AutoFilterRowHandle) fv = -1;
				BaseView detail = null;
				fv += delta;
				if(byKey == Keys.Down || byKey == Keys.Up) {
					if(e.Alt) {
						int handle = byKey == Keys.Down ? DataController.GetNextSibling(FocusedRowHandle) : DataController.GetPrevSibling(FocusedRowHandle);
						fv = GetVisibleIndex(handle);
					}
					else {
					if(IsDetailView && !IsZoomedView) {
						if(fv < minVisibleIndex) {
							if(!CheckCanLeaveRow(FocusedRowHandle, true)) return;
							FocusCreator();
							GridControl.FocusedView = ParentView;
							return; 
						}
						if(fv >= RowCount) {
							if(byKey == Keys.Down) {
								if(IsMasterRow(FocusedRowHandle) && GetMasterRowExpanded(FocusedRowHandle)) {
									detail = GetVisibleDetailView(FocusedRowHandle);
									if(detail != null) {
										if(!CheckCanLeaveRow(FocusedRowHandle, true)) return;
										GridControl.FocusedView = detail;
										return;
									}
								}
							}
							detail = ParentView.CanMoveFocusedRow(1);
							if(detail != null && detail.IsVisible) {
								if(!CheckCanLeaveRow(FocusedRowHandle, true)) return;
								FocusCreator();
								GridControl.FocusedView = detail;
								detail.DoMoveFocusedRow(1, Keys.None);
								return;
							}
						}
					}
					if(byKey == Keys.Down) {
						if(IsMasterRow(FocusedRowHandle) && GetMasterRowExpanded(FocusedRowHandle)) {
							if(!CheckCanLeaveRow(FocusedRowHandle, true)) return;
							GridControl.FocusedView = GetVisibleDetailView(FocusedRowHandle);
							return;
						}
					}
				}
				}
				if(fv < minVisibleIndex) fv = minVisibleIndex;
				if(fv >= RowCount) fv = RowCount - 1;
				FocusedRowHandle = GetVisibleRowHandle(fv);
				if(prevFocusedHandle != FocusedRowHandle && byKey == Keys.Up) {
					if(IsMasterRow(FocusedRowHandle) && GetMasterRowExpanded(FocusedRowHandle)) {
						if(!CheckCanLeaveRow(FocusedRowHandle, true)) return;
						GridControl.FocusedView = GetVisibleDetailView(FocusedRowHandle);
					}
				}
			}
			finally {
				DoAfterMoveFocusedRow(byKey, prevFocusedHandle, null, null);
			}
		}
		protected internal override void OnColumnWidthChanged(GridColumn column) { 
			base.OnColumnWidthChanged(column);
			RaiseColumnWidthChanged(new ColumnEventArgs(column));
		}
		protected virtual void EndColumnSizing() {
			GridColumn col = Painter.ReSizingObject as GridColumn;
			GridColumnInfoArgs ci = ViewInfo.ColumnsInfo[col];
			if(ci != null) {
				int newSize = Painter.CurrentSizerPos - ci.Bounds.Left;
				if(newSize < 0) newSize = ci.Bounds.Right - Painter.CurrentSizerPos;
				if(newSize < GetColumnMinWidth(col)) newSize = GetColumnMinWidth(col);
				if(GetColumnMaxWidth(col) > 0) newSize = Math.Min(newSize, GetColumnMaxWidth(col));
				col.Resize(newSize);
			}
		}
		protected virtual void EndRowSizing() {
			int rowHandle = (int)(Painter.ReSizingObject);
			GridRowInfo ri = ViewInfo.GetGridRowInfo(rowHandle);
			if(ri == null) return;
			int height = (Painter.CurrentSizerPos - ri.DataBounds.Top) / ViewInfo.RowLineCount;
			if(height > 0)
				RowHeight = height;
		}
		protected virtual void EndRowDetailSizing() {
			int rowHandle = (int)(Painter.ReSizingObject);
			GridDataRowInfo ri = ViewInfo.GetGridRowInfo(rowHandle) as GridDataRowInfo;
			if(ri == null) return;
			int height = Painter.CurrentSizerPos - ri.DetailBounds.Top;
			BaseView gv = GetVisibleDetailView(rowHandle);
			if(gv != null && height > 0) 
				gv.DetailHeight = height;
		}
		internal void EndSizingCore() { EndSizing(); }
		protected virtual void EndSizing() {
			Painter.HideSizerLine();
			if(Painter.StartSizerPos != Painter.CurrentSizerPos && Painter.ReSizingObject != null) {
				if(State == GridState.ColumnSizing) {
					EndColumnSizing();
				}
				if(State == GridState.RowDetailSizing) {
					EndRowDetailSizing();
				}
				if(State == GridState.RowSizing) {
					EndRowSizing();
				}
			}
			Painter.StopSizing();
		}
		protected internal virtual int GetColumnIndent(GridColumn column) {
			int result = 0;
			if(!IsInitialized) return 0;
			if(IsFirstVisibleColumn(column)) {
				if(IsShowDetailButtons) 
					result += ViewInfo.PlusMinusButtonSize.Width;
				result += ViewInfo.CalcRowLevelIndent(null, SortInfo.GroupCount);
			}
			return result;
		}
		protected virtual bool IsFirstVisibleColumn(GridColumn column) {
			return column.VisibleIndex == 0;
		}
		protected internal override bool GetColumnAllowMerge(GridColumn column) {
			DefaultBoolean opt = column.OptionsColumn.AllowMerge;
			if(!IsLoading && opt == DefaultBoolean.Default) {
				if(column.GetIsNonSortableEditor()) return false;
				opt = DefaultBoolean.True;
			}
			bool res = opt != DefaultBoolean.False;
			if(!res || IsLoading || ViewInfo == null) return res;
			return column.VisibleIndex != 0 || !ViewInfo.ShowDetailButtons;
		}
		protected internal override int GetColumnMaxWidth(GridColumn column) {
			if(column.MaxWidth == 0) return 0;
			return column.MaxWidth + GetColumnIndent(column);
		}
		protected internal override int GetColumnMinWidth(GridColumn column) {
			int r = column.MinWidth;
			int result = r + GetColumnIndent(column);
			return result;
		}
		protected internal virtual AppearanceObject GetLevelStyle(int level) {
			AppearanceObject appearance = ViewInfo.PaintAppearance.GroupRow;
			GroupLevelStyleEventHandler handler = (GroupLevelStyleEventHandler)this.Events[groupLevelStyle];
			if(handler == null) return appearance;
			GroupLevelStyleEventArgs e = new GroupLevelStyleEventArgs(level, appearance.Clone() as AppearanceObject);
			handler(this, e);
			return e.LevelAppearance;
		}
		public virtual Hashtable GetGroupSummaryValues(int rowHandle) {
			return DataController.GetGroupSummary(rowHandle);
		}
		public object GetGroupSummaryValue(int rowHandle, GridGroupSummaryItem summaryItem) {
			if(summaryItem == null) throw new ArgumentNullException("summaryItem");
			Hashtable hash = GetGroupSummaryValues(rowHandle);
			if(hash == null) return null;
			return hash[summaryItem];
		}
		public string GetGroupSummaryDisplayText(int rowHandle, GridGroupSummaryItem summaryItem) {
			if(summaryItem == null) throw new ArgumentNullException("summaryItem");
			Hashtable hash = GetGroupSummaryValues(rowHandle);
			if(hash == null || !hash.ContainsKey(summaryItem)) return null;
			object val = hash[summaryItem];
			return summaryItem.GetDisplayText(val, true);
		}
		public virtual string GetGroupSummaryText(int rowHandle) {
			string result = "";
			Hashtable summary = GetGroupSummaryValues(rowHandle);
			if(summary == null) return result;
			int maxCount = summary.Count, n;
			object[] items = new object[maxCount];
			for(n = 0; n < maxCount; n++) { items[n] = null; }
			n = 0;
			foreach(DictionaryEntry dEntry in summary) {
				GridGroupSummaryItem item = dEntry.Key as GridGroupSummaryItem;
				if(item.ShowInGroupColumnFooter != null) continue; 
				items[n++] = dEntry;
			}
			if(n == 0) return result;
			Array.Sort(items, summaryComparer);
			for(n = 0; n < maxCount; n++) {
				if(items[n] == null) continue;
				GridGroupSummaryItem item = ((DictionaryEntry)items[n]).Key as GridGroupSummaryItem;
				result += (result.Length != 0 ? ", " : "") + item.GetDisplayText(((DictionaryEntry)items[n]).Value, true);
			}
			return result;
		}
		public virtual DictionaryEntry GetRowSummaryItem(int rowHandle, GridColumn column) {
			if(column == null) return new DictionaryEntry();
			Hashtable summary = GetGroupSummaryValues(rowHandle);
			if(summary == null) return new DictionaryEntry();
			foreach(DictionaryEntry dEntry in summary) {
				GridGroupSummaryItem item = dEntry.Key as GridGroupSummaryItem;
				if(item.ShowInGroupColumnFooter != column) continue;
				return dEntry;
			}
			return new DictionaryEntry();
		}
		public virtual string GetRowFooterCellText(int rowHandle, GridColumn column) {
			string result = "";
			DictionaryEntry dEntry = GetRowSummaryItem(rowHandle, column);
			if(dEntry.Key == null) return result;
			GridGroupSummaryItem item = dEntry.Key as GridGroupSummaryItem;
			return item.GetDisplayText(dEntry.Value, false);
		}
		public virtual bool IsShowRowFooterCell(int rowHandle, GridColumn column) {
			int gCount = GroupSummary.Count;
			if(GroupSummary.ActiveCount == 0) return false;
			if(column == null) return false;
			for(int n = 0; n < gCount; n++) {
				GridGroupSummaryItem item = GroupSummary[n] as GridGroupSummaryItem;
				if(item.SummaryType != SummaryItemType.None && item.ShowInGroupColumnFooter == column) return true;
			}
			return false;
		}
		public virtual object GetGroupRowPrintValue(int rowHandle) {
			int level = GetRowLevel(rowHandle);
			if(level > -1 && level < GroupCount) {
				DevExpress.XtraEditors.Repository.RepositoryItem ritem = GetRowCellRepositoryItem(rowHandle, SortInfo[level].Column);
				if(ritem == null || ritem.ExportMode == ExportMode.Value)
					return GetGroupRowValue(rowHandle);
				else
					return GetGroupRowDisplayText(rowHandle);
			}
			return GetGroupRowValue(rowHandle);
		}
		public virtual object GetGroupRowValue(int rowHandle) {
			int level = GetRowLevel(rowHandle);
			if(level > -1 && level < GroupCount) return DataController.GetGroupRowValue(rowHandle, SortInfo[level].Column.ColumnInfo);
			return DataController.GetGroupRowValue(rowHandle);
		}
		public virtual object GetGroupRowValue(int rowHandle, GridColumn column) {
			if(column == null) return GetGroupRowValue(rowHandle);
			return DataController.GetGroupRowValue(rowHandle, column.ColumnInfo);
		}
		protected internal virtual string GetGroupRowDisplayText(int rowHandle, bool fullText, out string groupValueDisplayText) {
			groupValueDisplayText = string.Empty;
			string s;
			int rowLevel = GetRowLevel(rowHandle);
			GridColumn column = rowLevel < SortInfo.GroupCount ? SortInfo[rowLevel].Column : null;
			if(column == null) return "";
			object val = GetGroupRowValue(rowHandle, column);
			GridDataColumnSortInfo info = SortData.GetSortInfo(column);
			if(info != null) val = info.UpdateGroupDisplayValue(val);
			s = GetGroupRowDisplayText(rowHandle, column, val, info == null ? column.GroupFormat : info.GetColumnGroupFormat());
			if(info != null) {
				s = info.GetGroupDisplayText(val, s);
				if(!info.AllowImageGroup) fullText = false;
			}
			groupValueDisplayText = s;
			string s2 = GetGroupSummaryText(rowHandle);
			string res = String.Format(GroupFormat, column.GetTextCaption(), s, s2);
			if(!fullText) res = res.Replace(DevExpress.XtraEditors.Drawing.BaseEditorGroupRowPainter.ImageText, "");
			return res;
		}
		public virtual string GetGroupRowDisplayText(int rowHandle, bool fullText) {
			string text;
			return GetGroupRowDisplayText(rowHandle, fullText, out text);
		}
		public string GetGroupRowDisplayText(int rowHandle) { return GetGroupRowDisplayText(rowHandle, false); }
		public virtual int GetRowLevel(int rowHandle) {
			return DataController.GetRowLevel(rowHandle);
		}
		public virtual string GetRowPreviewDisplayText(int rowHandle) {
			string s = "";
			if(PreviewFieldName.Length != 0 && DataController.IsReady) 
				s = DataController.GetRowDisplayText(rowHandle, PreviewFieldHandle);
			RaiseGetPreviewDisplayText(rowHandle, ref s);
			if(DesignMode && s == "") {
				int lineCount = Math.Min(10, PreviewLineCount < 1 ? 1 : PreviewLineCount);
				for(int n = 0; n < lineCount; n ++) {
					s += string.Format("Preview line {0}\xd\xa", n + 1);
				}
			}
			return s;
		}
		public virtual bool IsShowRowFooters() {
			if(GroupFooterShowMode == GroupFooterShowMode.Hidden) return false;
			if(SortInfo.GroupCount == 0) return false;
			return true;
		}
		public virtual bool IsExistAnyRowFooterCell(int rowHandle) {
			foreach(GridColumn col in Columns) {
				if(col.VisibleIndex == -1) continue;
				if(IsShowRowFooterCell(rowHandle, col)) return true;
			}
			return false;
		}
		public virtual int GetVisibleRowLevel(int rowVisibleIndex) {
			return GetRowLevel(DataController.GetControllerRowHandle(rowVisibleIndex));
		}
		protected internal override void OnGotFocus() {
			if(InternalFocusLock != 0) return;
			base.OnGotFocus();
			RefreshRow(FocusedRowHandle, false, false);
			if(IsMultiSelect && SelectedRowsCount > 0) InvalidateRows();
		}
		protected internal override void OnLostFocus() {
			if(InternalFocusLock != 0) return;
			base.OnLostFocus();
			InvalidateRow(FocusedRowHandle);
			if(IsMultiSelect && SelectedRowsCount > 0) InvalidateRows();
		}
		internal void HideDetailTip() {
			detailTip.HideTip();
		}
		internal void CloseActiveEditor() {
			if(GridControl == null) return;
			if(GridControl.FocusedView != this && GridControl.FocusedView != null) {
				GridControl.FocusedView.CloseEditor();
			}
			CloseEditor();
		}
		int prevTopRowIndex = -1;
		[Browsable(false)]
		public int PrevTopRowIndex { get { return prevTopRowIndex; } }
		protected virtual void InternalSetTopRowIndex(int newTopRowIndex) {
			if(newTopRowIndex >= RowCount) newTopRowIndex = RowCount - 1;
			if(newTopRowIndex < 0) newTopRowIndex = 0;
			if(newTopRowIndex == TopRowIndex) return;
			CloseActiveEditor();
			prevTopRowIndex = topRowIndex;
			topRowIndex = newTopRowIndex;
			DoTopRowIndexChanged(prevTopRowIndex);
		}
		protected virtual void RecalcRealColumnWidthes() {
			if(!OptionsView.ColumnAutoWidth) return;
			int colCount = VisibleColumns.Count;
			for(int i = 0; i < colCount; i++) {
				GridColumn col = GetVisibleColumn(i);
				int minWidth = GetColumnMinWidth(col), maxWidth = GetColumnMaxWidth(col);
				col.InternalSetWidth(col.VisibleWidth);
				if(col.width < minWidth) col.InternalSetWidth(minWidth);
				if(col.width > maxWidth && maxWidth > 0) col.InternalSetWidth(maxWidth);
			}
		}
		protected override bool CanUseFixedStyle { get { return true; } } 
		protected internal override void SetColumnFixedStyle(GridColumn column, FixedStyle newValue) {
			if(IsLoading || IsDeserializing) return;
			RefreshVisibleColumnsList();
			OnPropertiesChanged();
		}
		protected internal override void SetColumnVisibleIndex(GridColumn column, int newValue) {
			base.SetColumnVisibleIndex(column, newValue);
			UpdateColumnsCustomization();
		}
		internal void ShowDetailTipCore(GridHitInfo hi) { ShowDetailTip(hi); }
		protected virtual void ShowDetailTip(GridHitInfo hi) {
			if(!OptionsDetail.EnableDetailToolTip ||
				DataController == null ||	GetRelationCount(hi.RowHandle) < 1) 
				return;
			if(detailTip.RowHandle == hi.RowHandle) {
				return;
			}
			GridDetailInfo[] details = GetDetailInfo(hi.RowHandle, false);
			HideDetailTip();
			detailTip.RowHandle = GridControl.InvalidRowHandle;
			if(details == null || details.Length == 0) return;
			if(details.Length == 1 && GetMasterRowExpanded(hi.RowHandle)) return;
			GridRowInfo ri = ViewInfo.GetGridRowInfo(hi.RowHandle);
			GridCellInfo cell = ViewInfo.GetGridCellInfo(hi);
			AppearanceObject appearance = ViewInfo.PaintAppearance.DetailTip;
			detailTip.RowHandle = hi.RowHandle;
			detailTip.Location = new Point(cell.CellValueRect.Left, cell.Bounds.Top);
			detailTip.Font = appearance.Font;
			detailTip.ForeColor = appearance.ForeColor;
			detailTip.BackColor = appearance.BackColor;
			detailTip.Size = detailTip.CalcSize(details);
			if(!detailTip.CanShowTip) return;
			if(detailTip.Right > ViewInfo.ViewRects.Client.Right) {
				int width = detailTip.Size.Width - (detailTip.Right - ViewInfo.ViewRects.Client.Right);
				if(width < 10) {
					HideDetailTip();
					return;
				}
				detailTip.Size = new Size(width, detailTip.Size.Height);
			}
			if(detailTip.Bottom > ViewInfo.ViewRects.Client.Bottom) {
				detailTip.Top -= (detailTip.Bottom - ViewInfo.ViewRects.Client.Bottom);
			}
			if(GridControl.Controls.GetChildIndex(detailTip, false) == -1) {
				GridControl.Controls.Add(detailTip);
			}
			detailTip.ShowTip();
		}
		protected virtual void StopColumnDragging() {
			GridControl.DragController.CancelDrag();
			ViewInfo.SelectionInfo.ClearPressedInfo();
		}
		protected internal override void OnVisibleChanged() {
			base.OnVisibleChanged();
			if(GridControl != null && GridControl.Visible) {
				ScrollInfo.UpdateVisiblity();
			}
			if(GridControl != null && (!GridControl.Visible || GridControl.FindForm() == null || !GridControl.FindForm().Visible)) {
				DestroyCustomization();
				if(State == GridState.ColumnDragging) SetState((int)GridState.Normal);
			}
		}
		protected override void OnActiveFilterEnabledChanged() {
			base.OnActiveFilterEnabledChanged();
			MakeRowVisible(FocusedRowHandle, false);
		}
		protected override void RaiseColumnFilterChanged() {
			MakeRowVisible(FocusedRowHandle, false);
			TopRowIndex = CheckTopRowIndex(TopRowIndex);
			base.RaiseColumnFilterChanged();
		}
		protected override void SetViewRect(Rectangle newValue) {
			if(ViewRect == newValue) return;
			if(newValue.Width < 0 || newValue.Height < 0)
				newValue = Rectangle.Empty;
			if(ViewDisposing) {
				this.fViewRect = Rectangle.Empty;
				return;
			}
			if(this.fViewRect == newValue) return;
			try {
				fUpdateSize ++;
				bool gridSizeChanged = true;
				int prevCalc = -1;
				if(newValue.Width == this.fViewRect.Width && newValue.Height == fViewRect.Height) {
					prevCalc = calculatedRealViewHeight;
					gridSizeChanged = false;
				}
				if(newValue.IsEmpty) {
					ScrollInfo.ClientRect = newValue;
					prevCalc = -1;
					gridSizeChanged = false;
				} else {
					if(this.fViewRect.IsEmpty) {
						CheckSynchronize();
					}
				}
				try {
					this.fViewRect = newValue;
					LayoutChangedSynchronized();
				}
				finally {
					if(!gridSizeChanged) {
						calculatedRealViewHeight = prevCalc;
					}
				}
				if(gridSizeChanged && IsVisible) {
					InternalSetTopRowIndex(CheckTopRowIndex(TopRowIndex)); 
				}
			}
			finally {
				fUpdateSize --;
			}
		}
		protected internal virtual bool IsCellMerge {
			get {
				return OptionsView.AllowCellMerge && !OptionsView.ShowPreview && RowSeparatorHeight == 0;
			}
		}
		[Browsable(false)]
		public override Rectangle ViewRect {
			get { return fViewRect; }
		}
		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public virtual GridState State { get { return state; } }
		[Description("Indicates whether multiple rows are allowed to be selected.")]
		public override bool IsMultiSelect { get { return base.IsMultiSelect && !OptionsView.AllowCellMerge; } }
		[Browsable(false), DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
		public virtual bool IsCellSelect { get { return IsMultiSelect && OptionsSelection.MultiSelectMode != GridMultiSelectMode.RowSelect; } }
		protected internal override bool IsAllowZoomDetail {
			get { return OptionsDetail.AllowZoomDetail; }
		}
		protected internal override bool IsAutoCollapseDetail {
			get { return OptionsDetail.AutoZoomDetail; }
		}
		[Description("Gets a value indicating whether the View is visible on screen.")]
		public override bool IsVisible {
			get { return ViewRect.X > -10000 && !ViewRect.IsEmpty && ViewRect.Right > 0 && ViewRect.Bottom > 0; }
		}
		protected internal override bool NeedReLayout { 
			get { return !OptionsView.ColumnAutoWidth || true; }
		}
		protected internal virtual ScrollInfo ScrollInfo { get { return scrollInfo; } }
		protected internal override void CreateHandles() {
			base.CreateHandles();
			if(IsLoading) return;
			if(ScrollInfo != null && GridControl.IsHandleCreated) ScrollInfo.CreateHandles();
		}
		protected virtual int StateInt { get { return (int)state; } }
		protected virtual void SetStateInt(int newState) {
			this.state = (GridState)newState;
		}
		protected internal virtual bool DoIncrementalSearch(string text) {
			if(text == IncrementalText) {
				return false;
			}
			System.Diagnostics.Debug.WriteLine(string.Format("StartIncremental '{0}' - '{1}'",
				text, IncrementalText));
			if(text != "") {
				int newRow = FindRow(new FindRowArgs(FocusedRowHandle, FocusedColumn, text, true), 
					delegate(object completed) { 
						IncrementalSearchResult((int)completed, text, true);
					});
				if(newRow == BaseGridController.OperationInProgress) {
					IncrementalText = text;
					return true;
				}
				if(newRow == GridControl.InvalidRowHandle) return true;
				IncrementalSearchResult(newRow, text, false);
			}
			return true;
		}
		protected override void OnAsyncTotalsReceived() {
			if(WorkAsLookup) return;
			if(!IsValidRowHandle(FocusedRowHandle)) FocusedRowHandle = GetVisibleRowHandle(0);
			if(GroupCount > 0 && IsDataRow(FocusedRowHandle) && !DataController.IsRowVisible(FocusedRowHandle)) {
				FocusedRowHandle = GetVisibleRowHandle(0);
			} 
		}
		string lastValidIncrementalText = "";
		protected void IncrementalSearchResult(int row, string text, bool isAsync) {
			System.Diagnostics.Debug.WriteLine(string.Format(" + Incremental {0} - '{1}' - '{2}'",
				row, text, IncrementalText));
			if(row == GridControl.InvalidRowHandle) {
				if(isAsync) {
					if(!string.IsNullOrEmpty(lastValidIncrementalText) && IncrementalText.StartsWith(lastValidIncrementalText)) {
						IncrementalText = lastValidIncrementalText;
						System.Diagnostics.Debug.WriteLine(string.Format(" + Reset to {0}", lastValidIncrementalText));
					}
					else {
						IncrementalText = "";
						System.Diagnostics.Debug.WriteLine(string.Format(" + Reset to zero"));
					}
				}
				return;
			}
			this.lastValidIncrementalText = text;
			SetStateCore(GridState.IncrementalSearch); 
			IncrementalText = text;
			FocusedRowHandle = row;
			SelectFocusedRowCore();
			SetStateCore(GridState.IncrementalSearch); 
			IncrementalText = text;
		}
		public void StartIncrementalSearch(string start) {
			if(start == null || start.Length == 0) return;
			DoIncrementalSearch(start);
		}
		public void StopIncrementalSearch() {
			if(State == GridState.IncrementalSearch) 
				SetState((int)GridState.Normal);
		}
		internal void SetStateCore(GridState val) { SetState((int)val); }
		protected virtual void SetState(int value) {
			if(StateInt == value) return;
			DestroyFilterPopup();
			if(value != (int)GridState.IncrementalSearch) {
				DataController.CancelFindIncremental();
				IncrementalText = "";
			}
			if(State == GridState.Scrolling) StopScrolling();
			if(State == GridState.Selection) EndAccessSelection();
			bool prevDrag = IsDraggingState, prevNormal = IsDefaultState;
			if(IsSizingState) 
				Painter.StopSizing();
			if(IsEditing) 
				CloseEditor();
			if(IsEditing && !fAllowCloseEditor) return;
			if(prevNormal && value != (int)GridState.Editing) {
				if(!UpdateCurrentRow()) return;
			}
			SetStateInt((int)value);
			if(IsDefaultState) 
				ViewInfo.SelectionInfo.ClearPressedInfo();
			else {
				HideHint();
			}
			if(prevDrag) {
				StopColumnDragging();
			}
			UpdateNavigator();
			OnStateChanged();
		}
		protected virtual void OnStateChanged() {
			if(State != GridState.ColumnDown && State != GridState.Normal) FireChanged();
		}
		protected internal virtual GridCellInfo EditingCell { get { return fEditingCell; } }
		protected internal new GridViewInfo ViewInfo { get { return base.ViewInfo as GridViewInfo; } }
		protected override string ViewName { get { return "GridView"; } }
		protected internal new GridPainter Painter { get { return base.Painter as GridPainter; } }
		protected override void UpdateSelectedTabPage(ViewTab tabControl, int rowHandle) {
			if(tabControl == null) return;
			int vIndex = GetVisibleDetailRelationIndex(rowHandle);
			ViewTabPage selectedPage = null;
			foreach(ViewTabPage page in tabControl.Pages) {
				if((int)page.Tag == vIndex) {
					selectedPage = page;
					break;
				}
			}
			if(selectedPage != null) tabControl.SelectedPage = selectedPage;
		}
		protected override void PopulateTabMasterData(ViewTab tabControl, int rowHandle) {
			tabControl.HeaderLocation = DetailTabHeaderLocation;
			GridDetailInfo[] details = GetDetailInfo(rowHandle, false);
			if(details == null) return;
			int vIndex = GetVisibleDetailRelationIndex(rowHandle);
			foreach(GridDetailInfo detail in details) {
				if(!OptionsDetail.AllowExpandEmptyDetails && IsMasterRowEmptyEx(rowHandle, detail.RelationIndex))
					continue;
				bool exp =  vIndex == detail.RelationIndex;
				ViewTabPage page = new ViewTabPage(tabControl);
				page.Text = detail.Caption.Trim();
				page.Tag = detail.RelationIndex;
				page.DetailInfo = detail;
				tabControl.Pages.Add(page);
				if(exp) tabControl.SelectedPage = page;
			}
		}
		protected override void OnChildViewTabChanging(BaseView baseView, DevExpress.XtraTab.ViewInfo.ViewInfoTabPageChangingEventArgs e) {
			CloseEditor();
			e.Cancel = !UpdateCurrentRow();
		}
		protected override void OnChildViewTabChanged(BaseView childView, DevExpress.XtraTab.ViewInfo.ViewInfoTabPageChangedEventArgs e) { 
			int sourceRowHandle = childView.SourceRowHandle;
			int relIndex = (int)((ViewTabPage)e.Page).Tag;
			bool autoZoom = false;
			if(childView == GridControl.DefaultView) autoZoom = true;
			bool prevAutoZoom = OptionsDetail.AutoZoomDetail, prevAllowZoom = OptionsDetail.AllowZoomDetail;
			if(autoZoom) {
				OptionsDetail.BeginUpdate();
				OptionsDetail.AllowZoomDetail = true;
				OptionsDetail.AutoZoomDetail = true;
				OptionsDetail.CancelUpdate();
			}
			try {
				VisualSetMasterRowExpandedEx(childView.SourceRowHandle, relIndex, true);
			}
			catch(HideException) {
				if(childView.TabControl != null) {
					int vIndex = GetVisibleDetailRelationIndex(childView.SourceRowHandle);
					if(vIndex < childView.TabControl.Pages.Count && vIndex >= 0)
						childView.TabControl.SelectedPage = childView.TabControl.Pages[vIndex];
				}
			}
			finally {
				if(autoZoom) {
					OptionsDetail.BeginUpdate();
					OptionsDetail.AllowZoomDetail = prevAllowZoom;
					OptionsDetail.AutoZoomDetail = prevAutoZoom;
					OptionsDetail.CancelUpdate();
				}
			}
			BaseView view = GetDetailView(sourceRowHandle, relIndex);
			if(view != null) view.Focus();
			if(view == null) view = childView;
			if(view != null && !view.ViewDisposing && view.TabControl != null) {
				view.TabControl.Populate();
				view.TabControl.LayoutChanged();
			}
		}
		public override DevExpress.XtraGrid.Export.BaseExportLink CreateExportLink(DevExpress.XtraExport.IExportProvider provider) {
#pragma warning disable 618
		   return new DevExpress.XtraGrid.Export.GridViewExportLink(this, provider);
#pragma warning restore 618
	   }
		protected internal override UserControl PrintDesigner { 
			get { 
				UserControl ctrl = new UserControl();
				DevExpress.XtraGrid.Frames.GridViewPrinting gvp = new DevExpress.XtraGrid.Frames.GridViewPrinting();
				gvp.InitFrame(this, "GridView", new Bitmap(16, 16));
				gvp.AutoApply = false;
				gvp.HideCaption();
				gvp.Dock = DockStyle.Fill;
				ctrl.Controls.Add(gvp);
				ctrl.Visible = true;
				ctrl.Dock = DockStyle.Fill;
				ctrl.Size = gvp.UserControlSize;
				return ctrl; 
			} 
		}
		protected new GridViewPrintInfo PrintInfo { get { return base.PrintInfo as GridViewPrintInfo; } }
		protected internal override bool IsSupportPrinting { get { return true; } }
		protected internal override bool IsRecreateOnMarginChanged { get { return OptionsPrint.AutoWidth; } }
		protected override BaseViewPrintInfo CreatePrintInfoInstance(PrintInfoArgs args) {
			return new GridViewPrintInfo(args);
		}
		GridSummaryComparer summaryComparer = new GridSummaryComparer();
		class GridSummaryComparer : IComparer {
			int IComparer.Compare(object a, object b) {
				if(a == b) return 0;
				if(a == null) return -1;
				if(b == null) return 1;
				GridSummaryItem item1 = ((DictionaryEntry)a).Key as GridSummaryItem;
				GridSummaryItem item2 = ((DictionaryEntry)b).Key as GridSummaryItem;
				return Comparer.Default.Compare(item1.Index, item2.Index);
			}
		}
		protected internal override GroupSummarySortInfoCollection GroupSummarySortInfoCore { get { return GroupSummarySortInfo; } }
		protected internal virtual void OnGroupSummarySortInfoCollectionChanged(CollectionChangeEventArgs e) {
			if(IsLoading) return;
			CheckLoaded();
			SynchronizeSortingAndGrouping();
			FireChanged();
		}
		bool IGridDesignTime.Enabled { get { return true; } }
		DragDropEffects IGridDesignTime.DoDragDrop(object obj) {
			GridHandler handler = Handler as GridHandler;
			GridControl.Capture = true;
			handler.DoStartDragObject(obj, Size.Empty);
			return DevExpress.XtraGrid.Dragging.DragManager.DragMaster.LastEffect;
		}
		#region Events
		protected internal override bool HasCustomColumnGroupEvent { get { return this.Events[customColumnGroup] != null; } }
		protected internal override void RaiseCustomColumnGroup(CustomColumnSortEventArgs e) {
			CustomColumnSortEventHandler handler = (CustomColumnSortEventHandler)this.Events[customColumnGroup];
			if(handler != null) handler(this, e);
		}
		protected virtual void RaiseColumnWidthChanged(ColumnEventArgs e) {
			ColumnEventHandler handler = (ColumnEventHandler)this.Events[columnWidthChanged];
			if(handler != null) handler(this, e);
		}
		protected virtual void RaiseLeftCoordChanged() {
			EventHandler handler = (EventHandler)this.Events[leftCoordChanged];
			if(handler != null) handler(this, EventArgs.Empty);
		}
		protected virtual bool RaiseGroupRowExpanding(int rowHandle) {
			RowAllowEventHandler handler = (RowAllowEventHandler)this.Events[groupRowExpanding];
			if(handler != null) {
				RowAllowEventArgs e = new RowAllowEventArgs(rowHandle, true);
				handler(this, e);
				return e.Allow;
			}
			return true;
		}
		protected virtual bool RaiseGroupRowCollapsing(int rowHandle) {
			RowAllowEventHandler handler = (RowAllowEventHandler)this.Events[groupRowCollapsing];
			if(handler != null) {
				RowAllowEventArgs e = new RowAllowEventArgs(rowHandle, true);
				handler(this, e);
				return e.Allow;
			}
			return true;
		}
		protected virtual void RaiseGroupRowCollapsed(int rowHandle) {
			RowEventHandler handler = (RowEventHandler)this.Events[groupRowCollapsed];
			if(handler != null) {
				RowEventArgs e = new RowEventArgs(rowHandle);
				handler(this, e);
			}
		}
		protected virtual void RaiseGroupRowExpanded(int rowHandle) {
			RowEventHandler handler = (RowEventHandler)this.Events[groupRowExpanded];
			if(handler != null) {
				RowEventArgs e = new RowEventArgs(rowHandle);
				handler(this, e);
			}
		}
		protected virtual void RaiseMasterRowEmpty(MasterRowEmptyEventArgs e) {
			MasterRowEmptyEventHandler handler = (MasterRowEmptyEventHandler)this.Events[masterRowEmpty];
			if(handler != null) handler(this, e);
		}
		protected virtual void RaiseMasterRowCollapsed(int rowHandle, int relationIndex) {
			CheckUpdateParentLayout();
			CustomMasterRowEventHandler handler = (CustomMasterRowEventHandler)this.Events[masterRowCollapsed];
			if(handler != null) {
				CustomMasterRowEventArgs e = new CustomMasterRowEventArgs(rowHandle, relationIndex);
				handler(this, e);
			}
		}
		protected virtual void RaiseMasterRowExpanded(int rowHandle, int relationIndex) {
			CheckUpdateParentLayout();
			CustomMasterRowEventHandler handler = (CustomMasterRowEventHandler)this.Events[masterRowExpanded];
			if(handler != null) {
				CustomMasterRowEventArgs e = new CustomMasterRowEventArgs(rowHandle, relationIndex);
				handler(this, e);
			}
		}
		void CheckUpdateParentLayout() {
			if(DetailLevel >= 2 && ParentView != null) { 
				if(ParentView.GetViewInfo() != null) ParentView.GetViewInfo().IsReady = false;
				ParentView.Invalidate();
			}
		}
		[Obsolete()]
		protected virtual void RaiseShowGridMenu(GridMenuEventArgs e) {
			GridMenuEventHandler handler = (GridMenuEventHandler)this.Events[showGridMenu];
			if(handler != null) handler(this, e);
		}
		protected virtual void RaisePopupMenuShowing(PopupMenuShowingEventArgs e) {
			PopupMenuShowingEventHandler handler = (PopupMenuShowingEventHandler)this.Events[onPopupMenuShowing];
			if (handler != null) handler(this, e);
		}
		protected virtual void RaiseGetPreviewDisplayText(int rowHandle, ref string s) {
			CalcPreviewTextEventHandler handler = (CalcPreviewTextEventHandler)this.Events[calcPreviewText];
			if(handler != null) {
				CalcPreviewTextEventArgs e = new CalcPreviewTextEventArgs(rowHandle, s);
				handler(this, e);
				s = e.PreviewText;
			}
		}
		protected internal virtual int RaiseMeasurePreviewHeight(int rowHandle) {
			RowHeightEventHandler handler = (RowHeightEventHandler)this.Events[measurePreviewHeight];
			if(handler != null) {
				RowHeightEventArgs e = new RowHeightEventArgs(rowHandle, -1);
				handler(this, e);
				return e.RowHeight;
			}
			return -1;
		}
		protected virtual string RaiseGetRelationName(MasterRowGetRelationNameEventArgs e) {
			MasterRowGetRelationNameEventHandler handler = (MasterRowGetRelationNameEventHandler)this.Events[masterRowGetRelationName];
			if(handler != null) {
				handler(this, e);
			}
			return e.RelationName;
		}
		protected virtual string RaiseGetRelationDisplayCaption(MasterRowGetRelationNameEventArgs e) {
			MasterRowGetRelationNameEventHandler handler = (MasterRowGetRelationNameEventHandler)this.Events[masterRowGetRelationDisplayCaption];
			if(handler != null) {
				handler(this, e);
			}
			return e.RelationName;
		}
		protected internal virtual int RaiseRowHeight(int rowHandle, int rowHeight) {
			RowHeightEventHandler handler = (RowHeightEventHandler)this.Events[calcRowHeight];
			if(handler != null) {
				RowHeightEventArgs e = new RowHeightEventArgs(rowHandle, rowHeight);
				handler(this, e);
				rowHeight = e.RowHeight;
			}
			return rowHeight;
		}
		protected internal virtual void RaiseCustomDrawGroupPanel(CustomDrawEventArgs e) {
			CustomDrawEventHandler handler = (CustomDrawEventHandler)this.Events[customDrawGroupPanel];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseCustomDrawRowFooter(RowObjectCustomDrawEventArgs e) {
			RowObjectCustomDrawEventHandler handler = (RowObjectCustomDrawEventHandler)this.Events[customDrawRowFooter];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseCustomDrawFooter(RowObjectCustomDrawEventArgs e) {
			RowObjectCustomDrawEventHandler handler = (RowObjectCustomDrawEventHandler)this.Events[customDrawFooter];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseCustomDrawRowIndicator(RowIndicatorCustomDrawEventArgs e) {
			RowIndicatorCustomDrawEventHandler handler = (RowIndicatorCustomDrawEventHandler)this.Events[customDrawRowIndicator];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseCustomDrawColumnHeader(EventArgs e) { 
			ColumnHeaderCustomDrawEventHandler handler = (ColumnHeaderCustomDrawEventHandler)this.Events[customDrawColumnHeader];
			if(handler != null) handler(this, e as ColumnHeaderCustomDrawEventArgs);
		}
		protected internal virtual void RaiseCustomDrawFooterCell(FooterCellCustomDrawEventArgs e) {
			FooterCellCustomDrawEventHandler handler = (FooterCellCustomDrawEventHandler)this.Events[customDrawFooterCell];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseCustomDrawRowFooterCell(FooterCellCustomDrawEventArgs e) {
			FooterCellCustomDrawEventHandler handler = (FooterCellCustomDrawEventHandler)this.Events[customDrawRowFooterCell];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseCustomDrawCell(RowCellCustomDrawEventArgs e) {
			if(!CanRaiseCustomDrawCell) return;
			RowCellCustomDrawEventHandler handler = (RowCellCustomDrawEventHandler)this.Events[customDrawCell]; 
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseCustomDrawGroupRow(RowObjectCustomDrawEventArgs e) {
			RowObjectCustomDrawEventHandler handler = (RowObjectCustomDrawEventHandler)this.Events[customDrawGroupRow];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseCustomDrawRowPreview(RowObjectCustomDrawEventArgs e) {
			RowObjectCustomDrawEventHandler handler = (RowObjectCustomDrawEventHandler)this.Events[customDrawRowPreview];
			if(handler != null) handler(this, e);
		}
		protected internal bool CanRaiseCustomDrawCell {
			get { 
				return this.Events[customDrawCell] != null; 
			}
		}
		bool IsAllowIgnoreStyleEvents() {
			return false;
		}
		protected virtual AppearanceObject RaiseGetRowCellStyle(int rowHandle, GridColumn column, GridRowCellState state, AppearanceObject appearance) {
			RowCellStyleEventHandler handler = (RowCellStyleEventHandler)this.Events[rowCellStyle];
			if(handler == null || IsAllowIgnoreStyleEvents()) return appearance;
			styleEventArgs.state = state;
			styleEventArgs.SetAppearance(appearance);
			styleEventArgs.rowHandle = rowHandle;
			styleEventArgs.column = column;
			handler(this, styleEventArgs);
			return styleEventArgs.Appearance;
		}
		protected internal virtual AppearanceObject RaiseGetRowStyle(int rowHandle, GridRowCellState state, AppearanceObject appearance, out bool highPriority) {
			highPriority = false;
			RowStyleEventHandler handler = (RowStyleEventHandler)this.Events[rowStyle];
			if(handler == null || IsAllowIgnoreStyleEvents()) return appearance;
			RowStyleEventArgs e = new RowStyleEventArgs(rowHandle, state, appearance.Clone() as AppearanceObject);
			handler(this, e);
			highPriority = e.HighPriority;
			return e.Appearance;
		}
		protected internal virtual void RaiseDragObjectDrop(DragObjectDropEventArgs e) {
			DragObjectDropEventHandler handler = (DragObjectDropEventHandler)this.Events[dragObjectDrop];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseBeforePrintRow(CancelPrintRowEventArgs e) {
			BeforePrintRowEventHandler handler = (BeforePrintRowEventHandler)this.Events[beforePrintRow];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseAfterPrintRow(PrintRowEventArgs e) {
			AfterPrintRowEventHandler handler = (AfterPrintRowEventHandler)this.Events[afterPrintRow];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseDragObjectOver(DragObjectOverEventArgs e) {
			DragObjectOverEventHandler handler = (DragObjectOverEventHandler)this.Events[dragObjectOver];
			if(handler != null) handler(this, e);
		}
		protected internal virtual bool RaiseDragObjectStart(DragObjectStartEventArgs e) {
			DragObjectStartEventHandler handler = (DragObjectStartEventHandler)this.Events[dragObjectStart];
			if(handler != null) handler(this, e);
			return e.Allow;
		}
		protected virtual void RaiseHideCustomizationForm(EventArgs e) {
			EventHandler handler = (EventHandler)this.Events[hideCustomizationForm];
			if(handler != null) handler(this, e);
		}
		protected virtual void RaiseShowCustomizationForm(EventArgs e) {
			EventHandler handler = (EventHandler)this.Events[showCustomizationForm];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseCellMerge(CellMergeEventArgs e) {
			CellMergeEventHandler handler = (CellMergeEventHandler)this.Events[cellMerge];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseRowClick(RowClickEventArgs e) {
			RowClickEventHandler handler = (RowClickEventHandler)this.Events[rowClick];
			if(handler != null) handler(this, e);
		}
		protected internal virtual void RaiseRowCellClick(RowCellClickEventArgs e) {
			RowCellClickEventHandler handler = (RowCellClickEventHandler)this.Events[rowCellClick];
			if(handler != null) handler(this, e);
		}
		protected internal bool CanRaiseRowCellUserEvents { get { return IsFocusedRowLoaded; } }
		[Description("Fires before printing/exporting each individual row, and allows you to add custom information to the printout/export output, and prevent a row from being printed/exported."), Category("Printing")]
		public event BeforePrintRowEventHandler BeforePrintRow {
			add { this.Events.AddHandler(beforePrintRow, value); }
			remove { this.Events.RemoveHandler(beforePrintRow, value); }
		}
		[Description("Fires after an individual row has been printed/exported, and allows you to add custom information to the printout/export output."), Category("Printing")]
		public event AfterPrintRowEventHandler AfterPrintRow {
			add { this.Events.AddHandler(afterPrintRow, value); }
			remove { this.Events.RemoveHandler(afterPrintRow, value); }
		}
		[Description("Allows you to respond to clicking a row. The event will not fire when clicking on a row cell, if data editing is enabled and the ColumnViewOptionsBehavior.EditorShowMode property is set to MouseDown (and to Default, if multiple row selection is disabled)."), Category("Action")]
		public event RowClickEventHandler RowClick {
			add { this.Events.AddHandler(rowClick, value); }
			remove { this.Events.RemoveHandler(rowClick, value); }
		}
		[Description("Allows you to respond to clicking a cell within a row. The event will not fire when clicking on a row cell, if data editing is enabled and the ColumnViewOptionsBehavior.EditorShowMode property is set to MouseDown (and to Default, if multiple row selection is disabled)."), Category("Action")]
		public event RowCellClickEventHandler RowCellClick {
			add { this.Events.AddHandler(rowCellClick, value); }
			remove { this.Events.RemoveHandler(rowCellClick, value); }
		}
		[Description("Provides the ability to customize cell merging behavior."), Category("Merge")]
		public event CellMergeEventHandler CellMerge {
			add { this.Events.AddHandler(cellMerge, value); }
			remove { this.Events.RemoveHandler(cellMerge, value); }
		}
		[Description("Fires immediately after a drag and drop operation on a column header or band header has been completed."), Category("DragDrop")]
		public event DragObjectDropEventHandler DragObjectDrop {
			add { this.Events.AddHandler(dragObjectDrop, value); }
			remove { this.Events.RemoveHandler(dragObjectDrop, value); }
		}
		[Description("Fires when the end-user attempts to drag a  column header or band header."), Category("DragDrop")]
		public event DragObjectStartEventHandler DragObjectStart {
			add { this.Events.AddHandler(dragObjectStart, value); }
			remove { this.Events.RemoveHandler(dragObjectStart, value); }
		}
		[Description("Enables you to control whether the dragged column header or band header can be dropped at the current position."), Category("DragDrop")]
		public event DragObjectOverEventHandler DragObjectOver {
			add { this.Events.AddHandler(dragObjectOver, value); }
			remove { this.Events.RemoveHandler(dragObjectOver, value); }
		}
		[Description("Enables you to paint the group panel manually."), Category("CustomDraw")]
		public event CustomDrawEventHandler CustomDrawGroupPanel {
			add { this.Events.AddHandler(customDrawGroupPanel, value); }
			remove { this.Events.RemoveHandler(customDrawGroupPanel, value); }
		}
		[Description("Enables you to paint column headers manually."), Category("CustomDraw")]
		public event ColumnHeaderCustomDrawEventHandler CustomDrawColumnHeader {
			add { this.Events.AddHandler(customDrawColumnHeader, value); }
			remove { this.Events.RemoveHandler(customDrawColumnHeader, value); }
		}
		[Description("Enables you to custom paint cells within the row indicator panel."), Category("CustomDraw")]
		public event RowIndicatorCustomDrawEventHandler CustomDrawRowIndicator {
			add { this.Events.AddHandler(customDrawRowIndicator, value); }
			remove { this.Events.RemoveHandler(customDrawRowIndicator, value); }
		}
		[Description("Enables data cells to be painted manually."), Category("CustomDraw")]
		public event RowCellCustomDrawEventHandler CustomDrawCell {
			add { this.Events.AddHandler(customDrawCell, value); }
			remove { this.Events.RemoveHandler(customDrawCell, value); }
		}
		[Description("Enables you to paint group footer cells manually."), Category("CustomDraw")]
		public event FooterCellCustomDrawEventHandler CustomDrawRowFooterCell {
			add { this.Events.AddHandler(customDrawRowFooterCell, value); }
			remove { this.Events.RemoveHandler(customDrawRowFooterCell, value); }
		}
		[Description("Enables you to paint view footer cells manually."), Category("CustomDraw")]
		public event FooterCellCustomDrawEventHandler CustomDrawFooterCell {
			add { this.Events.AddHandler(customDrawFooterCell, value); }
			remove { this.Events.RemoveHandler(customDrawFooterCell, value); }
		}
		[Description("Enables you to paint preview sections manually."), Category("CustomDraw")]
		public event RowObjectCustomDrawEventHandler CustomDrawRowPreview {
			add { this.Events.AddHandler(customDrawRowPreview, value); }
			remove { this.Events.RemoveHandler(customDrawRowPreview, value); }
		}
		[Description("Enables you to paint group rows manually."), Category("CustomDraw")]
		public event RowObjectCustomDrawEventHandler CustomDrawGroupRow {
			add { this.Events.AddHandler(customDrawGroupRow, value); }
			remove { this.Events.RemoveHandler(customDrawGroupRow, value); }
		}
		[Description("Enables you to paint group footers manually."), Category("CustomDraw")]
		public event RowObjectCustomDrawEventHandler CustomDrawRowFooter {
			add { this.Events.AddHandler(customDrawRowFooter, value); }
			remove { this.Events.RemoveHandler(customDrawRowFooter, value); }
		}
		[Description("Enables you to paint the view footer manually."), Category("CustomDraw")]
		public event RowObjectCustomDrawEventHandler CustomDrawFooter {
			add { this.Events.AddHandler(customDrawFooter, value); }
			remove { this.Events.RemoveHandler(customDrawFooter, value); }
		}
		[Description("Enables you to specify custom styles for group rows (and corresponding indents) residing at particular nesting levels."), Category("Appearance")]
		public event GroupLevelStyleEventHandler GroupLevelStyle {
			add { this.Events.AddHandler(groupLevelStyle, value); }
			remove { this.Events.RemoveHandler(groupLevelStyle, value); }
		}
		[Description("Enables the appearance settings of individual cells to be changed."), Category("Appearance")]
		public event RowCellStyleEventHandler RowCellStyle {
			add { this.Events.AddHandler(rowCellStyle, value); }
			remove { this.Events.RemoveHandler(rowCellStyle, value); }
		}
		[Description("Enables the appearance settings of individual rows to be changed."), Category("Appearance")]
		public event RowStyleEventHandler RowStyle {
			add { this.Events.AddHandler(rowStyle, value); }
			remove { this.Events.RemoveHandler(rowStyle, value); }
		}
		[Description("Enables you to specify whether a particular detail has data."), Category("MasterDetail")]
		public event MasterRowEmptyEventHandler MasterRowEmpty {
			add { this.Events.AddHandler(masterRowEmpty, value); }
			remove { this.Events.RemoveHandler(masterRowEmpty, value); }
		}
		[Description("Enables you to control whether particular detail clones can be displayed."), Category("MasterDetail")]
		public event MasterRowCanExpandEventHandler MasterRowExpanding {
			add { this.Events.AddHandler(masterRowExpanding, value); }
			remove { this.Events.RemoveHandler(masterRowExpanding, value); }
		}
		[Description("Fires immediately after a particular detail clone has become visible."), Category("MasterDetail")]
		public event CustomMasterRowEventHandler MasterRowExpanded {
			add { this.Events.AddHandler(masterRowExpanded, value); }
			remove { this.Events.RemoveHandler(masterRowExpanded, value); }
		}
		[Description("Enables you to control whether master rows can be collapsed."), Category("MasterDetail")]
		public event MasterRowCanExpandEventHandler MasterRowCollapsing {
			add { this.Events.AddHandler(masterRowCollapsing, value); }
			remove { this.Events.RemoveHandler(masterRowCollapsing, value); }
		}
		[Description("Fires immediately after a detail clone has been destroyed."), Category("MasterDetail")]
		public event CustomMasterRowEventHandler MasterRowCollapsed {
			add { this.Events.AddHandler(masterRowCollapsed, value); }
			remove { this.Events.RemoveHandler(masterRowCollapsed, value); }
		}
		[Description("Enables you to specify a pattern view to represent a particular detail."), Category("MasterDetail")]
		public event MasterRowGetLevelDefaultViewEventHandler MasterRowGetLevelDefaultView {
			add { this.Events.AddHandler(masterRowGetLevelDefaultView, value); }
			remove { this.Events.RemoveHandler(masterRowGetLevelDefaultView, value); }
		}
		[Description("Enables you to supply detail data manually."), Category("MasterDetail")]
		public event MasterRowGetChildListEventHandler MasterRowGetChildList {
			add { this.Events.AddHandler(masterRowGetChildList, value); }
			remove { this.Events.RemoveHandler(masterRowGetChildList, value); }
		}
		[Description("Enables you to specify the pattern view that will represent a particular detail clone."), Category("MasterDetail")]
		public event MasterRowGetRelationNameEventHandler MasterRowGetRelationName {
			add { this.Events.AddHandler(masterRowGetRelationName, value); }
			remove { this.Events.RemoveHandler(masterRowGetRelationName, value); }
		}
		[Description("Enables the display caption for a particular relationship (detail clone) to be specified."), Category("MasterDetail")]
		public event MasterRowGetRelationNameEventHandler MasterRowGetRelationDisplayCaption {
			add { this.Events.AddHandler(masterRowGetRelationDisplayCaption, value); }
			remove { this.Events.RemoveHandler(masterRowGetRelationDisplayCaption, value); }
		}
		[Description("Enables you to specify the number of details for individual master rows."), Category("MasterDetail")]
		public event MasterRowGetRelationCountEventHandler MasterRowGetRelationCount {
			add { this.Events.AddHandler(masterRowGetRelationCount, value); }
			remove { this.Events.RemoveHandler(masterRowGetRelationCount, value); }
		}
		[Description("Enables you to assign editors to individual cells."), Category("Editor")]
		public event CustomRowCellEditEventHandler CustomRowCellEdit {
			add { this.Events.AddHandler(customRowCellEdit, value); }
			remove { this.Events.RemoveHandler(customRowCellEdit, value); }
		}
		[Description("Allows you to assign a custom editor to a column for in-place editing and so override the default column editor, which is by default used both in display and edit modes."), Category("Editor")]
		public event CustomRowCellEditEventHandler CustomRowCellEditForEditing {
			add { this.Events.AddHandler(customRowCellEditForEditing, value); }
			remove { this.Events.RemoveHandler(customRowCellEditForEditing, value); }
		}
		[Description("Fires when the View is scrolled horizontally."), Category("Property Changed")]
		public event EventHandler LeftCoordChanged {
			add { this.Events.AddHandler(leftCoordChanged, value); }
			remove { this.Events.RemoveHandler(leftCoordChanged, value); }
		}
		[Description("Occurs after a column's width has been changed."), Category("Property Changed")]
		public event ColumnEventHandler ColumnWidthChanged {
			add { this.Events.AddHandler(columnWidthChanged, value); }
			remove { this.Events.RemoveHandler(columnWidthChanged, value); }
		}
		[Description("Fires when the View is scrolled vertically."), Category("Property Changed")]
		public event EventHandler TopRowChanged {
			add { this.Events.AddHandler(topRowChanged, value); }
			remove { this.Events.RemoveHandler(topRowChanged, value); }
		}
		[Description("Enables you to provide custom responses to clicking context menu items."), Category("Behavior")]
		public event GridMenuItemClickEventHandler GridMenuItemClick {
			add { this.Events.AddHandler(gridMenuItemClick, value); }
			remove { this.Events.RemoveHandler(gridMenuItemClick, value); }
		}
		[Description("Enables you to customize or prohibit grid context menus."), Category("Behavior")]
		[Browsable(false), EditorBrowsable(EditorBrowsableState.Never), Obsolete("You should use the 'PopupMenuShowing' instead", false)]
		public event GridMenuEventHandler ShowGridMenu {
			add { this.Events.AddHandler(showGridMenu, value); }
			remove { this.Events.RemoveHandler(showGridMenu, value); }
		}
		[Description("Enables you to customize or prohibit grid context menus."), Category("Behavior")]
		public event PopupMenuShowingEventHandler PopupMenuShowing {
			add { this.Events.AddHandler(onPopupMenuShowing, value); }
			remove { this.Events.RemoveHandler(onPopupMenuShowing, value); }
		}
		[Category("Appearance"), Description("Enables you to specify the height of individual rows.")]
		public event RowHeightEventHandler CalcRowHeight {
			add { this.Events.AddHandler(calcRowHeight, value); }
			remove { this.Events.RemoveHandler(calcRowHeight, value); }
		}
		[Category("Data"), Description("Enables you to calculate summary values manually.")]
		public event CustomSummaryEventHandler CustomSummaryCalculate {
			add { this.Events.AddHandler(customSummaryCalculate, value); }
			remove { this.Events.RemoveHandler(customSummaryCalculate, value); }
		}
		[Category("Data"), Description("Enables you to specify which summaries should be calculated and displayed.")]
		public event CustomSummaryExistEventHandler CustomSummaryExists {
			add { this.Events.AddHandler(customSummaryExists, value); }
			remove { this.Events.RemoveHandler(customSummaryExists, value); }
		}
		[Category("Data"), Description("Enables you to provide custom text for preview sections.")]
		public event CalcPreviewTextEventHandler CalcPreviewText {
			add { this.Events.AddHandler(calcPreviewText, value); }
			remove { this.Events.RemoveHandler(calcPreviewText, value); }
		}
		[Category("Data"), Description("Provides the ability to specify the height of individual preview sections in pixels.")]
		public event RowHeightEventHandler MeasurePreviewHeight {
			add { this.Events.AddHandler(measurePreviewHeight, value); }
			remove { this.Events.RemoveHandler(measurePreviewHeight, value); }
		}
		[Description("Fires immediately after a group row has been expanded."), Category("Behavior")]
		public event RowEventHandler GroupRowExpanded {
			add { this.Events.AddHandler(groupRowExpanded, value); }
			remove { this.Events.RemoveHandler(groupRowExpanded, value); }
		}
		[Description("Fires immediately after a group row has been collapsed."), Category("Behavior")]
		public event RowEventHandler GroupRowCollapsed {
			add { this.Events.AddHandler(groupRowCollapsed, value); }
			remove { this.Events.RemoveHandler(groupRowCollapsed, value); }
		}
		[Description("Occurs before group rows are collapsed."), Category("Behavior")]
		public event RowAllowEventHandler GroupRowCollapsing {
			add { this.Events.AddHandler(groupRowCollapsing, value); }
			remove { this.Events.RemoveHandler(groupRowCollapsing, value); }
		}
		[Description("Occurs when a group row is about to be expanded."), Category("Behavior")]
		public event RowAllowEventHandler GroupRowExpanding {
			add { this.Events.AddHandler(groupRowExpanding, value); }
			remove { this.Events.RemoveHandler(groupRowExpanding, value); }
		}
		[Description("Fires immediately after the customization form has been invoked."), Category("Customization")]
		public event EventHandler ShowCustomizationForm {
			add { this.Events.AddHandler(showCustomizationForm, value); }
			remove { this.Events.RemoveHandler(showCustomizationForm, value); }
		}
		[Description("Fires before the customization form is closed."), Category("Customization")]
		public event EventHandler HideCustomizationForm {
			add { this.Events.AddHandler(hideCustomizationForm, value); }
			remove { this.Events.RemoveHandler(hideCustomizationForm, value); }
		}
		[Description("Provides the ability to group data using custom rules."), Category("Sort")]
		public event CustomColumnSortEventHandler CustomColumnGroup {
			add { this.Events.AddHandler(customColumnGroup, value); }
			remove { this.Events.RemoveHandler(customColumnGroup, value); }
		}
		#endregion
		#region IDataControllerRelationSupport 
		string IDataControllerRelationSupport.GetRelationName(string name, int controllerRow, int relationIndex) {
			return RaiseGetRelationName(new MasterRowGetRelationNameEventArgs(controllerRow, relationIndex, name));
		}
		string IDataControllerRelationSupport.GetRelationDisplayName(string displayName, int controllerRow, int relationIndex) {
			string levelName = displayName;
			BaseView view = null;
			if(view == null)
				view = GetLevelDefault(controllerRow, relationIndex, out levelName);
			if(!string.IsNullOrEmpty(displayName)) levelName = displayName;
			if(view != null) {
				if(view.ViewCaption != "") levelName = view.ViewCaption;
			}
			return RaiseGetRelationDisplayCaption(new MasterRowGetRelationNameEventArgs(controllerRow, relationIndex, levelName));
		}
		bool IDataControllerRelationSupport.IsMasterRowEmpty(bool isEmpty, int controllerRow, int relationIndex) {
			this.isMasterRowEmptyEventArgs.rowHandle = controllerRow;
			this.isMasterRowEmptyEventArgs.relationIndex = relationIndex;
			this.isMasterRowEmptyEventArgs.isEmpty = isEmpty;
			RaiseMasterRowEmpty(this.isMasterRowEmptyEventArgs);
			return this.isMasterRowEmptyEventArgs.IsEmpty;
		}
		IList IDataControllerRelationSupport.GetDetailList(int controllerRow, int relationIndex) {
			return GetChildDataView(controllerRow, relationIndex);
		}
		int IDataControllerRelationSupport.GetRelationCount(int relationCount, int controllerRow) {
			MasterRowGetRelationCountEventHandler handler = (MasterRowGetRelationCountEventHandler)this.Events[masterRowGetRelationCount];
			if(handler != null) {
				MasterRowGetRelationCountEventArgs e = new MasterRowGetRelationCountEventArgs(controllerRow, relationCount);
				handler(this, e);
				relationCount = e.RelationCount;
			}
			return relationCount;
		}
		#endregion IDataControllerRelationSupport 
		#region IDataControllerVisualClient
		bool allowUpdateRowIndexes = true;
		protected override void VisualClientUpdateRowIndexes(int newTopRowIndex) {
			if(IsLockUpdate) return;
			if(!this.allowUpdateRowIndexes || ViewInfo.RowsInfo.GetFirstForcedRowIndex() != -1) {
				VisualClientUpdateRows(0);
				return;
			}
			newTopRowIndex = Math.Max(0, newTopRowIndex);
			ViewInfo.UpdateRowIndexes(newTopRowIndex);
			this.topRowIndex = newTopRowIndex;
			VisualClientUpdateScrollBar();
		}
		protected override void VisualClientUpdateRows(int topRowIndexDelta) {
			if(IsLockUpdate) return;
			if(GridControl != null && GridControl.DefaultView != this) {
				VisualClientUpdateLayout();
				return;
			}
			if(topRowIndexDelta != 0 && TopRowIndex > 0) {
				this.requireCheckTopRowIndex = true;
				this.topRowIndex = Math.Max(0, TopRowIndex + topRowIndexDelta);
			}
			if(ActiveEditor != null && topRowIndexDelta == 0) {
				RefreshRows(false, false);
			}
			else {
				SetLayoutDirty();
			}
		}
		protected override void VisualClientUpdateLayout() {
			if(IsLockUpdate || ViewInfo == null) return;
			if(GridControl == null) return;
			if(GridControl.DefaultView == this)
				SetLayoutDirty();
			else {
				SetLayoutDirty();
				ViewInfo.IsReady = false;
			}
			CheckDataControllerError();
		}
		protected override void VisualClientUpdateScrollBar() {
			if(IsLockUpdate) return;
			UpdateScrollBars();
		}
		protected override void VisualClientUpdateTotalSummary() {
			if(IsLockUpdate) return;
			ViewInfo.FooterInfo.SetDirty();
			InvalidateFooter();
		}
		protected override int VisualClientTopRowIndex { get { return TopRowIndex; } }
		protected override int VisualClientPageRowCount { get { return ViewInfo.RowsInfo.Count + 1; } }
		protected override int VisualClientVisibleRowCount { get { return ViewInfo.RowsLoadInfo == null ? -1 : ViewInfo.RowsLoadInfo.VisibleRowCount; } }
		#endregion IDataControllerVisualClient
		#region IDataControllerValidationSupport
		IBoundControl IDataControllerValidationSupport.BoundControl { get { return GridControl; } }
		void IDataControllerValidationSupport.OnStartNewItemRow() {
			if(DesignMode) return;
			if(OptionsView.NewItemRowPosition == NewItemRowPosition.None) LayoutChangedSynchronized();
			FocusedRowHandle = CurrencyDataController.NewItemRow;
			if(FocusedRowHandle == CurrencyDataController.NewItemRow) {
				DataController.BeginCurrentRowEdit();
			}
			if(IsDetailView) {
				CheckViewInfo();
				TopRowIndex = CheckTopRowIndex(TopRowIndex);
				MakeRowVisible(FocusedRowHandle, false);
			}
			RaiseInitNewRow(new InitNewRowEventArgs(CurrencyDataController.NewItemRow));
		}
		void IDataControllerValidationSupport.OnEndNewItemRow() { 
			if(OptionsView.NewItemRowPosition == NewItemRowPosition.None) {
				LayoutChangedSynchronized();
				if(GridControl != null && FocusedRowHandle == CurrencyDataController.NewItemRow) {
					if(GridControl.IsHandleCreated) GridControl.BeginInvoke(new MethodInvoker(MoveLastVisibleDelayed));
				}
			}
			RefreshRow(CurrencyDataController.NewItemRow);
		}
		void MoveLastVisibleDelayed() {
			if(FocusedRowHandle == CurrencyDataController.NewItemRow) MoveLastVisible();
		}
		void IDataControllerValidationSupport.OnBeginCurrentRowEdit() { }
		void IDataControllerValidationSupport.OnCurrentRowUpdated(ControllerRowEventArgs e) { 
			RaiseRowUpdated(new RowObjectEventArgs(e.RowHandle, e.Row));
			UpdateNavigator();
		}
		void IDataControllerValidationSupport.OnValidatingCurrentRow(ValidateControllerRowEventArgs e) { 
			if(e.RowHandle != FocusedRowHandle) return;
			ValidateRowEventArgs rv = new ValidateRowEventArgs(FocusedRowHandle, e.Row);
			rv.Valid = e.Valid;
			rv.ErrorText = e.ErrorText;
			RaiseValidateRow(rv);
			if(!rv.Valid) throw new WarningException(rv.ErrorText);
		}
		void IDataControllerValidationSupport.OnPostRowException(ControllerRowExceptionEventArgs e) { 
			OnPostRowException(e);
		}
		void IDataControllerValidationSupport.OnPostCellException(ControllerRowCellExceptionEventArgs e) { 
			throw e.Exception;
		}
		protected override void OnCurrentControllerRowChanged(CurrentRowEventArgs e) { 
			if(IsFilterRow(FocusedRowHandle)) {
				return;
			}
			FocusedRowHandle = DataController.CurrentControllerRow;
			if(!IsInitialized) return;
			MakeRowVisible(FocusedRowHandle, true);
		}
		void IDataControllerValidationSupport.OnControllerItemChanged(ListChangedEventArgs e) { 
			if(OptionsNavigation.AutoFocusNewRow && e.ListChangedType == ListChangedType.ItemAdded) {
				if(IsValidRowHandle(e.NewIndex)) {
					FocusedRowHandle = e.NewIndex;
					ClearSelection();
					SelectRow(FocusedRowHandle);
				}
			}
			if(e.ListChangedType == ListChangedType.ItemAdded || e.ListChangedType == ListChangedType.ItemDeleted) {
				if(ViewInfo != null) ViewInfo.AutoRowHeightCache.Clear();
				ClearPrevSelectionInfo();
				ClearColumnErrors();
				DataController.SyncCurrentRow();
		}
		}
		#endregion IDataControllerValidationSupport
		int IAccessibleGrid.HeaderCount { get {	return GetAccessibleHeaderCount();	} }
		int IAccessibleGrid.RowCount { 
			get { 
				int res = RowCount + (OptionsView.ShowAutoFilterRow ? 1 : 0);
				if(OptionsView.NewItemRowPosition == NewItemRowPosition.Top) res ++;
				return res;
			} 
		}
		int IAccessibleGrid.SelectedRow { get { return RowHandle2AccessibleIndex(FocusedRowHandle);	} }
		ScrollBarBase IAccessibleGrid.HScroll { get { return ScrollInfo.HScrollVisible ? ScrollInfo.HScroll : null; } }
		ScrollBarBase IAccessibleGrid.VScroll { get { return ScrollInfo.VScrollVisible ? ScrollInfo.VScroll : null; } }
		IAccessibleGridRow IAccessibleGrid.GetRow(int index) { 
			int rowHandle = AccessibleIndex2RowHandle(index);
			if(!IsValidRowHandle(rowHandle)) return null;
			if(IsGroupRow(rowHandle)) return new DevExpress.XtraGrid.Accessibility.GridAccessibleGroupRow(this, rowHandle);
			return new DevExpress.XtraGrid.Accessibility.GridAccessibleDataRow(this, rowHandle);
		} 
		int IAccessibleGrid.FindRow(int x, int y) { 
			GridRowInfo row = ViewInfo.RowsInfo.GetInfo(x, y);
			if(row != null) return RowHandle2AccessibleIndex(row.RowHandle);
			return -1;
		}
		protected virtual int GetAccessibleHeaderCount() { return VisibleColumns.Count; }
		protected internal override int AccessibleIndex2RowHandle(int index) {
			if(OptionsView.ShowAutoFilterRow) {
				if(index-- == 0) return GridControl.AutoFilterRowHandle;
			}
			if(OptionsView.NewItemRowPosition == NewItemRowPosition.Top) {
				if(index-- == 0) return GridControl.NewItemRowHandle;
			}
			return GetVisibleRowHandle(index);
		}
		protected internal override int RowHandle2AccessibleIndex(int rowHandle) {
			int vindex = GetVisibleIndex(rowHandle);
			if(vindex > -1) return VisibleIndex2AccessibleIndex(vindex);
			if(IsFilterRow(rowHandle)) return 0;
			if(IsNewItemRow(rowHandle) && OptionsView.NewItemRowPosition == NewItemRowPosition.Top) {
				return 0 + (OptionsView.ShowAutoFilterRow ? 1 : 0);
			}
			return -1;
		}
		protected internal override int VisibleIndex2AccessibleIndex(int visibleIndex) {
			if(visibleIndex < 0) return -1;
			visibleIndex += OptionsView.ShowAutoFilterRow ? 1 : 0;
			visibleIndex += OptionsView.NewItemRowPosition == NewItemRowPosition.Top ? 1 : 0;
			return visibleIndex;
		}
		protected override DevExpress.Accessibility.BaseAccessible CreateAccessibleInstance() { return new DevExpress.XtraGrid.Accessibility.GridViewAccessibleObject(this); }
		void IGridLookUp.Setup() {
			BeginUpdate();
			try {
				FocusRectStyle = DrawFocusRectStyle.RowFocus;
				OptionsView.ShowGroupPanel = false;
				OptionsSelection.EnableAppearanceFocusedCell = false;
			} finally {
				EndUpdate();
			}
		}
		protected override bool AllowAutoPopulateColumns { 
			get { 
				if(!base.AllowAutoPopulateColumns) return false;
				if(LookUpOwner != null && LookUpOwner.IsDesignMode) return false;
				return true;
			} 
		}
		string extraFilter = string.Empty, extraFilterText = string.Empty;
		internal bool firstMouseEnter = true;
		void IGridLookUp.Show(object editValue, string filterText) {
			this.firstMouseEnter = true;
			if(LookUpOwner == null) return;
			((IGridLookUp)this).SetDisplayFilter(filterText);
			if(LookUpOwner.TextEditStyle == TextEditStyles.DisableTextEditor && RowCount == 0 && ExtraFilterText != string.Empty) ((IGridLookUp)this).SetDisplayFilter(string.Empty);
			int rowHandle = DataController.FindRowByValue(LookUpOwner.ValueMember, editValue, delegate(object args) {
				int row = (int)args;
				if(row >= 0) {
					FocusedRowHandle = row;
					MakeRowVisible(FocusedRowHandle, false);
				}
				else {
					FocusedRowHandle = InvalidRowHandle;
				}
			});
			if(rowHandle == AsyncServerModeDataController.OperationInProgress) {
				rowHandle = FocusedRowHandle;
			}
			BeginUpdate();
			try {
				TopRowIndex = 0;
				FocusedRowHandle = rowHandle;
			} finally {
				EndUpdate();
			}
			MakeRowVisible(FocusedRowHandle, false);
		}
		void IGridLookUp.SetDisplayFilter(string text) {
			if(LookUpOwner == null) return;
			string displayMember = LookUpOwner.DisplayMember;
			this.extraFilterText = this.extraFilter = string.Empty;
			string filter = RowFilter;
			if(text == null) text = string.Empty;
			if(LookUpOwner.GetFilterMode() == PopupFilterMode.Default) {
				this.extraFilterText = this.extraFilter = string.Empty;
				ApplyFindFilter(text);
			}
			else {
				if(LookUpDisplayColumn == null && DataController.Columns[displayMember] == null) return;
				this.extraFilterText = text;
				if(text == "") {
					if(Equals(DataController.FilterCriteria, ActiveFilterCriteria))
						return;
				}
				else {
					this.extraFilter = OnCreateLookupDisplayFilter(text, displayMember);
				}
				ApplyColumnsFilterEx();
			}
			if(!LookUpOwner.OwnerEdit.IsAutoComplete) FocusedRowHandle = InvalidRowHandle;
		}
		protected virtual string OnCreateLookupDisplayFilter(string text, string displayMember) {
			FunctionOperatorType opType = LookUpOwner.GetFilterMode() == PopupFilterMode.StartsWith ? FunctionOperatorType.StartsWith : FunctionOperatorType.Contains;
			CriteriaOperator op = new FunctionOperator(opType, new OperandProperty(displayMember), text);
			return CriteriaOperator.ToString(op);
		}
		protected internal override string ExtraFilterText { get { return extraFilterText; } }
		protected internal override string ExtraFilter { get { return extraFilter; } }
		[Description("Determines whether end-users can modify the View's cell values.")]
		public override bool Editable { get { return base.Editable && !WorkAsLookup; } }
		internal void ResetEvents() {
			Events.Dispose();
		}
		public void GuessAutoFilterRowValuesFromFilter() {
			if(!OptionsView.ShowAutoFilterRow)
				return;
			foreach(GridColumn c in Columns) {
				if(!c.Visible)
					continue;
				ColumnFilterInfo fi = c.FilterInfo;
				if(fi == null)
					continue;
				if(fi.Type != ColumnFilterType.Custom)
					continue;
				AutoFilterCondition cond = ResolveAutoFilterCondition(c);
				BinaryOperator bop = fi.FilterCriteria as BinaryOperator;
				if(!ReferenceEquals(null, bop)) {
					if(cond != AutoFilterCondition.Equals)
						continue;
					if(bop.OperatorType != BinaryOperatorType.Equal)
						continue;
					OperandValue ov = bop.RightOperand as OperandValue;
					if(ReferenceEquals(null, ov))
						continue;
					object val = ov.Value;
					if(val == null)
						continue;
					c.FilterInfo = new ColumnFilterInfo(ColumnFilterType.AutoFilter, val, fi.FilterString);
				}
				FunctionOperator fop = fi.FilterCriteria as FunctionOperator;
				if(!ReferenceEquals(null, fop)) {
					if(fop.Operands.Count != 2)
						continue;
					OperandValue ov = fop.Operands[1] as OperandValue;
					if(ReferenceEquals(null, ov))
						continue;
					string val = ov.Value as string;
					if(string.IsNullOrEmpty(val))
						continue;
					if(cond == AutoFilterCondition.Contains && fop.OperatorType == FunctionOperatorType.Contains) {
						c.FilterInfo = new ColumnFilterInfo(ColumnFilterType.AutoFilter, val, fi.FilterString);
					} else if(cond == AutoFilterCondition.Like && fop.OperatorType == FunctionOperatorType.Contains) {
						c.FilterInfo = new ColumnFilterInfo(ColumnFilterType.AutoFilter, '%' + val, fi.FilterString);
					} else if(cond == AutoFilterCondition.Like && fop.OperatorType == FunctionOperatorType.StartsWith) {
						c.FilterInfo = new ColumnFilterInfo(ColumnFilterType.AutoFilter, val, fi.FilterString);
					}
				}
			}
		}
		public static bool? GuessAutoFilterRowValuesFromFilterAfterRestoreLayout;
		protected override void OnEndDeserializing(string restoredVersion) {
			base.OnEndDeserializing(restoredVersion);
			if(GuessAutoFilterRowValuesFromFilterAfterRestoreLayout == true)
				GuessAutoFilterRowValuesFromFilter();
		}
		protected internal override string GetNonFormattedCaption(string caption) {
			if(!OptionsView.AllowHtmlDrawHeaders) return caption;
			return StringPainter.Default.RemoveFormat(caption);
		}
		internal bool IsColumnFiltered(GridColumn column) {
			return GridCriteriaHelper.IsColumnFiltered(column, ActiveFilter.NonColumnFilterCriteria);
		}
		#region IXtraSupportDeserializeCollection Members
		void IXtraSupportDeserializeCollection.AfterDeserializeCollection(string propertyName, XtraItemEventArgs e) {
			OnAfterDeserializeCollection(propertyName, e);
		}
		void IXtraSupportDeserializeCollection.BeforeDeserializeCollection(string propertyName, XtraItemEventArgs e) {
			OnBeforeDeserializeCollection(propertyName, e);
		}
		bool IXtraSupportDeserializeCollection.ClearCollection(string propertyName, XtraItemEventArgs e) { return false;  }
		protected virtual void OnAfterDeserializeCollection(object propertyName, XtraItemEventArgs e) { }
		protected virtual void OnBeforeDeserializeCollection(object propertyName, XtraItemEventArgs e) { }
		#endregion
		#region ISummaryItemsOwner Members
		void ISummaryItemsOwner.SetItems(List<ISummaryItem> items) {
			try {
				GroupSummary.BeginUpdate();
				for(int i = GroupSummary.Count - 1; i >= 0; i--) {
					GridGroupSummaryItem item = GroupSummary[i] as GridGroupSummaryItem;
					if(item == null) {
						GroupSummary.RemoveAt(i);
						continue;
					}
					if(item.ShowInGroupColumnFooter == null)
						GroupSummary.RemoveAt(i);
				}
				foreach (ISummaryItem item in items) {
					GroupSummary.Add((GridGroupSummaryItem)item);
				}
			} finally {
				GroupSummary.EndUpdate();
			}
		}
		List<ISummaryItem> ISummaryItemsOwner.GetItems() {
			List<ISummaryItem> items = new List<ISummaryItem>();
			foreach (GridGroupSummaryItem item in GroupSummary) {
				if(item.ShowInGroupColumnFooter == null)
				items.Add(item);
			}
			return items;
		}
		ISummaryItem ISummaryItemsOwner.CreateItem(string fieldName, SummaryItemType summaryType) {
			GridGroupSummaryItem summaryItem = new GridGroupSummaryItem();
			summaryItem.FieldName = fieldName;
			summaryItem.SummaryType = summaryType;
			summaryItem.DisplayFormat = GetSummaryItemDisplayFormat(summaryItem);
			return summaryItem;
		}
		List<string> ISummaryItemsOwner.GetFieldNames() {
			List<string> list = new List<string>();
			foreach (GridColumn column in Columns) {
				if (CanBeUsedInGroupSummary(column)) {
					list.Add(column.FieldName);
				}
			}
			return list;
		}
		string ISummaryItemsOwner.GetCaptionByFieldName(string fieldName) {
			return Columns[fieldName].GetTextCaption();
		}
		Type ISummaryItemsOwner.GetTypeByFieldName(string fieldName) {
			return Columns[fieldName].ColumnType;
		}
		protected virtual bool CanBeUsedInGroupSummary(GridColumn column) {
			return CanDataSummaryColumn(column) && (column.Visible || column.CanShowInCustomizationForm);
		}
		string GetSummaryItemDisplayFormat(GridGroupSummaryItem summaryItem) {
			SummaryItemType summaryType = summaryItem.SummaryType;
			if ((summaryType == SummaryItemType.Count && string.IsNullOrEmpty(summaryItem.FieldName)) || summaryType == SummaryItemType.None ||
				summaryType == SummaryItemType.Custom) return string.Empty;
			return "(" + Columns[summaryItem.FieldName].GetTextCaption() + ": " + summaryItem.GetDisplayFormatByType(summaryType) + ")";
		}
		#endregion
		public string GetSummaryFormat(GridColumn column, SummaryItemType sumType) {
			string res = "";
			switch(sumType) {
				case SummaryItemType.Sum: res = GridLocalizer.Active.GetLocalizedString(GridStringId.MenuFooterSumFormat); break;
				case SummaryItemType.Min: res = GridLocalizer.Active.GetLocalizedString(GridStringId.MenuFooterMinFormat); break;
				case SummaryItemType.Max: res = GridLocalizer.Active.GetLocalizedString(GridStringId.MenuFooterMaxFormat); break;
				case SummaryItemType.Count: res = GridLocalizer.Active.GetLocalizedString(GridStringId.MenuFooterCountFormat); break;
				case SummaryItemType.Average: res = GridLocalizer.Active.GetLocalizedString(GridStringId.MenuFooterAverageFormat); break;
			}
			if(this.FootersIgnoreColumnFormat || sumType == SummaryItemType.Count ||
				(column.DisplayFormat.FormatType == FormatType.None && column.DisplayFormat.Format == null)
				|| string.IsNullOrEmpty(column.DisplayFormat.FormatString)) return res;
			try {
				res = string.Format(res, column.DisplayFormat.GetFormatString());
			}
			catch {
			}
			return res;
		}
		protected internal virtual bool AllowAddNewSummaryItemMenu {
			get {
				return OptionsMenu.ShowAddNewSummaryItem != DefaultBoolean.False;
			}
		}
	}
	public class DataMasterRowEventArgs : EventArgs {
		int rowHandle;
		int relationIndex;
		DetailInfo detailInfo;
		public DataMasterRowEventArgs(int rowHandle, int relationIndex, DetailInfo detailInfo) {
			this.rowHandle = rowHandle;
			this.relationIndex = relationIndex;
			this.detailInfo = detailInfo;
		}
		public int RowHandle { get { return rowHandle; } }
		public int RelationIndex { get { return relationIndex; } }
		public DetailInfo DetailInfo  { get { return detailInfo; } }
	}
	public class InitNewRowEventArgs : EventArgs {
		int rowHandle;
		public InitNewRowEventArgs(int rowHandle) {
			this.rowHandle = rowHandle;
		}
		public int RowHandle { get { return rowHandle; } }
	}
	public delegate void DataMasterRowEventHandler(object sender, DataMasterRowEventArgs e);
	public delegate void InitNewRowEventHandler(object sender, InitNewRowEventArgs e);
	public class GridDetailInfo {
		int relationIndex;
		string relationName;
		string caption;
		public GridDetailInfo(int relationIndex, string relationName, string caption) {
			this.relationIndex = relationIndex;
			this.relationName = relationName;
			this.caption = caption;
		}
		public int RelationIndex { get { return relationIndex; } }
		public string RelationName { get { return relationName; } }
		public string Caption { get { return caption; } }
	}
	public class GridRowSelectionInfo {
		public GridRowSelectionInfo(GridColumn column) {
			Add(column);
		}
		public GridRowSelectionInfo() { }
		HybridDictionary cells = null;
		public void AddRange(ICollection columns) {
			foreach(GridColumn column in columns) {
				Add(column, 0);
			}
		}
		public void Add(GridColumn column) { Add(column, 0); }
		internal void Add(GridColumn column, int blockCount) {
			if(column == null) return;
			CreateCells();
			this.cells[column] = blockCount;
		}
		internal void AddReference(GridColumn column) {
			if(column == null) return;
			CreateCells();
			int bk = 0;
			if(this.cells.Contains(column)) {
				bk = 1 + (int)this.cells[column];
			}
			this.cells[column] = bk;
		}
		internal bool ReleaseRow() {
			if(IsEmpty) return false;
			GridColumn[] columns = new GridColumn[cells.Count];
			cells.Keys.CopyTo(columns, 0);
			bool res = false;
			for(int n = 0; n < columns.Length; n++) {
				res |= Release(columns[n]);
			}
			return res;
		}
		internal bool Release(GridColumn column) {
			if(IsEmpty) return false;
			if(this.cells[column] != null) {
				int bc = (int)this.cells[column];
				if(bc == 0) {
					this.cells.Remove(column);
					if(this.cells.Count == 0) this.cells = null;
					return true;
				} else {
					this.cells[column] = bc - 1;
				}
			}
			return false;
		}
		public bool Remove(GridColumn column) {
			if(IsEmpty) return false;
			if(this.cells[column] != null) {
				this.cells.Remove(column);
				if(this.cells.Count == 0) this.cells = null;
				return true;
			}
			return false;
		}
		public bool Contains(GridColumn column) {
			return !IsEmpty && cells.Contains(column);
		}
		void CreateCells() {
			if(this.cells == null) this.cells = new HybridDictionary();
		}
		public bool IsEmpty { get { return cells == null; } }
		public int Count { get { return this.cells == null ? 0 : this.cells.Count; } }
		public GridColumn[] GetColumns() { 
			if(IsEmpty) return null;
			GridColumn[] columns = new GridColumn[cells.Count];
			cells.Keys.CopyTo(columns, 0);
			return columns;
		}
		public override bool Equals(object obj) {
			GridRowSelectionInfo info = obj as GridRowSelectionInfo;
			if(info == null) return false;
			if(Object.ReferenceEquals(this, obj)) return true;
			if(this.Count != info.Count) return false;
			return true;
		}
		public override int GetHashCode() {
			return base.GetHashCode();
		}
	}
}
